' Header extension for libgda5.bi.
' (C) by Thomas{ dot ]Freiherr{ at }gmx[ dot }at, licence LGPLv2
' Translated with help of h_2_bi.bas

#IFNDEF __RT_PARSER_H__
#DEFINE __RT_PARSER_H__
#INCLUDE ONCE "crt/string.bi"
#INCLUDE ONCE "libxml2.bi"
#INCLUDE ONCE "glib.bi"
#INCLUDE ONCE "libgda5.bi"
#INCLUDE ONCE "gda-report-engine.bi"

EXTERN "C"

ENUM RtMarkup
	RT_MARKUP_NONE
	RT_MARKUP_PARA
	RT_MARKUP_BOLD
	RT_MARKUP_TT
	RT_MARKUP_VERBATIM
	RT_MARKUP_ITALIC
	RT_MARKUP_STRIKE
	RT_MARKUP_UNDERLINE
	RT_MARKUP_TITLE
	RT_MARKUP_PICTURE
	RT_MARKUP_LIST
END ENUM

TYPE RtNode AS _RtNode

TYPE _RtNode
	AS RtNode PTR parent
	AS RtNode PTR child
	AS RtNode PTR prev
	AS RtNode PTR next
	AS RtMarkup markup
	AS gint offset
	AS gchar PTR text
	AS GdaBinary binary
END TYPE

DECLARE FUNCTION rt_parse_text(BYVAL AS CONST gchar PTR) AS RtNode PTR
DECLARE SUB rt_free_node(BYVAL AS RtNode PTR)
DECLARE SUB rt_dump_tree(BYVAL AS RtNode PTR)
DECLARE FUNCTION rt_dump_to_string(BYVAL AS RtNode PTR) AS gchar PTR
DECLARE SUB parse_rich_text_to_docbook(BYVAL AS GdaReportEngine PTR, BYVAL AS xmlNodePtr, BYVAL AS CONST gchar PTR)
DECLARE SUB parse_rich_text_to_html(BYVAL AS GdaReportEngine PTR, BYVAL AS xmlNodePtr, BYVAL AS CONST gchar PTR)

END EXTERN
#ENDIF ' __RT_PARSER_H__
