' Header extension for libgda5.bi.
' (C) by Thomas{ dot ]Freiherr{ at }gmx[ dot }at, licence LGPLv2
' Translated with help of h_2_bi.bas

#IFNDEF LIBCSV_H__
#DEFINE LIBCSV_H__
#INCLUDE ONCE "crt/stdlib.bi"
#INCLUDE ONCE "crt/stdio.bi"

EXTERN "C"
#DEFINE CSV_MAJOR 2
#DEFINE CSV_MINOR 0
#DEFINE CSV_RELEASE 1
#DEFINE CSV_SUCCESS 0
#DEFINE CSV_EPARSE 1
#DEFINE CSV_ENOMEM 2
#DEFINE CSV_ETOOBIG 3
#DEFINE CSV_EINVALID 4
#DEFINE CSV_STRICT 1
#DEFINE CSV_REPALL_NL 2
#DEFINE CSV_STRICT_FINI 4
#DEFINE CSV_TAB &h09
#DEFINE CSV_SPACE &h20
#DEFINE CSV_CR &h0D
#DEFINE CSV_LF &h0A
#DEFINE CSV_COMMA &h2C
#DEFINE CSV_QUOTE &h22

TYPE csv_parser
	AS INTEGER pstate
	AS INTEGER quoted
	AS size_t spaces
	AS ZSTRING PTR entry_buf
	AS size_t entry_pos
	AS size_t entry_size
	AS INTEGER status
	AS UBYTE options
	AS UBYTE quote_char
	AS UBYTE delim_char
	is_space AS FUNCTION(BYVAL AS UBYTE) AS INTEGER
	is_term AS FUNCTION(BYVAL AS UBYTE) AS INTEGER
END TYPE

DECLARE FUNCTION csv_init(BYVAL AS csv_parser PTR PTR, BYVAL AS UBYTE) AS INTEGER
DECLARE FUNCTION csv_fini(BYVAL AS csv_parser PTR, BYVAL AS SUB(BYVAL AS ZSTRING PTR, BYVAL AS size_t, BYVAL AS ANY PTR), BYVAL AS SUB(BYVAL AS UBYTE, BYVAL AS ANY PTR), BYVAL AS ANY PTR) AS INTEGER
DECLARE SUB csv_free(BYVAL AS csv_parser PTR)
DECLARE FUNCTION csv_error(BYVAL AS csv_parser PTR) AS INTEGER
DECLARE FUNCTION csv_strerror(BYVAL AS INTEGER) AS ZSTRING PTR
DECLARE FUNCTION csv_parse(BYVAL AS csv_parser PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS size_t, BYVAL AS SUB(BYVAL AS ZSTRING PTR, BYVAL AS size_t, BYVAL AS ANY PTR), BYVAL AS SUB(BYVAL AS UBYTE, BYVAL AS ANY PTR), BYVAL AS ANY PTR) AS size_t
DECLARE FUNCTION csv_write(BYVAL AS ZSTRING PTR, BYVAL AS size_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS size_t) AS size_t
DECLARE FUNCTION csv_fwrite(BYVAL AS FILE PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS size_t) AS INTEGER
DECLARE FUNCTION csv_write2(BYVAL AS ZSTRING PTR, BYVAL AS size_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS size_t, BYVAL AS UBYTE) AS size_t
DECLARE FUNCTION csv_fwrite2(BYVAL AS FILE PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS size_t, BYVAL AS UBYTE) AS INTEGER
DECLARE FUNCTION csv_opts(BYVAL AS csv_parser PTR, BYVAL AS UBYTE) AS INTEGER
DECLARE SUB csv_set_delim(BYVAL AS csv_parser PTR, BYVAL AS UBYTE)
DECLARE SUB csv_set_quote(BYVAL AS csv_parser PTR, BYVAL AS UBYTE)
DECLARE FUNCTION csv_get_delim(BYVAL AS csv_parser PTR) AS UBYTE
DECLARE FUNCTION csv_get_quote(BYVAL AS csv_parser PTR) AS UBYTE
DECLARE SUB csv_set_space_func(BYVAL AS csv_parser PTR, BYVAL AS FUNCTION(BYVAL AS UBYTE) AS INTEGER)
DECLARE SUB csv_set_term_func(BYVAL AS csv_parser PTR, BYVAL AS FUNCTION(BYVAL AS UBYTE) AS INTEGER)

END EXTERN
#ENDIF ' LIBCSV_H__
