' Header extension for libgda5.bi.
' (C) by Thomas{ dot ]Freiherr{ at }gmx[ dot }at, licence LGPLv2
' Translated with help of h_2_bi.bas

#IFNDEF __GDA_CONNECTION_INTERNAL_H_
#DEFINE __GDA_CONNECTION_INTERNAL_H_

#INCLUDE ONCE "libgda5.bi"
#INCLUDE ONCE "libgda/thread-wrapper/gda-thread-wrapper.bi"

EXTERN "C"
#IFDEF GDA_DEBUG
#DEFINE ASSERT_TABLE_NAME(x,y) g_assert ( 0 = strcmp ((x), (y)))
#DEFINE WARN_METHOD_NOT_IMPLEMENTED(prov,method) g_warning (@!"Provider '%s' does not implement the META method '%s()', please report the error to bugzilla.gnome.org", gda_server_provider_get_name (prov), (method))
#DEFINE WARN_META_UPDATE_FAILURE(x,method) if ( 0 = (x)) g_print IIF(@!"%s (meta method=> %s) ERROR: %s\n", __FUNCTION__, (method), error  ANDALSO *error  ANDALSO (*error)->message , (*error)->message , @!"???")
#ELSE ' GDA_DEBUG
#DEFINE ASSERT_TABLE_NAME(x,y)
#DEFINE WARN_METHOD_NOT_IMPLEMENTED(prov,method)
#DEFINE WARN_META_UPDATE_FAILURE(x,method)
#ENDIF ' GDA_DEBUG

DECLARE FUNCTION _gda_open_internal_sqlite_connection(BYVAL AS CONST gchar PTR) AS GdaConnection PTR

TYPE ThreadConnectionAsyncTask
	AS guint jid
	AS GdaServerProviderExecCallback async_cb
	AS gpointer cb_data
END TYPE

DECLARE SUB _ThreadConnectionAsyncTask_free(BYVAL AS ThreadConnectionAsyncTask PTR)

TYPE ThreadConnectionData
	AS GdaConnection PTR sub_connection
	AS gboolean sub_connection_has_closed
	AS GdaServerProvider PTR cnc_provider
	AS GdaThreadWrapper PTR wrapper
	AS GArray PTR handlers_ids
	AS GSList PTR async_tasks
END TYPE

DECLARE SUB _gda_thread_connection_set_data(BYVAL AS GdaConnection PTR, BYVAL AS ThreadConnectionData PTR)
DECLARE FUNCTION _gda_thread_connection_get_data(BYVAL AS GdaConnection PTR) AS ThreadConnectionData PTR
DECLARE SUB _gda_thread_connection_data_free(BYVAL AS ThreadConnectionData PTR)
DECLARE SUB _gda_connection_force_transaction_status(BYVAL AS GdaConnection PTR, BYVAL AS GdaConnection PTR)
DECLARE FUNCTION _gda_connection_get_internal_thread_provider() AS GdaServerProvider PTR
DECLARE SUB _gda_connection_signal_meta_table_update(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR)
DECLARE FUNCTION _gda_connection_compute_table_virtual_name(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR) AS gchar PTR

END EXTERN
#ENDIF ' __GDA_CONNECTION_INTERNAL_H_
