' Header extension for libgda5.bi.
' (C) by Thomas{ dot ]Freiherr{ at }gmx[ dot }at, licence LGPLv2
' Translated with help of h_2_bi.bas

#IFNDEF __GDA_DATA_SELECT_H__
#DEFINE __GDA_DATA_SELECT_H__
#INCLUDE ONCE "glib-object.bi"

#INCLUDE ONCE "libgda5.bi"
#INCLUDE ONCE "libgda/providers-support/gda-pstmt.bi"
#INCLUDE ONCE "libgda/sql-parser/gda-sql-statement.bi"

EXTERN "C"
#DEFINE GDA_TYPE_DATA_SELECT (gda_data_select_get_type())
#DEFINE GDA_DATA_SELECT(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_DATA_SELECT, GdaDataSelect))
#DEFINE GDA_DATA_SELECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_DATA_SELECT, GdaDataSelectClass))
#DEFINE GDA_IS_DATA_SELECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_DATA_SELECT))
#DEFINE GDA_IS_DATA_SELECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_DATA_SELECT))

TYPE GdaDataSelect AS _GdaDataSelect
TYPE GdaDataSelectClass AS _GdaDataSelectClass
TYPE GdaDataSelectPrivate AS _GdaDataSelectPrivate

EXTERN gda_data_select_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_DATA_SELECT_ERROR gda_data_select_error_quark ()

ENUM GdaDataSelectError
	GDA_DATA_SELECT_MODIFICATION_STATEMENT_ERROR
	GDA_DATA_SELECT_MISSING_MODIFICATION_STATEMENT_ERROR
	GDA_DATA_SELECT_CONNECTION_ERROR
	GDA_DATA_SELECT_ACCESS_ERROR
	GDA_DATA_SELECT_SQL_ERROR
	GDA_DATA_SELECT_SAFETY_LOCKED_ERROR
END ENUM

ENUM GdaDataSelectConditionType
	GDA_DATA_SELECT_COND_PK
	GDA_DATA_SELECT_COND_ALL_COLUMNS
END ENUM

TYPE _GdaDataSelect
	AS GObject object
	AS GdaDataSelectPrivate PTR priv
	AS GdaPStmt PTR prep_stmt
	AS gint nb_stored_rows
	AS gint advertized_nrows
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

TYPE _GdaDataSelectClass
	AS GObjectClass parent_class
	fetch_nb_rows AS FUNCTION(BYVAL AS GdaDataSelect PTR) AS gint
	fetch_random AS FUNCTION(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaRow PTR PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
	store_all AS FUNCTION(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean
	fetch_next AS FUNCTION(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaRow PTR PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
	fetch_prev AS FUNCTION(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaRow PTR PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
	fetch_at AS FUNCTION(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaRow PTR PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_data_select_get_type() AS GType
DECLARE FUNCTION gda_data_select_set_row_selection_condition(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaSqlExpr PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_set_row_selection_condition_sql(BYVAL AS GdaDataSelect PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_compute_row_selection_condition(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_set_modification_statement(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaStatement PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_set_modification_statement_sql(BYVAL AS GdaDataSelect PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_compute_modification_statements(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_compute_modification_statements_ext(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaDataSelectConditionType, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_compute_columns_attributes(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_get_connection(BYVAL AS GdaDataSelect PTR) AS GdaConnection PTR
DECLARE FUNCTION gda_data_select_rerun(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_prepare_for_offline(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean

END EXTERN
#ENDIF ' __GDA_DATA_SELECT_H__
