' Header extension for libgda5.bi.
' (C) by Thomas{ dot ]Freiherr{ at }gmx[ dot }at, licence LGPLv2
' Translated with help of h_2_bi.bas

#IFNDEF __GDA_SQL_PARSER_H_
#DEFINE __GDA_SQL_PARSER_H_

#INCLUDE ONCE "libgda5.bi"
#INCLUDE ONCE "gda-statement-struct-util.bi"

EXTERN "C"

#DEFINE GDA_TYPE_SQL_PARSER (gda_sql_parser_get_type())
#DEFINE GDA_SQL_PARSER(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_sql_parser_get_type(), GdaSqlParser)
#DEFINE GDA_SQL_PARSER_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_sql_parser_get_type (), GdaSqlParserClass)
#DEFINE GDA_IS_SQL_PARSER(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_sql_parser_get_type ())

EXTERN gda_sql_parser_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_SQL_PARSER_ERROR gda_sql_parser_error_quark ()

ENUM GdaSqlParserError
	GDA_SQL_PARSER_SYNTAX_ERROR
	GDA_SQL_PARSER_OVERFLOW_ERROR
	GDA_SQL_PARSER_EMPTY_SQL_ERROR
END ENUM

ENUM GdaSqlParserMode
	GDA_SQL_PARSER_MODE_PARSE
	GDA_SQL_PARSER_MODE_DELIMIT
END ENUM

ENUM GdaSqlParserFlavour
	GDA_SQL_PARSER_FLAVOUR_STANDARD = 0
	GDA_SQL_PARSER_FLAVOUR_SQLITE = 1
	GDA_SQL_PARSER_FLAVOUR_MYSQL = 2
	GDA_SQL_PARSER_FLAVOUR_ORACLE = 3
	GDA_SQL_PARSER_FLAVOUR_POSTGRESQL = 4
END ENUM

TYPE _GdaSqlParser
	AS GObject object
	AS GdaSqlParserPrivate PTR priv
END TYPE

TYPE _GdaSqlParserIface
	AS GdaSqlParser PTR parser
	AS GdaSqlStatement PTR parsed_statement
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

TYPE GdaSqlParserIface AS _GdaSqlParserIface

TYPE _GdaSqlParserClass
	AS GObjectClass parent_class
	delim_alloc AS FUNCTION(BYVAL AS FUNCTION(BYVAL AS size_t) AS ANY PTR) AS ANY PTR
	delim_free AS SUB(BYVAL AS ANY PTR, BYVAL AS SUB(BYVAL AS ANY PTR))
	delim_trace AS SUB(BYVAL AS ANY PTR, BYVAL AS ZSTRING PTR)
	delim_parse AS SUB(BYVAL AS ANY PTR, BYVAL AS INTEGER, BYVAL AS GValue PTR, BYVAL AS GdaSqlParserIface PTR)
	AS gint PTR delim_tokens_trans
	parser_alloc AS FUNCTION(BYVAL AS FUNCTION(BYVAL AS size_t) AS ANY PTR) AS ANY PTR
	parser_free AS SUB(BYVAL AS ANY PTR, BYVAL AS SUB(BYVAL AS ANY PTR))
	parser_trace AS SUB(BYVAL AS ANY PTR, BYVAL AS ZSTRING PTR)
	parser_parse AS SUB(BYVAL AS ANY PTR, BYVAL AS INTEGER, BYVAL AS GValue PTR, BYVAL AS GdaSqlParserIface PTR)
	AS gint PTR parser_tokens_trans
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_sql_parser_get_type() AS GType
DECLARE FUNCTION gda_sql_parser_new() AS GdaSqlParser PTR
DECLARE FUNCTION gda_sql_parser_parse_string(BYVAL AS GdaSqlParser PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR PTR, BYVAL AS GError PTR PTR) AS GdaStatement PTR
DECLARE FUNCTION gda_sql_parser_parse_string_as_batch(BYVAL AS GdaSqlParser PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR PTR, BYVAL AS GError PTR PTR) AS GdaBatch PTR
DECLARE FUNCTION gda_sql_parser_parse_file_as_batch(BYVAL AS GdaSqlParser PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS GdaBatch PTR
DECLARE SUB gda_sql_parser_set_syntax_error(BYVAL AS GdaSqlParser PTR)
DECLARE SUB gda_sql_parser_set_overflow_error(BYVAL AS GdaSqlParser PTR)

END EXTERN ' (h_2_bi -P_oCD option)

#ENDIF ' __GDA_SQL_PARSER_H_
