' Header extension for libgda5.bi.
' (C) by Thomas{ dot ]Freiherr{ at }gmx[ dot }at, licence LGPLv2
' Translated with help of h_2_bi.bas

#IFNDEF _GDA_STATEMENT_STRUCT_COMPOUND_H_
#DEFINE _GDA_STATEMENT_STRUCT_COMPOUND_H_

#INCLUDE ONCE "glib.bi"
#INCLUDE ONCE "glib-object.bi"
#INCLUDE ONCE "gda-statement-struct-decl.bi"
#INCLUDE ONCE "gda-statement-struct-select.bi"

EXTERN "C"

ENUM GdaSqlStatementCompoundType
	GDA_SQL_STATEMENT_COMPOUND_UNION
	GDA_SQL_STATEMENT_COMPOUND_UNION_ALL
	GDA_SQL_STATEMENT_COMPOUND_INTERSECT
	GDA_SQL_STATEMENT_COMPOUND_INTERSECT_ALL
	GDA_SQL_STATEMENT_COMPOUND_EXCEPT
	GDA_SQL_STATEMENT_COMPOUND_EXCEPT_ALL
END ENUM

TYPE _GdaSqlStatementCompound
	AS GdaSqlAnyPart any
	AS GdaSqlStatementCompoundType compound_type
	AS GSList PTR stmt_list
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION _gda_sql_statement_compound_copy(BYVAL AS gpointer) AS gpointer
DECLARE SUB _gda_sql_statement_compound_free(BYVAL AS gpointer)
DECLARE FUNCTION _gda_sql_statement_compound_serialize(BYVAL AS gpointer) AS gchar PTR
DECLARE FUNCTION _gda_sql_statement_compound_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE FUNCTION _gda_sql_statement_compound_get_n_cols(BYVAL AS GdaSqlStatementCompound PTR, BYVAL AS GError PTR PTR) AS gint
DECLARE FUNCTION _gda_sql_statement_compound_reduce(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlAnyPart PTR
DECLARE SUB gda_sql_statement_compound_set_type(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSqlStatementCompoundType)
DECLARE SUB gda_sql_statement_compound_take_stmt(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSqlStatement PTR)

END EXTERN
#ENDIF ' _GDA_STATEMENT_STRUCT_COMPOUND_H_

