' Header extension for libgda5.bi.
' (C) by Thomas{ dot ]Freiherr{ at }gmx[ dot }at, licence LGPLv2
' Translated with help of h_2_bi.bas

#IFNDEF _GDA_STATEMENT_STRUCT_DECL_H
#DEFINE _GDA_STATEMENT_STRUCT_DECL_H
#INCLUDE ONCE "glib.bi"
#INCLUDE ONCE "glib-object.bi"

#INCLUDE ONCE "libgda5.bi"

EXTERN "C"

EXTERN gda_sql_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_SQL_ERROR gda_sql_error_quark ()

ENUM GdaSqlError
	GDA_SQL_STRUCTURE_CONTENTS_ERROR
	GDA_SQL_MALFORMED_IDENTIFIER_ERROR
	GDA_SQL_MISSING_IDENTIFIER_ERROR
	GDA_SQL_VALIDATION_ERROR
END ENUM

TYPE GdaSqlErrorType AS GdaSqlError
TYPE GdaSqlAnyPart AS _GdaSqlAnyPart
TYPE GdaSqlStatement AS _GdaSqlStatement
TYPE GdaSqlStatementUnknown AS _GdaSqlStatementUnknown
TYPE GdaSqlStatementTransaction AS _GdaSqlStatementTransaction
TYPE GdaSqlStatementSelect AS _GdaSqlStatementSelect
TYPE GdaSqlStatementInsert AS _GdaSqlStatementInsert
TYPE GdaSqlStatementDelete AS _GdaSqlStatementDelete
TYPE GdaSqlStatementUpdate AS _GdaSqlStatementUpdate
TYPE GdaSqlStatementCompound AS _GdaSqlStatementCompound

ENUM GdaSqlStatementType
	GDA_SQL_STATEMENT_SELECT
	GDA_SQL_STATEMENT_INSERT
	GDA_SQL_STATEMENT_UPDATE
	GDA_SQL_STATEMENT_DELETE
	GDA_SQL_STATEMENT_COMPOUND
	GDA_SQL_STATEMENT_BEGIN
	GDA_SQL_STATEMENT_ROLLBACK
	GDA_SQL_STATEMENT_COMMIT
	GDA_SQL_STATEMENT_SAVEPOINT
	GDA_SQL_STATEMENT_ROLLBACK_SAVEPOINT
	GDA_SQL_STATEMENT_DELETE_SAVEPOINT
	GDA_SQL_STATEMENT_UNKNOWN
	GDA_SQL_STATEMENT_NONE
END ENUM

ENUM GdaSqlAnyPartType
	GDA_SQL_ANY_STMT_SELECT = GDA_SQL_STATEMENT_SELECT
	GDA_SQL_ANY_STMT_INSERT = GDA_SQL_STATEMENT_INSERT
	GDA_SQL_ANY_STMT_UPDATE = GDA_SQL_STATEMENT_UPDATE
	GDA_SQL_ANY_STMT_DELETE = GDA_SQL_STATEMENT_DELETE
	GDA_SQL_ANY_STMT_COMPOUND = GDA_SQL_STATEMENT_COMPOUND
	GDA_SQL_ANY_STMT_BEGIN = GDA_SQL_STATEMENT_BEGIN
	GDA_SQL_ANY_STMT_ROLLBACK = GDA_SQL_STATEMENT_ROLLBACK
	GDA_SQL_ANY_STMT_COMMIT = GDA_SQL_STATEMENT_COMMIT
	GDA_SQL_ANY_STMT_SAVEPOINT = GDA_SQL_STATEMENT_SAVEPOINT
	GDA_SQL_ANY_STMT_ROLLBACK_SAVEPOINT = GDA_SQL_STATEMENT_ROLLBACK_SAVEPOINT
	GDA_SQL_ANY_STMT_DELETE_SAVEPOINT = GDA_SQL_STATEMENT_DELETE_SAVEPOINT
	GDA_SQL_ANY_STMT_UNKNOWN = GDA_SQL_STATEMENT_UNKNOWN
	GDA_SQL_ANY_EXPR = 500
	GDA_SQL_ANY_SQL_FIELD
	GDA_SQL_ANY_SQL_TABLE
	GDA_SQL_ANY_SQL_FUNCTION
	GDA_SQL_ANY_SQL_OPERATION
	GDA_SQL_ANY_SQL_CASE
	GDA_SQL_ANY_SQL_SELECT_FIELD
	GDA_SQL_ANY_SQL_SELECT_TARGET
	GDA_SQL_ANY_SQL_SELECT_JOIN
	GDA_SQL_ANY_SQL_SELECT_FROM
	GDA_SQL_ANY_SQL_SELECT_ORDER
END ENUM

TYPE _GdaSqlAnyPart
	AS GdaSqlAnyPartType type
	AS GdaSqlAnyPart PTR parent
END TYPE

#DEFINE GDA_SQL_ANY_PART(x) (CAST(GdaSqlAnyPart PTR, (x)))
#DEFINE gda_sql_any_part_set_parent(a,p) _
 IF CAST(a, GDA_SQL_ANY_PART(a))->parent = GDA_SQL_ANY_PART(p) THEN

TYPE GdaSqlForeachFunc AS FUNCTION(BYVAL AS GdaSqlAnyPart PTR, BYVAL AS gpointer, BYVAL AS GError PTR PTR) AS gboolean

DECLARE FUNCTION gda_sql_any_part_foreach(BYVAL AS GdaSqlAnyPart PTR, BYVAL AS GdaSqlForeachFunc, BYVAL AS gpointer, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_sql_any_part_check_structure(BYVAL AS GdaSqlAnyPart PTR, BYVAL AS GError PTR PTR) AS gboolean

TYPE GdaSqlStatementContentsInfo
	AS GdaSqlStatementType type
	AS gchar PTR name
	construct AS FUNCTION() AS gpointer
	free AS SUB(BYVAL AS gpointer)
	copy AS FUNCTION(BYVAL AS gpointer) AS gpointer
	serialize AS FUNCTION(BYVAL AS gpointer) AS gchar PTR
	AS GdaSqlForeachFunc check_structure_func
	AS GdaSqlForeachFunc check_validity_func
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

TYPE GdaSqlStatementCheckValidityData
	AS GdaConnection PTR cnc
	AS GdaMetaStore PTR store
	AS GdaMetaStruct PTR mstruct
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

END EXTERN
#ENDIF ' _GDA_STATEMENT_STRUCT_DECL_H
