' Header extension for libgda5.bi.
' (C) by Thomas{ dot ]Freiherr{ at }gmx[ dot }at, licence LGPLv2
' Translated with help of h_2_bi.bas

#IFNDEF _GDA_STATEMENT_STRUCT_PARTS_H
#DEFINE _GDA_STATEMENT_STRUCT_PARTS_H
#INCLUDE ONCE "glib.bi"
#INCLUDE ONCE "glib-object.bi"

#INCLUDE ONCE "gda-statement-struct.bi"
#INCLUDE ONCE "gda-statement-struct-pspec.bi"
#INCLUDE ONCE "gda-statement-struct-decl.bi"
#INCLUDE ONCE "libgda5.bi"

EXTERN "C"

TYPE GdaSqlExpr AS _GdaSqlExpr
TYPE GdaSqlField AS _GdaSqlField
TYPE GdaSqlTable AS _GdaSqlTable
TYPE GdaSqlFunction AS _GdaSqlFunction
TYPE GdaSqlOperation AS _GdaSqlOperation
TYPE GdaSqlCase AS _GdaSqlCase
TYPE GdaSqlSelectField AS _GdaSqlSelectField
TYPE GdaSqlSelectTarget AS _GdaSqlSelectTarget
TYPE GdaSqlSelectJoin AS _GdaSqlSelectJoin
TYPE GdaSqlSelectFrom AS _GdaSqlSelectFrom
TYPE GdaSqlSelectOrder AS _GdaSqlSelectOrder

TYPE _GdaSqlExpr
	AS GdaSqlAnyPart any
	AS GValue PTR value
	AS GdaSqlParamSpec PTR param_spec
	AS GdaSqlFunction PTR func
	AS GdaSqlOperation PTR cond
	AS GdaSqlAnyPart PTR select
	AS GdaSqlCase PTR case_s
	AS gchar PTR cast_as
	AS gboolean value_is_ident
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

#DEFINE GDA_TYPE_SQL_EXPR (gda_sql_expr_get_type())

DECLARE FUNCTION gda_sql_expr_get_type() AS GType
DECLARE FUNCTION gda_sql_expr_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlExpr PTR
DECLARE SUB gda_sql_expr_free(BYVAL AS GdaSqlExpr PTR)
DECLARE FUNCTION gda_sql_expr_copy(BYVAL AS GdaSqlExpr PTR) AS GdaSqlExpr PTR
DECLARE FUNCTION gda_sql_expr_serialize(BYVAL AS GdaSqlExpr PTR) AS gchar PTR
DECLARE SUB _gda_sql_expr_check_clean(BYVAL AS GdaSqlExpr PTR)
DECLARE SUB gda_sql_expr_take_select(BYVAL AS GdaSqlExpr PTR, BYVAL AS GdaSqlStatement PTR)

TYPE _GdaSqlField
	AS GdaSqlAnyPart any
	AS gchar PTR field_name
	AS GdaMetaTableColumn PTR validity_meta_table_column
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_field_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlField PTR
DECLARE SUB gda_sql_field_free(BYVAL AS GdaSqlField PTR)
DECLARE FUNCTION gda_sql_field_copy(BYVAL AS GdaSqlField PTR) AS GdaSqlField PTR
DECLARE FUNCTION gda_sql_field_serialize(BYVAL AS GdaSqlField PTR) AS gchar PTR
DECLARE SUB _gda_sql_field_check_clean(BYVAL AS GdaSqlField PTR)
DECLARE SUB gda_sql_field_take_name(BYVAL AS GdaSqlField PTR, BYVAL AS GValue PTR)

TYPE _GdaSqlTable
	AS GdaSqlAnyPart any
	AS gchar PTR table_name
	AS GdaMetaDbObject PTR validity_meta_object
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_table_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlTable PTR
DECLARE SUB gda_sql_table_free(BYVAL AS GdaSqlTable PTR)
DECLARE FUNCTION gda_sql_table_copy(BYVAL AS GdaSqlTable PTR) AS GdaSqlTable PTR
DECLARE FUNCTION gda_sql_table_serialize(BYVAL AS GdaSqlTable PTR) AS gchar PTR
DECLARE SUB _gda_sql_table_check_clean(BYVAL AS GdaSqlTable PTR)
DECLARE SUB gda_sql_table_take_name(BYVAL AS GdaSqlTable PTR, BYVAL AS GValue PTR)

TYPE _GdaSqlFunction
	AS GdaSqlAnyPart any
	AS gchar PTR function_name
	AS GSList PTR args_list
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_function_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlFunction PTR
DECLARE SUB gda_sql_function_free(BYVAL AS GdaSqlFunction PTR)
DECLARE FUNCTION gda_sql_function_copy(BYVAL AS GdaSqlFunction PTR) AS GdaSqlFunction PTR
DECLARE FUNCTION gda_sql_function_serialize(BYVAL AS GdaSqlFunction PTR) AS gchar PTR
DECLARE SUB gda_sql_function_check_clean(BYVAL AS GdaSqlFunction PTR)
DECLARE SUB gda_sql_function_take_name(BYVAL AS GdaSqlFunction PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_function_take_args_list(BYVAL AS GdaSqlFunction PTR, BYVAL AS GSList PTR)

ENUM GdaSqlOperatorType
	GDA_SQL_OPERATOR_TYPE_AND
	GDA_SQL_OPERATOR_TYPE_OR
	GDA_SQL_OPERATOR_TYPE_EQ
	GDA_SQL_OPERATOR_TYPE_IS
	GDA_SQL_OPERATOR_TYPE_LIKE
	GDA_SQL_OPERATOR_TYPE_BETWEEN
	GDA_SQL_OPERATOR_TYPE_GT
	GDA_SQL_OPERATOR_TYPE_LT
	GDA_SQL_OPERATOR_TYPE_GEQ
	GDA_SQL_OPERATOR_TYPE_LEQ
	GDA_SQL_OPERATOR_TYPE_DIFF
	GDA_SQL_OPERATOR_TYPE_REGEXP
	GDA_SQL_OPERATOR_TYPE_REGEXP_CI
	GDA_SQL_OPERATOR_TYPE_NOT_REGEXP
	GDA_SQL_OPERATOR_TYPE_NOT_REGEXP_CI
	GDA_SQL_OPERATOR_TYPE_SIMILAR
	GDA_SQL_OPERATOR_TYPE_ISNULL
	GDA_SQL_OPERATOR_TYPE_ISNOTNULL
	GDA_SQL_OPERATOR_TYPE_NOT
	GDA_SQL_OPERATOR_TYPE_IN
	GDA_SQL_OPERATOR_TYPE_NOTIN
	GDA_SQL_OPERATOR_TYPE_CONCAT
	GDA_SQL_OPERATOR_TYPE_PLUS
	GDA_SQL_OPERATOR_TYPE_MINUS
	GDA_SQL_OPERATOR_TYPE_STAR
	GDA_SQL_OPERATOR_TYPE_DIV
	GDA_SQL_OPERATOR_TYPE_REM
	GDA_SQL_OPERATOR_TYPE_BITAND
	GDA_SQL_OPERATOR_TYPE_BITOR
	GDA_SQL_OPERATOR_TYPE_BITNOT
	GDA_SQL_OPERATOR_TYPE_ILIKE
	GDA_SQL_OPERATOR_TYPE_NOTLIKE
	GDA_SQL_OPERATOR_TYPE_NOTILIKE
END ENUM

TYPE _GdaSqlOperation
	AS GdaSqlAnyPart any
	AS GdaSqlOperatorType operator_type
	AS GSList PTR operands
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_operation_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlOperation PTR
DECLARE SUB gda_sql_operation_free(BYVAL AS GdaSqlOperation PTR)
DECLARE FUNCTION gda_sql_operation_copy(BYVAL AS GdaSqlOperation PTR) AS GdaSqlOperation PTR
DECLARE FUNCTION gda_sql_operation_serialize(BYVAL AS GdaSqlOperation PTR) AS gchar PTR
DECLARE FUNCTION gda_sql_operation_operator_to_string(BYVAL AS GdaSqlOperatorType) AS CONST gchar PTR
DECLARE FUNCTION gda_sql_operation_operator_from_string(BYVAL AS CONST gchar PTR) AS GdaSqlOperatorType

TYPE _GdaSqlCase
	AS GdaSqlAnyPart any
	AS GdaSqlExpr PTR base_expr
	AS GSList PTR when_expr_list
	AS GSList PTR then_expr_list
	AS GdaSqlExpr PTR else_expr
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_case_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlCase PTR
DECLARE SUB gda_sql_case_free(BYVAL AS GdaSqlCase PTR)
DECLARE FUNCTION gda_sql_case_copy(BYVAL AS GdaSqlCase PTR) AS GdaSqlCase PTR
DECLARE FUNCTION gda_sql_case_serialize(BYVAL AS GdaSqlCase PTR) AS gchar PTR

TYPE _GdaSqlSelectField
	AS GdaSqlAnyPart any
	AS GdaSqlExpr PTR expr
	AS gchar PTR field_name
	AS gchar PTR table_name
	AS gchar PTR as
	AS GdaMetaDbObject PTR validity_meta_object
	AS GdaMetaTableColumn PTR validity_meta_table_column
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_select_field_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlSelectField PTR
DECLARE SUB gda_sql_select_field_free(BYVAL AS GdaSqlSelectField PTR)
DECLARE FUNCTION gda_sql_select_field_copy(BYVAL AS GdaSqlSelectField PTR) AS GdaSqlSelectField PTR
DECLARE FUNCTION gda_sql_select_field_serialize(BYVAL AS GdaSqlSelectField PTR) AS gchar PTR
DECLARE SUB _gda_sql_select_field_check_clean(BYVAL AS GdaSqlSelectField PTR)
DECLARE SUB gda_sql_select_field_take_star_value(BYVAL AS GdaSqlSelectField PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_select_field_take_expr(BYVAL AS GdaSqlSelectField PTR, BYVAL AS GdaSqlExpr PTR)
DECLARE SUB gda_sql_select_field_take_alias(BYVAL AS GdaSqlSelectField PTR, BYVAL AS GValue PTR)

TYPE _GdaSqlSelectTarget
	AS GdaSqlAnyPart any
	AS GdaSqlExpr PTR expr
	AS gchar PTR table_name
	AS gchar PTR as
	AS GdaMetaDbObject PTR validity_meta_object
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_select_target_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlSelectTarget PTR
DECLARE SUB gda_sql_select_target_free(BYVAL AS GdaSqlSelectTarget PTR)
DECLARE FUNCTION gda_sql_select_target_copy(BYVAL AS GdaSqlSelectTarget PTR) AS GdaSqlSelectTarget PTR
DECLARE FUNCTION gda_sql_select_target_serialize(BYVAL AS GdaSqlSelectTarget PTR) AS gchar PTR
DECLARE SUB _gda_sql_select_target_check_clean(BYVAL AS GdaSqlSelectTarget PTR)
DECLARE SUB gda_sql_select_target_take_table_name(BYVAL AS GdaSqlSelectTarget PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_select_target_take_select(BYVAL AS GdaSqlSelectTarget PTR, BYVAL AS GdaSqlStatement PTR)
DECLARE SUB gda_sql_select_target_take_alias(BYVAL AS GdaSqlSelectTarget PTR, BYVAL AS GValue PTR)

ENUM GdaSqlSelectJoinType
	GDA_SQL_SELECT_JOIN_CROSS
	GDA_SQL_SELECT_JOIN_NATURAL
	GDA_SQL_SELECT_JOIN_INNER
	GDA_SQL_SELECT_JOIN_LEFT
	GDA_SQL_SELECT_JOIN_RIGHT
	GDA_SQL_SELECT_JOIN_FULL
END ENUM

TYPE _GdaSqlSelectJoin
	AS GdaSqlAnyPart any
	AS GdaSqlSelectJoinType type
	AS gint position
	AS GdaSqlExpr PTR expr
	AS GSList PTR use
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_select_join_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlSelectJoin PTR
DECLARE SUB gda_sql_select_join_free(BYVAL AS GdaSqlSelectJoin PTR)
DECLARE FUNCTION gda_sql_select_join_copy(BYVAL AS GdaSqlSelectJoin PTR) AS GdaSqlSelectJoin PTR
DECLARE FUNCTION gda_sql_select_join_serialize(BYVAL AS GdaSqlSelectJoin PTR) AS gchar PTR
DECLARE FUNCTION gda_sql_select_join_type_to_string(BYVAL AS GdaSqlSelectJoinType) AS CONST gchar PTR

TYPE _GdaSqlSelectFrom
	AS GdaSqlAnyPart any
	AS GSList PTR targets
	AS GSList PTR joins
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_select_from_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlSelectFrom PTR
DECLARE SUB gda_sql_select_from_free(BYVAL AS GdaSqlSelectFrom PTR)
DECLARE FUNCTION gda_sql_select_from_copy(BYVAL AS GdaSqlSelectFrom PTR) AS GdaSqlSelectFrom PTR
DECLARE FUNCTION gda_sql_select_from_serialize(BYVAL AS GdaSqlSelectFrom PTR) AS gchar PTR
DECLARE SUB gda_sql_select_from_take_new_target(BYVAL AS GdaSqlSelectFrom PTR, BYVAL AS GdaSqlSelectTarget PTR)
DECLARE SUB gda_sql_select_from_take_new_join(BYVAL AS GdaSqlSelectFrom PTR, BYVAL AS GdaSqlSelectJoin PTR)

TYPE _GdaSqlSelectOrder
	AS GdaSqlAnyPart any
	AS GdaSqlExpr PTR expr
	AS gboolean asc
	AS gchar PTR collation_name
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_select_order_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlSelectOrder PTR
DECLARE SUB gda_sql_select_order_free(BYVAL AS GdaSqlSelectOrder PTR)
DECLARE FUNCTION gda_sql_select_order_copy(BYVAL AS GdaSqlSelectOrder PTR) AS GdaSqlSelectOrder PTR
DECLARE FUNCTION gda_sql_select_order_serialize(BYVAL AS GdaSqlSelectOrder PTR) AS gchar PTR

END EXTERN
#ENDIF ' _GDA_STATEMENT_STRUCT_PARTS_H
