' Header extension for libgda5.bi.
' (C) by Thomas{ dot ]Freiherr{ at }gmx[ dot }at, licence LGPLv2
' Translated with help of h_2_bi.bas

#IFNDEF _GDA_STATEMENT_STRUCT_H_
#DEFINE _GDA_STATEMENT_STRUCT_H_
#INCLUDE ONCE "glib.bi"
#INCLUDE ONCE "glib-object.bi"

#INCLUDE ONCE "gda-statement-struct-decl.bi"
#INCLUDE ONCE "libgda5.bi"

EXTERN "C"
TYPE _GdaSqlStatement
	AS gchar PTR sql
	AS GdaSqlStatementType stmt_type
	AS gpointer contents
	AS GdaMetaStruct PTR validity_meta_struct
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

#DEFINE GDA_TYPE_SQL_STATEMENT (gda_sql_statement_get_type())

DECLARE FUNCTION gda_sql_statement_get_type() AS GType
DECLARE FUNCTION gda_sql_statement_new(BYVAL AS GdaSqlStatementType) AS GdaSqlStatement PTR
DECLARE FUNCTION gda_sql_statement_copy(BYVAL AS GdaSqlStatement PTR) AS GdaSqlStatement PTR
DECLARE SUB gda_sql_statement_free(BYVAL AS GdaSqlStatement PTR)
DECLARE FUNCTION gda_sql_statement_serialize(BYVAL AS GdaSqlStatement PTR) AS gchar PTR
DECLARE FUNCTION gda_sql_statement_type_to_string(BYVAL AS GdaSqlStatementType) AS CONST gchar PTR
DECLARE FUNCTION gda_sql_statement_string_to_type(BYVAL AS CONST gchar PTR) AS GdaSqlStatementType
DECLARE FUNCTION gda_sql_statement_check_structure(BYVAL AS GdaSqlStatement PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_sql_statement_check_validity(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaConnection PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_sql_statement_check_validity_m(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaMetaStruct PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE SUB gda_sql_statement_check_clean(BYVAL AS GdaSqlStatement PTR)
DECLARE FUNCTION gda_sql_statement_normalize(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaConnection PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_sql_statement_get_contents_infos(BYVAL AS GdaSqlStatementType) AS GdaSqlStatementContentsInfo PTR

END EXTERN
#ENDIF ' _GDA_STATEMENT_STRUCT_H_
