' Header extension for libgda5.bi.
' (C) by Thomas{ dot ]Freiherr{ at }gmx[ dot }at, licence LGPLv2
' Translated with help of h_2_bi.bas

#IFNDEF __GDA_THREAD_WRAPPER_H__
#DEFINE __GDA_THREAD_WRAPPER_H__
#INCLUDE ONCE "glib-object.bi"

EXTERN "C"
#DEFINE GDA_TYPE_THREAD_WRAPPER (gda_thread_wrapper_get_type())
#DEFINE GDA_THREAD_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_THREAD_WRAPPER, GdaThreadWrapper))
#DEFINE GDA_THREAD_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_THREAD_WRAPPER, GdaThreadWrapperClass))
#DEFINE GDA_IS_THREAD_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_THREAD_WRAPPER))
#DEFINE GDA_IS_THREAD_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_THREAD_WRAPPER))
#DEFINE GDA_THREAD_WRAPPER_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GDA_TYPE_THREAD_WRAPPER, GdaThreadWrapperClass))

TYPE GdaThreadWrapper AS _GdaThreadWrapper
TYPE GdaThreadWrapperClass AS _GdaThreadWrapperClass
TYPE GdaThreadWrapperPrivate AS _GdaThreadWrapperPrivate

EXTERN gda_thread_wrapper_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_THREAD_WRAPPER_ERROR gda_thread_wrapper_error_quark ()

ENUM GdaThreadWrapperError
	GDA_THREAD_WRAPPER_UNKNOWN_ERROR
END ENUM

TYPE _GdaThreadWrapper
	AS GObject object
	AS GdaThreadWrapperPrivate PTR priv
END TYPE

TYPE _GdaThreadWrapperClass
	AS GObjectClass object_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

ENUM GdaThreadNotificationType
	GDA_THREAD_NOTIFICATION_JOB = &h01
	GDA_THREAD_NOTIFICATION_SIGNAL = &h02
END ENUM

TYPE GdaThreadNotification
	AS GdaThreadNotificationType type
	AS guint job_id
END TYPE

TYPE GdaThreadWrapperFunc AS FUNCTION(BYVAL AS gpointer, BYVAL AS GError PTR PTR) AS gpointer
TYPE GdaThreadWrapperVoidFunc AS SUB(BYVAL AS gpointer, BYVAL AS GError PTR PTR)
TYPE GdaThreadWrapperCallback AS SUB(BYVAL AS GdaThreadWrapper PTR, BYVAL AS gpointer, BYVAL AS CONST gchar PTR, BYVAL AS gint, BYVAL AS CONST GValue PTR, BYVAL AS gpointer, BYVAL AS gpointer)

DECLARE FUNCTION gda_thread_wrapper_get_type() AS GType
DECLARE FUNCTION gda_thread_wrapper_new() AS GdaThreadWrapper PTR
DECLARE FUNCTION gda_thread_wrapper_get_io_channel(BYVAL AS GdaThreadWrapper PTR) AS GIOChannel PTR
DECLARE SUB gda_thread_wrapper_unset_io_channel(BYVAL AS GdaThreadWrapper PTR)
DECLARE FUNCTION gda_thread_wrapper_execute(BYVAL AS GdaThreadWrapper PTR, BYVAL AS GdaThreadWrapperFunc, BYVAL AS gpointer, BYVAL AS GDestroyNotify, BYVAL AS GError PTR PTR) AS guint
DECLARE FUNCTION gda_thread_wrapper_execute_void(BYVAL AS GdaThreadWrapper PTR, BYVAL AS GdaThreadWrapperVoidFunc, BYVAL AS gpointer, BYVAL AS GDestroyNotify, BYVAL AS GError PTR PTR) AS guint
DECLARE FUNCTION gda_thread_wrapper_cancel(BYVAL AS GdaThreadWrapper PTR, BYVAL AS guint) AS gboolean
DECLARE SUB gda_thread_wrapper_iterate(BYVAL AS GdaThreadWrapper PTR, BYVAL AS gboolean)
DECLARE FUNCTION gda_thread_wrapper_fetch_result(BYVAL AS GdaThreadWrapper PTR, BYVAL AS gboolean, BYVAL AS guint, BYVAL AS GError PTR PTR) AS gpointer
DECLARE FUNCTION gda_thread_wrapper_get_waiting_size(BYVAL AS GdaThreadWrapper PTR) AS gint
DECLARE FUNCTION gda_thread_wrapper_connect_raw(BYVAL AS GdaThreadWrapper PTR, BYVAL AS gpointer, BYVAL AS CONST gchar PTR, BYVAL AS gboolean, BYVAL AS gboolean, BYVAL AS GdaThreadWrapperCallback, BYVAL AS gpointer) AS gulong
DECLARE SUB gda_thread_wrapper_disconnect(BYVAL AS GdaThreadWrapper PTR, BYVAL AS gulong)
DECLARE SUB gda_thread_wrapper_steal_signal(BYVAL AS GdaThreadWrapper PTR, BYVAL AS gulong)

END EXTERN
#ENDIF ' __GDA_THREAD_WRAPPER_H__

