#IFDEF __FB_WIN32__
#PRAGMA push(msbitfields)
#ENDIF

#INCLIB "xml2" ' place the name of your lib into quotes

#LANG "fb"
EXTERN "C" ' (h_2_bi -P_oCD option)

#IFNDEF __XML_PARSER_H__
#DEFINE __XML_PARSER_H__

#INCLUDE ONCE "crt/stdarg.bi"

#IFNDEF __XML_VERSION_H__
#DEFINE __XML_VERSION_H__

DECLARE SUB xmlCheckVersion(BYVAL AS INTEGER)

#DEFINE LIBXML_DOTTED_VERSION @!"2.7.8"
#DEFINE LIBXML_VERSION 20708
#DEFINE LIBXML_VERSION_STRING @!"20708"
#DEFINE LIBXML_VERSION_EXTRA @!""
#DEFINE LIBXML_TEST_VERSION (xmlCheckVersion(LIBXML_VERSION))

#IF 0
#DEFINE WITH_TRIO
#ELSE ' 0
#DEFINE WITHOUT_TRIO
#ENDIF ' 0

#DEFINE LIBXML_TREE_ENABLED
#DEFINE LIBXML_OUTPUT_ENABLED
#DEFINE LIBXML_PUSH_ENABLED
#DEFINE LIBXML_READER_ENABLED
#DEFINE LIBXML_PATTERN_ENABLED
#DEFINE LIBXML_WRITER_ENABLED
#DEFINE LIBXML_SAX1_ENABLED
#DEFINE LIBXML_FTP_ENABLED
#DEFINE LIBXML_HTTP_ENABLED
#DEFINE LIBXML_VALID_ENABLED
#DEFINE LIBXML_HTML_ENABLED
#DEFINE LIBXML_LEGACY_ENABLED
#DEFINE LIBXML_C14N_ENABLED
#DEFINE LIBXML_CATALOG_ENABLED
#DEFINE LIBXML_DOCB_ENABLED
#DEFINE LIBXML_XPATH_ENABLED
#DEFINE LIBXML_XPTR_ENABLED
#DEFINE LIBXML_XINCLUDE_ENABLED
#DEFINE LIBXML_ICONV_ENABLED
'#DEFINE LIBXML_ICU_ENABLED
#DEFINE LIBXML_ISO8859X_ENABLED
#DEFINE LIBXML_DEBUG_ENABLED
'#DEFINE DEBUG_MEMORY_LOCATION
'#DEFINE LIBXML_DEBUG_RUNTIME
#DEFINE LIBXML_UNICODE_ENABLED
#DEFINE LIBXML_REGEXP_ENABLED
#DEFINE LIBXML_AUTOMATA_ENABLED
#DEFINE LIBXML_EXPR_ENABLED
#DEFINE LIBXML_SCHEMAS_ENABLED
#DEFINE LIBXML_SCHEMATRON_ENABLED
#DEFINE LIBXML_MODULES_ENABLED
#DEFINE LIBXML_MODULE_EXTENSION @!".so"
#DEFINE LIBXML_ZLIB_ENABLED

#IFDEF __GNUC__
#IFDEF HAVE_ANSIDECL_H

' file not found: ansidecl.h

#ENDIF ' HAVE_ANSIDECL_H

#IFNDEF ATTRIBUTE_UNUSED
#DEFINE ATTRIBUTE_UNUSED __attribute__((unused))
#ENDIF ' ATTRIBUTE_UNUSED

#IFNDEF LIBXML_ATTR_ALLOC_SIZE
#IF ((__GNUC__  > 4) OR ((__GNUC__ = 4) AND (__GNUC_MINOR__  >= 3)))
#DEFINE LIBXML_ATTR_ALLOC_SIZE(x) __attribute__((alloc_size(x)))
#ELSE ' ((__GNUC__  > 4...
#DEFINE LIBXML_ATTR_ALLOC_SIZE(x)
#ENDIF ' ((__GNUC__  > 4...
#ELSE ' LIBXML_ATTR_ALLOC_SIZE
#DEFINE LIBXML_ATTR_ALLOC_SIZE(x)
#ENDIF ' LIBXML_ATTR_ALLOC_SIZE

#IFNDEF LIBXML_ATTR_FORMAT
#IF ((__GNUC__  > 3) OR ((__GNUC__ = 3) AND (__GNUC_MINOR__  >= 3)))
#DEFINE LIBXML_ATTR_FORMAT(fmt,args) __attribute__((__format__(__printf__,fmt,args)))
#ELSE ' ((__GNUC__  > 3...
#DEFINE LIBXML_ATTR_FORMAT(fmt,args)
#ENDIF ' ((__GNUC__  > 3...
#ELSE ' LIBXML_ATTR_FORMAT
#DEFINE LIBXML_ATTR_FORMAT(fmt,args)
#ENDIF ' LIBXML_ATTR_FORMAT
#ELSE ' __GNUC__
#DEFINE ATTRIBUTE_UNUSED
#DEFINE LIBXML_ATTR_ALLOC_SIZE(x)
#DEFINE LIBXML_ATTR_FORMAT(fmt,args)
#ENDIF ' __GNUC__

#ENDIF ' __XML_VERSION_H__

#IFNDEF __XML_TREE_H__
#DEFINE __XML_TREE_H__
#INCLUDE ONCE "crt/stdio.bi"

#IFNDEF __XML_STRING_H__
#DEFINE __XML_STRING_H__

TYPE xmlChar AS UBYTE

'#DEFINE BAD_CAST (xmlChar *)

DECLARE FUNCTION xmlStrdup(BYVAL AS CONST xmlChar PTR) AS xmlChar PTR
DECLARE FUNCTION xmlStrndup(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS xmlChar PTR
DECLARE FUNCTION xmlCharStrndup(BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlChar PTR
DECLARE FUNCTION xmlCharStrdup(BYVAL AS CONST ZSTRING PTR) AS xmlChar PTR
DECLARE FUNCTION xmlStrsub(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS INTEGER) AS xmlChar PTR
DECLARE FUNCTION xmlStrchr(BYVAL AS CONST xmlChar PTR, BYVAL AS xmlChar) AS CONST xmlChar PTR
DECLARE FUNCTION xmlStrstr(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS CONST xmlChar PTR
DECLARE FUNCTION xmlStrcasestr(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS CONST xmlChar PTR
DECLARE FUNCTION xmlStrcmp(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlStrncmp(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlStrcasecmp(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlStrncasecmp(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlStrEqual(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlStrQEqual(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlStrlen(BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlStrcat(BYVAL AS xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlChar PTR
DECLARE FUNCTION xmlStrncat(BYVAL AS xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS xmlChar PTR
DECLARE FUNCTION xmlStrncatNew(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS xmlChar PTR
DECLARE FUNCTION xmlStrPrintf(BYVAL AS xmlChar PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, ...) AS INTEGER
DECLARE FUNCTION xmlStrVPrintf(BYVAL AS xmlChar PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS va_list) AS INTEGER
DECLARE FUNCTION xmlGetUTF8Char(BYVAL AS CONST UBYTE PTR, BYVAL AS INTEGER PTR) AS INTEGER
DECLARE FUNCTION xmlCheckUTF8(BYVAL AS CONST UBYTE PTR) AS INTEGER
DECLARE FUNCTION xmlUTF8Strsize(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlUTF8Strndup(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS xmlChar PTR
DECLARE FUNCTION xmlUTF8Strpos(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS CONST xmlChar PTR
DECLARE FUNCTION xmlUTF8Strloc(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlUTF8Strsub(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS INTEGER) AS xmlChar PTR
DECLARE FUNCTION xmlUTF8Strlen(BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlUTF8Size(BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlUTF8Charcmp(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS INTEGER

#ENDIF ' __XML_STRING_H__

TYPE xmlParserInputBuffer AS _xmlParserInputBuffer
TYPE AS xmlParserInputBuffer PTR xmlParserInputBufferPtr
TYPE xmlOutputBuffer AS _xmlOutputBuffer
TYPE AS xmlOutputBuffer PTR xmlOutputBufferPtr
TYPE xmlParserInput AS _xmlParserInput
TYPE AS xmlParserInput PTR xmlParserInputPtr
TYPE xmlParserCtxt AS _xmlParserCtxt
TYPE AS xmlParserCtxt PTR xmlParserCtxtPtr
TYPE xmlSAXLocator AS _xmlSAXLocator
TYPE AS xmlSAXLocator PTR xmlSAXLocatorPtr
TYPE xmlSAXHandler AS _xmlSAXHandler
TYPE AS xmlSAXHandler PTR xmlSAXHandlerPtr
TYPE xmlEntity AS _xmlEntity
TYPE AS xmlEntity PTR xmlEntityPtr

TYPE _xmlSAXLocator
	getPublicId AS FUNCTION(BYVAL AS ANY PTR) AS CONST xmlChar PTR
	getSystemId AS FUNCTION(BYVAL AS ANY PTR) AS CONST xmlChar PTR
	getLineNumber AS FUNCTION(BYVAL AS ANY PTR) AS INTEGER
	getColumnNumber AS FUNCTION(BYVAL AS ANY PTR) AS INTEGER
END TYPE

TYPE xmlSAXHandlerV1 AS _xmlSAXHandlerV1
TYPE AS xmlSAXHandlerV1 PTR xmlSAXHandlerV1Ptr

#DEFINE BASE_BUFFER_SIZE 4096

ENUM xmlBufferAllocationScheme
	XML_BUFFER_ALLOC_DOUBLEIT
	XML_BUFFER_ALLOC_EXACT
	XML_BUFFER_ALLOC_IMMUTABLE
	XML_BUFFER_ALLOC_IO
END ENUM

TYPE xmlBuffer AS _xmlBuffer
TYPE AS xmlBuffer PTR xmlBufferPtr

TYPE _xmlBuffer
	AS xmlChar PTR content
	AS UINTEGER use
	AS UINTEGER size
	AS xmlBufferAllocationScheme alloc
	AS xmlChar PTR contentIO
END TYPE

#DEFINE XML_XML_NAMESPACE _
    CAST(CONST xmlChar PTR, @@!"http://www.w3.org/XML/1998/namespace")
#DEFINE XML_XML_ID CAST(CONST xmlChar PTR, @@!"xml:id")

ENUM xmlElementType
	XML_ELEMENT_NODE = 1
	XML_ATTRIBUTE_NODE = 2
	XML_TEXT_NODE = 3
	XML_CDATA_SECTION_NODE = 4
	XML_ENTITY_REF_NODE = 5
	XML_ENTITY_NODE = 6
	XML_PI_NODE = 7
	XML_COMMENT_NODE = 8
	XML_DOCUMENT_NODE = 9
	XML_DOCUMENT_TYPE_NODE = 10
	XML_DOCUMENT_FRAG_NODE = 11
	XML_NOTATION_NODE = 12
	XML_HTML_DOCUMENT_NODE = 13
	XML_DTD_NODE = 14
	XML_ELEMENT_DECL = 15
	XML_ATTRIBUTE_DECL = 16
	XML_ENTITY_DECL = 17
	XML_NAMESPACE_DECL = 18
	XML_XINCLUDE_START = 19
  XML_XINCLUDE_END= 20
#IFDEF LIBXML_DOCB_ENABLED
  XML_DOCB_DOCUMENT_NODE= 21
#ENDIF
END ENUM

TYPE xmlNotation AS _xmlNotation
TYPE AS xmlNotation PTR xmlNotationPtr

TYPE _xmlNotation
	AS CONST xmlChar PTR name
	AS CONST xmlChar PTR PublicID
	AS CONST xmlChar PTR SystemID
END TYPE

ENUM xmlAttributeType
	XML_ATTRIBUTE_CDATA = 1
	XML_ATTRIBUTE_ID
	XML_ATTRIBUTE_IDREF
	XML_ATTRIBUTE_IDREFS
	XML_ATTRIBUTE_ENTITY
	XML_ATTRIBUTE_ENTITIES
	XML_ATTRIBUTE_NMTOKEN
	XML_ATTRIBUTE_NMTOKENS
	XML_ATTRIBUTE_ENUMERATION
	XML_ATTRIBUTE_NOTATION
END ENUM

ENUM xmlAttributeDefault
	XML_ATTRIBUTE_NONE = 1
	XML_ATTRIBUTE_REQUIRED
	XML_ATTRIBUTE_IMPLIED
	XML_ATTRIBUTE_FIXED
END ENUM

TYPE xmlEnumeration AS _xmlEnumeration
TYPE AS xmlEnumeration PTR xmlEnumerationPtr

TYPE _xmlEnumeration
	AS _xmlEnumeration PTR next
	AS CONST xmlChar PTR name
END TYPE

TYPE xmlAttribute AS _xmlAttribute
TYPE AS xmlAttribute PTR xmlAttributePtr

TYPE xmlDoc AS _xmlDoc
TYPE xmlNs AS _xmlNs
TYPE xmlAttr AS _xmlAttr
TYPE xmlDict AS _xmlDict
TYPE xmlNode AS _xmlNode

TYPE _xmlNode
	AS ANY PTR _private
	AS xmlElementType type
	AS CONST xmlChar PTR name
	AS _xmlNode PTR children
	AS _xmlNode PTR last
	AS _xmlNode PTR parent
	AS _xmlNode PTR next
	AS _xmlNode PTR prev
	AS xmlDoc PTR doc
	AS xmlNs PTR ns
	AS xmlChar PTR content
	AS xmlAttr PTR properties
	AS xmlNs PTR nsDef
	AS ANY PTR psvi
	AS USHORT line
	AS USHORT extra
END TYPE

TYPE _xmlDtd
	AS ANY PTR _private
	AS xmlElementType type
	AS CONST xmlChar PTR name
	AS _xmlNode PTR children
	AS _xmlNode PTR last
	AS xmlDoc PTR parent
	AS _xmlNode PTR next
	AS _xmlNode PTR prev
	AS xmlDoc PTR doc
	AS ANY PTR notations
	AS ANY PTR elements
	AS ANY PTR attributes
	AS ANY PTR entities
	AS CONST xmlChar PTR ExternalID
	AS CONST xmlChar PTR SystemID
	AS ANY PTR pentities
END TYPE

TYPE _xmlDoc
	AS ANY PTR _private
	AS xmlElementType type
	AS ZSTRING PTR name
	AS _xmlNode PTR children
	AS _xmlNode PTR last
	AS _xmlNode PTR parent
	AS _xmlNode PTR next
	AS _xmlNode PTR prev
	AS _xmlDoc PTR doc
	AS INTEGER compression
	AS INTEGER standalone
	AS _xmlDtd PTR intSubset
	AS _xmlDtd PTR extSubset
	AS xmlNs PTR oldNs
	AS CONST xmlChar PTR version
	AS CONST xmlChar PTR encoding
	AS ANY PTR ids
	AS ANY PTR refs
	AS CONST xmlChar PTR URL
	AS INTEGER charset
	AS xmlDict PTR dict
	AS ANY PTR psvi
	AS INTEGER parseFlags
	AS INTEGER properties
END TYPE

TYPE _xmlAttribute
	AS ANY PTR _private
	AS xmlElementType type
	AS CONST xmlChar PTR name
	AS _xmlNode PTR children
	AS _xmlNode PTR last
	AS _xmlDtd PTR parent
	AS _xmlNode PTR next
	AS _xmlNode PTR prev
	AS _xmlDoc PTR doc
	AS _xmlAttribute PTR nexth
	AS xmlAttributeType atype
	AS xmlAttributeDefault def
	AS CONST xmlChar PTR defaultValue
	AS xmlEnumerationPtr tree
	AS CONST xmlChar PTR prefix
	AS CONST xmlChar PTR elem
END TYPE

ENUM xmlElementContentType
	XML_ELEMENT_CONTENT_PCDATA = 1
	XML_ELEMENT_CONTENT_ELEMENT
	XML_ELEMENT_CONTENT_SEQ
	XML_ELEMENT_CONTENT_OR
END ENUM

ENUM xmlElementContentOccur
	XML_ELEMENT_CONTENT_ONCE = 1
	XML_ELEMENT_CONTENT_OPT
	XML_ELEMENT_CONTENT_MULT
	XML_ELEMENT_CONTENT_PLUS
END ENUM

TYPE xmlElementContent AS _xmlElementContent
TYPE AS xmlElementContent PTR xmlElementContentPtr

TYPE _xmlElementContent
	AS xmlElementContentType type
	AS xmlElementContentOccur ocur
	AS CONST xmlChar PTR name
	AS _xmlElementContent PTR c1
	AS _xmlElementContent PTR c2
	AS _xmlElementContent PTR parent
	AS CONST xmlChar PTR prefix
END TYPE

ENUM xmlElementTypeVal
	XML_ELEMENT_TYPE_UNDEFINED = 0
	XML_ELEMENT_TYPE_EMPTY = 1
	XML_ELEMENT_TYPE_ANY
	XML_ELEMENT_TYPE_MIXED
	XML_ELEMENT_TYPE_ELEMENT
END ENUM

TYPE xmlSAXHandlerV1 AS _xmlSAXHandlerV1
TYPE AS xmlSAXHandlerV1 PTR xmlSAXHandlerV1Ptr

TYPE resolveEntitySAXFunc AS FUNCTION(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlParserInputPtr
TYPE internalSubsetSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
TYPE externalSubsetSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
TYPE getEntitySAXFunc AS FUNCTION(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
TYPE getParameterEntitySAXFunc AS FUNCTION(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
TYPE entityDeclSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlChar PTR)
TYPE notationDeclSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
TYPE attributeDeclSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlEnumerationPtr)
TYPE elementDeclSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS xmlElementContentPtr)
TYPE unparsedEntityDeclSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
TYPE setDocumentLocatorSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS xmlSAXLocatorPtr)
TYPE startDocumentSAXFunc AS SUB(BYVAL AS ANY PTR)
TYPE endDocumentSAXFunc AS SUB(BYVAL AS ANY PTR)
TYPE startElementSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR PTR)
TYPE endElementSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR)
TYPE attributeSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
TYPE referenceSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR)
TYPE charactersSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER)
TYPE ignorableWhitespaceSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER)
TYPE processingInstructionSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
TYPE commentSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR)
TYPE cdataBlockSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER)
TYPE warningSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, ...)
TYPE errorSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, ...)
TYPE fatalErrorSAXFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, ...)
TYPE isStandaloneSAXFunc AS FUNCTION(BYVAL AS ANY PTR) AS INTEGER
TYPE hasInternalSubsetSAXFunc AS FUNCTION(BYVAL AS ANY PTR) AS INTEGER
TYPE hasExternalSubsetSAXFunc AS FUNCTION(BYVAL AS ANY PTR) AS INTEGER

TYPE _xmlSAXHandlerV1
	AS internalSubsetSAXFunc internalSubset
	AS isStandaloneSAXFunc isStandalone
	AS hasInternalSubsetSAXFunc hasInternalSubset
	AS hasExternalSubsetSAXFunc hasExternalSubset
	AS resolveEntitySAXFunc resolveEntity
	AS getEntitySAXFunc getEntity
	AS entityDeclSAXFunc entityDecl
	AS notationDeclSAXFunc notationDecl
	AS attributeDeclSAXFunc attributeDecl
	AS elementDeclSAXFunc elementDecl
	AS unparsedEntityDeclSAXFunc unparsedEntityDecl
	AS setDocumentLocatorSAXFunc setDocumentLocator
	AS startDocumentSAXFunc startDocument
	AS endDocumentSAXFunc endDocument
	AS startElementSAXFunc startElement
	AS endElementSAXFunc endElement
	AS referenceSAXFunc reference
	AS charactersSAXFunc characters
	AS ignorableWhitespaceSAXFunc ignorableWhitespace
	AS processingInstructionSAXFunc processingInstruction
	AS commentSAXFunc comment
	AS warningSAXFunc warning
	AS errorSAXFunc error
	AS fatalErrorSAXFunc fatalError
	AS getParameterEntitySAXFunc getParameterEntity
	AS cdataBlockSAXFunc cdataBlock
	AS externalSubsetSAXFunc externalSubset
	AS UINTEGER initialized
END TYPE

#IFNDEF __XML_REGEXP_H__
#DEFINE __XML_REGEXP_H__

#IFDEF LIBXML_REGEXP_ENABLED

TYPE xmlRegexp AS _xmlRegexp
TYPE AS xmlRegexp PTR xmlRegexpPtr
TYPE xmlRegExecCtxt AS _xmlRegExecCtxt
TYPE AS xmlRegExecCtxt PTR xmlRegExecCtxtPtr

#IFNDEF __XML_DICT_H__
#DEFINE __XML_DICT_H__

TYPE AS xmlDict PTR xmlDictPtr

DECLARE FUNCTION xmlDictCreate() AS xmlDictPtr
DECLARE FUNCTION xmlDictCreateSub(BYVAL AS xmlDictPtr) AS xmlDictPtr
DECLARE FUNCTION xmlDictReference(BYVAL AS xmlDictPtr) AS INTEGER
DECLARE SUB xmlDictFree(BYVAL AS xmlDictPtr)
DECLARE FUNCTION xmlDictLookup(BYVAL AS xmlDictPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS CONST xmlChar PTR
DECLARE FUNCTION xmlDictExists(BYVAL AS xmlDictPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS CONST xmlChar PTR
DECLARE FUNCTION xmlDictQLookup(BYVAL AS xmlDictPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS CONST xmlChar PTR
DECLARE FUNCTION xmlDictOwns(BYVAL AS xmlDictPtr, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlDictSize(BYVAL AS xmlDictPtr) AS INTEGER
DECLARE SUB xmlDictCleanup()

#ENDIF ' __XML_DICT_H__

DECLARE FUNCTION xmlRegexpCompile(BYVAL AS CONST xmlChar PTR) AS xmlRegexpPtr
DECLARE SUB xmlRegFreeRegexp(BYVAL AS xmlRegexpPtr)
DECLARE FUNCTION xmlRegexpExec(BYVAL AS xmlRegexpPtr, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE SUB xmlRegexpPrint(BYVAL AS FILE PTR, BYVAL AS xmlRegexpPtr)
DECLARE FUNCTION xmlRegexpIsDeterminist(BYVAL AS xmlRegexpPtr) AS INTEGER

TYPE xmlRegExecCallbacks AS SUB(BYVAL AS xmlRegExecCtxtPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR, BYVAL AS ANY PTR)

DECLARE FUNCTION xmlRegNewExecCtxt(BYVAL AS xmlRegexpPtr, BYVAL AS xmlRegExecCallbacks, BYVAL AS ANY PTR) AS xmlRegExecCtxtPtr
DECLARE SUB xmlRegFreeExecCtxt(BYVAL AS xmlRegExecCtxtPtr)
DECLARE FUNCTION xmlRegExecPushString(BYVAL AS xmlRegExecCtxtPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlRegExecPushString2(BYVAL AS xmlRegExecCtxtPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlRegExecNextValues(BYVAL AS xmlRegExecCtxtPtr, BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR, BYVAL AS xmlChar PTR PTR, BYVAL AS INTEGER PTR) AS INTEGER
DECLARE FUNCTION xmlRegExecErrInfo(BYVAL AS xmlRegExecCtxtPtr, BYVAL AS CONST xmlChar PTR PTR, BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR, BYVAL AS xmlChar PTR PTR, BYVAL AS INTEGER PTR) AS INTEGER

#IFDEF LIBXML_EXPR_ENABLED

TYPE xmlExpCtxt AS _xmlExpCtxt
TYPE AS xmlExpCtxt PTR xmlExpCtxtPtr

DECLARE SUB xmlExpFreeCtxt(BYVAL AS xmlExpCtxtPtr)
DECLARE FUNCTION xmlExpNewCtxt(BYVAL AS INTEGER, BYVAL AS xmlDictPtr) AS xmlExpCtxtPtr
DECLARE FUNCTION xmlExpCtxtNbNodes(BYVAL AS xmlExpCtxtPtr) AS INTEGER
DECLARE FUNCTION xmlExpCtxtNbCons(BYVAL AS xmlExpCtxtPtr) AS INTEGER

TYPE xmlExpNode AS _xmlExpNode
TYPE AS xmlExpNode PTR xmlExpNodePtr

ENUM xmlExpNodeType
	XML_EXP_EMPTY = 0
	XML_EXP_FORBID = 1
	XML_EXP_ATOM = 2
	XML_EXP_SEQ = 3
	XML_EXP_OR = 4
	XML_EXP_COUNT = 5
END ENUM

EXTERN AS xmlExpNodePtr forbiddenExp
EXTERN AS xmlExpNodePtr emptyExp

DECLARE SUB xmlExpFree(BYVAL AS xmlExpCtxtPtr, BYVAL AS xmlExpNodePtr)
DECLARE SUB xmlExpRef(BYVAL AS xmlExpNodePtr)
DECLARE FUNCTION xmlExpParse(BYVAL AS xmlExpCtxtPtr, BYVAL AS CONST ZSTRING PTR) AS xmlExpNodePtr
DECLARE FUNCTION xmlExpNewAtom(BYVAL AS xmlExpCtxtPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS xmlExpNodePtr
DECLARE FUNCTION xmlExpNewOr(BYVAL AS xmlExpCtxtPtr, BYVAL AS xmlExpNodePtr, BYVAL AS xmlExpNodePtr) AS xmlExpNodePtr
DECLARE FUNCTION xmlExpNewSeq(BYVAL AS xmlExpCtxtPtr, BYVAL AS xmlExpNodePtr, BYVAL AS xmlExpNodePtr) AS xmlExpNodePtr
DECLARE FUNCTION xmlExpNewRange(BYVAL AS xmlExpCtxtPtr, BYVAL AS xmlExpNodePtr, BYVAL AS INTEGER, BYVAL AS INTEGER) AS xmlExpNodePtr
DECLARE FUNCTION xmlExpIsNillable(BYVAL AS xmlExpNodePtr) AS INTEGER
DECLARE FUNCTION xmlExpMaxToken(BYVAL AS xmlExpNodePtr) AS INTEGER
DECLARE FUNCTION xmlExpGetLanguage(BYVAL AS xmlExpCtxtPtr, BYVAL AS xmlExpNodePtr, BYVAL AS CONST xmlChar PTR PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlExpGetStart(BYVAL AS xmlExpCtxtPtr, BYVAL AS xmlExpNodePtr, BYVAL AS CONST xmlChar PTR PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlExpStringDerive(BYVAL AS xmlExpCtxtPtr, BYVAL AS xmlExpNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS xmlExpNodePtr
DECLARE FUNCTION xmlExpExpDerive(BYVAL AS xmlExpCtxtPtr, BYVAL AS xmlExpNodePtr, BYVAL AS xmlExpNodePtr) AS xmlExpNodePtr
DECLARE FUNCTION xmlExpSubsume(BYVAL AS xmlExpCtxtPtr, BYVAL AS xmlExpNodePtr, BYVAL AS xmlExpNodePtr) AS INTEGER
DECLARE SUB xmlExpDump(BYVAL AS xmlBufferPtr, BYVAL AS xmlExpNodePtr)

#ENDIF ' LIBXML_EXPR_ENABLED
#ENDIF ' LIBXML_REGEXP_ENABLED
#ENDIF ' __XML_REGEXP_H__

TYPE xmlElement AS _xmlElement
TYPE AS xmlElement PTR xmlElementPtr

TYPE _xmlElement
	AS ANY PTR _private
	AS xmlElementType type
	AS CONST xmlChar PTR name
	AS _xmlNode PTR children
	AS _xmlNode PTR last
	AS _xmlDtd PTR parent
	AS _xmlNode PTR next
	AS _xmlNode PTR prev
	AS _xmlDoc PTR doc
	AS xmlElementTypeVal etype
	AS xmlElementContentPtr content
	AS xmlAttributePtr attributes
	AS CONST xmlChar PTR prefix
#IFDEF LIBXML_REGEXP_ENABLED
	AS xmlRegexpPtr contModel
#ELSE ' LIBXML_REGEXP_ENABLED
	AS ANY PTR contModel
#ENDIF ' LIBXML_REGEXP_ENABLED
END TYPE

#DEFINE XML_LOCAL_NAMESPACE XML_NAMESPACE_DECL

TYPE xmlNsType AS xmlElementType
TYPE AS xmlNs PTR xmlNsPtr

TYPE _xmlNs
	AS _xmlNs PTR next
	AS xmlNsType type
	AS CONST xmlChar PTR href
	AS CONST xmlChar PTR prefix
	AS ANY PTR _private
	AS _xmlDoc PTR context
END TYPE

TYPE AS xmlDtd PTR xmlDtdPtr

TYPE AS xmlAttr PTR xmlAttrPtr

TYPE _xmlAttr
	AS ANY PTR _private
	AS xmlElementType type
	AS CONST xmlChar PTR name
	AS _xmlNode PTR children
	AS _xmlNode PTR last
	AS _xmlNode PTR parent
	AS _xmlAttr PTR next
	AS _xmlAttr PTR prev
	AS _xmlDoc PTR doc
	AS xmlNs PTR ns
	AS xmlAttributeType atype
	AS ANY PTR psvi
END TYPE

TYPE xmlID AS _xmlID
TYPE AS xmlID PTR xmlIDPtr

TYPE _xmlID
	AS _xmlID PTR next
	AS CONST xmlChar PTR value
	AS xmlAttrPtr attr
	AS CONST xmlChar PTR name
	AS INTEGER lineno
	AS _xmlDoc PTR doc
END TYPE

TYPE xmlRef AS _xmlRef
TYPE AS xmlRef PTR xmlRefPtr

TYPE _xmlRef
	AS _xmlRef PTR next
	AS CONST xmlChar PTR value
	AS xmlAttrPtr attr
	AS CONST xmlChar PTR name
	AS INTEGER lineno
END TYPE

TYPE AS xmlNode PTR xmlNodePtr

#DEFINE XML_GET_CONTENT(n) _
    IIF((n)->type = XML_ELEMENT_NODE , NULL , (n)->content)
#DEFINE XML_GET_LINE(n) _
    (xmlGetLineNo(n))

ENUM xmlDocProperties
	XML_DOC_WELLFORMED = 1 SHL 0
	XML_DOC_NSVALID = 1 SHL 1
	XML_DOC_OLD10 = 1 SHL 2
	XML_DOC_DTDVALID = 1 SHL 3
	XML_DOC_XINCLUDE = 1 SHL 4
	XML_DOC_USERBUILT = 1 SHL 5
	XML_DOC_INTERNAL = 1 SHL 6
	XML_DOC_HTML = 1 SHL 7
END ENUM

TYPE AS xmlDoc PTR xmlDocPtr

TYPE xmlDOMWrapCtxt AS _xmlDOMWrapCtxt
TYPE AS xmlDOMWrapCtxt PTR xmlDOMWrapCtxtPtr
TYPE xmlDOMWrapAcquireNsFunction AS FUNCTION(BYVAL AS xmlDOMWrapCtxtPtr, BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlNsPtr

TYPE _xmlDOMWrapCtxt
	AS ANY PTR _private
	AS INTEGER type
	AS ANY PTR namespaceMap
	AS xmlDOMWrapAcquireNsFunction getNsForNodeFunc
END TYPE

#IFNDEF xmlChildrenNode
#DEFINE xmlChildrenNode children
#ENDIF ' xmlChildrenNode

#IFNDEF xmlRootNode
#DEFINE xmlRootNode children
#ENDIF ' xmlRootNode

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_XPATH_ENABLED) OR DEFINED(LIBXML_SCHEMAS_ENABLED) OR DEFINED(LIBXML_DEBUG_ENABLED)  OR DEFINED (LIBXML_HTML_ENABLED)  OR DEFINED(LIBXML_SAX1_ENABLED)  OR DEFINED(LIBXML_HTML_ENABLED)  OR DEFINED(LIBXML_WRITER_ENABLED) OR DEFINED(LIBXML_DOCB_ENABLED)

DECLARE FUNCTION xmlValidateNCName(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS INTEGER

#ENDIF ' DEFINED(LIBXML_...

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_SCHEMAS_ENABLED)

DECLARE FUNCTION xmlValidateQName(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlValidateName(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlValidateNMToken(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS INTEGER

#ENDIF ' DEFINED(LIBXML_...

DECLARE FUNCTION xmlBuildQName(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlChar PTR, BYVAL AS INTEGER) AS xmlChar PTR
DECLARE FUNCTION xmlSplitQName2(BYVAL AS CONST xmlChar PTR, BYVAL AS xmlChar PTR PTR) AS xmlChar PTR
DECLARE FUNCTION xmlSplitQName3(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER PTR) AS CONST xmlChar PTR
DECLARE SUB xmlSetBufferAllocationScheme(BYVAL AS xmlBufferAllocationScheme)
DECLARE FUNCTION xmlGetBufferAllocationScheme() AS xmlBufferAllocationScheme
DECLARE FUNCTION xmlBufferCreate() AS xmlBufferPtr
DECLARE FUNCTION xmlBufferCreateSize(BYVAL AS size_t) AS xmlBufferPtr
DECLARE FUNCTION xmlBufferCreateStatic(BYVAL AS ANY PTR, BYVAL AS size_t) AS xmlBufferPtr
DECLARE FUNCTION xmlBufferResize(BYVAL AS xmlBufferPtr, BYVAL AS UINTEGER) AS INTEGER
DECLARE SUB xmlBufferFree(BYVAL AS xmlBufferPtr)
DECLARE FUNCTION xmlBufferDump(BYVAL AS FILE PTR, BYVAL AS xmlBufferPtr) AS INTEGER
DECLARE FUNCTION xmlBufferAdd(BYVAL AS xmlBufferPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlBufferAddHead(BYVAL AS xmlBufferPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlBufferCat(BYVAL AS xmlBufferPtr, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlBufferCCat(BYVAL AS xmlBufferPtr, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlBufferShrink(BYVAL AS xmlBufferPtr, BYVAL AS UINTEGER) AS INTEGER
DECLARE FUNCTION xmlBufferGrow(BYVAL AS xmlBufferPtr, BYVAL AS UINTEGER) AS INTEGER
DECLARE SUB xmlBufferEmpty(BYVAL AS xmlBufferPtr)
DECLARE FUNCTION xmlBufferContent(BYVAL AS CONST xmlBufferPtr) AS CONST xmlChar PTR
DECLARE SUB xmlBufferSetAllocationScheme(BYVAL AS xmlBufferPtr, BYVAL AS xmlBufferAllocationScheme)
DECLARE FUNCTION xmlBufferLength(BYVAL AS CONST xmlBufferPtr) AS INTEGER
DECLARE FUNCTION xmlCreateIntSubset(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlDtdPtr
DECLARE FUNCTION xmlNewDtd(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlDtdPtr
DECLARE FUNCTION xmlGetIntSubset(BYVAL AS xmlDocPtr) AS xmlDtdPtr
DECLARE SUB xmlFreeDtd(BYVAL AS xmlDtdPtr)

#IFDEF LIBXML_LEGACY_ENABLED

DECLARE FUNCTION xmlNewGlobalNs(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlNsPtr

#ENDIF ' LIBXML_LEGACY_ENABLED

DECLARE FUNCTION xmlNewNs(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlNsPtr
DECLARE SUB xmlFreeNs(BYVAL AS xmlNsPtr)
DECLARE SUB xmlFreeNsList(BYVAL AS xmlNsPtr)
DECLARE FUNCTION xmlNewDoc(BYVAL AS CONST xmlChar PTR) AS xmlDocPtr
DECLARE SUB xmlFreeDoc(BYVAL AS xmlDocPtr)
DECLARE FUNCTION xmlNewDocProp(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlAttrPtr

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_HTML_ENABLED) OR DEFINED(LIBXML_SCHEMAS_ENABLED)

DECLARE FUNCTION xmlNewProp(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlAttrPtr

#ENDIF ' DEFINED(LIBXML_...

DECLARE FUNCTION xmlNewNsProp(BYVAL AS xmlNodePtr, BYVAL AS xmlNsPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlAttrPtr
DECLARE FUNCTION xmlNewNsPropEatName(BYVAL AS xmlNodePtr, BYVAL AS xmlNsPtr, BYVAL AS xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlAttrPtr
DECLARE SUB xmlFreePropList(BYVAL AS xmlAttrPtr)
DECLARE SUB xmlFreeProp(BYVAL AS xmlAttrPtr)
DECLARE FUNCTION xmlCopyProp(BYVAL AS xmlNodePtr, BYVAL AS xmlAttrPtr) AS xmlAttrPtr
DECLARE FUNCTION xmlCopyPropList(BYVAL AS xmlNodePtr, BYVAL AS xmlAttrPtr) AS xmlAttrPtr

#IFDEF LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlCopyDtd(BYVAL AS xmlDtdPtr) AS xmlDtdPtr

#ENDIF ' LIBXML_TREE_ENABLED

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_SCHEMAS_ENABLED)

DECLARE FUNCTION xmlCopyDoc(BYVAL AS xmlDocPtr, BYVAL AS INTEGER) AS xmlDocPtr

#ENDIF ' DEFINED(LIBXML_...

DECLARE FUNCTION xmlNewDocNode(BYVAL AS xmlDocPtr, BYVAL AS xmlNsPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewDocNodeEatName(BYVAL AS xmlDocPtr, BYVAL AS xmlNsPtr, BYVAL AS xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewNode(BYVAL AS xmlNsPtr, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewNodeEatName(BYVAL AS xmlNsPtr, BYVAL AS xmlChar PTR) AS xmlNodePtr

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_SCHEMAS_ENABLED)

DECLARE FUNCTION xmlNewChild(BYVAL AS xmlNodePtr, BYVAL AS xmlNsPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr

#ENDIF ' DEFINED(LIBXML_...

DECLARE FUNCTION xmlNewDocText(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewText(BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewDocPI(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewPI(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewDocTextLen(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS xmlNodePtr
DECLARE FUNCTION xmlNewTextLen(BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS xmlNodePtr
DECLARE FUNCTION xmlNewDocComment(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewComment(BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewCDataBlock(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS xmlNodePtr
DECLARE FUNCTION xmlNewCharRef(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewReference(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlCopyNode(BYVAL AS CONST xmlNodePtr, BYVAL AS INTEGER) AS xmlNodePtr
DECLARE FUNCTION xmlDocCopyNode(BYVAL AS CONST xmlNodePtr, BYVAL AS xmlDocPtr, BYVAL AS INTEGER) AS xmlNodePtr
DECLARE FUNCTION xmlDocCopyNodeList(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlNodePtr) AS xmlNodePtr
DECLARE FUNCTION xmlCopyNodeList(BYVAL AS CONST xmlNodePtr) AS xmlNodePtr

#IFDEF LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlNewTextChild(BYVAL AS xmlNodePtr, BYVAL AS xmlNsPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewDocRawNode(BYVAL AS xmlDocPtr, BYVAL AS xmlNsPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlNewDocFragment(BYVAL AS xmlDocPtr) AS xmlNodePtr

#ENDIF ' LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlGetLineNo(BYVAL AS xmlNodePtr) AS INTEGER

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_DEBUG_ENABLED)

DECLARE FUNCTION xmlGetNodePath(BYVAL AS xmlNodePtr) AS xmlChar PTR

#ENDIF ' DEFINED(LIBXML_...

DECLARE FUNCTION xmlDocGetRootElement(BYVAL AS xmlDocPtr) AS xmlNodePtr
DECLARE FUNCTION xmlGetLastChild(BYVAL AS xmlNodePtr) AS xmlNodePtr
DECLARE FUNCTION xmlNodeIsText(BYVAL AS xmlNodePtr) AS INTEGER
DECLARE FUNCTION xmlIsBlankNode(BYVAL AS xmlNodePtr) AS INTEGER

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_WRITER_ENABLED)

DECLARE FUNCTION xmlDocSetRootElement(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr) AS xmlNodePtr

#ENDIF ' DEFINED(LIBXML_...

#IFDEF LIBXML_TREE_ENABLED

DECLARE SUB xmlNodeSetName(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR)

#ENDIF ' LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlAddChild(BYVAL AS xmlNodePtr, BYVAL AS xmlNodePtr) AS xmlNodePtr
DECLARE FUNCTION xmlAddChildList(BYVAL AS xmlNodePtr, BYVAL AS xmlNodePtr) AS xmlNodePtr

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_WRITER_ENABLED)

DECLARE FUNCTION xmlReplaceNode(BYVAL AS xmlNodePtr, BYVAL AS xmlNodePtr) AS xmlNodePtr

#ENDIF ' DEFINED(LIBXML_...

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_HTML_ENABLED) OR DEFINED(LIBXML_SCHEMAS_ENABLED)

DECLARE FUNCTION xmlAddPrevSibling(BYVAL AS xmlNodePtr, BYVAL AS xmlNodePtr) AS xmlNodePtr

#ENDIF ' DEFINED(LIBXML_...

DECLARE FUNCTION xmlAddSibling(BYVAL AS xmlNodePtr, BYVAL AS xmlNodePtr) AS xmlNodePtr
DECLARE FUNCTION xmlAddNextSibling(BYVAL AS xmlNodePtr, BYVAL AS xmlNodePtr) AS xmlNodePtr
DECLARE SUB xmlUnlinkNode(BYVAL AS xmlNodePtr)
DECLARE FUNCTION xmlTextMerge(BYVAL AS xmlNodePtr, BYVAL AS xmlNodePtr) AS xmlNodePtr
DECLARE FUNCTION xmlTextConcat(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE SUB xmlFreeNodeList(BYVAL AS xmlNodePtr)
DECLARE SUB xmlFreeNode(BYVAL AS xmlNodePtr)
DECLARE SUB xmlSetTreeDoc(BYVAL AS xmlNodePtr, BYVAL AS xmlDocPtr)
DECLARE SUB xmlSetListDoc(BYVAL AS xmlNodePtr, BYVAL AS xmlDocPtr)
DECLARE FUNCTION xmlSearchNs(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR) AS xmlNsPtr
DECLARE FUNCTION xmlSearchNsByHref(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR) AS xmlNsPtr

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_XPATH_ENABLED) OR DEFINED(LIBXML_SCHEMAS_ENABLED)

DECLARE FUNCTION xmlGetNsList(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr) AS xmlNsPtr PTR

#ENDIF ' DEFINED(LIBXML_...

DECLARE SUB xmlSetNs(BYVAL AS xmlNodePtr, BYVAL AS xmlNsPtr)
DECLARE FUNCTION xmlCopyNamespace(BYVAL AS xmlNsPtr) AS xmlNsPtr
DECLARE FUNCTION xmlCopyNamespaceList(BYVAL AS xmlNsPtr) AS xmlNsPtr

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_XINCLUDE_ENABLED) OR DEFINED(LIBXML_SCHEMAS_ENABLED) OR DEFINED(LIBXML_HTML_ENABLED)

DECLARE FUNCTION xmlSetProp(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlAttrPtr
DECLARE FUNCTION xmlSetNsProp(BYVAL AS xmlNodePtr, BYVAL AS xmlNsPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlAttrPtr

#ENDIF ' DEFINED(LIBXML_...

DECLARE FUNCTION xmlGetNoNsProp(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR) AS xmlChar PTR
DECLARE FUNCTION xmlGetProp(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR) AS xmlChar PTR
DECLARE FUNCTION xmlHasProp(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR) AS xmlAttrPtr
DECLARE FUNCTION xmlHasNsProp(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlAttrPtr
DECLARE FUNCTION xmlGetNsProp(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlChar PTR
DECLARE FUNCTION xmlStringGetNodeList(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlNodePtr
DECLARE FUNCTION xmlStringLenGetNodeList(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS xmlNodePtr
DECLARE FUNCTION xmlNodeListGetString(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS INTEGER) AS xmlChar PTR

#IFDEF LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlNodeListGetRawString(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS INTEGER) AS xmlChar PTR

#ENDIF ' LIBXML_TREE_ENABLED

DECLARE SUB xmlNodeSetContent(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR)

#IFDEF LIBXML_TREE_ENABLED

DECLARE SUB xmlNodeSetContentLen(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER)

#ENDIF ' LIBXML_TREE_ENABLED

DECLARE SUB xmlNodeAddContent(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR)
DECLARE SUB xmlNodeAddContentLen(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER)
DECLARE FUNCTION xmlNodeGetContent(BYVAL AS xmlNodePtr) AS xmlChar PTR
DECLARE FUNCTION xmlNodeBufGetContent(BYVAL AS xmlBufferPtr, BYVAL AS xmlNodePtr) AS INTEGER
DECLARE FUNCTION xmlNodeGetLang(BYVAL AS xmlNodePtr) AS xmlChar PTR
DECLARE FUNCTION xmlNodeGetSpacePreserve(BYVAL AS xmlNodePtr) AS INTEGER

#IFDEF LIBXML_TREE_ENABLED

DECLARE SUB xmlNodeSetLang(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR)
DECLARE SUB xmlNodeSetSpacePreserve(BYVAL AS xmlNodePtr, BYVAL AS INTEGER)

#ENDIF ' LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlNodeGetBase(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr) AS xmlChar PTR

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_XINCLUDE_ENABLED)

DECLARE SUB xmlNodeSetBase(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR)

#ENDIF ' DEFINED(LIBXML_...

DECLARE FUNCTION xmlRemoveProp(BYVAL AS xmlAttrPtr) AS INTEGER

#IF DEFINED(LIBXML_TREE_ENABLED) OR DEFINED(LIBXML_SCHEMAS_ENABLED)

DECLARE FUNCTION xmlUnsetNsProp(BYVAL AS xmlNodePtr, BYVAL AS xmlNsPtr, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlUnsetProp(BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR) AS INTEGER

#ENDIF ' DEFINED(LIBXML_...

DECLARE SUB xmlBufferWriteCHAR(BYVAL AS xmlBufferPtr, BYVAL AS CONST xmlChar PTR)
DECLARE SUB xmlBufferWriteChar_(BYVAL AS xmlBufferPtr, BYVAL AS CONST ZSTRING PTR)
DECLARE SUB xmlBufferWriteQuotedString(BYVAL AS xmlBufferPtr, BYVAL AS CONST xmlChar PTR)

#IFDEF LIBXML_OUTPUT_ENABLED

DECLARE SUB xmlAttrSerializeTxtContent(BYVAL AS xmlBufferPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlAttrPtr, BYVAL AS CONST xmlChar PTR)

#ENDIF ' LIBXML_OUTPUT_ENABLED

#IFDEF LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlReconciliateNs(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr) AS INTEGER

#ENDIF ' LIBXML_TREE_ENABLED

#IFDEF LIBXML_OUTPUT_ENABLED

DECLARE SUB xmlDocDumpFormatMemory(BYVAL AS xmlDocPtr, BYVAL AS xmlChar PTR PTR, BYVAL AS INTEGER PTR, BYVAL AS INTEGER)
DECLARE SUB xmlDocDumpMemory(BYVAL AS xmlDocPtr, BYVAL AS xmlChar PTR PTR, BYVAL AS INTEGER PTR)
DECLARE SUB xmlDocDumpMemoryEnc(BYVAL AS xmlDocPtr, BYVAL AS xmlChar PTR PTR, BYVAL AS INTEGER PTR, BYVAL AS CONST ZSTRING PTR)
DECLARE SUB xmlDocDumpFormatMemoryEnc(BYVAL AS xmlDocPtr, BYVAL AS xmlChar PTR PTR, BYVAL AS INTEGER PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER)
DECLARE FUNCTION xmlDocFormatDump(BYVAL AS FILE PTR, BYVAL AS xmlDocPtr, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlDocDump(BYVAL AS FILE PTR, BYVAL AS xmlDocPtr) AS INTEGER
DECLARE SUB xmlElemDump(BYVAL AS FILE PTR, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr)
DECLARE FUNCTION xmlSaveFile(BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlDocPtr) AS INTEGER
DECLARE FUNCTION xmlSaveFormatFile(BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlDocPtr, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlNodeDump(BYVAL AS xmlBufferPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlSaveFileTo(BYVAL AS xmlOutputBufferPtr, BYVAL AS xmlDocPtr, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlSaveFormatFileTo(BYVAL AS xmlOutputBufferPtr, BYVAL AS xmlDocPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE SUB xmlNodeDumpOutput(BYVAL AS xmlOutputBufferPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR)
DECLARE FUNCTION xmlSaveFormatFileEnc(BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlDocPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlSaveFileEnc(BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlDocPtr, BYVAL AS CONST ZSTRING PTR) AS INTEGER

#ENDIF ' LIBXML_OUTPUT_ENABLED

DECLARE FUNCTION xmlIsXHTML(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlGetDocCompressMode(BYVAL AS xmlDocPtr) AS INTEGER
DECLARE SUB xmlSetDocCompressMode(BYVAL AS xmlDocPtr, BYVAL AS INTEGER)
DECLARE FUNCTION xmlGetCompressMode() AS INTEGER
DECLARE SUB xmlSetCompressMode(BYVAL AS INTEGER)
DECLARE FUNCTION xmlDOMWrapNewCtxt() AS xmlDOMWrapCtxtPtr
DECLARE SUB xmlDOMWrapFreeCtxt(BYVAL AS xmlDOMWrapCtxtPtr)
DECLARE FUNCTION xmlDOMWrapReconcileNamespaces(BYVAL AS xmlDOMWrapCtxtPtr, BYVAL AS xmlNodePtr, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlDOMWrapAdoptNode(BYVAL AS xmlDOMWrapCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlDOMWrapRemoveNode(BYVAL AS xmlDOMWrapCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlDOMWrapCloneNode(BYVAL AS xmlDOMWrapCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS xmlNodePtr PTR, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER

#IFDEF LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlChildElementCount(BYVAL AS xmlNodePtr) AS UINTEGER
DECLARE FUNCTION xmlNextElementSibling(BYVAL AS xmlNodePtr) AS xmlNodePtr
DECLARE FUNCTION xmlFirstElementChild(BYVAL AS xmlNodePtr) AS xmlNodePtr
DECLARE FUNCTION xmlLastElementChild(BYVAL AS xmlNodePtr) AS xmlNodePtr
DECLARE FUNCTION xmlPreviousElementSibling(BYVAL AS xmlNodePtr) AS xmlNodePtr

#ENDIF ' LIBXML_TREE_ENABLED

#IFNDEF __DEBUG_MEMORY_ALLOC__
#DEFINE __DEBUG_MEMORY_ALLOC__

#IFDEF DEBUG
#IFNDEF DEBUG_MEMORY
#DEFINE DEBUG_MEMORY
#ENDIF ' DEBUG_MEMORY
#ENDIF ' DEBUG

#IFDEF DEBUG_MEMORY_LOCATION
#ENDIF ' DEBUG_MEMORY_LOCATION

TYPE xmlFreeFunc AS SUB(BYVAL AS ANY PTR)
TYPE xmlMallocFunc AS FUNCTION(BYVAL AS size_t) AS ANY PTR
TYPE xmlReallocFunc AS FUNCTION(BYVAL AS ANY PTR, BYVAL AS size_t) AS ANY PTR
TYPE xmlStrdupFunc AS FUNCTION(BYVAL AS CONST ZSTRING PTR) AS ZSTRING PTR

DECLARE FUNCTION xmlMemSetup(BYVAL AS xmlFreeFunc, BYVAL AS xmlMallocFunc, BYVAL AS xmlReallocFunc, BYVAL AS xmlStrdupFunc) AS INTEGER
DECLARE FUNCTION xmlMemGet(BYVAL AS xmlFreeFunc, BYVAL AS xmlMallocFunc PTR, BYVAL AS xmlReallocFunc, BYVAL AS xmlStrdupFunc) AS INTEGER
DECLARE FUNCTION xmlGcMemSetup(BYVAL AS xmlFreeFunc, BYVAL AS xmlMallocFunc, BYVAL AS xmlMallocFunc, BYVAL AS xmlReallocFunc, BYVAL AS xmlStrdupFunc) AS INTEGER
DECLARE FUNCTION xmlGcMemGet(BYVAL AS xmlFreeFunc, BYVAL AS xmlMallocFunc PTR, BYVAL AS xmlMallocFunc PTR, BYVAL AS xmlReallocFunc, BYVAL AS xmlStrdupFunc) AS INTEGER
DECLARE FUNCTION xmlInitMemory() AS INTEGER
DECLARE SUB xmlCleanupMemory()
DECLARE FUNCTION xmlMemUsed() AS INTEGER
DECLARE FUNCTION xmlMemBlocks() AS INTEGER
DECLARE SUB xmlMemDisplay(BYVAL AS FILE PTR)
DECLARE SUB xmlMemDisplayLast(BYVAL AS FILE PTR, BYVAL AS INTEGER)
DECLARE SUB xmlMemShow(BYVAL AS FILE PTR, BYVAL AS INTEGER)
DECLARE SUB xmlMemoryDump()
DECLARE FUNCTION xmlMemMalloc(BYVAL AS size_t) AS ANY PTR
DECLARE FUNCTION xmlMemRealloc(BYVAL AS ANY PTR, BYVAL AS size_t) AS ANY PTR
DECLARE SUB xmlMemFree(BYVAL AS ANY PTR)
DECLARE FUNCTION xmlMemoryStrdup(BYVAL AS CONST ZSTRING PTR) AS ZSTRING PTR
DECLARE FUNCTION xmlMallocLoc(BYVAL AS size_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS ANY PTR
DECLARE FUNCTION xmlReallocLoc(BYVAL AS ANY PTR, BYVAL AS size_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS ANY PTR
DECLARE FUNCTION xmlMallocAtomicLoc(BYVAL AS size_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS ANY PTR
DECLARE FUNCTION xmlMemStrdupLoc(BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS ZSTRING PTR

#IFDEF DEBUG_MEMORY_LOCATION
#DEFINE xmlMalloc(size) xmlMallocLoc((size), __FILE__, __LINE__)
#DEFINE xmlMallocAtomic(size) xmlMallocAtomicLoc((size), __FILE__, __LINE__)
#DEFINE xmlRealloc(ptr, size) xmlReallocLoc((ptr), (size), __FILE__, __LINE__)
#DEFINE xmlMemStrdup(str) xmlMemStrdupLoc((str), __FILE__, __LINE__)
#ENDIF ' DEBUG_MEMORY_LOCATION

#IFNDEF __XML_THREADS_H__
#DEFINE __XML_THREADS_H__

TYPE xmlMutex AS _xmlMutex
TYPE AS xmlMutex PTR xmlMutexPtr
TYPE xmlRMutex AS _xmlRMutex
TYPE AS xmlRMutex PTR xmlRMutexPtr

#IFNDEF __XML_GLOBALS_H
#DEFINE __XML_GLOBALS_H

#IFNDEF __XML_ERROR_H__
#DEFINE __XML_ERROR_H__

ENUM xmlErrorLevel
	XML_ERR_NONE = 0
	XML_ERR_WARNING = 1
	XML_ERR_ERROR = 2
	XML_ERR_FATAL = 3
END ENUM

ENUM xmlErrorDomain
	XML_FROM_NONE = 0
	XML_FROM_PARSER
	XML_FROM_TREE
	XML_FROM_NAMESPACE
	XML_FROM_DTD
	XML_FROM_HTML
	XML_FROM_MEMORY
	XML_FROM_OUTPUT
	XML_FROM_IO
	XML_FROM_FTP
	XML_FROM_HTTP
	XML_FROM_XINCLUDE
	XML_FROM_XPATH
	XML_FROM_XPOINTER
	XML_FROM_REGEXP
	XML_FROM_DATATYPE
	XML_FROM_SCHEMASP
	XML_FROM_SCHEMASV
	XML_FROM_RELAXNGP
	XML_FROM_RELAXNGV
	XML_FROM_CATALOG
	XML_FROM_C14N
	XML_FROM_XSLT
	XML_FROM_VALID
	XML_FROM_CHECK
	XML_FROM_WRITER
	XML_FROM_MODULE
	XML_FROM_I18N
	XML_FROM_SCHEMATRONV
END ENUM

TYPE xmlError AS _xmlError
TYPE AS xmlError PTR xmlErrorPtr

TYPE _xmlError
	AS INTEGER domain
	AS INTEGER code
	AS ZSTRING PTR message
	AS xmlErrorLevel level
	AS ZSTRING PTR file
	AS INTEGER line
	AS ZSTRING PTR str1
	AS ZSTRING PTR str2
	AS ZSTRING PTR str3
	AS INTEGER int1
	AS INTEGER int2
	AS ANY PTR ctxt
	AS ANY PTR node
END TYPE

ENUM xmlParserErrors
	XML_ERR_OK = 0
	XML_ERR_INTERNAL_ERROR
	XML_ERR_NO_MEMORY
	XML_ERR_DOCUMENT_START
	XML_ERR_DOCUMENT_EMPTY
	XML_ERR_DOCUMENT_END
	XML_ERR_INVALID_HEX_CHARREF
	XML_ERR_INVALID_DEC_CHARREF
	XML_ERR_INVALID_CHARREF
	XML_ERR_INVALID_CHAR
	XML_ERR_CHARREF_AT_EOF
	XML_ERR_CHARREF_IN_PROLOG
	XML_ERR_CHARREF_IN_EPILOG
	XML_ERR_CHARREF_IN_DTD
	XML_ERR_ENTITYREF_AT_EOF
	XML_ERR_ENTITYREF_IN_PROLOG
	XML_ERR_ENTITYREF_IN_EPILOG
	XML_ERR_ENTITYREF_IN_DTD
	XML_ERR_PEREF_AT_EOF
	XML_ERR_PEREF_IN_PROLOG
	XML_ERR_PEREF_IN_EPILOG
	XML_ERR_PEREF_IN_INT_SUBSET
	XML_ERR_ENTITYREF_NO_NAME
	XML_ERR_ENTITYREF_SEMICOL_MISSING
	XML_ERR_PEREF_NO_NAME
	XML_ERR_PEREF_SEMICOL_MISSING
	XML_ERR_UNDECLARED_ENTITY
	XML_WAR_UNDECLARED_ENTITY
	XML_ERR_UNPARSED_ENTITY
	XML_ERR_ENTITY_IS_EXTERNAL
	XML_ERR_ENTITY_IS_PARAMETER
	XML_ERR_UNKNOWN_ENCODING
	XML_ERR_UNSUPPORTED_ENCODING
	XML_ERR_STRING_NOT_STARTED
	XML_ERR_STRING_NOT_CLOSED
	XML_ERR_NS_DECL_ERROR
	XML_ERR_ENTITY_NOT_STARTED
	XML_ERR_ENTITY_NOT_FINISHED
	XML_ERR_LT_IN_ATTRIBUTE
	XML_ERR_ATTRIBUTE_NOT_STARTED
	XML_ERR_ATTRIBUTE_NOT_FINISHED
	XML_ERR_ATTRIBUTE_WITHOUT_VALUE
	XML_ERR_ATTRIBUTE_REDEFINED
	XML_ERR_LITERAL_NOT_STARTED
	XML_ERR_LITERAL_NOT_FINISHED
	XML_ERR_COMMENT_NOT_FINISHED
	XML_ERR_PI_NOT_STARTED
	XML_ERR_PI_NOT_FINISHED
	XML_ERR_NOTATION_NOT_STARTED
	XML_ERR_NOTATION_NOT_FINISHED
	XML_ERR_ATTLIST_NOT_STARTED
	XML_ERR_ATTLIST_NOT_FINISHED
	XML_ERR_MIXED_NOT_STARTED
	XML_ERR_MIXED_NOT_FINISHED
	XML_ERR_ELEMCONTENT_NOT_STARTED
	XML_ERR_ELEMCONTENT_NOT_FINISHED
	XML_ERR_XMLDECL_NOT_STARTED
	XML_ERR_XMLDECL_NOT_FINISHED
	XML_ERR_CONDSEC_NOT_STARTED
	XML_ERR_CONDSEC_NOT_FINISHED
	XML_ERR_EXT_SUBSET_NOT_FINISHED
	XML_ERR_DOCTYPE_NOT_FINISHED
	XML_ERR_MISPLACED_CDATA_END
	XML_ERR_CDATA_NOT_FINISHED
	XML_ERR_RESERVED_XML_NAME
	XML_ERR_SPACE_REQUIRED
	XML_ERR_SEPARATOR_REQUIRED
	XML_ERR_NMTOKEN_REQUIRED
	XML_ERR_NAME_REQUIRED
	XML_ERR_PCDATA_REQUIRED
	XML_ERR_URI_REQUIRED
	XML_ERR_PUBID_REQUIRED
	XML_ERR_LT_REQUIRED
	XML_ERR_GT_REQUIRED
	XML_ERR_LTSLASH_REQUIRED
	XML_ERR_EQUAL_REQUIRED
	XML_ERR_TAG_NAME_MISMATCH
	XML_ERR_TAG_NOT_FINISHED
	XML_ERR_STANDALONE_VALUE
	XML_ERR_ENCODING_NAME
	XML_ERR_HYPHEN_IN_COMMENT
	XML_ERR_INVALID_ENCODING
	XML_ERR_EXT_ENTITY_STANDALONE
	XML_ERR_CONDSEC_INVALID
	XML_ERR_VALUE_REQUIRED
	XML_ERR_NOT_WELL_BALANCED
	XML_ERR_EXTRA_CONTENT
	XML_ERR_ENTITY_CHAR_ERROR
	XML_ERR_ENTITY_PE_INTERNAL
	XML_ERR_ENTITY_LOOP
	XML_ERR_ENTITY_BOUNDARY
	XML_ERR_INVALID_URI
	XML_ERR_URI_FRAGMENT
	XML_WAR_CATALOG_PI
	XML_ERR_NO_DTD
	XML_ERR_CONDSEC_INVALID_KEYWORD
	XML_ERR_VERSION_MISSING
	XML_WAR_UNKNOWN_VERSION
	XML_WAR_LANG_VALUE
	XML_WAR_NS_URI
	XML_WAR_NS_URI_RELATIVE
	XML_ERR_MISSING_ENCODING
	XML_WAR_SPACE_VALUE
	XML_ERR_NOT_STANDALONE
	XML_ERR_ENTITY_PROCESSING
	XML_ERR_NOTATION_PROCESSING
	XML_WAR_NS_COLUMN
	XML_WAR_ENTITY_REDEFINED
	XML_ERR_UNKNOWN_VERSION
	XML_ERR_VERSION_MISMATCH
	XML_NS_ERR_XML_NAMESPACE = 200
	XML_NS_ERR_UNDEFINED_NAMESPACE
	XML_NS_ERR_QNAME
	XML_NS_ERR_ATTRIBUTE_REDEFINED
	XML_NS_ERR_EMPTY
	XML_NS_ERR_COLON
	XML_DTD_ATTRIBUTE_DEFAULT = 500
	XML_DTD_ATTRIBUTE_REDEFINED
	XML_DTD_ATTRIBUTE_VALUE
	XML_DTD_CONTENT_ERROR
	XML_DTD_CONTENT_MODEL
	XML_DTD_CONTENT_NOT_DETERMINIST
	XML_DTD_DIFFERENT_PREFIX
	XML_DTD_ELEM_DEFAULT_NAMESPACE
	XML_DTD_ELEM_NAMESPACE
	XML_DTD_ELEM_REDEFINED
	XML_DTD_EMPTY_NOTATION
	XML_DTD_ENTITY_TYPE
	XML_DTD_ID_FIXED
	XML_DTD_ID_REDEFINED
	XML_DTD_ID_SUBSET
	XML_DTD_INVALID_CHILD
	XML_DTD_INVALID_DEFAULT
	XML_DTD_LOAD_ERROR
	XML_DTD_MISSING_ATTRIBUTE
	XML_DTD_MIXED_CORRUPT
	XML_DTD_MULTIPLE_ID
	XML_DTD_NO_DOC
	XML_DTD_NO_DTD
	XML_DTD_NO_ELEM_NAME
	XML_DTD_NO_PREFIX
	XML_DTD_NO_ROOT
	XML_DTD_NOTATION_REDEFINED
	XML_DTD_NOTATION_VALUE
	XML_DTD_NOT_EMPTY
	XML_DTD_NOT_PCDATA
	XML_DTD_NOT_STANDALONE
	XML_DTD_ROOT_NAME
	XML_DTD_STANDALONE_WHITE_SPACE
	XML_DTD_UNKNOWN_ATTRIBUTE
	XML_DTD_UNKNOWN_ELEM
	XML_DTD_UNKNOWN_ENTITY
	XML_DTD_UNKNOWN_ID
	XML_DTD_UNKNOWN_NOTATION
	XML_DTD_STANDALONE_DEFAULTED
	XML_DTD_XMLID_VALUE
	XML_DTD_XMLID_TYPE
	XML_DTD_DUP_TOKEN
	XML_HTML_STRUCURE_ERROR = 800
	XML_HTML_UNKNOWN_TAG
	XML_RNGP_ANYNAME_ATTR_ANCESTOR = 1000
	XML_RNGP_ATTR_CONFLICT
	XML_RNGP_ATTRIBUTE_CHILDREN
	XML_RNGP_ATTRIBUTE_CONTENT
	XML_RNGP_ATTRIBUTE_EMPTY
	XML_RNGP_ATTRIBUTE_NOOP
	XML_RNGP_CHOICE_CONTENT
	XML_RNGP_CHOICE_EMPTY
	XML_RNGP_CREATE_FAILURE
	XML_RNGP_DATA_CONTENT
	XML_RNGP_DEF_CHOICE_AND_INTERLEAVE
	XML_RNGP_DEFINE_CREATE_FAILED
	XML_RNGP_DEFINE_EMPTY
	XML_RNGP_DEFINE_MISSING
	XML_RNGP_DEFINE_NAME_MISSING
	XML_RNGP_ELEM_CONTENT_EMPTY
	XML_RNGP_ELEM_CONTENT_ERROR
	XML_RNGP_ELEMENT_EMPTY
	XML_RNGP_ELEMENT_CONTENT
	XML_RNGP_ELEMENT_NAME
	XML_RNGP_ELEMENT_NO_CONTENT
	XML_RNGP_ELEM_TEXT_CONFLICT
	XML_RNGP_EMPTY
	XML_RNGP_EMPTY_CONSTRUCT
	XML_RNGP_EMPTY_CONTENT
	XML_RNGP_EMPTY_NOT_EMPTY
	XML_RNGP_ERROR_TYPE_LIB
	XML_RNGP_EXCEPT_EMPTY
	XML_RNGP_EXCEPT_MISSING
	XML_RNGP_EXCEPT_MULTIPLE
	XML_RNGP_EXCEPT_NO_CONTENT
	XML_RNGP_EXTERNALREF_EMTPY
	XML_RNGP_EXTERNAL_REF_FAILURE
	XML_RNGP_EXTERNALREF_RECURSE
	XML_RNGP_FORBIDDEN_ATTRIBUTE
	XML_RNGP_FOREIGN_ELEMENT
	XML_RNGP_GRAMMAR_CONTENT
	XML_RNGP_GRAMMAR_EMPTY
	XML_RNGP_GRAMMAR_MISSING
	XML_RNGP_GRAMMAR_NO_START
	XML_RNGP_GROUP_ATTR_CONFLICT
	XML_RNGP_HREF_ERROR
	XML_RNGP_INCLUDE_EMPTY
	XML_RNGP_INCLUDE_FAILURE
	XML_RNGP_INCLUDE_RECURSE
	XML_RNGP_INTERLEAVE_ADD
	XML_RNGP_INTERLEAVE_CREATE_FAILED
	XML_RNGP_INTERLEAVE_EMPTY
	XML_RNGP_INTERLEAVE_NO_CONTENT
	XML_RNGP_INVALID_DEFINE_NAME
	XML_RNGP_INVALID_URI
	XML_RNGP_INVALID_VALUE
	XML_RNGP_MISSING_HREF
	XML_RNGP_NAME_MISSING
	XML_RNGP_NEED_COMBINE
	XML_RNGP_NOTALLOWED_NOT_EMPTY
	XML_RNGP_NSNAME_ATTR_ANCESTOR
	XML_RNGP_NSNAME_NO_NS
	XML_RNGP_PARAM_FORBIDDEN
	XML_RNGP_PARAM_NAME_MISSING
	XML_RNGP_PARENTREF_CREATE_FAILED
	XML_RNGP_PARENTREF_NAME_INVALID
	XML_RNGP_PARENTREF_NO_NAME
	XML_RNGP_PARENTREF_NO_PARENT
	XML_RNGP_PARENTREF_NOT_EMPTY
	XML_RNGP_PARSE_ERROR
	XML_RNGP_PAT_ANYNAME_EXCEPT_ANYNAME
	XML_RNGP_PAT_ATTR_ATTR
	XML_RNGP_PAT_ATTR_ELEM
	XML_RNGP_PAT_DATA_EXCEPT_ATTR
	XML_RNGP_PAT_DATA_EXCEPT_ELEM
	XML_RNGP_PAT_DATA_EXCEPT_EMPTY
	XML_RNGP_PAT_DATA_EXCEPT_GROUP
	XML_RNGP_PAT_DATA_EXCEPT_INTERLEAVE
	XML_RNGP_PAT_DATA_EXCEPT_LIST
	XML_RNGP_PAT_DATA_EXCEPT_ONEMORE
	XML_RNGP_PAT_DATA_EXCEPT_REF
	XML_RNGP_PAT_DATA_EXCEPT_TEXT
	XML_RNGP_PAT_LIST_ATTR
	XML_RNGP_PAT_LIST_ELEM
	XML_RNGP_PAT_LIST_INTERLEAVE
	XML_RNGP_PAT_LIST_LIST
	XML_RNGP_PAT_LIST_REF
	XML_RNGP_PAT_LIST_TEXT
	XML_RNGP_PAT_NSNAME_EXCEPT_ANYNAME
	XML_RNGP_PAT_NSNAME_EXCEPT_NSNAME
	XML_RNGP_PAT_ONEMORE_GROUP_ATTR
	XML_RNGP_PAT_ONEMORE_INTERLEAVE_ATTR
	XML_RNGP_PAT_START_ATTR
	XML_RNGP_PAT_START_DATA
	XML_RNGP_PAT_START_EMPTY
	XML_RNGP_PAT_START_GROUP
	XML_RNGP_PAT_START_INTERLEAVE
	XML_RNGP_PAT_START_LIST
	XML_RNGP_PAT_START_ONEMORE
	XML_RNGP_PAT_START_TEXT
	XML_RNGP_PAT_START_VALUE
	XML_RNGP_PREFIX_UNDEFINED
	XML_RNGP_REF_CREATE_FAILED
	XML_RNGP_REF_CYCLE
	XML_RNGP_REF_NAME_INVALID
	XML_RNGP_REF_NO_DEF
	XML_RNGP_REF_NO_NAME
	XML_RNGP_REF_NOT_EMPTY
	XML_RNGP_START_CHOICE_AND_INTERLEAVE
	XML_RNGP_START_CONTENT
	XML_RNGP_START_EMPTY
	XML_RNGP_START_MISSING
	XML_RNGP_TEXT_EXPECTED
	XML_RNGP_TEXT_HAS_CHILD
	XML_RNGP_TYPE_MISSING
	XML_RNGP_TYPE_NOT_FOUND
	XML_RNGP_TYPE_VALUE
	XML_RNGP_UNKNOWN_ATTRIBUTE
	XML_RNGP_UNKNOWN_COMBINE
	XML_RNGP_UNKNOWN_CONSTRUCT
	XML_RNGP_UNKNOWN_TYPE_LIB
	XML_RNGP_URI_FRAGMENT
	XML_RNGP_URI_NOT_ABSOLUTE
	XML_RNGP_VALUE_EMPTY
	XML_RNGP_VALUE_NO_CONTENT
	XML_RNGP_XMLNS_NAME
	XML_RNGP_XML_NS
	XML_XPATH_EXPRESSION_OK = 1200
	XML_XPATH_NUMBER_ERROR
	XML_XPATH_UNFINISHED_LITERAL_ERROR
	XML_XPATH_START_LITERAL_ERROR
	XML_XPATH_VARIABLE_REF_ERROR
	XML_XPATH_UNDEF_VARIABLE_ERROR
	XML_XPATH_INVALID_PREDICATE_ERROR
	XML_XPATH_EXPR_ERROR
	XML_XPATH_UNCLOSED_ERROR
	XML_XPATH_UNKNOWN_FUNC_ERROR
	XML_XPATH_INVALID_OPERAND
	XML_XPATH_INVALID_TYPE
	XML_XPATH_INVALID_ARITY
	XML_XPATH_INVALID_CTXT_SIZE
	XML_XPATH_INVALID_CTXT_POSITION
	XML_XPATH_MEMORY_ERROR
	XML_XPTR_SYNTAX_ERROR
	XML_XPTR_RESOURCE_ERROR
	XML_XPTR_SUB_RESOURCE_ERROR
	XML_XPATH_UNDEF_PREFIX_ERROR
	XML_XPATH_ENCODING_ERROR
	XML_XPATH_INVALID_CHAR_ERROR
	XML_TREE_INVALID_HEX = 1300
	XML_TREE_INVALID_DEC
	XML_TREE_UNTERMINATED_ENTITY
	XML_TREE_NOT_UTF8
	XML_SAVE_NOT_UTF8 = 1400
	XML_SAVE_CHAR_INVALID
	XML_SAVE_NO_DOCTYPE
	XML_SAVE_UNKNOWN_ENCODING
	XML_REGEXP_COMPILE_ERROR = 1450
	XML_IO_UNKNOWN = 1500
	XML_IO_EACCES
	XML_IO_EAGAIN
	XML_IO_EBADF
	XML_IO_EBADMSG
	XML_IO_EBUSY
	XML_IO_ECANCELED
	XML_IO_ECHILD
	XML_IO_EDEADLK
	XML_IO_EDOM
	XML_IO_EEXIST
	XML_IO_EFAULT
	XML_IO_EFBIG
	XML_IO_EINPROGRESS
	XML_IO_EINTR
	XML_IO_EINVAL
	XML_IO_EIO
	XML_IO_EISDIR
	XML_IO_EMFILE
	XML_IO_EMLINK
	XML_IO_EMSGSIZE
	XML_IO_ENAMETOOLONG
	XML_IO_ENFILE
	XML_IO_ENODEV
	XML_IO_ENOENT
	XML_IO_ENOEXEC
	XML_IO_ENOLCK
	XML_IO_ENOMEM
	XML_IO_ENOSPC
	XML_IO_ENOSYS
	XML_IO_ENOTDIR
	XML_IO_ENOTEMPTY
	XML_IO_ENOTSUP
	XML_IO_ENOTTY
	XML_IO_ENXIO
	XML_IO_EPERM
	XML_IO_EPIPE
	XML_IO_ERANGE
	XML_IO_EROFS
	XML_IO_ESPIPE
	XML_IO_ESRCH
	XML_IO_ETIMEDOUT
	XML_IO_EXDEV
	XML_IO_NETWORK_ATTEMPT
	XML_IO_ENCODER
	XML_IO_FLUSH
	XML_IO_WRITE
	XML_IO_NO_INPUT
	XML_IO_BUFFER_FULL
	XML_IO_LOAD_ERROR
	XML_IO_ENOTSOCK
	XML_IO_EISCONN
	XML_IO_ECONNREFUSED
	XML_IO_ENETUNREACH
	XML_IO_EADDRINUSE
	XML_IO_EALREADY
	XML_IO_EAFNOSUPPORT
	XML_XINCLUDE_RECURSION = 1600
	XML_XINCLUDE_PARSE_VALUE
	XML_XINCLUDE_ENTITY_DEF_MISMATCH
	XML_XINCLUDE_NO_HREF
	XML_XINCLUDE_NO_FALLBACK
	XML_XINCLUDE_HREF_URI
	XML_XINCLUDE_TEXT_FRAGMENT
	XML_XINCLUDE_TEXT_DOCUMENT
	XML_XINCLUDE_INVALID_CHAR
	XML_XINCLUDE_BUILD_FAILED
	XML_XINCLUDE_UNKNOWN_ENCODING
	XML_XINCLUDE_MULTIPLE_ROOT
	XML_XINCLUDE_XPTR_FAILED
	XML_XINCLUDE_XPTR_RESULT
	XML_XINCLUDE_INCLUDE_IN_INCLUDE
	XML_XINCLUDE_FALLBACKS_IN_INCLUDE
	XML_XINCLUDE_FALLBACK_NOT_IN_INCLUDE
	XML_XINCLUDE_DEPRECATED_NS
	XML_XINCLUDE_FRAGMENT_ID
	XML_CATALOG_MISSING_ATTR = 1650
	XML_CATALOG_ENTRY_BROKEN
	XML_CATALOG_PREFER_VALUE
	XML_CATALOG_NOT_CATALOG
	XML_CATALOG_RECURSION
	XML_SCHEMAP_PREFIX_UNDEFINED = 1700
	XML_SCHEMAP_ATTRFORMDEFAULT_VALUE
	XML_SCHEMAP_ATTRGRP_NONAME_NOREF
	XML_SCHEMAP_ATTR_NONAME_NOREF
	XML_SCHEMAP_COMPLEXTYPE_NONAME_NOREF
	XML_SCHEMAP_ELEMFORMDEFAULT_VALUE
	XML_SCHEMAP_ELEM_NONAME_NOREF
	XML_SCHEMAP_EXTENSION_NO_BASE
	XML_SCHEMAP_FACET_NO_VALUE
	XML_SCHEMAP_FAILED_BUILD_IMPORT
	XML_SCHEMAP_GROUP_NONAME_NOREF
	XML_SCHEMAP_IMPORT_NAMESPACE_NOT_URI
	XML_SCHEMAP_IMPORT_REDEFINE_NSNAME
	XML_SCHEMAP_IMPORT_SCHEMA_NOT_URI
	XML_SCHEMAP_INVALID_BOOLEAN
	XML_SCHEMAP_INVALID_ENUM
	XML_SCHEMAP_INVALID_FACET
	XML_SCHEMAP_INVALID_FACET_VALUE
	XML_SCHEMAP_INVALID_MAXOCCURS
	XML_SCHEMAP_INVALID_MINOCCURS
	XML_SCHEMAP_INVALID_REF_AND_SUBTYPE
	XML_SCHEMAP_INVALID_WHITE_SPACE
	XML_SCHEMAP_NOATTR_NOREF
	XML_SCHEMAP_NOTATION_NO_NAME
	XML_SCHEMAP_NOTYPE_NOREF
	XML_SCHEMAP_REF_AND_SUBTYPE
	XML_SCHEMAP_RESTRICTION_NONAME_NOREF
	XML_SCHEMAP_SIMPLETYPE_NONAME
	XML_SCHEMAP_TYPE_AND_SUBTYPE
	XML_SCHEMAP_UNKNOWN_ALL_CHILD
	XML_SCHEMAP_UNKNOWN_ANYATTRIBUTE_CHILD
	XML_SCHEMAP_UNKNOWN_ATTR_CHILD
	XML_SCHEMAP_UNKNOWN_ATTRGRP_CHILD
	XML_SCHEMAP_UNKNOWN_ATTRIBUTE_GROUP
	XML_SCHEMAP_UNKNOWN_BASE_TYPE
	XML_SCHEMAP_UNKNOWN_CHOICE_CHILD
	XML_SCHEMAP_UNKNOWN_COMPLEXCONTENT_CHILD
	XML_SCHEMAP_UNKNOWN_COMPLEXTYPE_CHILD
	XML_SCHEMAP_UNKNOWN_ELEM_CHILD
	XML_SCHEMAP_UNKNOWN_EXTENSION_CHILD
	XML_SCHEMAP_UNKNOWN_FACET_CHILD
	XML_SCHEMAP_UNKNOWN_FACET_TYPE
	XML_SCHEMAP_UNKNOWN_GROUP_CHILD
	XML_SCHEMAP_UNKNOWN_IMPORT_CHILD
	XML_SCHEMAP_UNKNOWN_LIST_CHILD
	XML_SCHEMAP_UNKNOWN_NOTATION_CHILD
	XML_SCHEMAP_UNKNOWN_PROCESSCONTENT_CHILD
	XML_SCHEMAP_UNKNOWN_REF
	XML_SCHEMAP_UNKNOWN_RESTRICTION_CHILD
	XML_SCHEMAP_UNKNOWN_SCHEMAS_CHILD
	XML_SCHEMAP_UNKNOWN_SEQUENCE_CHILD
	XML_SCHEMAP_UNKNOWN_SIMPLECONTENT_CHILD
	XML_SCHEMAP_UNKNOWN_SIMPLETYPE_CHILD
	XML_SCHEMAP_UNKNOWN_TYPE
	XML_SCHEMAP_UNKNOWN_UNION_CHILD
	XML_SCHEMAP_ELEM_DEFAULT_FIXED
	XML_SCHEMAP_REGEXP_INVALID
	XML_SCHEMAP_FAILED_LOAD
	XML_SCHEMAP_NOTHING_TO_PARSE
	XML_SCHEMAP_NOROOT
	XML_SCHEMAP_REDEFINED_GROUP
	XML_SCHEMAP_REDEFINED_TYPE
	XML_SCHEMAP_REDEFINED_ELEMENT
	XML_SCHEMAP_REDEFINED_ATTRGROUP
	XML_SCHEMAP_REDEFINED_ATTR
	XML_SCHEMAP_REDEFINED_NOTATION
	XML_SCHEMAP_FAILED_PARSE
	XML_SCHEMAP_UNKNOWN_PREFIX
	XML_SCHEMAP_DEF_AND_PREFIX
	XML_SCHEMAP_UNKNOWN_INCLUDE_CHILD
	XML_SCHEMAP_INCLUDE_SCHEMA_NOT_URI
	XML_SCHEMAP_INCLUDE_SCHEMA_NO_URI
	XML_SCHEMAP_NOT_SCHEMA
	XML_SCHEMAP_UNKNOWN_MEMBER_TYPE
	XML_SCHEMAP_INVALID_ATTR_USE
	XML_SCHEMAP_RECURSIVE
	XML_SCHEMAP_SUPERNUMEROUS_LIST_ITEM_TYPE
	XML_SCHEMAP_INVALID_ATTR_COMBINATION
	XML_SCHEMAP_INVALID_ATTR_INLINE_COMBINATION
	XML_SCHEMAP_MISSING_SIMPLETYPE_CHILD
	XML_SCHEMAP_INVALID_ATTR_NAME
	XML_SCHEMAP_REF_AND_CONTENT
	XML_SCHEMAP_CT_PROPS_CORRECT_1
	XML_SCHEMAP_CT_PROPS_CORRECT_2
	XML_SCHEMAP_CT_PROPS_CORRECT_3
	XML_SCHEMAP_CT_PROPS_CORRECT_4
	XML_SCHEMAP_CT_PROPS_CORRECT_5
	XML_SCHEMAP_DERIVATION_OK_RESTRICTION_1
	XML_SCHEMAP_DERIVATION_OK_RESTRICTION_2_1_1
	XML_SCHEMAP_DERIVATION_OK_RESTRICTION_2_1_2
	XML_SCHEMAP_DERIVATION_OK_RESTRICTION_2_2
	XML_SCHEMAP_DERIVATION_OK_RESTRICTION_3
	XML_SCHEMAP_WILDCARD_INVALID_NS_MEMBER
	XML_SCHEMAP_INTERSECTION_NOT_EXPRESSIBLE
	XML_SCHEMAP_UNION_NOT_EXPRESSIBLE
	XML_SCHEMAP_SRC_IMPORT_3_1
	XML_SCHEMAP_SRC_IMPORT_3_2
	XML_SCHEMAP_DERIVATION_OK_RESTRICTION_4_1
	XML_SCHEMAP_DERIVATION_OK_RESTRICTION_4_2
	XML_SCHEMAP_DERIVATION_OK_RESTRICTION_4_3
	XML_SCHEMAP_COS_CT_EXTENDS_1_3
	XML_SCHEMAV_NOROOT = 1801
	XML_SCHEMAV_UNDECLAREDELEM
	XML_SCHEMAV_NOTTOPLEVEL
	XML_SCHEMAV_MISSING
	XML_SCHEMAV_WRONGELEM
	XML_SCHEMAV_NOTYPE
	XML_SCHEMAV_NOROLLBACK
	XML_SCHEMAV_ISABSTRACT
	XML_SCHEMAV_NOTEMPTY
	XML_SCHEMAV_ELEMCONT
	XML_SCHEMAV_HAVEDEFAULT
	XML_SCHEMAV_NOTNILLABLE
	XML_SCHEMAV_EXTRACONTENT
	XML_SCHEMAV_INVALIDATTR
	XML_SCHEMAV_INVALIDELEM
	XML_SCHEMAV_NOTDETERMINIST
	XML_SCHEMAV_CONSTRUCT
	XML_SCHEMAV_INTERNAL
	XML_SCHEMAV_NOTSIMPLE
	XML_SCHEMAV_ATTRUNKNOWN
	XML_SCHEMAV_ATTRINVALID
	XML_SCHEMAV_VALUE
	XML_SCHEMAV_FACET
	XML_SCHEMAV_CVC_DATATYPE_VALID_1_2_1
	XML_SCHEMAV_CVC_DATATYPE_VALID_1_2_2
	XML_SCHEMAV_CVC_DATATYPE_VALID_1_2_3
	XML_SCHEMAV_CVC_TYPE_3_1_1
	XML_SCHEMAV_CVC_TYPE_3_1_2
	XML_SCHEMAV_CVC_FACET_VALID
	XML_SCHEMAV_CVC_LENGTH_VALID
	XML_SCHEMAV_CVC_MINLENGTH_VALID
	XML_SCHEMAV_CVC_MAXLENGTH_VALID
	XML_SCHEMAV_CVC_MININCLUSIVE_VALID
	XML_SCHEMAV_CVC_MAXINCLUSIVE_VALID
	XML_SCHEMAV_CVC_MINEXCLUSIVE_VALID
	XML_SCHEMAV_CVC_MAXEXCLUSIVE_VALID
	XML_SCHEMAV_CVC_TOTALDIGITS_VALID
	XML_SCHEMAV_CVC_FRACTIONDIGITS_VALID
	XML_SCHEMAV_CVC_PATTERN_VALID
	XML_SCHEMAV_CVC_ENUMERATION_VALID
	XML_SCHEMAV_CVC_COMPLEX_TYPE_2_1
	XML_SCHEMAV_CVC_COMPLEX_TYPE_2_2
	XML_SCHEMAV_CVC_COMPLEX_TYPE_2_3
	XML_SCHEMAV_CVC_COMPLEX_TYPE_2_4
	XML_SCHEMAV_CVC_ELT_1
	XML_SCHEMAV_CVC_ELT_2
	XML_SCHEMAV_CVC_ELT_3_1
	XML_SCHEMAV_CVC_ELT_3_2_1
	XML_SCHEMAV_CVC_ELT_3_2_2
	XML_SCHEMAV_CVC_ELT_4_1
	XML_SCHEMAV_CVC_ELT_4_2
	XML_SCHEMAV_CVC_ELT_4_3
	XML_SCHEMAV_CVC_ELT_5_1_1
	XML_SCHEMAV_CVC_ELT_5_1_2
	XML_SCHEMAV_CVC_ELT_5_2_1
	XML_SCHEMAV_CVC_ELT_5_2_2_1
	XML_SCHEMAV_CVC_ELT_5_2_2_2_1
	XML_SCHEMAV_CVC_ELT_5_2_2_2_2
	XML_SCHEMAV_CVC_ELT_6
	XML_SCHEMAV_CVC_ELT_7
	XML_SCHEMAV_CVC_ATTRIBUTE_1
	XML_SCHEMAV_CVC_ATTRIBUTE_2
	XML_SCHEMAV_CVC_ATTRIBUTE_3
	XML_SCHEMAV_CVC_ATTRIBUTE_4
	XML_SCHEMAV_CVC_COMPLEX_TYPE_3_1
	XML_SCHEMAV_CVC_COMPLEX_TYPE_3_2_1
	XML_SCHEMAV_CVC_COMPLEX_TYPE_3_2_2
	XML_SCHEMAV_CVC_COMPLEX_TYPE_4
	XML_SCHEMAV_CVC_COMPLEX_TYPE_5_1
	XML_SCHEMAV_CVC_COMPLEX_TYPE_5_2
	XML_SCHEMAV_ELEMENT_CONTENT
	XML_SCHEMAV_DOCUMENT_ELEMENT_MISSING
	XML_SCHEMAV_CVC_COMPLEX_TYPE_1
	XML_SCHEMAV_CVC_AU
	XML_SCHEMAV_CVC_TYPE_1
	XML_SCHEMAV_CVC_TYPE_2
	XML_SCHEMAV_CVC_IDC
	XML_SCHEMAV_CVC_WILDCARD
	XML_SCHEMAV_MISC
	XML_XPTR_UNKNOWN_SCHEME = 1900
	XML_XPTR_CHILDSEQ_START
	XML_XPTR_EVAL_FAILED
	XML_XPTR_EXTRA_OBJECTS
	XML_C14N_CREATE_CTXT = 1950
	XML_C14N_REQUIRES_UTF8
	XML_C14N_CREATE_STACK
	XML_C14N_INVALID_NODE
	XML_C14N_UNKNOW_NODE
	XML_C14N_RELATIVE_NAMESPACE
	XML_FTP_PASV_ANSWER = 2000
	XML_FTP_EPSV_ANSWER
	XML_FTP_ACCNT
	XML_FTP_URL_SYNTAX
	XML_HTTP_URL_SYNTAX = 2020
	XML_HTTP_USE_IP
	XML_HTTP_UNKNOWN_HOST
	XML_SCHEMAP_SRC_SIMPLE_TYPE_1 = 3000
	XML_SCHEMAP_SRC_SIMPLE_TYPE_2
	XML_SCHEMAP_SRC_SIMPLE_TYPE_3
	XML_SCHEMAP_SRC_SIMPLE_TYPE_4
	XML_SCHEMAP_SRC_RESOLVE
	XML_SCHEMAP_SRC_RESTRICTION_BASE_OR_SIMPLETYPE
	XML_SCHEMAP_SRC_LIST_ITEMTYPE_OR_SIMPLETYPE
	XML_SCHEMAP_SRC_UNION_MEMBERTYPES_OR_SIMPLETYPES
	XML_SCHEMAP_ST_PROPS_CORRECT_1
	XML_SCHEMAP_ST_PROPS_CORRECT_2
	XML_SCHEMAP_ST_PROPS_CORRECT_3
	XML_SCHEMAP_COS_ST_RESTRICTS_1_1
	XML_SCHEMAP_COS_ST_RESTRICTS_1_2
	XML_SCHEMAP_COS_ST_RESTRICTS_1_3_1
	XML_SCHEMAP_COS_ST_RESTRICTS_1_3_2
	XML_SCHEMAP_COS_ST_RESTRICTS_2_1
	XML_SCHEMAP_COS_ST_RESTRICTS_2_3_1_1
	XML_SCHEMAP_COS_ST_RESTRICTS_2_3_1_2
	XML_SCHEMAP_COS_ST_RESTRICTS_2_3_2_1
	XML_SCHEMAP_COS_ST_RESTRICTS_2_3_2_2
	XML_SCHEMAP_COS_ST_RESTRICTS_2_3_2_3
	XML_SCHEMAP_COS_ST_RESTRICTS_2_3_2_4
	XML_SCHEMAP_COS_ST_RESTRICTS_2_3_2_5
	XML_SCHEMAP_COS_ST_RESTRICTS_3_1
	XML_SCHEMAP_COS_ST_RESTRICTS_3_3_1
	XML_SCHEMAP_COS_ST_RESTRICTS_3_3_1_2
	XML_SCHEMAP_COS_ST_RESTRICTS_3_3_2_2
	XML_SCHEMAP_COS_ST_RESTRICTS_3_3_2_1
	XML_SCHEMAP_COS_ST_RESTRICTS_3_3_2_3
	XML_SCHEMAP_COS_ST_RESTRICTS_3_3_2_4
	XML_SCHEMAP_COS_ST_RESTRICTS_3_3_2_5
	XML_SCHEMAP_COS_ST_DERIVED_OK_2_1
	XML_SCHEMAP_COS_ST_DERIVED_OK_2_2
	XML_SCHEMAP_S4S_ELEM_NOT_ALLOWED
	XML_SCHEMAP_S4S_ELEM_MISSING
	XML_SCHEMAP_S4S_ATTR_NOT_ALLOWED
	XML_SCHEMAP_S4S_ATTR_MISSING
	XML_SCHEMAP_S4S_ATTR_INVALID_VALUE
	XML_SCHEMAP_SRC_ELEMENT_1
	XML_SCHEMAP_SRC_ELEMENT_2_1
	XML_SCHEMAP_SRC_ELEMENT_2_2
	XML_SCHEMAP_SRC_ELEMENT_3
	XML_SCHEMAP_P_PROPS_CORRECT_1
	XML_SCHEMAP_P_PROPS_CORRECT_2_1
	XML_SCHEMAP_P_PROPS_CORRECT_2_2
	XML_SCHEMAP_E_PROPS_CORRECT_2
	XML_SCHEMAP_E_PROPS_CORRECT_3
	XML_SCHEMAP_E_PROPS_CORRECT_4
	XML_SCHEMAP_E_PROPS_CORRECT_5
	XML_SCHEMAP_E_PROPS_CORRECT_6
	XML_SCHEMAP_SRC_INCLUDE
	XML_SCHEMAP_SRC_ATTRIBUTE_1
	XML_SCHEMAP_SRC_ATTRIBUTE_2
	XML_SCHEMAP_SRC_ATTRIBUTE_3_1
	XML_SCHEMAP_SRC_ATTRIBUTE_3_2
	XML_SCHEMAP_SRC_ATTRIBUTE_4
	XML_SCHEMAP_NO_XMLNS
	XML_SCHEMAP_NO_XSI
	XML_SCHEMAP_COS_VALID_DEFAULT_1
	XML_SCHEMAP_COS_VALID_DEFAULT_2_1
	XML_SCHEMAP_COS_VALID_DEFAULT_2_2_1
	XML_SCHEMAP_COS_VALID_DEFAULT_2_2_2
	XML_SCHEMAP_CVC_SIMPLE_TYPE
	XML_SCHEMAP_COS_CT_EXTENDS_1_1
	XML_SCHEMAP_SRC_IMPORT_1_1
	XML_SCHEMAP_SRC_IMPORT_1_2
	XML_SCHEMAP_SRC_IMPORT_2
	XML_SCHEMAP_SRC_IMPORT_2_1
	XML_SCHEMAP_SRC_IMPORT_2_2
	XML_SCHEMAP_INTERNAL
	XML_SCHEMAP_NOT_DETERMINISTIC
	XML_SCHEMAP_SRC_ATTRIBUTE_GROUP_1
	XML_SCHEMAP_SRC_ATTRIBUTE_GROUP_2
	XML_SCHEMAP_SRC_ATTRIBUTE_GROUP_3
	XML_SCHEMAP_MG_PROPS_CORRECT_1
	XML_SCHEMAP_MG_PROPS_CORRECT_2
	XML_SCHEMAP_SRC_CT_1
	XML_SCHEMAP_DERIVATION_OK_RESTRICTION_2_1_3
	XML_SCHEMAP_AU_PROPS_CORRECT_2
	XML_SCHEMAP_A_PROPS_CORRECT_2
	XML_SCHEMAP_C_PROPS_CORRECT
	XML_SCHEMAP_SRC_REDEFINE
	XML_SCHEMAP_SRC_IMPORT
	XML_SCHEMAP_WARN_SKIP_SCHEMA
	XML_SCHEMAP_WARN_UNLOCATED_SCHEMA
	XML_SCHEMAP_WARN_ATTR_REDECL_PROH
	XML_SCHEMAP_WARN_ATTR_POINTLESS_PROH
	XML_SCHEMAP_AG_PROPS_CORRECT
	XML_SCHEMAP_COS_CT_EXTENDS_1_2
	XML_SCHEMAP_AU_PROPS_CORRECT
	XML_SCHEMAP_A_PROPS_CORRECT_3
	XML_SCHEMAP_COS_ALL_LIMITED
	XML_SCHEMATRONV_ASSERT = 4000
	XML_SCHEMATRONV_REPORT
	XML_MODULE_OPEN = 4900
	XML_MODULE_CLOSE
	XML_CHECK_FOUND_ELEMENT = 5000
	XML_CHECK_FOUND_ATTRIBUTE
	XML_CHECK_FOUND_TEXT
	XML_CHECK_FOUND_CDATA
	XML_CHECK_FOUND_ENTITYREF
	XML_CHECK_FOUND_ENTITY
	XML_CHECK_FOUND_PI
	XML_CHECK_FOUND_COMMENT
	XML_CHECK_FOUND_DOCTYPE
	XML_CHECK_FOUND_FRAGMENT
	XML_CHECK_FOUND_NOTATION
	XML_CHECK_UNKNOWN_NODE
	XML_CHECK_ENTITY_TYPE
	XML_CHECK_NO_PARENT
	XML_CHECK_NO_DOC
	XML_CHECK_NO_NAME
	XML_CHECK_NO_ELEM
	XML_CHECK_WRONG_DOC
	XML_CHECK_NO_PREV
	XML_CHECK_WRONG_PREV
	XML_CHECK_NO_NEXT
	XML_CHECK_WRONG_NEXT
	XML_CHECK_NOT_DTD
	XML_CHECK_NOT_ATTR
	XML_CHECK_NOT_ATTR_DECL
	XML_CHECK_NOT_ELEM_DECL
	XML_CHECK_NOT_ENTITY_DECL
	XML_CHECK_NOT_NS_DECL
	XML_CHECK_NO_HREF
	XML_CHECK_WRONG_PARENT
	XML_CHECK_NS_SCOPE
	XML_CHECK_NS_ANCESTOR
	XML_CHECK_NOT_UTF8
	XML_CHECK_NO_DICT
	XML_CHECK_NOT_NCNAME
	XML_CHECK_OUTSIDE_DICT
	XML_CHECK_WRONG_NAME
	XML_CHECK_NAME_NOT_NULL
	XML_I18N_NO_NAME = 6000
	XML_I18N_NO_HANDLER
	XML_I18N_EXCESS_HANDLER
	XML_I18N_CONV_FAILED
  XML_I18N_NO_OUTPUT
#IF 0
	XML_CHECK_
#ENDIF
END ENUM

TYPE xmlGenericErrorFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, ...)
TYPE xmlStructuredErrorFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS xmlErrorPtr)

DECLARE SUB xmlSetGenericErrorFunc(BYVAL AS ANY PTR, BYVAL AS xmlGenericErrorFunc)
DECLARE SUB initGenericErrorDefaultFunc(BYVAL AS xmlGenericErrorFunc)
DECLARE SUB xmlSetStructuredErrorFunc(BYVAL AS ANY PTR, BYVAL AS xmlStructuredErrorFunc)
DECLARE SUB xmlParserError(BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, ...)
DECLARE SUB xmlParserWarning(BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, ...)
DECLARE SUB xmlParserValidityError(BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, ...)
DECLARE SUB xmlParserValidityWarning(BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, ...)
DECLARE SUB xmlParserPrintFileInfo(BYVAL AS xmlParserInputPtr)
DECLARE SUB xmlParserPrintFileContext(BYVAL AS xmlParserInputPtr)
DECLARE FUNCTION xmlGetLastError() AS xmlErrorPtr
DECLARE SUB xmlResetLastError()
DECLARE FUNCTION xmlCtxtGetLastError(BYVAL AS ANY PTR) AS xmlErrorPtr
DECLARE SUB xmlCtxtResetLastError(BYVAL AS ANY PTR)
DECLARE SUB xmlResetError(BYVAL AS xmlErrorPtr)
DECLARE FUNCTION xmlCopyError(BYVAL AS xmlErrorPtr, BYVAL AS xmlErrorPtr) AS INTEGER

#IFDEF IN_LIBXML

DECLARE SUB __xmlRaiseError CDECL(BYVAL AS xmlStructuredErrorFunc, BYVAL AS xmlGenericErrorFunc, BYVAL AS ANY PTR, BYVAL AS ANY PTR, BYVAL AS ANY PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS xmlErrorLevel, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, ...)
DECLARE SUB xmlStructuredErrorFunc(BYVAL AS xmlStructuredErrorFunc, BYVAL AS xmlGenericErrorFunc, BYVAL AS ANY PTR, BYVAL AS ANY PTR, BYVAL AS ANY PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS xmlErrorLevel, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, ...) '??? macro expansion
DECLARE SUB __xmlSimpleError(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS xmlNodePtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR)

#ENDIF ' IN_LIBXML
#ENDIF ' __XML_ERROR_H__

#IFNDEF __XML_SAX_H__
#DEFINE __XML_SAX_H__

#INCLUDE ONCE "crt/stdlib.bi"

#IFNDEF __XML_XLINK_H__
#DEFINE __XML_XLINK_H__

#IFDEF LIBXML_XPTR_ENABLED

TYPE AS xmlChar PTR xlinkHRef
TYPE AS xmlChar PTR xlinkRole
TYPE AS xmlChar PTR xlinkTitle

ENUM xlinkType
	XLINK_TYPE_NONE = 0
	XLINK_TYPE_SIMPLE
	XLINK_TYPE_EXTENDED
	XLINK_TYPE_EXTENDED_SET
END ENUM

ENUM xlinkShow
	XLINK_SHOW_NONE = 0
	XLINK_SHOW_NEW
	XLINK_SHOW_EMBED
	XLINK_SHOW_REPLACE
END ENUM

ENUM xlinkActuate
	XLINK_ACTUATE_NONE = 0
	XLINK_ACTUATE_AUTO
	XLINK_ACTUATE_ONREQUEST
END ENUM

TYPE xlinkNodeDetectFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS xmlNodePtr)
TYPE xlinkSimpleLinkFunk AS SUB(BYVAL AS ANY PTR, BYVAL AS xmlNodePtr, BYVAL AS CONST xlinkHRef, BYVAL AS CONST xlinkRole, BYVAL AS CONST xlinkTitle)
TYPE xlinkExtendedLinkFunk AS SUB(BYVAL AS ANY PTR, BYVAL AS xmlNodePtr, BYVAL AS INTEGER, BYVAL AS CONST xlinkHRef PTR, BYVAL AS CONST xlinkRole PTR, BYVAL AS INTEGER, BYVAL AS CONST xlinkRole PTR, BYVAL AS CONST xlinkRole PTR, BYVAL AS xlinkShow PTR, BYVAL AS xlinkActuate PTR, BYVAL AS INTEGER, BYVAL AS CONST xlinkTitle PTR, BYVAL AS CONST xmlChar PTR PTR)
TYPE xlinkExtendedLinkSetFunk AS SUB(BYVAL AS ANY PTR, BYVAL AS xmlNodePtr, BYVAL AS INTEGER, BYVAL AS CONST xlinkHRef PTR, BYVAL AS CONST xlinkRole PTR, BYVAL AS INTEGER, BYVAL AS CONST xlinkTitle PTR, BYVAL AS CONST xmlChar PTR PTR)
TYPE xlinkHandler AS _xlinkHandler
TYPE AS xlinkHandler PTR xlinkHandlerPtr

TYPE _xlinkHandler
	AS xlinkSimpleLinkFunk simple
	AS xlinkExtendedLinkFunk extended
	AS xlinkExtendedLinkSetFunk set
END TYPE

DECLARE FUNCTION xlinkGetDefaultDetect() AS xlinkNodeDetectFunc
DECLARE SUB xlinkSetDefaultDetect(BYVAL AS xlinkNodeDetectFunc)
DECLARE FUNCTION xlinkGetDefaultHandler() AS xlinkHandlerPtr
DECLARE SUB xlinkSetDefaultHandler(BYVAL AS xlinkHandlerPtr)
DECLARE FUNCTION xlinkIsLink(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr) AS xlinkType

#ENDIF ' LIBXML_XPTR_ENABLED
#ENDIF ' __XML_XLINK_H__

#IFDEF LIBXML_LEGACY_ENABLED

DECLARE FUNCTION getPublicId(BYVAL AS ANY PTR) AS CONST xmlChar PTR
DECLARE FUNCTION getSystemId(BYVAL AS ANY PTR) AS CONST xmlChar PTR
DECLARE SUB setDocumentLocator(BYVAL AS ANY PTR, BYVAL AS xmlSAXLocatorPtr)
DECLARE FUNCTION getLineNumber(BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION getColumnNumber(BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION isStandalone(BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION hasInternalSubset(BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION hasExternalSubset(BYVAL AS ANY PTR) AS INTEGER
DECLARE SUB internalSubset(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB externalSubset(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE FUNCTION getEntity(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
DECLARE FUNCTION getParameterEntity(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
DECLARE FUNCTION resolveEntity(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlParserInputPtr
DECLARE SUB entityDecl(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlChar PTR)
DECLARE SUB attributeDecl(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlEnumerationPtr)
DECLARE SUB elementDecl(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS xmlElementContentPtr)
DECLARE SUB notationDecl(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB unparsedEntityDecl(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB startDocument(BYVAL AS ANY PTR)
DECLARE SUB endDocument(BYVAL AS ANY PTR)
DECLARE SUB attribute(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB startElement(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR PTR)
DECLARE SUB endElement(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB reference(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB characters(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER)
DECLARE SUB ignorableWhitespace(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER)
DECLARE SUB processingInstruction(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB globalNamespace(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB setNamespace(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR)
DECLARE FUNCTION getNamespace(BYVAL AS ANY PTR) AS xmlNsPtr
DECLARE FUNCTION checkNamespace(BYVAL AS ANY PTR, BYVAL AS xmlChar PTR) AS INTEGER
DECLARE SUB namespaceDecl(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB comment(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB cdataBlock(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER)

#IFDEF LIBXML_SAX1_ENABLED

DECLARE SUB initxmlDefaultSAXHandler(BYVAL AS xmlSAXHandlerV1 PTR, BYVAL AS INTEGER)

#IFDEF LIBXML_HTML_ENABLED

DECLARE SUB inithtmlDefaultSAXHandler(BYVAL AS xmlSAXHandlerV1 PTR)

#ENDIF ' LIBXML_HTML_ENABLED

#IFDEF LIBXML_DOCB_ENABLED

DECLARE SUB initdocbDefaultSAXHandler(BYVAL AS xmlSAXHandlerV1 PTR)

#ENDIF ' LIBXML_DOCB_ENABLED
#ENDIF ' LIBXML_SAX1_ENABLED
#ENDIF ' LIBXML_LEGACY_ENABLED
#ENDIF ' __XML_SAX_H__

#IFNDEF __XML_SAX2_H__
#DEFINE __XML_SAX2_H__

DECLARE FUNCTION xmlSAX2GetPublicId(BYVAL AS ANY PTR) AS CONST xmlChar PTR
DECLARE FUNCTION xmlSAX2GetSystemId(BYVAL AS ANY PTR) AS CONST xmlChar PTR
DECLARE SUB xmlSAX2SetDocumentLocator(BYVAL AS ANY PTR, BYVAL AS xmlSAXLocatorPtr)
DECLARE FUNCTION xmlSAX2GetLineNumber(BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlSAX2GetColumnNumber(BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlSAX2IsStandalone(BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlSAX2HasInternalSubset(BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlSAX2HasExternalSubset(BYVAL AS ANY PTR) AS INTEGER
DECLARE SUB xmlSAX2InternalSubset(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB xmlSAX2ExternalSubset(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE FUNCTION xmlSAX2GetEntity(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
DECLARE FUNCTION xmlSAX2GetParameterEntity(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
DECLARE FUNCTION xmlSAX2ResolveEntity(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlParserInputPtr
DECLARE SUB xmlSAX2EntityDecl(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlChar PTR)
DECLARE SUB xmlSAX2AttributeDecl(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlEnumerationPtr)
DECLARE SUB xmlSAX2ElementDecl(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS xmlElementContentPtr)
DECLARE SUB xmlSAX2NotationDecl(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB xmlSAX2UnparsedEntityDecl(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB xmlSAX2StartDocument(BYVAL AS ANY PTR)
DECLARE SUB xmlSAX2EndDocument(BYVAL AS ANY PTR)

#IF DEFINED(LIBXML_SAX1_ENABLED) OR DEFINED(LIBXML_HTML_ENABLED) OR DEFINED(LIBXML_WRITER_ENABLED) OR DEFINED(LIBXML_DOCB_ENABLED)

DECLARE SUB xmlSAX2StartElement(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR PTR)
DECLARE SUB xmlSAX2EndElement(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR)

#ENDIF ' DEFINED(LIBXML_...

DECLARE SUB xmlSAX2StartElementNs(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR PTR)
DECLARE SUB xmlSAX2EndElementNs(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB xmlSAX2Reference(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB xmlSAX2Characters(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER)
DECLARE SUB xmlSAX2IgnorableWhitespace(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER)
DECLARE SUB xmlSAX2ProcessingInstruction(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB xmlSAX2Comment(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR)
DECLARE SUB xmlSAX2CDataBlock(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER)

#IFDEF LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlSAXDefaultVersion(BYVAL AS INTEGER) AS INTEGER

#ENDIF ' LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlSAXVersion(BYVAL AS xmlSAXHandler PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE SUB xmlSAX2InitDefaultSAXHandler(BYVAL AS xmlSAXHandler PTR, BYVAL AS INTEGER)

#IFDEF LIBXML_HTML_ENABLED

DECLARE SUB xmlSAX2InitHtmlDefaultSAXHandler(BYVAL AS xmlSAXHandler PTR)
DECLARE SUB htmlDefaultSAXHandlerInit()

#ENDIF ' LIBXML_HTML_ENABLED

#IFDEF LIBXML_DOCB_ENABLED

DECLARE SUB xmlSAX2InitDocbDefaultSAXHandler(BYVAL AS xmlSAXHandler PTR)
DECLARE SUB docbDefaultSAXHandlerInit()

#ENDIF ' LIBXML_DOCB_ENABLED

DECLARE SUB xmlDefaultSAXHandlerInit()

#ENDIF ' __XML_SAX2_H__

ENUM xmlCharEncoding
	XML_CHAR_ENCODING_ERROR = -1
	XML_CHAR_ENCODING_NONE = 0
	XML_CHAR_ENCODING_UTF8 = 1
	XML_CHAR_ENCODING_UTF16LE = 2
	XML_CHAR_ENCODING_UTF16BE = 3
	XML_CHAR_ENCODING_UCS4LE = 4
	XML_CHAR_ENCODING_UCS4BE = 5
	XML_CHAR_ENCODING_EBCDIC = 6
	XML_CHAR_ENCODING_UCS4_2143 = 7
	XML_CHAR_ENCODING_UCS4_3412 = 8
	XML_CHAR_ENCODING_UCS2 = 9
	XML_CHAR_ENCODING_8859_1 = 10
	XML_CHAR_ENCODING_8859_2 = 11
	XML_CHAR_ENCODING_8859_3 = 12
	XML_CHAR_ENCODING_8859_4 = 13
	XML_CHAR_ENCODING_8859_5 = 14
	XML_CHAR_ENCODING_8859_6 = 15
	XML_CHAR_ENCODING_8859_7 = 16
	XML_CHAR_ENCODING_8859_8 = 17
	XML_CHAR_ENCODING_8859_9 = 18
	XML_CHAR_ENCODING_2022_JP = 19
	XML_CHAR_ENCODING_SHIFT_JIS = 20
	XML_CHAR_ENCODING_EUC_JP = 21
	XML_CHAR_ENCODING_ASCII = 22
END ENUM

TYPE xmlCharEncodingHandler AS _xmlCharEncodingHandler
TYPE AS xmlCharEncodingHandler PTR xmlCharEncodingHandlerPtr

DECLARE SUB xmlInitGlobals()
DECLARE SUB xmlCleanupGlobals()

TYPE xmlParserInputBufferCreateFilenameFunc AS FUNCTION(BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlCharEncoding) AS xmlParserInputBufferPtr
TYPE xmlOutputBufferCreateFilenameFunc AS FUNCTION(BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlCharEncodingHandlerPtr, BYVAL AS INTEGER) AS xmlOutputBufferPtr

DECLARE FUNCTION xmlParserInputBufferCreateFilenameDefault(BYVAL AS xmlParserInputBufferCreateFilenameFunc) AS xmlParserInputBufferCreateFilenameFunc
DECLARE FUNCTION xmlOutputBufferCreateFilenameDefault(BYVAL AS xmlOutputBufferCreateFilenameFunc) AS xmlOutputBufferCreateFilenameFunc

#UNDEF docbDefaultSAXHandler
#UNDEF htmlDefaultSAXHandler
#UNDEF oldXMLWDcompatibility
#UNDEF xmlBufferAllocScheme
#UNDEF xmlDefaultBufferSize
#UNDEF xmlDefaultSAXHandler
#UNDEF xmlDefaultSAXLocator
#UNDEF xmlDoValidityCheckingDefaultValue
#UNDEF xmlFree
#UNDEF xmlGenericError
#UNDEF xmlStructuredError
#UNDEF xmlGenericErrorContext
#UNDEF xmlStructuredErrorContext
#UNDEF xmlGetWarningsDefaultValue
#UNDEF xmlIndentTreeOutput
#UNDEF xmlTreeIndentString
#UNDEF xmlKeepBlanksDefaultValue
#UNDEF xmlLineNumbersDefaultValue
#UNDEF xmlLoadExtDtdDefaultValue
#UNDEF xmlMalloc
#UNDEF xmlMallocAtomic
#UNDEF xmlMemStrdup
#UNDEF xmlParserDebugEntities
#UNDEF xmlParserVersion
#UNDEF xmlPedanticParserDefaultValue
#UNDEF xmlRealloc
#UNDEF xmlSaveNoEmptyTags
#UNDEF xmlSubstituteEntitiesDefaultValue
#UNDEF xmlRegisterNodeDefaultValue
#UNDEF xmlDeregisterNodeDefaultValue
#UNDEF xmlLastError
#UNDEF xmlParserInputBufferCreateFilenameValue
#UNDEF xmlOutputBufferCreateFilenameValue

TYPE xmlRegisterNodeFunc AS SUB(BYVAL AS xmlNodePtr)
TYPE xmlDeregisterNodeFunc AS SUB(BYVAL AS xmlNodePtr)
TYPE xmlGlobalState AS _xmlGlobalState
TYPE AS xmlGlobalState PTR xmlGlobalStatePtr

TYPE _xmlGlobalState
	AS CONST ZSTRING PTR xmlParserVersion
	AS xmlSAXLocator xmlDefaultSAXLocator
	AS xmlSAXHandlerV1 xmlDefaultSAXHandler
	AS xmlSAXHandlerV1 docbDefaultSAXHandler
	AS xmlSAXHandlerV1 htmlDefaultSAXHandler
	AS xmlFreeFunc xmlFree
	AS xmlMallocFunc xmlMalloc
	AS xmlStrdupFunc xmlMemStrdup
	AS xmlReallocFunc xmlRealloc
	AS xmlGenericErrorFunc xmlGenericError
	AS xmlStructuredErrorFunc xmlStructuredError
	AS ANY PTR xmlGenericErrorContext
	AS INTEGER oldXMLWDcompatibility
	AS xmlBufferAllocationScheme xmlBufferAllocScheme
	AS INTEGER xmlDefaultBufferSize
	AS INTEGER xmlSubstituteEntitiesDefaultValue
	AS INTEGER xmlDoValidityCheckingDefaultValue
	AS INTEGER xmlGetWarningsDefaultValue
	AS INTEGER xmlKeepBlanksDefaultValue
	AS INTEGER xmlLineNumbersDefaultValue
	AS INTEGER xmlLoadExtDtdDefaultValue
	AS INTEGER xmlParserDebugEntities
	AS INTEGER xmlPedanticParserDefaultValue
	AS INTEGER xmlSaveNoEmptyTags
	AS INTEGER xmlIndentTreeOutput
	AS CONST ZSTRING PTR xmlTreeIndentString
	AS xmlRegisterNodeFunc xmlRegisterNodeDefaultValue
	AS xmlDeregisterNodeFunc xmlDeregisterNodeDefaultValue
	AS xmlMallocFunc xmlMallocAtomic
	AS xmlError xmlLastError
	AS xmlParserInputBufferCreateFilenameFunc xmlParserInputBufferCreateFilenameValue
	AS xmlOutputBufferCreateFilenameFunc xmlOutputBufferCreateFilenameValue
	AS ANY PTR xmlStructuredErrorContext
END TYPE

DECLARE SUB xmlInitializeGlobalState(BYVAL AS xmlGlobalStatePtr)
DECLARE SUB xmlThrDefSetGenericErrorFunc(BYVAL AS ANY PTR, BYVAL AS xmlGenericErrorFunc)
DECLARE SUB xmlThrDefSetStructuredErrorFunc(BYVAL AS ANY PTR, BYVAL AS xmlStructuredErrorFunc)
DECLARE FUNCTION xmlRegisterNodeDefault(BYVAL AS xmlRegisterNodeFunc) AS xmlRegisterNodeFunc
DECLARE FUNCTION xmlThrDefRegisterNodeDefault(BYVAL AS xmlRegisterNodeFunc) AS xmlRegisterNodeFunc
DECLARE FUNCTION xmlDeregisterNodeDefault(BYVAL AS xmlDeregisterNodeFunc) AS xmlDeregisterNodeFunc
DECLARE FUNCTION xmlThrDefDeregisterNodeDefault(BYVAL AS xmlDeregisterNodeFunc) AS xmlDeregisterNodeFunc
DECLARE FUNCTION xmlThrDefOutputBufferCreateFilenameDefault(BYVAL AS xmlOutputBufferCreateFilenameFunc) AS xmlOutputBufferCreateFilenameFunc
DECLARE FUNCTION xmlThrDefParserInputBufferCreateFilenameDefault(BYVAL AS xmlParserInputBufferCreateFilenameFunc) AS xmlParserInputBufferCreateFilenameFunc

#IFDEF LIBXML_THREAD_ALLOC_ENABLED
#IFDEF LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlMalloc() AS xmlMallocFunc PTR

#DEFINE xmlMalloc _
(*(__xmlMalloc()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlMallocFunc xmlMalloc

#ENDIF ' LIBXML_THREAD_ENABLED

#IFDEF LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlMallocAtomic() AS xmlMallocFunc PTR

#DEFINE xmlMallocAtomic _
(*(__xmlMallocAtomic()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlMallocFunc xmlMallocAtomic

#ENDIF ' LIBXML_THREAD_ENABLED

#IFDEF LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlRealloc() AS xmlReallocFunc

#DEFINE xmlRealloc _
(*(__xmlRealloc()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlReallocFunc xmlRealloc

#ENDIF ' LIBXML_THREAD_ENABLED

#IFDEF LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlFree() AS xmlFreeFunc

#DEFINE xmlFree _
(*(__xmlFree()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlFreeFunc xmlFree

#ENDIF ' LIBXML_THREAD_ENABLED

#IFDEF LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlMemStrdup() AS xmlStrdupFunc

#DEFINE xmlMemStrdup _
(*(__xmlMemStrdup()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlStrdupFunc xmlMemStrdup

#ENDIF ' LIBXML_THREAD_ENABLED
#ELSE ' LIBXML_THREAD_ALLOC_ENABLED

EXTERN AS xmlMallocFunc xmlMalloc
EXTERN AS xmlMallocFunc xmlMallocAtomic
EXTERN AS xmlReallocFunc xmlRealloc
EXTERN AS xmlFreeFunc xmlFree
EXTERN AS xmlStrdupFunc xmlMemStrdup

#ENDIF ' LIBXML_THREAD_ALLOC_ENABLED

#IFDEF LIBXML_DOCB_ENABLED

DECLARE FUNCTION __docbDefaultSAXHandler() AS xmlSAXHandlerV1 PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE docbDefaultSAXHandler _
(*(__docbDefaultSAXHandler()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlSAXHandlerV1 docbDefaultSAXHandler

#ENDIF ' LIBXML_THREAD_ENABLED
#ENDIF ' LIBXML_DOCB_ENABLED

#IFDEF LIBXML_HTML_ENABLED

DECLARE FUNCTION __htmlDefaultSAXHandler() AS xmlSAXHandlerV1 PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE htmlDefaultSAXHandler _
(*(__htmlDefaultSAXHandler()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlSAXHandlerV1 htmlDefaultSAXHandler

#ENDIF ' LIBXML_THREAD_ENABLED
#ENDIF ' LIBXML_HTML_ENABLED

DECLARE FUNCTION __xmlLastError() AS xmlError PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlLastError _
(*(__xmlLastError()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlError xmlLastError

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __oldXMLWDcompatibility() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE oldXMLWDcompatibility _
(*(__oldXMLWDcompatibility()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER oldXMLWDcompatibility

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlBufferAllocScheme() AS xmlBufferAllocationScheme PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlBufferAllocScheme _
(*(__xmlBufferAllocScheme()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlBufferAllocationScheme xmlBufferAllocScheme

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefBufferAllocScheme(BYVAL AS xmlBufferAllocationScheme) AS xmlBufferAllocationScheme
DECLARE FUNCTION __xmlDefaultBufferSize() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlDefaultBufferSize _
(*(__xmlDefaultBufferSize()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER xmlDefaultBufferSize

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefDefaultBufferSize(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION __xmlDefaultSAXHandler() AS xmlSAXHandlerV1 PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlDefaultSAXHandler _
(*(__xmlDefaultSAXHandler()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlSAXHandlerV1 xmlDefaultSAXHandler

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlDefaultSAXLocator() AS xmlSAXLocator PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlDefaultSAXLocator _
(*(__xmlDefaultSAXLocator()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlSAXLocator xmlDefaultSAXLocator

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlDoValidityCheckingDefaultValue() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlDoValidityCheckingDefaultValue _
(*(__xmlDoValidityCheckingDefaultValue()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER xmlDoValidityCheckingDefaultValue

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefDoValidityCheckingDefaultValue(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION __xmlGenericError() AS xmlGenericErrorFunc

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlGenericError _
(*(__xmlGenericError()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlGenericErrorFunc xmlGenericError

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlStructuredError() AS xmlStructuredErrorFunc

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlStructuredError _
(*(__xmlStructuredError()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlStructuredErrorFunc xmlStructuredError

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlGenericErrorContext() AS ANY PTR PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlGenericErrorContext _
(*(__xmlGenericErrorContext()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS ANY PTR xmlGenericErrorContext

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlStructuredErrorContext() AS ANY PTR PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlStructuredErrorContext _
(*(__xmlStructuredErrorContext()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS ANY PTR xmlStructuredErrorContext

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlGetWarningsDefaultValue() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlGetWarningsDefaultValue _
(*(__xmlGetWarningsDefaultValue()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER xmlGetWarningsDefaultValue

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefGetWarningsDefaultValue(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION __xmlIndentTreeOutput() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlIndentTreeOutput _
(*(__xmlIndentTreeOutput()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER xmlIndentTreeOutput

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefIndentTreeOutput(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION __xmlTreeIndentString() AS CONST ZSTRING PTR PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlTreeIndentString _
(*(__xmlTreeIndentString()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS CONST ZSTRING PTR xmlTreeIndentString

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefTreeIndentString(BYVAL AS CONST ZSTRING PTR) AS CONST ZSTRING PTR
DECLARE FUNCTION __xmlKeepBlanksDefaultValue() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlKeepBlanksDefaultValue _
(*(__xmlKeepBlanksDefaultValue()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER xmlKeepBlanksDefaultValue

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefKeepBlanksDefaultValue(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION __xmlLineNumbersDefaultValue() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlLineNumbersDefaultValue _
(*(__xmlLineNumbersDefaultValue()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER xmlLineNumbersDefaultValue

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefLineNumbersDefaultValue(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION __xmlLoadExtDtdDefaultValue() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlLoadExtDtdDefaultValue _
(*(__xmlLoadExtDtdDefaultValue()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER xmlLoadExtDtdDefaultValue

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefLoadExtDtdDefaultValue(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION __xmlParserDebugEntities() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlParserDebugEntities _
(*(__xmlParserDebugEntities()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER xmlParserDebugEntities

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefParserDebugEntities(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION __xmlParserVersion() AS CONST ZSTRING PTR PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlParserVersion _
(*(__xmlParserVersion()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS CONST ZSTRING PTR xmlParserVersion

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlPedanticParserDefaultValue() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlPedanticParserDefaultValue _
(*(__xmlPedanticParserDefaultValue()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER xmlPedanticParserDefaultValue

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefPedanticParserDefaultValue(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION __xmlSaveNoEmptyTags() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlSaveNoEmptyTags _
(*(__xmlSaveNoEmptyTags()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER xmlSaveNoEmptyTags

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefSaveNoEmptyTags(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION __xmlSubstituteEntitiesDefaultValue() AS INTEGER PTR

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlSubstituteEntitiesDefaultValue _
(*(__xmlSubstituteEntitiesDefaultValue()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS INTEGER xmlSubstituteEntitiesDefaultValue

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION xmlThrDefSubstituteEntitiesDefaultValue(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION __xmlRegisterNodeDefaultValue() AS xmlRegisterNodeFunc

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlRegisterNodeDefaultValue _
(*(__xmlRegisterNodeDefaultValue()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlRegisterNodeFunc xmlRegisterNodeDefaultValue

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlDeregisterNodeDefaultValue() AS xmlDeregisterNodeFunc

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlDeregisterNodeDefaultValue _
(*(__xmlDeregisterNodeDefaultValue()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlDeregisterNodeFunc xmlDeregisterNodeDefaultValue

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlParserInputBufferCreateFilenameValue() AS xmlParserInputBufferCreateFilenameFunc

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlParserInputBufferCreateFilenameValue _
(*(__xmlParserInputBufferCreateFilenameValue()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlParserInputBufferCreateFilenameFunc xmlParserInputBufferCreateFilenameValue

#ENDIF ' LIBXML_THREAD_ENABLED

DECLARE FUNCTION __xmlOutputBufferCreateFilenameValue() AS xmlOutputBufferCreateFilenameFunc

#IFDEF LIBXML_THREAD_ENABLED
#DEFINE xmlOutputBufferCreateFilenameValue _
(*(__xmlOutputBufferCreateFilenameValue()))
#ELSE ' LIBXML_THREAD_ENABLED

EXTERN AS xmlOutputBufferCreateFilenameFunc xmlOutputBufferCreateFilenameValue

#ENDIF ' LIBXML_THREAD_ENABLED
#ENDIF ' __XML_GLOBALS_H

DECLARE FUNCTION xmlNewMutex() AS xmlMutexPtr
DECLARE SUB xmlMutexLock(BYVAL AS xmlMutexPtr)
DECLARE SUB xmlMutexUnlock(BYVAL AS xmlMutexPtr)
DECLARE SUB xmlFreeMutex(BYVAL AS xmlMutexPtr)
DECLARE FUNCTION xmlNewRMutex() AS xmlRMutexPtr
DECLARE SUB xmlRMutexLock(BYVAL AS xmlRMutexPtr)
DECLARE SUB xmlRMutexUnlock(BYVAL AS xmlRMutexPtr)
DECLARE SUB xmlFreeRMutex(BYVAL AS xmlRMutexPtr)
DECLARE SUB xmlInitThreads()
DECLARE SUB xmlLockLibrary()
DECLARE SUB xmlUnlockLibrary()
DECLARE FUNCTION xmlGetThreadId() AS INTEGER
DECLARE FUNCTION xmlIsMainThread() AS INTEGER
DECLARE SUB xmlCleanupThreads()
DECLARE FUNCTION xmlGetGlobalState() AS xmlGlobalStatePtr

#IF DEFINED(HAVE_WIN32_THREADS) AND NOT DEFINED(HAVE_COMPILER_TLS) AND DEFINED(LIBXML_STATIC_FOR_DLL)

DECLARE FUNCTION xmlDllMain(BYVAL AS ANY PTR, BYVAL AS UINTEGER, BYVAL AS ANY PTR) AS INTEGER

#ENDIF ' DEFINED(HAVE_WI...
#ENDIF ' __XML_THREADS_H__

#ENDIF ' __DEBUG_MEMORY_ALLOC__
#ENDIF ' __XML_TREE_H__

#IFNDEF __XML_HASH_H__
#DEFINE __XML_HASH_H__

TYPE xmlHashTable AS _xmlHashTable
TYPE AS xmlHashTable PTR xmlHashTablePtr

#DEFINE XML_CAST_FPTR(fptr) fptr

TYPE xmlHashDeallocator AS SUB(BYVAL AS ANY PTR, BYVAL AS xmlChar PTR)
TYPE xmlHashCopier AS FUNCTION(BYVAL AS ANY PTR, BYVAL AS xmlChar PTR) AS ANY PTR
TYPE xmlHashScanner AS SUB(BYVAL AS ANY PTR, BYVAL AS ANY PTR, BYVAL AS xmlChar PTR)
TYPE xmlHashScannerFull AS SUB(BYVAL AS ANY PTR, BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)

DECLARE FUNCTION xmlHashCreate(BYVAL AS INTEGER) AS xmlHashTablePtr
DECLARE FUNCTION xmlHashCreateDict(BYVAL AS INTEGER, BYVAL AS xmlDictPtr) AS xmlHashTablePtr
DECLARE SUB xmlHashFree(BYVAL AS xmlHashTablePtr, BYVAL AS xmlHashDeallocator)
DECLARE FUNCTION xmlHashAddEntry(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlHashUpdateEntry(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR, BYVAL AS xmlHashDeallocator) AS INTEGER
DECLARE FUNCTION xmlHashAddEntry2(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlHashUpdateEntry2(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR, BYVAL AS xmlHashDeallocator) AS INTEGER
DECLARE FUNCTION xmlHashAddEntry3(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlHashUpdateEntry3(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR, BYVAL AS xmlHashDeallocator) AS INTEGER
DECLARE FUNCTION xmlHashRemoveEntry(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlHashDeallocator) AS INTEGER
DECLARE FUNCTION xmlHashRemoveEntry2(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlHashDeallocator) AS INTEGER
DECLARE FUNCTION xmlHashRemoveEntry3(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlHashDeallocator) AS INTEGER
DECLARE FUNCTION xmlHashLookup(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR) AS ANY PTR
DECLARE FUNCTION xmlHashLookup2(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS ANY PTR
DECLARE FUNCTION xmlHashLookup3(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS ANY PTR
DECLARE FUNCTION xmlHashQLookup(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS ANY PTR
DECLARE FUNCTION xmlHashQLookup2(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS ANY PTR
DECLARE FUNCTION xmlHashQLookup3(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS ANY PTR
DECLARE FUNCTION xmlHashCopy(BYVAL AS xmlHashTablePtr, BYVAL AS xmlHashCopier) AS xmlHashTablePtr
DECLARE FUNCTION xmlHashSize(BYVAL AS xmlHashTablePtr) AS INTEGER
DECLARE SUB xmlHashScan(BYVAL AS xmlHashTablePtr, BYVAL AS xmlHashScanner, BYVAL AS ANY PTR)
DECLARE SUB xmlHashScan3(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlHashScanner, BYVAL AS ANY PTR)
DECLARE SUB xmlHashScanFull(BYVAL AS xmlHashTablePtr, BYVAL AS xmlHashScannerFull, BYVAL AS ANY PTR)
DECLARE SUB xmlHashScanFull3(BYVAL AS xmlHashTablePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlHashScannerFull, BYVAL AS ANY PTR)

#ENDIF ' __XML_HASH_H__

#IFNDEF __XML_VALID_H__
#DEFINE __XML_VALID_H__

#IFNDEF __XML_LINK_INCLUDE__
#DEFINE __XML_LINK_INCLUDE__

TYPE xmlLink AS _xmlLink
TYPE AS xmlLink PTR xmlLinkPtr
TYPE xmlList AS _xmlList
TYPE AS xmlList PTR xmlListPtr
TYPE xmlListDeallocator AS SUB(BYVAL AS xmlLinkPtr)
TYPE xmlListDataCompare AS FUNCTION(BYVAL AS CONST ANY PTR, BYVAL AS CONST ANY PTR) AS INTEGER
TYPE xmlListWalker AS FUNCTION(BYVAL AS CONST ANY PTR, BYVAL AS CONST ANY PTR) AS INTEGER

DECLARE FUNCTION xmlListCreate(BYVAL AS xmlListDeallocator, BYVAL AS xmlListDataCompare) AS xmlListPtr
DECLARE SUB xmlListDelete(BYVAL AS xmlListPtr)
DECLARE FUNCTION xmlListSearch(BYVAL AS xmlListPtr, BYVAL AS ANY PTR) AS ANY PTR
DECLARE FUNCTION xmlListReverseSearch(BYVAL AS xmlListPtr, BYVAL AS ANY PTR) AS ANY PTR
DECLARE FUNCTION xmlListInsert(BYVAL AS xmlListPtr, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlListAppend(BYVAL AS xmlListPtr, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlListRemoveFirst(BYVAL AS xmlListPtr, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlListRemoveLast(BYVAL AS xmlListPtr, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlListRemoveAll(BYVAL AS xmlListPtr, BYVAL AS ANY PTR) AS INTEGER
DECLARE SUB xmlListClear(BYVAL AS xmlListPtr)
DECLARE FUNCTION xmlListEmpty(BYVAL AS xmlListPtr) AS INTEGER
DECLARE FUNCTION xmlListFront(BYVAL AS xmlListPtr) AS xmlLinkPtr
DECLARE FUNCTION xmlListEnd(BYVAL AS xmlListPtr) AS xmlLinkPtr
DECLARE FUNCTION xmlListSize(BYVAL AS xmlListPtr) AS INTEGER
DECLARE SUB xmlListPopFront(BYVAL AS xmlListPtr)
DECLARE SUB xmlListPopBack(BYVAL AS xmlListPtr)
DECLARE FUNCTION xmlListPushFront(BYVAL AS xmlListPtr, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlListPushBack(BYVAL AS xmlListPtr, BYVAL AS ANY PTR) AS INTEGER
DECLARE SUB xmlListReverse(BYVAL AS xmlListPtr)
DECLARE SUB xmlListSort(BYVAL AS xmlListPtr)
DECLARE SUB xmlListWalk(BYVAL AS xmlListPtr, BYVAL AS xmlListWalker, BYVAL AS CONST ANY PTR)
DECLARE SUB xmlListReverseWalk(BYVAL AS xmlListPtr, BYVAL AS xmlListWalker, BYVAL AS CONST ANY PTR)
DECLARE SUB xmlListMerge(BYVAL AS xmlListPtr, BYVAL AS xmlListPtr)
DECLARE FUNCTION xmlListDup(BYVAL AS CONST xmlListPtr) AS xmlListPtr
DECLARE FUNCTION xmlListCopy(BYVAL AS xmlListPtr, BYVAL AS CONST xmlListPtr) AS INTEGER
DECLARE FUNCTION xmlLinkGetData(BYVAL AS xmlLinkPtr) AS ANY PTR

#ENDIF ' __XML_LINK_INCLUDE__

#IFNDEF __XML_AUTOMATA_H__
#DEFINE __XML_AUTOMATA_H__

#IFDEF LIBXML_REGEXP_ENABLED
#IFDEF LIBXML_AUTOMATA_ENABLED

TYPE xmlAutomata AS _xmlAutomata
TYPE AS xmlAutomata PTR xmlAutomataPtr
TYPE xmlAutomataState AS _xmlAutomataState
TYPE AS xmlAutomataState PTR xmlAutomataStatePtr

DECLARE FUNCTION xmlNewAutomata() AS xmlAutomataPtr
DECLARE SUB xmlFreeAutomata(BYVAL AS xmlAutomataPtr)
DECLARE FUNCTION xmlAutomataGetInitState(BYVAL AS xmlAutomataPtr) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataSetFinalState(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr) AS INTEGER
DECLARE FUNCTION xmlAutomataNewState(BYVAL AS xmlAutomataPtr) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewTransition(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewTransition2(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewNegTrans(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS ANY PTR) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewCountTrans(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS ANY PTR) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewCountTrans2(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS ANY PTR) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewOnceTrans(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS ANY PTR) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewOnceTrans2(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS ANY PTR) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewAllTrans(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS INTEGER) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewEpsilon(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS xmlAutomataStatePtr) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewCountedTrans(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS INTEGER) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewCounterTrans(BYVAL AS xmlAutomataPtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS xmlAutomataStatePtr, BYVAL AS INTEGER) AS xmlAutomataStatePtr
DECLARE FUNCTION xmlAutomataNewCounter(BYVAL AS xmlAutomataPtr, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlAutomataCompile(BYVAL AS xmlAutomataPtr) AS xmlRegexpPtr
DECLARE FUNCTION xmlAutomataIsDeterminist(BYVAL AS xmlAutomataPtr) AS INTEGER

#ENDIF ' LIBXML_AUTOMATA_ENABLED
#ENDIF ' LIBXML_REGEXP_ENABLED
#ENDIF ' __XML_AUTOMATA_H__

TYPE xmlValidState AS _xmlValidState
TYPE AS xmlValidState PTR xmlValidStatePtr
TYPE xmlValidityErrorFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, ...)
TYPE xmlValidityWarningFunc AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, ...)

#IFDEF IN_LIBXML
#DEFINE XML_CTXT_FINISH_DTD_0 &hABCD1234
#DEFINE XML_CTXT_FINISH_DTD_1 &hABCD1235
#ENDIF ' IN_LIBXML

TYPE xmlValidCtxt AS _xmlValidCtxt
TYPE AS xmlValidCtxt PTR xmlValidCtxtPtr

TYPE _xmlValidCtxt
	AS ANY PTR userData
	AS xmlValidityErrorFunc error
	AS xmlValidityWarningFunc warning
	AS xmlNodePtr node
	AS INTEGER nodeNr
	AS INTEGER nodeMax
	AS xmlNodePtr PTR nodeTab
	AS UINTEGER finishDtd
	AS xmlDocPtr doc
	AS INTEGER valid
	AS xmlValidState PTR vstate
	AS INTEGER vstateNr
	AS INTEGER vstateMax
	AS xmlValidState PTR vstateTab
#IFDEF LIBXML_REGEXP_ENABLED
	AS xmlAutomataPtr am
	AS xmlAutomataStatePtr state
#ELSE ' LIBXML_REGEXP_ENABLED
	AS ANY PTR am
	AS ANY PTR state
#ENDIF ' LIBXML_REGEXP_ENABLED
END TYPE

TYPE xmlNotationTable AS _xmlHashTable
TYPE AS xmlNotationTable PTR xmlNotationTablePtr
TYPE xmlElementTable AS _xmlHashTable
TYPE AS xmlElementTable PTR xmlElementTablePtr
TYPE xmlAttributeTable AS _xmlHashTable
TYPE AS xmlAttributeTable PTR xmlAttributeTablePtr
TYPE xmlIDTable AS _xmlHashTable
TYPE AS xmlIDTable PTR xmlIDTablePtr
TYPE xmlRefTable AS _xmlHashTable
TYPE AS xmlRefTable PTR xmlRefTablePtr

DECLARE FUNCTION xmlAddNotationDecl(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDtdPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlNotationPtr

#IFDEF LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlCopyNotationTable(BYVAL AS xmlNotationTablePtr) AS xmlNotationTablePtr

#ENDIF ' LIBXML_TREE_ENABLED

DECLARE SUB xmlFreeNotationTable(BYVAL AS xmlNotationTablePtr)

#IFDEF LIBXML_OUTPUT_ENABLED

DECLARE SUB xmlDumpNotationDecl(BYVAL AS xmlBufferPtr, BYVAL AS xmlNotationPtr)
DECLARE SUB xmlDumpNotationTable(BYVAL AS xmlBufferPtr, BYVAL AS xmlNotationTablePtr)

#ENDIF ' LIBXML_OUTPUT_ENABLED

DECLARE FUNCTION xmlNewElementContent(BYVAL AS CONST xmlChar PTR, BYVAL AS xmlElementContentType) AS xmlElementContentPtr
DECLARE FUNCTION xmlCopyElementContent(BYVAL AS xmlElementContentPtr) AS xmlElementContentPtr
DECLARE SUB xmlFreeElementContent(BYVAL AS xmlElementContentPtr)
DECLARE FUNCTION xmlNewDocElementContent(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlElementContentType) AS xmlElementContentPtr
DECLARE FUNCTION xmlCopyDocElementContent(BYVAL AS xmlDocPtr, BYVAL AS xmlElementContentPtr) AS xmlElementContentPtr
DECLARE SUB xmlFreeDocElementContent(BYVAL AS xmlDocPtr, BYVAL AS xmlElementContentPtr)
DECLARE SUB xmlSnprintfElementContent(BYVAL AS ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS xmlElementContentPtr, BYVAL AS INTEGER)

#IFDEF LIBXML_OUTPUT_ENABLED

DECLARE SUB xmlSprintfElementContent(BYVAL AS ZSTRING PTR, BYVAL AS xmlElementContentPtr, BYVAL AS INTEGER)

#ENDIF ' LIBXML_OUTPUT_ENABLED

DECLARE FUNCTION xmlAddElementDecl(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDtdPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlElementTypeVal, BYVAL AS xmlElementContentPtr) AS xmlElementPtr

#IFDEF LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlCopyElementTable(BYVAL AS xmlElementTablePtr) AS xmlElementTablePtr

#ENDIF ' LIBXML_TREE_ENABLED

DECLARE SUB xmlFreeElementTable(BYVAL AS xmlElementTablePtr)

#IFDEF LIBXML_OUTPUT_ENABLED

DECLARE SUB xmlDumpElementTable(BYVAL AS xmlBufferPtr, BYVAL AS xmlElementTablePtr)
DECLARE SUB xmlDumpElementDecl(BYVAL AS xmlBufferPtr, BYVAL AS xmlElementPtr)

#ENDIF ' LIBXML_OUTPUT_ENABLED

DECLARE FUNCTION xmlCreateEnumeration(BYVAL AS CONST xmlChar PTR) AS xmlEnumerationPtr
DECLARE SUB xmlFreeEnumeration(BYVAL AS xmlEnumerationPtr)

#IFDEF LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlCopyEnumeration(BYVAL AS xmlEnumerationPtr) AS xmlEnumerationPtr

#ENDIF ' LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlAddAttributeDecl(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDtdPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlAttributeType, BYVAL AS xmlAttributeDefault, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlEnumerationPtr) AS xmlAttributePtr

#IFDEF LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlCopyAttributeTable(BYVAL AS xmlAttributeTablePtr) AS xmlAttributeTablePtr

#ENDIF ' LIBXML_TREE_ENABLED

DECLARE SUB xmlFreeAttributeTable(BYVAL AS xmlAttributeTablePtr)

#IFDEF LIBXML_OUTPUT_ENABLED

DECLARE SUB xmlDumpAttributeTable(BYVAL AS xmlBufferPtr, BYVAL AS xmlAttributeTablePtr)
DECLARE SUB xmlDumpAttributeDecl(BYVAL AS xmlBufferPtr, BYVAL AS xmlAttributePtr)

#ENDIF ' LIBXML_OUTPUT_ENABLED

DECLARE FUNCTION xmlAddID(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlAttrPtr) AS xmlIDPtr
DECLARE SUB xmlFreeIDTable(BYVAL AS xmlIDTablePtr)
DECLARE FUNCTION xmlGetID(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlAttrPtr
DECLARE FUNCTION xmlIsID(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS xmlAttrPtr) AS INTEGER
DECLARE FUNCTION xmlRemoveID(BYVAL AS xmlDocPtr, BYVAL AS xmlAttrPtr) AS INTEGER
DECLARE FUNCTION xmlAddRef(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlAttrPtr) AS xmlRefPtr
DECLARE SUB xmlFreeRefTable(BYVAL AS xmlRefTablePtr)
DECLARE FUNCTION xmlIsRef(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS xmlAttrPtr) AS INTEGER
DECLARE FUNCTION xmlRemoveRef(BYVAL AS xmlDocPtr, BYVAL AS xmlAttrPtr) AS INTEGER
DECLARE FUNCTION xmlGetRefs(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlListPtr

#IFDEF LIBXML_VALID_ENABLED

DECLARE FUNCTION xmlNewValidCtxt() AS xmlValidCtxtPtr
DECLARE SUB xmlFreeValidCtxt(BYVAL AS xmlValidCtxtPtr)
DECLARE FUNCTION xmlValidateRoot(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr) AS INTEGER
DECLARE FUNCTION xmlValidateElementDecl(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlElementPtr) AS INTEGER
DECLARE FUNCTION xmlValidNormalizeAttributeValue(BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlChar PTR
DECLARE FUNCTION xmlValidCtxtNormalizeAttributeValue(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlChar PTR
DECLARE FUNCTION xmlValidateAttributeDecl(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlAttributePtr) AS INTEGER
DECLARE FUNCTION xmlValidateAttributeValue(BYVAL AS xmlAttributeType, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlValidateNotationDecl(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNotationPtr) AS INTEGER
DECLARE FUNCTION xmlValidateDtd(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlDtdPtr) AS INTEGER
DECLARE FUNCTION xmlValidateDtdFinal(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr) AS INTEGER
DECLARE FUNCTION xmlValidateDocument(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr) AS INTEGER
DECLARE FUNCTION xmlValidateElement(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr) AS INTEGER
DECLARE FUNCTION xmlValidateOneElement(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr) AS INTEGER
DECLARE FUNCTION xmlValidateOneAttribute(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS xmlAttrPtr, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlValidateOneNamespace(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlNsPtr, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlValidateDocumentFinal(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr) AS INTEGER

#ENDIF ' LIBXML_VALID_ENABLED

#IF DEFINED(LIBXML_VALID_ENABLED) OR DEFINED(LIBXML_SCHEMAS_ENABLED)

DECLARE FUNCTION xmlValidateNotationUse(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS INTEGER

#ENDIF ' DEFINED(LIBXML_...

DECLARE FUNCTION xmlIsMixedElement(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlGetDtdAttrDesc(BYVAL AS xmlDtdPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlAttributePtr
DECLARE FUNCTION xmlGetDtdQAttrDesc(BYVAL AS xmlDtdPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlAttributePtr
DECLARE FUNCTION xmlGetDtdNotationDesc(BYVAL AS xmlDtdPtr, BYVAL AS CONST xmlChar PTR) AS xmlNotationPtr
DECLARE FUNCTION xmlGetDtdQElementDesc(BYVAL AS xmlDtdPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlElementPtr
DECLARE FUNCTION xmlGetDtdElementDesc(BYVAL AS xmlDtdPtr, BYVAL AS CONST xmlChar PTR) AS xmlElementPtr

#IFDEF LIBXML_VALID_ENABLED

DECLARE FUNCTION xmlValidGetPotentialChildren(BYVAL AS xmlElementContent PTR, BYVAL AS CONST xmlChar PTR PTR, BYVAL AS INTEGER PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlValidGetValidElements(BYVAL AS xmlNode PTR, BYVAL AS xmlNode PTR, BYVAL AS CONST xmlChar PTR PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlValidateNameValue(BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlValidateNamesValue(BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlValidateNmtokenValue(BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlValidateNmtokensValue(BYVAL AS CONST xmlChar PTR) AS INTEGER

#IFDEF LIBXML_REGEXP_ENABLED

DECLARE FUNCTION xmlValidBuildContentModel(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlElementPtr) AS INTEGER
DECLARE FUNCTION xmlValidatePushElement(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR) AS INTEGER
DECLARE FUNCTION xmlValidatePushCData(BYVAL AS xmlValidCtxtPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlValidatePopElement(BYVAL AS xmlValidCtxtPtr, BYVAL AS xmlDocPtr, BYVAL AS xmlNodePtr, BYVAL AS CONST xmlChar PTR) AS INTEGER

#ENDIF ' LIBXML_REGEXP_ENABLED
#ENDIF ' LIBXML_VALID_ENABLED
#ENDIF ' __XML_VALID_H__

#IFNDEF __XML_ENTITIES_H__
#DEFINE __XML_ENTITIES_H__

ENUM xmlEntityType
	XML_INTERNAL_GENERAL_ENTITY = 1
	XML_EXTERNAL_GENERAL_PARSED_ENTITY = 2
	XML_EXTERNAL_GENERAL_UNPARSED_ENTITY = 3
	XML_INTERNAL_PARAMETER_ENTITY = 4
	XML_EXTERNAL_PARAMETER_ENTITY = 5
	XML_INTERNAL_PREDEFINED_ENTITY = 6
END ENUM

TYPE _xmlEntity
	AS ANY PTR _private
	AS xmlElementType type
	AS CONST xmlChar PTR name
	AS _xmlNode PTR children
	AS _xmlNode PTR last
	AS _xmlDtd PTR parent
	AS _xmlNode PTR next
	AS _xmlNode PTR prev
	AS _xmlDoc PTR doc
	AS xmlChar PTR orig
	AS xmlChar PTR content
	AS INTEGER length
	AS xmlEntityType etype
	AS CONST xmlChar PTR ExternalID
	AS CONST xmlChar PTR SystemID
	AS _xmlEntity PTR nexte
	AS CONST xmlChar PTR URI
	AS INTEGER owner
	AS INTEGER checked
END TYPE

TYPE xmlEntitiesTable AS _xmlHashTable
TYPE AS xmlEntitiesTable PTR xmlEntitiesTablePtr

#IFDEF LIBXML_LEGACY_ENABLED

DECLARE SUB xmlInitializePredefinedEntities()

#ENDIF ' LIBXML_LEGACY_ENABLED

DECLARE FUNCTION xmlNewEntity(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
DECLARE FUNCTION xmlAddDocEntity(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
DECLARE FUNCTION xmlAddDtdEntity(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
DECLARE FUNCTION xmlGetPredefinedEntity(BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
DECLARE FUNCTION xmlGetDocEntity(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
DECLARE FUNCTION xmlGetDtdEntity(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr
DECLARE FUNCTION xmlGetParameterEntity(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlEntityPtr

#IFDEF LIBXML_LEGACY_ENABLED

DECLARE FUNCTION xmlEncodeEntities(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS CONST xmlChar PTR

#ENDIF ' LIBXML_LEGACY_ENABLED

DECLARE FUNCTION xmlEncodeEntitiesReentrant(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlChar PTR
DECLARE FUNCTION xmlEncodeSpecialChars(BYVAL AS xmlDocPtr, BYVAL AS CONST xmlChar PTR) AS xmlChar PTR
DECLARE FUNCTION xmlCreateEntitiesTable() AS xmlEntitiesTablePtr

#IFDEF LIBXML_TREE_ENABLED

DECLARE FUNCTION xmlCopyEntitiesTable(BYVAL AS xmlEntitiesTablePtr) AS xmlEntitiesTablePtr

#ENDIF ' LIBXML_TREE_ENABLED

DECLARE SUB xmlFreeEntitiesTable(BYVAL AS xmlEntitiesTablePtr)

#IFDEF LIBXML_OUTPUT_ENABLED

DECLARE SUB xmlDumpEntitiesTable(BYVAL AS xmlBufferPtr, BYVAL AS xmlEntitiesTablePtr)
DECLARE SUB xmlDumpEntityDecl(BYVAL AS xmlBufferPtr, BYVAL AS xmlEntityPtr)

#ENDIF ' LIBXML_OUTPUT_ENABLED

#IFDEF LIBXML_LEGACY_ENABLED

DECLARE SUB xmlCleanupPredefinedEntities()

#ENDIF ' LIBXML_LEGACY_ENABLED
#ENDIF ' __XML_ENTITIES_H__

#DEFINE XML_DEFAULT_VERSION @!"1.0"

TYPE xmlParserInputDeallocate AS SUB(BYVAL AS xmlChar PTR)

TYPE _xmlParserInput
	AS xmlParserInputBufferPtr buf
	AS CONST ZSTRING PTR filename
	AS CONST ZSTRING PTR directory
	AS CONST xmlChar PTR base
	AS CONST xmlChar PTR cur
	AS CONST xmlChar PTR end
	AS INTEGER length
	AS INTEGER line
	AS INTEGER col
	AS UINTEGER consumed
	AS xmlParserInputDeallocate free
	AS CONST xmlChar PTR encoding
	AS CONST xmlChar PTR version
	AS INTEGER standalone
	AS INTEGER id
END TYPE

TYPE xmlParserNodeInfo AS _xmlParserNodeInfo
TYPE AS xmlParserNodeInfo PTR xmlParserNodeInfoPtr

TYPE _xmlParserNodeInfo
	AS CONST _xmlNode PTR node
	AS UINTEGER begin_pos
	AS UINTEGER begin_line
	AS UINTEGER end_pos
	AS UINTEGER end_line
END TYPE

TYPE xmlParserNodeInfoSeq AS _xmlParserNodeInfoSeq
TYPE AS xmlParserNodeInfoSeq PTR xmlParserNodeInfoSeqPtr

TYPE _xmlParserNodeInfoSeq
	AS UINTEGER maximum
	AS UINTEGER length
	AS xmlParserNodeInfo PTR buffer
END TYPE

ENUM xmlParserInputState
	XML_PARSER_EOF = -1
	XML_PARSER_START = 0
	XML_PARSER_MISC
	XML_PARSER_PI
	XML_PARSER_DTD
	XML_PARSER_PROLOG
	XML_PARSER_COMMENT
	XML_PARSER_START_TAG
	XML_PARSER_CONTENT
	XML_PARSER_CDATA_SECTION
	XML_PARSER_END_TAG
	XML_PARSER_ENTITY_DECL
	XML_PARSER_ENTITY_VALUE
	XML_PARSER_ATTRIBUTE_VALUE
	XML_PARSER_SYSTEM_LITERAL
	XML_PARSER_EPILOG
	XML_PARSER_IGNORE
	XML_PARSER_PUBLIC_LITERAL
END ENUM

#DEFINE XML_DETECT_IDS 2
#DEFINE XML_COMPLETE_ATTRS 4
#DEFINE XML_SKIP_IDS 8

ENUM xmlParserMode
	XML_PARSE_UNKNOWN = 0
	XML_PARSE_DOM = 1
	XML_PARSE_SAX = 2
	XML_PARSE_PUSH_DOM = 3
	XML_PARSE_PUSH_SAX = 4
	XML_PARSE_READER = 5
END ENUM

TYPE _xmlParserCtxt
	AS xmlSAXHandler PTR sax
	AS ANY PTR userData
	AS xmlDocPtr myDoc
	AS INTEGER wellFormed
	AS INTEGER replaceEntities
	AS CONST xmlChar PTR version
	AS CONST xmlChar PTR encoding
	AS INTEGER standalone
	AS INTEGER html
	AS xmlParserInputPtr input
	AS INTEGER inputNr
	AS INTEGER inputMax
	AS xmlParserInputPtr PTR inputTab
	AS xmlNodePtr node
	AS INTEGER nodeNr
	AS INTEGER nodeMax
	AS xmlNodePtr PTR nodeTab
	AS INTEGER record_info
	AS xmlParserNodeInfoSeq node_seq
	AS INTEGER errNo
	AS INTEGER hasExternalSubset
	AS INTEGER hasPErefs
	AS INTEGER external
	AS INTEGER valid
	AS INTEGER validate
	AS xmlValidCtxt vctxt
	AS xmlParserInputState instate
	AS INTEGER token
	AS ZSTRING PTR directory
	AS CONST xmlChar PTR name
	AS INTEGER nameNr
	AS INTEGER nameMax
	AS CONST xmlChar PTR PTR nameTab
	AS INTEGER nbChars
	AS INTEGER checkIndex
	AS INTEGER keepBlanks
	AS INTEGER disableSAX
	AS INTEGER inSubset
	AS CONST xmlChar PTR intSubName
	AS xmlChar PTR extSubURI
	AS xmlChar PTR extSubSystem
	AS INTEGER PTR space
	AS INTEGER spaceNr
	AS INTEGER spaceMax
	AS INTEGER PTR spaceTab
	AS INTEGER depth
	AS xmlParserInputPtr entity
	AS INTEGER charset
	AS INTEGER nodelen
	AS INTEGER nodemem
	AS INTEGER pedantic
	AS ANY PTR _private
	AS INTEGER loadsubset
	AS INTEGER linenumbers
	AS ANY PTR catalogs
	AS INTEGER recovery
	AS INTEGER progressive
	AS xmlDictPtr dict
	AS CONST xmlChar PTR PTR atts
	AS INTEGER maxatts
	AS INTEGER docdict
	AS CONST xmlChar PTR str_xml
	AS CONST xmlChar PTR str_xmlns
	AS CONST xmlChar PTR str_xml_ns
	AS INTEGER sax2
	AS INTEGER nsNr
	AS INTEGER nsMax
	AS CONST xmlChar PTR PTR nsTab
	AS INTEGER PTR attallocs
	AS ANY PTR PTR pushTab
	AS xmlHashTablePtr attsDefault
	AS xmlHashTablePtr attsSpecial
	AS INTEGER nsWellFormed
	AS INTEGER options
	AS INTEGER dictNames
	AS INTEGER freeElemsNr
	AS xmlNodePtr freeElems
	AS INTEGER freeAttrsNr
	AS xmlAttrPtr freeAttrs
	AS xmlError lastError
	AS xmlParserMode parseMode
	AS UINTEGER nbentities
	AS UINTEGER sizeentities
	AS xmlParserNodeInfo PTR nodeInfo
	AS INTEGER nodeInfoNr
	AS INTEGER nodeInfoMax
	AS xmlParserNodeInfo PTR nodeInfoTab
END TYPE

#DEFINE XML_SAX2_MAGIC &hDEEDBEAF

TYPE startElementNsSAX2Func AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR PTR)
TYPE endElementNsSAX2Func AS SUB(BYVAL AS ANY PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR)

TYPE xmlExternalEntityLoader AS FUNCTION(BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlParserCtxtPtr) AS xmlParserInputPtr

#IFNDEF __XML_CHAR_ENCODING_H__
#DEFINE __XML_CHAR_ENCODING_H__

#IFDEF LIBXML_ICONV_ENABLED

#INCLUDE ONCE "iconv.bi"

#ENDIF ' LIBXML_ICONV_ENABLED

#IFDEF LIBXML_ICU_ENABLED

' file not found: unicode/ucnv.h

#ENDIF ' LIBXML_ICU_ENABLED

TYPE xmlCharEncodingInputFunc AS FUNCTION(BYVAL AS UBYTE PTR, BYVAL AS INTEGER PTR, BYVAL AS CONST UBYTE PTR, BYVAL AS INTEGER PTR) AS INTEGER
TYPE xmlCharEncodingOutputFunc AS FUNCTION(BYVAL AS UBYTE PTR, BYVAL AS INTEGER PTR, BYVAL AS CONST UBYTE PTR, BYVAL AS INTEGER PTR) AS INTEGER

#IFDEF LIBXML_ICU_ENABLED

TYPE _uconv_t
	AS UConverter PTR uconv
	AS UConverter PTR utf8
END TYPE

TYPE uconv_t AS _uconv_t

#ENDIF ' LIBXML_ICU_ENABLED

TYPE _xmlCharEncodingHandler
	AS ZSTRING PTR name
	AS xmlCharEncodingInputFunc input
	AS xmlCharEncodingOutputFunc output
#IFDEF LIBXML_ICONV_ENABLED
	AS iconv_t iconv_in
	AS iconv_t iconv_out
#ENDIF ' LIBXML_ICONV_ENABLED
#IFDEF LIBXML_ICU_ENABLED
	AS uconv_t PTR uconv_in
	AS uconv_t PTR uconv_out
#ENDIF ' LIBXML_ICU_ENABLED
END TYPE

DECLARE SUB xmlInitCharEncodingHandlers()
DECLARE SUB xmlCleanupCharEncodingHandlers()
DECLARE SUB xmlRegisterCharEncodingHandler(BYVAL AS xmlCharEncodingHandlerPtr)
DECLARE FUNCTION xmlGetCharEncodingHandler(BYVAL AS xmlCharEncoding) AS xmlCharEncodingHandlerPtr
DECLARE FUNCTION xmlFindCharEncodingHandler(BYVAL AS CONST ZSTRING PTR) AS xmlCharEncodingHandlerPtr
DECLARE FUNCTION xmlNewCharEncodingHandler(BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlCharEncodingInputFunc, BYVAL AS xmlCharEncodingOutputFunc) AS xmlCharEncodingHandlerPtr
DECLARE FUNCTION xmlAddEncodingAlias(BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlDelEncodingAlias(BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlGetEncodingAlias(BYVAL AS CONST ZSTRING PTR) AS CONST ZSTRING PTR
DECLARE SUB xmlCleanupEncodingAliases()
DECLARE FUNCTION xmlParseCharEncoding(BYVAL AS CONST ZSTRING PTR) AS xmlCharEncoding
DECLARE FUNCTION xmlGetCharEncodingName(BYVAL AS xmlCharEncoding) AS CONST ZSTRING PTR
DECLARE FUNCTION xmlDetectCharEncoding(BYVAL AS CONST UBYTE PTR, BYVAL AS INTEGER) AS xmlCharEncoding
DECLARE FUNCTION xmlCharEncOutFunc(BYVAL AS xmlCharEncodingHandler PTR, BYVAL AS xmlBufferPtr, BYVAL AS xmlBufferPtr) AS INTEGER
DECLARE FUNCTION xmlCharEncInFunc(BYVAL AS xmlCharEncodingHandler PTR, BYVAL AS xmlBufferPtr, BYVAL AS xmlBufferPtr) AS INTEGER
DECLARE FUNCTION xmlCharEncFirstLine(BYVAL AS xmlCharEncodingHandler PTR, BYVAL AS xmlBufferPtr, BYVAL AS xmlBufferPtr) AS INTEGER
DECLARE FUNCTION xmlCharEncCloseFunc(BYVAL AS xmlCharEncodingHandler PTR) AS INTEGER

#IFDEF LIBXML_OUTPUT_ENABLED

DECLARE FUNCTION UTF8Toisolat1(BYVAL AS UBYTE PTR, BYVAL AS INTEGER PTR, BYVAL AS CONST UBYTE PTR, BYVAL AS INTEGER PTR) AS INTEGER

#ENDIF ' LIBXML_OUTPUT_ENABLED

DECLARE FUNCTION isolat1ToUTF8(BYVAL AS UBYTE PTR, BYVAL AS INTEGER PTR, BYVAL AS CONST UBYTE PTR, BYVAL AS INTEGER PTR) AS INTEGER

#ENDIF ' __XML_CHAR_ENCODING_H__

#IFNDEF __XML_IO_H__
#DEFINE __XML_IO_H__

TYPE xmlInputMatchCallback AS FUNCTION(BYVAL AS ZSTRING CONST PTR) AS INTEGER
TYPE xmlInputOpenCallback AS FUNCTION(BYVAL AS ZSTRING CONST PTR) AS ANY PTR
TYPE xmlInputReadCallback AS FUNCTION(BYVAL AS ANY PTR, BYVAL AS ZSTRING PTR, BYVAL AS INTEGER) AS INTEGER
TYPE xmlInputCloseCallback AS FUNCTION(BYVAL AS ANY PTR) AS INTEGER

#IFDEF LIBXML_OUTPUT_ENABLED

TYPE xmlOutputMatchCallback AS FUNCTION(BYVAL AS ZSTRING CONST PTR) AS INTEGER
TYPE xmlOutputOpenCallback AS FUNCTION(BYVAL AS ZSTRING CONST PTR) AS ANY PTR
TYPE xmlOutputWriteCallback AS FUNCTION(BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS INTEGER
TYPE xmlOutputCloseCallback AS FUNCTION(BYVAL AS ANY PTR) AS INTEGER

#ENDIF ' LIBXML_OUTPUT_ENABLED

TYPE _xmlParserInputBuffer
	AS ANY PTR context
	AS xmlInputReadCallback readcallback
	AS xmlInputCloseCallback closecallback
	AS xmlCharEncodingHandlerPtr encoder
	AS xmlBufferPtr buffer
	AS xmlBufferPtr raw
	AS INTEGER compressed
	AS INTEGER error
	AS UINTEGER rawconsumed
END TYPE

#IFDEF LIBXML_OUTPUT_ENABLED

TYPE _xmlOutputBuffer
	AS ANY PTR context
	AS xmlOutputWriteCallback writecallback
	AS xmlOutputCloseCallback closecallback
	AS xmlCharEncodingHandlerPtr encoder
	AS xmlBufferPtr buffer
	AS xmlBufferPtr conv
	AS INTEGER written
	AS INTEGER error
END TYPE

#ENDIF ' LIBXML_OUTPUT_ENABLED

DECLARE SUB xmlCleanupInputCallbacks()
DECLARE FUNCTION xmlPopInputCallbacks() AS INTEGER
DECLARE SUB xmlRegisterDefaultInputCallbacks()
DECLARE FUNCTION xmlAllocParserInputBuffer(BYVAL AS xmlCharEncoding) AS xmlParserInputBufferPtr
DECLARE FUNCTION xmlParserInputBufferCreateFilename(BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlCharEncoding) AS xmlParserInputBufferPtr
DECLARE FUNCTION xmlParserInputBufferCreateFile(BYVAL AS FILE PTR, BYVAL AS xmlCharEncoding) AS xmlParserInputBufferPtr
DECLARE FUNCTION xmlParserInputBufferCreateFd(BYVAL AS INTEGER, BYVAL AS xmlCharEncoding) AS xmlParserInputBufferPtr
DECLARE FUNCTION xmlParserInputBufferCreateMem(BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS xmlCharEncoding) AS xmlParserInputBufferPtr
DECLARE FUNCTION xmlParserInputBufferCreateStatic(BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS xmlCharEncoding) AS xmlParserInputBufferPtr
DECLARE FUNCTION xmlParserInputBufferCreateIO(BYVAL AS xmlInputReadCallback, BYVAL AS xmlInputCloseCallback, BYVAL AS ANY PTR, BYVAL AS xmlCharEncoding) AS xmlParserInputBufferPtr
DECLARE FUNCTION xmlParserInputBufferRead(BYVAL AS xmlParserInputBufferPtr, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlParserInputBufferGrow(BYVAL AS xmlParserInputBufferPtr, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlParserInputBufferPush(BYVAL AS xmlParserInputBufferPtr, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE SUB xmlFreeParserInputBuffer(BYVAL AS xmlParserInputBufferPtr)
DECLARE FUNCTION xmlParserGetDirectory(BYVAL AS CONST ZSTRING PTR) AS ZSTRING PTR
DECLARE FUNCTION xmlRegisterInputCallbacks(BYVAL AS xmlInputMatchCallback, BYVAL AS xmlInputOpenCallback, BYVAL AS xmlInputReadCallback, BYVAL AS xmlInputCloseCallback) AS INTEGER
DECLARE FUNCTION __xmlParserInputBufferCreateFilename(BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlCharEncoding) AS xmlParserInputBufferPtr

#IFDEF LIBXML_OUTPUT_ENABLED

DECLARE SUB xmlCleanupOutputCallbacks()
DECLARE SUB xmlRegisterDefaultOutputCallbacks()
DECLARE FUNCTION xmlAllocOutputBuffer(BYVAL AS xmlCharEncodingHandlerPtr) AS xmlOutputBufferPtr
DECLARE FUNCTION xmlOutputBufferCreateFilename(BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlCharEncodingHandlerPtr, BYVAL AS INTEGER) AS xmlOutputBufferPtr
DECLARE FUNCTION xmlOutputBufferCreateFile(BYVAL AS FILE PTR, BYVAL AS xmlCharEncodingHandlerPtr) AS xmlOutputBufferPtr
DECLARE FUNCTION xmlOutputBufferCreateBuffer(BYVAL AS xmlBufferPtr, BYVAL AS xmlCharEncodingHandlerPtr) AS xmlOutputBufferPtr
DECLARE FUNCTION xmlOutputBufferCreateFd(BYVAL AS INTEGER, BYVAL AS xmlCharEncodingHandlerPtr) AS xmlOutputBufferPtr
DECLARE FUNCTION xmlOutputBufferCreateIO(BYVAL AS xmlOutputWriteCallback, BYVAL AS xmlOutputCloseCallback, BYVAL AS ANY PTR, BYVAL AS xmlCharEncodingHandlerPtr) AS xmlOutputBufferPtr
DECLARE FUNCTION xmlOutputBufferWrite(BYVAL AS xmlOutputBufferPtr, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlOutputBufferWriteString(BYVAL AS xmlOutputBufferPtr, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlOutputBufferWriteEscape(BYVAL AS xmlOutputBufferPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlCharEncodingOutputFunc) AS INTEGER
DECLARE FUNCTION xmlOutputBufferFlush(BYVAL AS xmlOutputBufferPtr) AS INTEGER
DECLARE FUNCTION xmlOutputBufferClose(BYVAL AS xmlOutputBufferPtr) AS INTEGER
DECLARE FUNCTION xmlRegisterOutputCallbacks(BYVAL AS xmlOutputMatchCallback, BYVAL AS xmlOutputOpenCallback, BYVAL AS xmlOutputWriteCallback, BYVAL AS xmlOutputCloseCallback) AS INTEGER
DECLARE FUNCTION __xmlOutputBufferCreateFilename(BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlCharEncodingHandlerPtr, BYVAL AS INTEGER) AS xmlOutputBufferPtr

#IFDEF LIBXML_HTTP_ENABLED

DECLARE SUB xmlRegisterHTTPPostCallbacks()

#ENDIF ' LIBXML_HTTP_ENABLED
#ENDIF ' LIBXML_OUTPUT_ENABLED

DECLARE FUNCTION xmlCheckHTTPInput(BYVAL AS xmlParserCtxtPtr, BYVAL AS xmlParserInputPtr) AS xmlParserInputPtr
DECLARE FUNCTION xmlNoNetExternalEntityLoader(BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlParserCtxtPtr) AS xmlParserInputPtr
DECLARE FUNCTION xmlNormalizeWindowsPath(BYVAL AS CONST xmlChar PTR) AS xmlChar PTR
DECLARE FUNCTION xmlCheckFilename(BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlFileMatch(BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlFileOpen(BYVAL AS CONST ZSTRING PTR) AS ANY PTR
DECLARE FUNCTION xmlFileRead(BYVAL AS ANY PTR, BYVAL AS ZSTRING PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlFileClose(BYVAL AS ANY PTR) AS INTEGER

#IFDEF LIBXML_HTTP_ENABLED

DECLARE FUNCTION xmlIOHTTPMatch(BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlIOHTTPOpen(BYVAL AS CONST ZSTRING PTR) AS ANY PTR

#IFDEF LIBXML_OUTPUT_ENABLED

DECLARE FUNCTION xmlIOHTTPOpenW(BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS ANY PTR

#ENDIF ' LIBXML_OUTPUT_ENABLED

DECLARE FUNCTION xmlIOHTTPRead(BYVAL AS ANY PTR, BYVAL AS ZSTRING PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlIOHTTPClose(BYVAL AS ANY PTR) AS INTEGER

#ENDIF ' LIBXML_HTTP_ENABLED

#IFDEF LIBXML_FTP_ENABLED

DECLARE FUNCTION xmlIOFTPMatch(BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlIOFTPOpen(BYVAL AS CONST ZSTRING PTR) AS ANY PTR
DECLARE FUNCTION xmlIOFTPRead(BYVAL AS ANY PTR, BYVAL AS ZSTRING PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlIOFTPClose(BYVAL AS ANY PTR) AS INTEGER

#ENDIF ' LIBXML_FTP_ENABLED
#ENDIF ' __XML_IO_H__

DECLARE SUB xmlInitParser()
DECLARE SUB xmlCleanupParser()
DECLARE FUNCTION xmlParserInputRead(BYVAL AS xmlParserInputPtr, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlParserInputGrow(BYVAL AS xmlParserInputPtr, BYVAL AS INTEGER) AS INTEGER

#IFDEF LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlParseDoc(BYVAL AS CONST xmlChar PTR) AS xmlDocPtr
DECLARE FUNCTION xmlParseFile(BYVAL AS CONST ZSTRING PTR) AS xmlDocPtr
DECLARE FUNCTION xmlParseMemory(BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr

#ENDIF ' LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlSubstituteEntitiesDefault(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlKeepBlanksDefault(BYVAL AS INTEGER) AS INTEGER
DECLARE SUB xmlStopParser(BYVAL AS xmlParserCtxtPtr)
DECLARE FUNCTION xmlPedanticParserDefault(BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlLineNumbersDefault(BYVAL AS INTEGER) AS INTEGER

#IFDEF LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlRecoverDoc(BYVAL AS CONST xmlChar PTR) AS xmlDocPtr
DECLARE FUNCTION xmlRecoverMemory(BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlRecoverFile(BYVAL AS CONST ZSTRING PTR) AS xmlDocPtr

#ENDIF ' LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlParseDocument(BYVAL AS xmlParserCtxtPtr) AS INTEGER
DECLARE FUNCTION xmlParseExtParsedEnt(BYVAL AS xmlParserCtxtPtr) AS INTEGER

#IFDEF LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlSAXUserParseFile(BYVAL AS xmlSAXHandlerPtr, BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlSAXUserParseMemory(BYVAL AS xmlSAXHandlerPtr, BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlSAXParseDoc(BYVAL AS xmlSAXHandlerPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlSAXParseMemory(BYVAL AS xmlSAXHandlerPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlSAXParseMemoryWithData(BYVAL AS xmlSAXHandlerPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS ANY PTR) AS xmlDocPtr
DECLARE FUNCTION xmlSAXParseFile(BYVAL AS xmlSAXHandlerPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlSAXParseFileWithData(BYVAL AS xmlSAXHandlerPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS ANY PTR) AS xmlDocPtr
DECLARE FUNCTION xmlSAXParseEntity(BYVAL AS xmlSAXHandlerPtr, BYVAL AS CONST ZSTRING PTR) AS xmlDocPtr
DECLARE FUNCTION xmlParseEntity(BYVAL AS CONST ZSTRING PTR) AS xmlDocPtr

#ENDIF ' LIBXML_SAX1_ENABLED

#IFDEF LIBXML_VALID_ENABLED

DECLARE FUNCTION xmlSAXParseDTD(BYVAL AS xmlSAXHandlerPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlDtdPtr
DECLARE FUNCTION xmlParseDTD(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR) AS xmlDtdPtr
DECLARE FUNCTION xmlIOParseDTD(BYVAL AS xmlSAXHandlerPtr, BYVAL AS xmlParserInputBufferPtr, BYVAL AS xmlCharEncoding) AS xmlDtdPtr

#ENDIF ' LIBXML_VALID_ENABLED

#IFDEF LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlParseBalancedChunkMemory(BYVAL AS xmlDocPtr, BYVAL AS xmlSAXHandlerPtr, BYVAL AS ANY PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlNodePtr PTR) AS INTEGER

#ENDIF ' LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlParseInNodeContext(BYVAL AS xmlNodePtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS xmlNodePtr PTR) AS xmlParserErrors

#IFDEF LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlParseBalancedChunkMemoryRecover(BYVAL AS xmlDocPtr, BYVAL AS xmlSAXHandlerPtr, BYVAL AS ANY PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlNodePtr PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlParseExternalEntity(BYVAL AS xmlDocPtr, BYVAL AS xmlSAXHandlerPtr, BYVAL AS ANY PTR, BYVAL AS INTEGER, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlNodePtr PTR) AS INTEGER

#ENDIF ' LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlParseCtxtExternalEntity(BYVAL AS xmlParserCtxtPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST xmlChar PTR, BYVAL AS xmlNodePtr PTR) AS INTEGER
DECLARE FUNCTION xmlNewParserCtxt() AS xmlParserCtxtPtr
DECLARE FUNCTION xmlInitParserCtxt(BYVAL AS xmlParserCtxtPtr) AS INTEGER
DECLARE SUB xmlClearParserCtxt(BYVAL AS xmlParserCtxtPtr)
DECLARE SUB xmlFreeParserCtxt(BYVAL AS xmlParserCtxtPtr)

#IFDEF LIBXML_SAX1_ENABLED

DECLARE SUB xmlSetupParserForBuffer(BYVAL AS xmlParserCtxtPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST ZSTRING PTR)

#ENDIF ' LIBXML_SAX1_ENABLED

DECLARE FUNCTION xmlCreateDocParserCtxt(BYVAL AS CONST xmlChar PTR) AS xmlParserCtxtPtr

#IFDEF LIBXML_LEGACY_ENABLED

DECLARE FUNCTION xmlGetFeaturesList(BYVAL AS INTEGER PTR, BYVAL AS CONST ZSTRING PTR PTR) AS INTEGER
DECLARE FUNCTION xmlGetFeature(BYVAL AS xmlParserCtxtPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION xmlSetFeature(BYVAL AS xmlParserCtxtPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS ANY PTR) AS INTEGER

#ENDIF ' LIBXML_LEGACY_ENABLED

#IFDEF LIBXML_PUSH_ENABLED

DECLARE FUNCTION xmlCreatePushParserCtxt(BYVAL AS xmlSAXHandlerPtr, BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR) AS xmlParserCtxtPtr
DECLARE FUNCTION xmlParseChunk(BYVAL AS xmlParserCtxtPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER

#ENDIF ' LIBXML_PUSH_ENABLED

DECLARE FUNCTION xmlCreateIOParserCtxt(BYVAL AS xmlSAXHandlerPtr, BYVAL AS ANY PTR, BYVAL AS xmlInputReadCallback, BYVAL AS xmlInputCloseCallback, BYVAL AS ANY PTR, BYVAL AS xmlCharEncoding) AS xmlParserCtxtPtr
DECLARE FUNCTION xmlNewIOInputStream(BYVAL AS xmlParserCtxtPtr, BYVAL AS xmlParserInputBufferPtr, BYVAL AS xmlCharEncoding) AS xmlParserInputPtr
DECLARE FUNCTION xmlParserFindNodeInfo(BYVAL AS CONST xmlParserCtxtPtr, BYVAL AS CONST xmlNodePtr) AS CONST xmlParserNodeInfo PTR
DECLARE SUB xmlInitNodeInfoSeq(BYVAL AS xmlParserNodeInfoSeqPtr)
DECLARE SUB xmlClearNodeInfoSeq(BYVAL AS xmlParserNodeInfoSeqPtr)
DECLARE FUNCTION xmlParserFindNodeInfoIndex(BYVAL AS CONST xmlParserNodeInfoSeqPtr, BYVAL AS CONST xmlNodePtr) AS UINTEGER
DECLARE SUB xmlParserAddNodeInfo(BYVAL AS xmlParserCtxtPtr, BYVAL AS CONST xmlParserNodeInfoPtr)
DECLARE SUB xmlSetExternalEntityLoader(BYVAL AS xmlExternalEntityLoader)
DECLARE FUNCTION xmlGetExternalEntityLoader() AS xmlExternalEntityLoader
DECLARE FUNCTION xmlLoadExternalEntity(BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS xmlParserCtxtPtr) AS xmlParserInputPtr
DECLARE FUNCTION xmlByteConsumed(BYVAL AS xmlParserCtxtPtr) AS INTEGER

ENUM xmlParserOption
	XML_PARSE_RECOVER = 1 SHL 0
	XML_PARSE_NOENT = 1 SHL 1
	XML_PARSE_DTDLOAD = 1 SHL 2
	XML_PARSE_DTDATTR = 1 SHL 3
	XML_PARSE_DTDVALID = 1 SHL 4
	XML_PARSE_NOERROR = 1 SHL 5
	XML_PARSE_NOWARNING = 1 SHL 6
	XML_PARSE_PEDANTIC = 1 SHL 7
	XML_PARSE_NOBLANKS = 1 SHL 8
	XML_PARSE_SAX1 = 1 SHL 9
	XML_PARSE_XINCLUDE = 1 SHL 10
	XML_PARSE_NONET = 1 SHL 11
	XML_PARSE_NODICT = 1 SHL 12
	XML_PARSE_NSCLEAN = 1 SHL 13
	XML_PARSE_NOCDATA = 1 SHL 14
	XML_PARSE_NOXINCNODE = 1 SHL 15
	XML_PARSE_COMPACT = 1 SHL 16
	XML_PARSE_OLD10 = 1 SHL 17
	XML_PARSE_NOBASEFIX = 1 SHL 18
	XML_PARSE_HUGE = 1 SHL 19
	XML_PARSE_OLDSAX = 1 SHL 20
END ENUM

DECLARE SUB xmlCtxtReset(BYVAL AS xmlParserCtxtPtr)
DECLARE FUNCTION xmlCtxtResetPush(BYVAL AS xmlParserCtxtPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION xmlCtxtUseOptions(BYVAL AS xmlParserCtxtPtr, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION xmlReadDoc(BYVAL AS CONST xmlChar PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlReadFile(BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlReadMemory(BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlReadFd(BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlReadIO(BYVAL AS xmlInputReadCallback, BYVAL AS xmlInputCloseCallback, BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlCtxtReadDoc(BYVAL AS xmlParserCtxtPtr, BYVAL AS CONST xmlChar PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlCtxtReadFile(BYVAL AS xmlParserCtxtPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlCtxtReadMemory(BYVAL AS xmlParserCtxtPtr, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlCtxtReadFd(BYVAL AS xmlParserCtxtPtr, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr
DECLARE FUNCTION xmlCtxtReadIO(BYVAL AS xmlParserCtxtPtr, BYVAL AS xmlInputReadCallback, BYVAL AS xmlInputCloseCallback, BYVAL AS ANY PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS xmlDocPtr

ENUM xmlFeature
	XML_WITH_THREAD = 1
	XML_WITH_TREE = 2
	XML_WITH_OUTPUT = 3
	XML_WITH_PUSH = 4
	XML_WITH_READER = 5
	XML_WITH_PATTERN = 6
	XML_WITH_WRITER = 7
	XML_WITH_SAX1 = 8
	XML_WITH_FTP = 9
	XML_WITH_HTTP = 10
	XML_WITH_VALID = 11
	XML_WITH_HTML = 12
	XML_WITH_LEGACY = 13
	XML_WITH_C14N = 14
	XML_WITH_CATALOG = 15
	XML_WITH_XPATH = 16
	XML_WITH_XPTR = 17
	XML_WITH_XINCLUDE = 18
	XML_WITH_ICONV = 19
	XML_WITH_ISO8859X = 20
	XML_WITH_UNICODE = 21
	XML_WITH_REGEXP = 22
	XML_WITH_AUTOMATA = 23
	XML_WITH_EXPR = 24
	XML_WITH_SCHEMAS = 25
	XML_WITH_SCHEMATRON = 26
	XML_WITH_MODULES = 27
	XML_WITH_DEBUG = 28
	XML_WITH_DEBUG_MEM = 29
	XML_WITH_DEBUG_RUN = 30
	XML_WITH_ZLIB = 31
	XML_WITH_ICU = 32
	XML_WITH_NONE = 99999
END ENUM

DECLARE FUNCTION xmlHasFeature(BYVAL AS xmlFeature) AS INTEGER

#ENDIF ' __XML_PARSER_H__

END EXTERN ' (h_2_bi -P_oCD option)

#IFDEF __FB_WIN32__
#PRAGMA pop(msbitfields)
#ENDIF

' Translated at 13-01-31 20:09:36, by h_2_bi (version 0.2.2.1,
' released under GPLv3 by Thomas[ dot ]Freiherr{ at }gmx[ dot ]net)

'   Protocol: libxml2.bi
' Parameters: 
'                                  Process time [s]: 0.4343211019877344
'                                  Bytes translated: 154495
'                                      Maximum deep: 7
'                                SUB/FUNCTION names: 776
'                                mangled TYPE names: 0
'                                        files done: 21
' /usr/include/libxml2/libxml/parser.h
' /usr/include/libxml2/libxml/xmlversion.h
' /usr/include/libxml2/libxml/xmlexports.h
' /usr/include/libxml2/libxml/tree.h
' /usr/include/libxml2/libxml/xmlstring.h
' /usr/include/libxml2/libxml/xmlregexp.h
' /usr/include/libxml2/libxml/dict.h
' /usr/include/libxml2/libxml/xmlmemory.h
' /usr/include/libxml2/libxml/threads.h
' /usr/include/libxml2/libxml/globals.h
' /usr/include/libxml2/libxml/xmlerror.h
' /usr/include/libxml2/libxml/SAX.h
' /usr/include/libxml2/libxml/xlink.h
' /usr/include/libxml2/libxml/SAX2.h
' /usr/include/libxml2/libxml/hash.h
' /usr/include/libxml2/libxml/valid.h
' /usr/include/libxml2/libxml/list.h
' /usr/include/libxml2/libxml/xmlautomata.h
' /usr/include/libxml2/libxml/entities.h
' /usr/include/libxml2/libxml/encoding.h
' /usr/include/libxml2/libxml/xmlIO.h
'                                      files missed: 3
' ansidecl.h
' iconv.h
' unicode/ucnv.h
'                                       __FOLDERS__: 2
' /usr/include/libxml2/libxml/
' /usr/include/libxml2/
'                                        __MACROS__: 4
' 712: #define XMLPUBFUN
' 40: #define XMLPUBVAR extern
' 721: #define XMLCALL
' 10: #define XMLCDECL
'                                       __HEADERS__: 0
'                                         __TYPES__: 0
'                                     __POST_REPS__: 0
