' FreeBasic header for libgda version 5.1.1
' (C) by Thomas{ dot ]Freiherr{ at }gmx[ dot }at, licence LGPLv2
' Translated with help of h_2_bi.bas
'
' Original licence text:
'/*
 '* Copyright (C) 2000 Reinhard MÃŒller <reinhard@src.gnome.org>
 '* Copyright (C) 2000 - 2004 Rodrigo Moya <rodrigo@gnome-db.org>
 '* Copyright (C) 2001 Carlos Perelló Marín <carlos@gnome-db.org>
 '* Copyright (C) 2001 - 2011 Vivien Malerba <malerba@gnome-db.org>
 '* Copyright (C) 2002 Andrew Hill <andru@src.gnome.org>
 '* Copyright (C) 2002 - 2003 Gonzalo Paniagua Javier <gonzalo@ximian.com>
 '* Copyright (C) 2003 - 2006 Murray Cumming <murrayc@murrayc.com>
 '* Copyright (C) 2004 Szalai Ferenc <szferi@einstein.ki.iif.hu>
 '* Copyright (C) 2005 Bas Driessen <bas.driessen@xobas.com>
 '* Copyright (C) 2005 Álvaro Peña <alvaropg@telefonica.net>
 '*
 '* This library is free software; you can redistribute it and/or
 '* modify it under the terms of the GNU Lesser General Public
 '* License as published by the Free Software Foundation; either
 '* version 2 of the License, or (at your option) any later version.
 '*
 '* This library is distributed in the hope that it will be useful,
 '* but WITHOUT ANY WARRANTY; without even the implied warranty of
 '* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 '* Lesser General Public License for more details.
 '*
 '* You should have received a copy of the GNU Lesser General Public
 '* License along with this library; if not, write to the
 '* Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 '* Boston, MA  02110-1301, USA.
 '*/

#IFDEF __FB_WIN32__
#PRAGMA push(msbitfields)
#ENDIF

#INCLIB "gda-5.0"

#LANG "fb"
EXTERN "C" ' (h_2_bi -P_oCD option)

#IFNDEF __LIBGDA_H__
#DEFINE __LIBGDA_H__

#IFNDEF __GDA_ATTRIBUTES_MANAGER_H__
#DEFINE __GDA_ATTRIBUTES_MANAGER_H__
#INCLUDE ONCE "glib-object.bi"

TYPE GdaAttributesManager AS _GdaAttributesManager
TYPE GdaAttributesManagerFunc AS SUB(BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR, BYVAL AS gpointer)
TYPE GdaAttributesManagerSignal AS SUB(BYVAL AS GObject PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR, BYVAL AS gpointer)

DECLARE FUNCTION gda_attributes_manager_new(BYVAL AS gboolean, BYVAL AS GdaAttributesManagerSignal, BYVAL AS gpointer) AS GdaAttributesManager PTR
DECLARE SUB gda_attributes_manager_free(BYVAL AS GdaAttributesManager PTR)
DECLARE SUB gda_attributes_manager_set(BYVAL AS GdaAttributesManager PTR, BYVAL AS gpointer, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR)
DECLARE SUB gda_attributes_manager_set_full(BYVAL AS GdaAttributesManager PTR, BYVAL AS gpointer, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR, BYVAL AS GDestroyNotify)
DECLARE FUNCTION gda_attributes_manager_get(BYVAL AS GdaAttributesManager PTR, BYVAL AS gpointer, BYVAL AS CONST gchar PTR) AS CONST GValue PTR
DECLARE SUB gda_attributes_manager_copy(BYVAL AS GdaAttributesManager PTR, BYVAL AS gpointer PTR, BYVAL AS GdaAttributesManager PTR, BYVAL AS gpointer PTR)
DECLARE SUB gda_attributes_manager_clear(BYVAL AS GdaAttributesManager PTR, BYVAL AS gpointer)
DECLARE SUB gda_attributes_manager_foreach(BYVAL AS GdaAttributesManager PTR, BYVAL AS gpointer, BYVAL AS GdaAttributesManagerFunc, BYVAL AS gpointer)

#DEFINE GDA_ATTRIBUTE_DESCRIPTION @!"__gda_attr_descr"
#DEFINE GDA_ATTRIBUTE_NAME @!"__gda_attr_name"
#DEFINE GDA_ATTRIBUTE_NUMERIC_PRECISION @!"__gda_attr_numeric_precision"
#DEFINE GDA_ATTRIBUTE_NUMERIC_SCALE @!"__gda_attr_numeric_scale"
#DEFINE GDA_ATTRIBUTE_AUTO_INCREMENT @!"__gda_attr_autoinc"
#DEFINE GDA_ATTRIBUTE_IS_DEFAULT @!"__gda_attr_is_default"
#DEFINE GDA_ATTRIBUTE_TREE_NODE_UNKNOWN_CHILDREN @!"__gda_attr_tnuchild"
#ENDIF ' __GDA_ATTRIBUTES_MANAGER_H__

#IFNDEF __GDA_COLUMN_H__
#DEFINE __GDA_COLUMN_H__

#IFNDEF __GDA_VALUE_H__
#DEFINE __GDA_VALUE_H__
#INCLUDE ONCE "crt/time.bi"
#INCLUDE ONCE "glib.bi"

#IFNDEF __GLOBAL_DECL_H_
#DEFINE __GLOBAL_DECL_H_

#IFNDEF _GDA_DEBUG_MACROS_H_
#DEFINE _GDA_DEBUG_MACROS_H_

#DEFINE TO_IMPLEMENT g_print (@!"Implementation missing: %s() in %s line %d\n", __FUNCTION__, __FILE__,__LINE__)
#ENDIF ' _GDA_DEBUG_MACROS_H_

TYPE GdaConfig AS _GdaConfig
TYPE GdaConfigClass AS _GdaConfigClass
TYPE GdaConnection AS _GdaConnection
TYPE GdaConnectionClass AS _GdaConnectionClass
TYPE GdaConnectionPrivate AS _GdaConnectionPrivate
TYPE GdaConnectionEvent AS _GdaConnectionEvent
TYPE GdaConnectionEventClass AS _GdaConnectionEventClass
TYPE GdaConnectionEventPrivate AS _GdaConnectionEventPrivate
TYPE GdaDataHandler AS _GdaDataHandler
TYPE GdaDataHandlerIface AS _GdaDataHandlerIface
TYPE GdaServerProvider AS _GdaServerProvider
TYPE GdaServerProviderClass AS _GdaServerProviderClass
TYPE GdaServerProviderPrivate AS _GdaServerProviderPrivate
TYPE GdaServerProviderInfo AS _GdaServerProviderInfo
TYPE GdaServerOperation AS _GdaServerOperation
TYPE GdaServerOperationClass AS _GdaServerOperationClass
TYPE GdaServerOperationPrivate AS _GdaServerOperationPrivate
TYPE GdaDataModelIface AS _GdaDataModelIface
TYPE GdaDataModel AS _GdaDataModel
TYPE GdaDataProxy AS _GdaDataProxy
TYPE GdaDataProxyClass AS _GdaDataProxyClass
TYPE GdaDataProxyPrivate AS _GdaDataProxyPrivate
TYPE GdaColumn AS _GdaColumn
TYPE GdaColumnClass AS _GdaColumnClass
TYPE GdaColumnPrivate AS _GdaColumnPrivate
TYPE GdaDataModelIter AS _GdaDataModelIter
TYPE GdaDataModelIterClass AS _GdaDataModelIterClass
TYPE GdaDataModelIterPrivate AS _GdaDataModelIterPrivate
TYPE GdaHolder AS _GdaHolder
TYPE GdaHolderClass AS _GdaHolderClass
TYPE GdaHolderPrivate AS _GdaHolderPrivate
TYPE GdaSet AS _GdaSet
TYPE GdaSetClass AS _GdaSetClass
TYPE GdaSetNode AS _GdaSetNode
TYPE GdaSetGroup AS _GdaSetGroup
TYPE GdaSetSource AS _GdaSetSource
TYPE GdaSetPrivate AS _GdaSetPrivate
TYPE GdaBlobOp AS _GdaBlobOp
TYPE GdaBlobOpClass AS _GdaBlobOpClass
TYPE GdaBatch AS _GdaBatch
TYPE GdaBatchClass AS _GdaBatchClass
TYPE GdaBatchPrivate AS _GdaBatchPrivate
TYPE GdaStatement AS _GdaStatement
TYPE GdaStatementClass AS _GdaStatementClass
TYPE GdaStatementPrivate AS _GdaStatementPrivate
TYPE GdaRepetitiveStatement AS _GdaRepetitiveStatement
TYPE GdaRepetitiveStatementClass AS _GdaRepetitiveStatementClass
TYPE GdaSqlParser AS _GdaSqlParser
TYPE GdaSqlParserClass AS _GdaSqlParserClass
TYPE GdaSqlParserPrivate AS _GdaSqlParserPrivate
TYPE GdaMetaStore AS _GdaMetaStore
TYPE GdaMetaStoreClass AS _GdaMetaStoreClass
TYPE GdaMetaStorePrivate AS _GdaMetaStorePrivate
TYPE GdaMetaStoreClassPrivate AS _GdaMetaStoreClassPrivate
TYPE GdaMetaStruct AS _GdaMetaStruct
TYPE GdaMetaStructClass AS _GdaMetaStructClass
TYPE GdaMetaStructPrivate AS _GdaMetaStructPrivate
TYPE GdaSqlReservedKeywordsFunc AS FUNCTION(BYVAL AS CONST gchar PTR) AS gboolean
TYPE GdaTree AS _GdaTree
TYPE GdaTreeClass AS _GdaTreeClass
TYPE GdaTreePrivate AS _GdaTreePrivate
TYPE GdaTreeManager AS _GdaTreeManager
TYPE GdaTreeManagerClass AS _GdaTreeManagerClass
TYPE GdaTreeManagerPrivate AS _GdaTreeManagerPrivate
TYPE GdaTreeNode AS _GdaTreeNode
TYPE GdaTreeNodeClass AS _GdaTreeNodeClass
TYPE GdaTreeNodePrivate AS _GdaTreeNodePrivate

#IFDEF G_OS_WIN32
#DEFINE strtok_r(s,d,p) strtok(s,d)
#ENDIF ' G_OS_WIN32

#IFNDEF GSEAL
#IFDEF GSEAL_ENABLE
#DEFINE GSEAL(ident) _g_sealed__ ## ident
#ELSE ' GSEAL_ENABLE
#DEFINE GSEAL(ident) ident
#ENDIF ' GSEAL_ENABLE
#ENDIF ' GSEAL
#ENDIF ' __GLOBAL_DECL_H_

#DEFINE GDA_TIMEZONE_INVALID (2*12*60*60)
#DEFINE GDA_TYPE_NULL (gda_null_get_type())
#DEFINE GDA_TYPE_DEFAULT (gda_default_get_type())
#DEFINE GDA_TYPE_BINARY (gda_binary_get_type())
#DEFINE GDA_TYPE_BLOB (gda_blob_get_type())
#DEFINE GDA_TYPE_GEOMETRIC_POINT (gda_geometricpoint_get_type())
#DEFINE GDA_TYPE_NUMERIC (gda_numeric_get_type())
#DEFINE GDA_TYPE_SHORT (gda_short_get_type())
#DEFINE GDA_TYPE_USHORT (gda_ushort_get_type())
#DEFINE GDA_TYPE_TIME (gda_time_get_type())
#DEFINE GDA_TYPE_TIMESTAMP (gda_timestamp_get_type())
#DEFINE GDA_VALUE_HOLDS_NULL(value) G_VALUE_HOLDS(value, GDA_TYPE_NULL)
#DEFINE GDA_VALUE_HOLDS_DEFAULT(value) G_VALUE_HOLDS(value, GDA_TYPE_DEFAULT)
#DEFINE GDA_VALUE_HOLDS_BINARY(value) G_VALUE_HOLDS(value, GDA_TYPE_BINARY)
#DEFINE GDA_VALUE_HOLDS_BLOB(value) G_VALUE_HOLDS(value, GDA_TYPE_BLOB)
#DEFINE GDA_VALUE_HOLDS_GEOMETRIC_POINT(value) G_VALUE_HOLDS(value, GDA_TYPE_GEOMETRIC_POINT)
#DEFINE GDA_VALUE_HOLDS_NUMERIC(value) G_VALUE_HOLDS(value, GDA_TYPE_NUMERIC)
#DEFINE GDA_VALUE_HOLDS_SHORT(value) G_VALUE_HOLDS(value, GDA_TYPE_SHORT)
#DEFINE GDA_VALUE_HOLDS_USHORT(value) G_VALUE_HOLDS(value, GDA_TYPE_USHORT)
#DEFINE GDA_VALUE_HOLDS_TIME(value) G_VALUE_HOLDS(value, GDA_TYPE_TIME)
#DEFINE GDA_VALUE_HOLDS_TIMESTAMP(value) G_VALUE_HOLDS(value, GDA_TYPE_TIMESTAMP)

TYPE GdaGeometricPoint
	AS gdouble x
	AS gdouble y
END TYPE

TYPE GdaNumeric AS _GdaNumeric

#IFDEF GSEAL_ENABLE
#ELSE ' GSEAL_ENABLE

TYPE _GdaNumeric
	AS gchar PTR number
	AS glong precision
	AS glong width
	AS gpointer reserved
END TYPE

#ENDIF ' GSEAL_ENABLE

TYPE GdaTime
	AS gushort hour
	AS gushort minute
	AS gushort second
	AS gulong fraction
	AS glong timezone
END TYPE

TYPE GdaTimestamp
	AS gshort year
	AS gushort month
	AS gushort day
	AS gushort hour
	AS gushort minute
	AS gushort second
	AS gulong fraction
	AS glong timezone
END TYPE

TYPE GdaBinary
	AS guchar PTR data
	AS glong binary_length
END TYPE

TYPE GdaBlob
	AS GdaBinary data
	AS GdaBlobOp PTR op
END TYPE

#DEFINE gda_value_isa(value, type) (G_VALUE_HOLDS(value, type))

DECLARE FUNCTION gda_value_new(BYVAL AS GType) AS GValue PTR
DECLARE FUNCTION gda_value_new_null() AS GValue PTR
DECLARE FUNCTION gda_value_new_default(BYVAL AS CONST gchar PTR) AS GValue PTR
DECLARE FUNCTION gda_value_new_binary(BYVAL AS CONST guchar PTR, BYVAL AS glong) AS GValue PTR
DECLARE FUNCTION gda_value_new_blob(BYVAL AS CONST guchar PTR, BYVAL AS glong) AS GValue PTR
DECLARE FUNCTION gda_value_new_blob_from_file(BYVAL AS CONST gchar PTR) AS GValue PTR
DECLARE FUNCTION gda_value_new_timestamp_from_timet(BYVAL AS time_t) AS GValue PTR
DECLARE FUNCTION gda_value_new_from_string(BYVAL AS CONST gchar PTR, BYVAL AS GType) AS GValue PTR
DECLARE FUNCTION gda_value_new_from_xml(BYVAL AS CONST xmlNodePtr) AS GValue PTR
DECLARE SUB gda_value_free(BYVAL AS GValue PTR)
DECLARE SUB gda_value_reset_with_type(BYVAL AS GValue PTR, BYVAL AS GType)
DECLARE FUNCTION gda_value_is_null(BYVAL AS CONST GValue PTR) AS gboolean
DECLARE FUNCTION gda_value_is_number(BYVAL AS CONST GValue PTR) AS gboolean
DECLARE FUNCTION gda_value_copy(BYVAL AS CONST GValue PTR) AS GValue PTR
DECLARE FUNCTION gda_value_get_binary(BYVAL AS CONST GValue PTR) AS CONST GdaBinary PTR
DECLARE SUB gda_value_set_binary(BYVAL AS GValue PTR, BYVAL AS CONST GdaBinary PTR)
DECLARE SUB gda_value_take_binary(BYVAL AS GValue PTR, BYVAL AS GdaBinary PTR)
DECLARE FUNCTION gda_value_get_blob(BYVAL AS CONST GValue PTR) AS CONST GdaBlob PTR
DECLARE SUB gda_value_set_blob(BYVAL AS GValue PTR, BYVAL AS CONST GdaBlob PTR)
DECLARE SUB gda_value_take_blob(BYVAL AS GValue PTR, BYVAL AS GdaBlob PTR)
DECLARE FUNCTION gda_value_get_geometric_point(BYVAL AS CONST GValue PTR) AS CONST GdaGeometricPoint PTR
DECLARE SUB gda_value_set_geometric_point(BYVAL AS GValue PTR, BYVAL AS CONST GdaGeometricPoint PTR)
DECLARE SUB gda_value_set_null(BYVAL AS GValue PTR)
DECLARE FUNCTION gda_value_get_numeric(BYVAL AS CONST GValue PTR) AS CONST GdaNumeric PTR
DECLARE SUB gda_value_set_numeric(BYVAL AS GValue PTR, BYVAL AS CONST GdaNumeric PTR)
DECLARE FUNCTION gda_value_get_short(BYVAL AS CONST GValue PTR) AS gshort
DECLARE SUB gda_value_set_short(BYVAL AS GValue PTR, BYVAL AS CONST gshort)
DECLARE FUNCTION gda_value_get_ushort(BYVAL AS CONST GValue PTR) AS gushort
DECLARE SUB gda_value_set_ushort(BYVAL AS GValue PTR, BYVAL AS CONST gushort)
DECLARE FUNCTION gda_value_get_time(BYVAL AS CONST GValue PTR) AS CONST GdaTime PTR
DECLARE SUB gda_value_set_time(BYVAL AS GValue PTR, BYVAL AS CONST GdaTime PTR)
DECLARE FUNCTION gda_value_get_timestamp(BYVAL AS CONST GValue PTR) AS CONST GdaTimestamp PTR
DECLARE SUB gda_value_set_timestamp(BYVAL AS GValue PTR, BYVAL AS CONST GdaTimestamp PTR)
DECLARE FUNCTION gda_value_set_from_string(BYVAL AS GValue PTR, BYVAL AS CONST gchar PTR, BYVAL AS GType) AS gboolean
DECLARE FUNCTION gda_value_set_from_value(BYVAL AS GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
DECLARE FUNCTION gda_value_differ(BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gint
DECLARE FUNCTION gda_value_compare(BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gint
DECLARE FUNCTION gda_value_stringify(BYVAL AS CONST GValue PTR) AS gchar PTR
DECLARE FUNCTION gda_value_to_xml(BYVAL AS CONST GValue PTR) AS xmlNodePtr
DECLARE FUNCTION gda_binary_to_string(BYVAL AS CONST GdaBinary PTR, BYVAL AS guint) AS gchar PTR
DECLARE FUNCTION gda_string_to_binary(BYVAL AS CONST gchar PTR) AS GdaBinary PTR
DECLARE FUNCTION gda_blob_to_string(BYVAL AS GdaBlob PTR, BYVAL AS guint) AS gchar PTR
DECLARE FUNCTION gda_string_to_blob(BYVAL AS CONST gchar PTR) AS GdaBlob PTR
DECLARE FUNCTION gda_null_get_type() AS GType
DECLARE FUNCTION gda_default_get_type() AS GType
DECLARE FUNCTION gda_numeric_get_type() AS GType
DECLARE FUNCTION gda_numeric_new() AS GdaNumeric PTR
DECLARE FUNCTION gda_numeric_copy(BYVAL AS GdaNumeric PTR) AS GdaNumeric PTR
DECLARE SUB gda_numeric_set_from_string(BYVAL AS GdaNumeric PTR, BYVAL AS CONST gchar PTR)
DECLARE SUB gda_numeric_set_double(BYVAL AS GdaNumeric PTR, BYVAL AS gdouble)
DECLARE FUNCTION gda_numeric_get_double(BYVAL AS GdaNumeric PTR) AS gdouble
DECLARE SUB gda_numeric_set_precision(BYVAL AS GdaNumeric PTR, BYVAL AS glong)
DECLARE FUNCTION gda_numeric_get_precision(BYVAL AS GdaNumeric PTR) AS glong
DECLARE SUB gda_numeric_set_width(BYVAL AS GdaNumeric PTR, BYVAL AS glong)
DECLARE FUNCTION gda_numeric_get_width(BYVAL AS GdaNumeric PTR) AS glong
DECLARE FUNCTION gda_numeric_get_string(BYVAL AS GdaNumeric PTR) AS gchar PTR
DECLARE SUB gda_numeric_free(BYVAL AS GdaNumeric PTR)
DECLARE FUNCTION gda_time_get_type() AS GType
DECLARE FUNCTION gda_time_copy(BYVAL AS gpointer) AS gpointer
DECLARE SUB gda_time_free(BYVAL AS gpointer)
DECLARE FUNCTION gda_time_valid(BYVAL AS CONST GdaTime PTR) AS gboolean
DECLARE FUNCTION gda_timestamp_get_type() AS GType
DECLARE FUNCTION gda_timestamp_copy(BYVAL AS gpointer) AS gpointer
DECLARE SUB gda_timestamp_free(BYVAL AS gpointer)
DECLARE FUNCTION gda_timestamp_valid(BYVAL AS CONST GdaTimestamp PTR) AS gboolean
DECLARE FUNCTION gda_geometricpoint_get_type() AS GType
DECLARE FUNCTION gda_geometricpoint_copy(BYVAL AS gpointer) AS gpointer
DECLARE SUB gda_geometricpoint_free(BYVAL AS gpointer)
DECLARE FUNCTION gda_binary_get_type() AS GType
DECLARE FUNCTION gda_binary_copy(BYVAL AS gpointer) AS gpointer
DECLARE SUB gda_binary_free(BYVAL AS gpointer)
DECLARE FUNCTION gda_blob_get_type() AS GType
DECLARE FUNCTION gda_blob_copy(BYVAL AS gpointer) AS gpointer
DECLARE SUB gda_blob_free(BYVAL AS gpointer)
DECLARE SUB gda_blob_set_op(BYVAL AS GdaBlob PTR, BYVAL AS GdaBlobOp PTR)
DECLARE FUNCTION gda_short_get_type() AS GType
DECLARE FUNCTION gda_ushort_get_type() AS GType

#ENDIF ' __GDA_VALUE_H__

#DEFINE GDA_TYPE_COLUMN (gda_column_get_type())
#DEFINE GDA_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_COLUMN, GdaColumn))
#DEFINE GDA_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_COLUMN, GdaColumnClass))
#DEFINE GDA_IS_COLUMN(obj) (G_TYPE_CHECK_INSTANCE_TYPE (obj, GDA_TYPE_COLUMN))
#DEFINE GDA_IS_COLUMN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GDA_TYPE_COLUMN))

TYPE _GdaColumn
	AS GObject object
	AS GdaColumnPrivate PTR priv
END TYPE

TYPE _GdaColumnClass
	AS GObjectClass parent_class
	name_changed AS SUB(BYVAL AS GdaColumn PTR, BYVAL AS CONST gchar PTR)
	g_type_changed AS SUB(BYVAL AS GdaColumn PTR, BYVAL AS GType, BYVAL AS GType)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_column_get_type() AS GType
DECLARE FUNCTION gda_column_new() AS GdaColumn PTR
DECLARE FUNCTION gda_column_copy(BYVAL AS GdaColumn PTR) AS GdaColumn PTR
DECLARE FUNCTION gda_column_get_description(BYVAL AS GdaColumn PTR) AS CONST gchar PTR
DECLARE SUB gda_column_set_description(BYVAL AS GdaColumn PTR, BYVAL AS CONST gchar PTR)
DECLARE FUNCTION gda_column_get_name(BYVAL AS GdaColumn PTR) AS CONST gchar PTR
DECLARE SUB gda_column_set_name(BYVAL AS GdaColumn PTR, BYVAL AS CONST gchar PTR)
DECLARE FUNCTION gda_column_get_dbms_type(BYVAL AS GdaColumn PTR) AS CONST gchar PTR
DECLARE SUB gda_column_set_dbms_type(BYVAL AS GdaColumn PTR, BYVAL AS CONST gchar PTR)
DECLARE FUNCTION gda_column_get_g_type(BYVAL AS GdaColumn PTR) AS GType
DECLARE SUB gda_column_set_g_type(BYVAL AS GdaColumn PTR, BYVAL AS GType)
DECLARE FUNCTION gda_column_get_allow_null(BYVAL AS GdaColumn PTR) AS gboolean
DECLARE SUB gda_column_set_allow_null(BYVAL AS GdaColumn PTR, BYVAL AS gboolean)
DECLARE FUNCTION gda_column_get_auto_increment(BYVAL AS GdaColumn PTR) AS gboolean
DECLARE SUB gda_column_set_auto_increment(BYVAL AS GdaColumn PTR, BYVAL AS gboolean)
DECLARE FUNCTION gda_column_get_position(BYVAL AS GdaColumn PTR) AS gint
DECLARE SUB gda_column_set_position(BYVAL AS GdaColumn PTR, BYVAL AS gint)
DECLARE FUNCTION gda_column_get_default_value(BYVAL AS GdaColumn PTR) AS CONST GValue PTR
DECLARE SUB gda_column_set_default_value(BYVAL AS GdaColumn PTR, BYVAL AS CONST GValue PTR)
DECLARE FUNCTION gda_column_get_attribute(BYVAL AS GdaColumn PTR, BYVAL AS CONST gchar PTR) AS CONST GValue PTR
DECLARE SUB gda_column_set_attribute(BYVAL AS GdaColumn PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR, BYVAL AS GDestroyNotify)

#DEFINE gda_column_set_attribute_static(holder,attribute,value) gda_column_set_attribute((holder),(attribute),(value),NULL)
#ENDIF ' __GDA_COLUMN_H__

#IFNDEF __GDA_CONFIG_H__
#DEFINE __GDA_CONFIG_H__

#IFNDEF __GDA_DATA_MODEL_H__
#DEFINE __GDA_DATA_MODEL_H__

#IFNDEF __GDA_ENUMS__
#DEFINE __GDA_ENUMS__

ENUM GdaTransactionIsolation
	GDA_TRANSACTION_ISOLATION_UNKNOWN
	GDA_TRANSACTION_ISOLATION_READ_COMMITTED
	GDA_TRANSACTION_ISOLATION_READ_UNCOMMITTED
	GDA_TRANSACTION_ISOLATION_REPEATABLE_READ
	GDA_TRANSACTION_ISOLATION_SERIALIZABLE
END ENUM

ENUM GdaValueAttribute
	GDA_VALUE_ATTR_NONE = 0
	GDA_VALUE_ATTR_IS_NULL = 1  SHL 0
	GDA_VALUE_ATTR_CAN_BE_NULL = 1  SHL 1
	GDA_VALUE_ATTR_IS_DEFAULT = 1  SHL 2
	GDA_VALUE_ATTR_CAN_BE_DEFAULT = 1  SHL 3
	GDA_VALUE_ATTR_IS_UNCHANGED = 1  SHL 4
	GDA_VALUE_ATTR_ACTIONS_SHOWN = 1  SHL 5
	GDA_VALUE_ATTR_DATA_NON_VALID = 1  SHL 6
	GDA_VALUE_ATTR_HAS_VALUE_ORIG = 1  SHL 7
	GDA_VALUE_ATTR_NO_MODIF = 1  SHL 8
	GDA_VALUE_ATTR_UNUSED = 1  SHL 9
END ENUM

ENUM GdaSqlIdentifierStyle
	GDA_SQL_IDENTIFIERS_LOWER_CASE = 1  SHL 0
	GDA_SQL_IDENTIFIERS_UPPER_CASE = 1  SHL 1
END ENUM

#DEFINE GDA_EXTRA_AUTO_INCREMENT @!"AUTO_INCREMENT"
#ENDIF ' __GDA_ENUMS__

#DEFINE GDA_TYPE_DATA_MODEL (gda_data_model_get_type())
#DEFINE GDA_DATA_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_DATA_MODEL, GdaDataModel))
#DEFINE GDA_IS_DATA_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE (obj, GDA_TYPE_DATA_MODEL))
#DEFINE GDA_DATA_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GDA_TYPE_DATA_MODEL, GdaDataModelIface))

EXTERN gda_data_model_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_DATA_MODEL_ERROR gda_data_model_error_quark ()

ENUM GdaDataModelAccessFlags
	GDA_DATA_MODEL_ACCESS_RANDOM = 1  SHL 0
	GDA_DATA_MODEL_ACCESS_CURSOR_FORWARD = 1  SHL 1
	GDA_DATA_MODEL_ACCESS_CURSOR_BACKWARD = 1  SHL 2
	GDA_DATA_MODEL_ACCESS_CURSOR = GDA_DATA_MODEL_ACCESS_CURSOR_FORWARD  OR GDA_DATA_MODEL_ACCESS_CURSOR_BACKWARD
	GDA_DATA_MODEL_ACCESS_INSERT = 1  SHL 3
	GDA_DATA_MODEL_ACCESS_UPDATE = 1  SHL 4
	GDA_DATA_MODEL_ACCESS_DELETE = 1  SHL 5
	GDA_DATA_MODEL_ACCESS_WRITE = GDA_DATA_MODEL_ACCESS_INSERT  OR GDA_DATA_MODEL_ACCESS_UPDATE  OR GDA_DATA_MODEL_ACCESS_DELETE
END ENUM

ENUM GdaDataModelHint
	GDA_DATA_MODEL_HINT_START_BATCH_UPDATE
	GDA_DATA_MODEL_HINT_END_BATCH_UPDATE
	GDA_DATA_MODEL_HINT_REFRESH
END ENUM

ENUM GdaDataModelIOFormat
	GDA_DATA_MODEL_IO_DATA_ARRAY_XML
	GDA_DATA_MODEL_IO_TEXT_SEPARATED
END ENUM

ENUM GdaDataModelError
	GDA_DATA_MODEL_ROW_OUT_OF_RANGE_ERROR
	GDA_DATA_MODEL_COLUMN_OUT_OF_RANGE_ERROR
	GDA_DATA_MODEL_VALUES_LIST_ERROR
	GDA_DATA_MODEL_VALUE_TYPE_ERROR
	GDA_DATA_MODEL_ROW_NOT_FOUND_ERROR
	GDA_DATA_MODEL_ACCESS_ERROR
	GDA_DATA_MODEL_FEATURE_NON_SUPPORTED_ERROR
	GDA_DATA_MODEL_FILE_EXIST_ERROR
	GDA_DATA_MODEL_XML_FORMAT_ERROR
	GDA_DATA_MODEL_TRUNCATED_ERROR
	GDA_DATA_MODEL_OTHER_ERROR
END ENUM

TYPE _GdaDataModelIface
	AS GTypeInterface g_iface
	i_get_n_rows AS FUNCTION(BYVAL AS GdaDataModel PTR) AS gint
	i_get_n_columns AS FUNCTION(BYVAL AS GdaDataModel PTR) AS gint
	i_describe_column AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS gint) AS GdaColumn PTR
	i_get_access_flags AS FUNCTION(BYVAL AS GdaDataModel PTR) AS GdaDataModelAccessFlags
	i_get_value_at AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS gint, BYVAL AS GError PTR PTR) AS CONST GValue PTR
	i_get_attributes_at AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS gint) AS GdaValueAttribute
	i_create_iter AS FUNCTION(BYVAL AS GdaDataModel PTR) AS GdaDataModelIter PTR
	i_iter_at_row AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelIter PTR, BYVAL AS gint) AS gboolean
	i_iter_next AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelIter PTR) AS gboolean
	i_iter_prev AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelIter PTR) AS gboolean
	i_set_value_at AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS gint, BYVAL AS CONST GValue PTR, BYVAL AS GError PTR PTR) AS gboolean
	i_iter_set_value AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelIter PTR, BYVAL AS gint, BYVAL AS CONST GValue PTR, BYVAL AS GError PTR PTR) AS gboolean
	i_set_values AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS GList PTR, BYVAL AS GError PTR PTR) AS gboolean
	i_append_values AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS CONST GList PTR, BYVAL AS GError PTR PTR) AS gint
	i_append_row AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS GError PTR PTR) AS gint
	i_remove_row AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
	i_find_row AS FUNCTION(BYVAL AS GdaDataModel PTR, BYVAL AS GSList PTR, BYVAL AS gint PTR) AS gint
	i_set_notify AS SUB(BYVAL AS GdaDataModel PTR, BYVAL AS gboolean)
	i_get_notify AS FUNCTION(BYVAL AS GdaDataModel PTR) AS gboolean
	i_send_hint AS SUB(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelHint, BYVAL AS CONST GValue PTR)
	row_inserted AS SUB(BYVAL AS GdaDataModel PTR, BYVAL AS gint)
	row_updated AS SUB(BYVAL AS GdaDataModel PTR, BYVAL AS gint)
	row_removed AS SUB(BYVAL AS GdaDataModel PTR, BYVAL AS gint)
	changed AS SUB(BYVAL AS GdaDataModel PTR)
	reset_ AS SUB(BYVAL AS GdaDataModel PTR)
	access_changed AS SUB(BYVAL AS GdaDataModel PTR)
	i_get_exceptions AS FUNCTION(BYVAL AS GdaDataModel PTR) AS GError PTR PTR
END TYPE

DECLARE FUNCTION gda_data_model_get_type() AS GType
DECLARE FUNCTION gda_data_model_get_access_flags(BYVAL AS GdaDataModel PTR) AS GdaDataModelAccessFlags
DECLARE FUNCTION gda_data_model_get_n_rows(BYVAL AS GdaDataModel PTR) AS gint
DECLARE FUNCTION gda_data_model_get_n_columns(BYVAL AS GdaDataModel PTR) AS gint
DECLARE FUNCTION gda_data_model_describe_column(BYVAL AS GdaDataModel PTR, BYVAL AS gint) AS GdaColumn PTR
DECLARE FUNCTION gda_data_model_get_column_index(BYVAL AS GdaDataModel PTR, BYVAL AS CONST gchar PTR) AS gint
DECLARE FUNCTION gda_data_model_get_column_name(BYVAL AS GdaDataModel PTR, BYVAL AS gint) AS CONST gchar PTR
DECLARE SUB gda_data_model_set_column_name(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS CONST gchar PTR)
DECLARE FUNCTION gda_data_model_get_column_title(BYVAL AS GdaDataModel PTR, BYVAL AS gint) AS CONST gchar PTR
DECLARE SUB gda_data_model_set_column_title(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS CONST gchar PTR)
DECLARE FUNCTION gda_data_model_get_value_at(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS gint, BYVAL AS GError PTR PTR) AS CONST GValue PTR
DECLARE FUNCTION gda_data_model_get_typed_value_at(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS gint, BYVAL AS GType, BYVAL AS gboolean, BYVAL AS GError PTR PTR) AS CONST GValue PTR
DECLARE FUNCTION gda_data_model_get_attributes_at(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS gint) AS GdaValueAttribute
DECLARE FUNCTION gda_data_model_create_iter(BYVAL AS GdaDataModel PTR) AS GdaDataModelIter PTR
DECLARE FUNCTION gda_data_model_iter_at_row(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelIter PTR, BYVAL AS gint) AS gboolean
DECLARE FUNCTION gda_data_model_iter_next(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelIter PTR) AS gboolean
DECLARE FUNCTION gda_data_model_iter_prev(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelIter PTR) AS gboolean
DECLARE FUNCTION gda_data_model_iter_set_value(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelIter PTR, BYVAL AS gint, BYVAL AS CONST GValue PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE SUB gda_data_model_freeze(BYVAL AS GdaDataModel PTR)
DECLARE SUB gda_data_model_thaw(BYVAL AS GdaDataModel PTR)
DECLARE SUB gda_data_model_set_notify(BYVAL AS GdaDataModel PTR, BYVAL AS gboolean)
DECLARE FUNCTION gda_data_model_get_notify(BYVAL AS GdaDataModel PTR) AS gboolean
DECLARE FUNCTION gda_data_model_set_value_at(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS gint, BYVAL AS CONST GValue PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_model_set_values(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS GList PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_model_append_row(BYVAL AS GdaDataModel PTR, BYVAL AS GError PTR PTR) AS gint
DECLARE FUNCTION gda_data_model_append_values(BYVAL AS GdaDataModel PTR, BYVAL AS CONST GList PTR, BYVAL AS GError PTR PTR) AS gint
DECLARE FUNCTION gda_data_model_remove_row(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_model_get_row_from_values(BYVAL AS GdaDataModel PTR, BYVAL AS GSList PTR, BYVAL AS gint PTR) AS gint
DECLARE SUB gda_data_model_send_hint(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelHint, BYVAL AS CONST GValue PTR)
DECLARE FUNCTION gda_data_model_get_exceptions(BYVAL AS GdaDataModel PTR) AS GError PTR PTR
DECLARE FUNCTION gda_data_model_export_to_string(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelIOFormat, BYVAL AS CONST gint PTR, BYVAL AS gint, BYVAL AS CONST gint PTR, BYVAL AS gint, BYVAL AS GdaSet PTR) AS gchar PTR
DECLARE FUNCTION gda_data_model_export_to_file(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModelIOFormat, BYVAL AS CONST gchar PTR, BYVAL AS CONST gint PTR, BYVAL AS gint, BYVAL AS CONST gint PTR, BYVAL AS gint, BYVAL AS GdaSet PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_model_import_from_model(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModel PTR, BYVAL AS gboolean, BYVAL AS GHashTable PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_model_import_from_string(BYVAL AS GdaDataModel PTR, BYVAL AS CONST gchar PTR, BYVAL AS GHashTable PTR, BYVAL AS GdaSet PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_model_import_from_file(BYVAL AS GdaDataModel PTR, BYVAL AS CONST gchar PTR, BYVAL AS GHashTable PTR, BYVAL AS GdaSet PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE SUB gda_data_model_dump(BYVAL AS GdaDataModel PTR, BYVAL AS FILE PTR)
DECLARE FUNCTION gda_data_model_dump_as_string(BYVAL AS GdaDataModel PTR) AS gchar PTR

#ENDIF ' __GDA_DATA_MODEL_H__

#DEFINE GDA_TYPE_CONFIG (gda_config_get_type())
#DEFINE GDA_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_CONFIG, GdaConfig))
#DEFINE GDA_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_CONFIG, GdaConfigClass))
#DEFINE GDA_IS_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_CONFIG))
#DEFINE GDA_IS_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_CONFIG))

TYPE GdaConfigPrivate AS _GdaConfigPrivate
TYPE GdaDsnInfo AS _GdaDsnInfo
TYPE GdaProviderInfo AS _GdaProviderInfo

EXTERN gda_config_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_CONFIG_ERROR gda_config_error_quark ()

ENUM GdaConfigError
	GDA_CONFIG_DSN_NOT_FOUND_ERROR
	GDA_CONFIG_PERMISSION_ERROR
	GDA_CONFIG_PROVIDER_NOT_FOUND_ERROR
	GDA_CONFIG_PROVIDER_CREATION_ERROR
END ENUM

TYPE _GdaDsnInfo
	AS gchar PTR name
	AS gchar PTR provider
	AS gchar PTR description
	AS gchar PTR cnc_string
	AS gchar PTR auth_string
	AS gboolean is_system
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

TYPE _GdaProviderInfo
	AS gchar PTR id
	AS gchar PTR location
	AS gchar PTR description
	AS GdaSet PTR dsn_params
	AS GdaSet PTR auth_params
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

TYPE _GdaConfig
	AS GObject object
	AS GdaConfigPrivate PTR priv
END TYPE

TYPE _GdaConfigClass
	AS GObjectClass object_class
	dsn_added AS SUB(BYVAL AS GdaConfig PTR, BYVAL AS GdaDsnInfo PTR)
	dsn_to_be_removed AS SUB(BYVAL AS GdaConfig PTR, BYVAL AS GdaDsnInfo PTR)
	dsn_removed AS SUB(BYVAL AS GdaConfig PTR, BYVAL AS GdaDsnInfo PTR)
	dsn_changed AS SUB(BYVAL AS GdaConfig PTR, BYVAL AS GdaDsnInfo PTR)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_config_get_type() AS GType
DECLARE FUNCTION gda_config_get() AS GdaConfig PTR
DECLARE FUNCTION gda_config_get_dsn_info(BYVAL AS CONST gchar PTR) AS GdaDsnInfo PTR
DECLARE FUNCTION gda_config_define_dsn(BYVAL AS CONST GdaDsnInfo PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_config_remove_dsn(BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_config_dsn_needs_authentication(BYVAL AS CONST gchar PTR) AS gboolean
DECLARE FUNCTION gda_config_list_dsn() AS GdaDataModel PTR
DECLARE FUNCTION gda_config_can_modify_system_config() AS gboolean
DECLARE FUNCTION gda_config_get_nb_dsn() AS gint
DECLARE FUNCTION gda_config_get_dsn_info_index(BYVAL AS CONST gchar PTR) AS gint
DECLARE FUNCTION gda_config_get_dsn_info_at_index(BYVAL AS gint) AS GdaDsnInfo PTR
DECLARE FUNCTION gda_config_get_provider_info(BYVAL AS CONST gchar PTR) AS GdaProviderInfo PTR
DECLARE FUNCTION gda_config_get_provider(BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS GdaServerProvider PTR
DECLARE FUNCTION gda_config_list_providers() AS GdaDataModel PTR

#ENDIF ' __GDA_CONFIG_H__

#IFNDEF __GDA_CONNECTION_EVENT_H__
#DEFINE __GDA_CONNECTION_EVENT_H__

#DEFINE GDA_TYPE_CONNECTION_EVENT (gda_connection_event_get_type())
#DEFINE GDA_CONNECTION_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_CONNECTION_EVENT, GdaConnectionEvent))
#DEFINE GDA_CONNECTION_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_CONNECTION_EVENT, GdaConnectionEventClass))
#DEFINE GDA_IS_CONNECTION_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_CONNECTION_EVENT))
#DEFINE GDA_IS_CONNECTION_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_CONNECTION_EVENT))

TYPE _GdaConnectionEvent
	AS GObject object
	AS GdaConnectionEventPrivate PTR priv
END TYPE

TYPE _GdaConnectionEventClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

ENUM GdaConnectionEventType
	GDA_CONNECTION_EVENT_NOTICE
	GDA_CONNECTION_EVENT_WARNING
	GDA_CONNECTION_EVENT_ERROR
	GDA_CONNECTION_EVENT_COMMAND
END ENUM

ENUM GdaConnectionEventCode
	GDA_CONNECTION_EVENT_CODE_CONSTRAINT_VIOLATION
	GDA_CONNECTION_EVENT_CODE_RESTRICT_VIOLATION
	GDA_CONNECTION_EVENT_CODE_NOT_NULL_VIOLATION
	GDA_CONNECTION_EVENT_CODE_FOREIGN_KEY_VIOLATION
	GDA_CONNECTION_EVENT_CODE_UNIQUE_VIOLATION
	GDA_CONNECTION_EVENT_CODE_CHECK_VIOLATION
	GDA_CONNECTION_EVENT_CODE_INSUFFICIENT_PRIVILEGES
	GDA_CONNECTION_EVENT_CODE_UNDEFINED_COLUMN
	GDA_CONNECTION_EVENT_CODE_UNDEFINED_FUNCTION
	GDA_CONNECTION_EVENT_CODE_UNDEFINED_TABLE
	GDA_CONNECTION_EVENT_CODE_DUPLICATE_COLUMN
	GDA_CONNECTION_EVENT_CODE_DUPLICATE_DATABASE
	GDA_CONNECTION_EVENT_CODE_DUPLICATE_FUNCTION
	GDA_CONNECTION_EVENT_CODE_DUPLICATE_SCHEMA
	GDA_CONNECTION_EVENT_CODE_DUPLICATE_TABLE
	GDA_CONNECTION_EVENT_CODE_DUPLICATE_ALIAS
	GDA_CONNECTION_EVENT_CODE_DUPLICATE_OBJECT
	GDA_CONNECTION_EVENT_CODE_SYNTAX_ERROR
	GDA_CONNECTION_EVENT_CODE_UNKNOWN
END ENUM

#DEFINE GDA_SQLSTATE_NO_ERROR @!"00000"
#DEFINE GDA_SQLSTATE_GENERAL_ERROR @!"HY000"

DECLARE FUNCTION gda_connection_event_get_type() AS GType
DECLARE SUB gda_connection_event_set_event_type(BYVAL AS GdaConnectionEvent PTR, BYVAL AS GdaConnectionEventType)
DECLARE FUNCTION gda_connection_event_get_event_type(BYVAL AS GdaConnectionEvent PTR) AS GdaConnectionEventType
DECLARE FUNCTION gda_connection_event_get_description(BYVAL AS GdaConnectionEvent PTR) AS CONST gchar PTR
DECLARE SUB gda_connection_event_set_description(BYVAL AS GdaConnectionEvent PTR, BYVAL AS CONST gchar PTR)
DECLARE FUNCTION gda_connection_event_get_code(BYVAL AS GdaConnectionEvent PTR) AS glong
DECLARE SUB gda_connection_event_set_code(BYVAL AS GdaConnectionEvent PTR, BYVAL AS glong)
DECLARE FUNCTION gda_connection_event_get_gda_code(BYVAL AS GdaConnectionEvent PTR) AS GdaConnectionEventCode
DECLARE SUB gda_connection_event_set_gda_code(BYVAL AS GdaConnectionEvent PTR, BYVAL AS GdaConnectionEventCode)
DECLARE FUNCTION gda_connection_event_get_source(BYVAL AS GdaConnectionEvent PTR) AS CONST gchar PTR
DECLARE SUB gda_connection_event_set_source(BYVAL AS GdaConnectionEvent PTR, BYVAL AS CONST gchar PTR)
DECLARE FUNCTION gda_connection_event_get_sqlstate(BYVAL AS GdaConnectionEvent PTR) AS CONST gchar PTR
DECLARE SUB gda_connection_event_set_sqlstate(BYVAL AS GdaConnectionEvent PTR, BYVAL AS CONST gchar PTR)

#ENDIF ' __GDA_CONNECTION_EVENT_H__

#IFNDEF __GDA_CONNECTION_H__
#DEFINE __GDA_CONNECTION_H__

#IFNDEF __GDA_TRANSACTION_STATUS_H__
#DEFINE __GDA_TRANSACTION_STATUS_H__

#DEFINE GDA_TYPE_TRANSACTION_STATUS (gda_transaction_status_get_type())
#DEFINE GDA_TRANSACTION_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_TRANSACTION_STATUS, GdaTransactionStatus))
#DEFINE GDA_TRANSACTION_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_TRANSACTION_STATUS, GdaTransactionStatusClass))
#DEFINE GDA_IS_TRANSACTION_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_TRANSACTION_STATUS))
#DEFINE GDA_IS_TRANSACTION_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_TRANSACTION_STATUS))

TYPE GdaTransactionStatus AS _GdaTransactionStatus
TYPE GdaTransactionStatusClass AS _GdaTransactionStatusClass
TYPE GdaTransactionStatusEvent AS _GdaTransactionStatusEvent

ENUM GdaTransactionStatusEventType
	GDA_TRANSACTION_STATUS_EVENT_SAVEPOINT
	GDA_TRANSACTION_STATUS_EVENT_SQL
	GDA_TRANSACTION_STATUS_EVENT_SUB_TRANSACTION
END ENUM

ENUM GdaTransactionStatusState
	GDA_TRANSACTION_STATUS_STATE_OK
	GDA_TRANSACTION_STATUS_STATE_FAILED
END ENUM

UNION _GdaTransactionStatusEvent_pl
	AS gchar PTR svp_name
	AS gchar PTR sql
	AS GdaTransactionStatus PTR sub_trans
END UNION

TYPE _GdaTransactionStatusEvent
	AS GdaTransactionStatus PTR trans
	AS GdaTransactionStatusEventType type
	AS _GdaTransactionStatusEvent_pl pl
	AS GdaConnectionEvent PTR conn_event
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

TYPE _GdaTransactionStatus
	AS GObject object
	AS gchar PTR name
	AS GdaTransactionIsolation isolation_level
	AS GdaTransactionStatusState state
	AS GList PTR events
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

TYPE _GdaTransactionStatusClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_transaction_status_get_type() AS GType
DECLARE FUNCTION gda_transaction_status_new(BYVAL AS CONST gchar PTR) AS GdaTransactionStatus PTR

#ENDIF ' __GDA_TRANSACTION_STATUS_H__

#IFNDEF _GDA_STATEMENT_H_
#DEFINE _GDA_STATEMENT_H_

#IFNDEF _GDA_STATEMENT_STRUCT_H_
#DEFINE _GDA_STATEMENT_STRUCT_H_

#IFNDEF _GDA_STATEMENT_STRUCT_DECL_H
#DEFINE _GDA_STATEMENT_STRUCT_DECL_H

#IFNDEF __GDA_META_STORE_H_
#DEFINE __GDA_META_STORE_H_

#DEFINE GDA_TYPE_META_STORE (gda_meta_store_get_type())
#DEFINE GDA_META_STORE(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_meta_store_get_type(), GdaMetaStore)
#DEFINE GDA_META_STORE_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_meta_store_get_type (), GdaMetaStoreClass)
#DEFINE GDA_IS_META_STORE(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_meta_store_get_type ())

EXTERN gda_meta_store_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_META_STORE_ERROR gda_meta_store_error_quark ()

ENUM GdaMetaStoreError
	GDA_META_STORE_INCORRECT_SCHEMA_ERROR
	GDA_META_STORE_UNSUPPORTED_PROVIDER_ERROR
	GDA_META_STORE_INTERNAL_ERROR
	GDA_META_STORE_META_CONTEXT_ERROR
	GDA_META_STORE_MODIFY_CONTENTS_ERROR
	GDA_META_STORE_EXTRACT_SQL_ERROR
	GDA_META_STORE_ATTRIBUTE_NOT_FOUND_ERROR
	GDA_META_STORE_ATTRIBUTE_ERROR
	GDA_META_STORE_SCHEMA_OBJECT_NOT_FOUND_ERROR
	GDA_META_STORE_SCHEMA_OBJECT_CONFLICT_ERROR
	GDA_META_STORE_SCHEMA_OBJECT_DESCR_ERROR
	GDA_META_STORE_TRANSACTION_ALREADY_STARTED_ERROR
END ENUM

ENUM GdaMetaStoreChangeType
	GDA_META_STORE_ADD
	GDA_META_STORE_REMOVE
	GDA_META_STORE_MODIFY
END ENUM

TYPE GdaMetaStoreChange
	AS GdaMetaStoreChangeType c_type
	AS gchar PTR table_name
	AS GHashTable PTR keys
END TYPE

#DEFINE GDA_TYPE_META_CONTEXT (gda_meta_context_get_type())

TYPE GdaMetaContext
	AS gchar PTR table_name
	AS gint size
	AS gchar PTR PTR column_names
	AS GValue PTR PTR column_values
	AS GHashTable PTR columns
END TYPE

TYPE _GdaMetaStore
	AS GObject object
	AS GdaMetaStorePrivate PTR priv
END TYPE

TYPE _GdaMetaStoreClass
	AS GObjectClass parent_class
	AS GdaMetaStoreClassPrivate PTR cpriv
	meta_reset AS SUB(BYVAL AS GdaMetaStore PTR)
	suggest_update AS FUNCTION(BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR) AS GError PTR
	meta_changed AS SUB(BYVAL AS GdaMetaStore PTR, BYVAL AS GSList PTR)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_meta_store_get_type() AS GType
DECLARE FUNCTION gda_meta_store_new_with_file(BYVAL AS CONST gchar PTR) AS GdaMetaStore PTR
DECLARE FUNCTION gda_meta_store_new(BYVAL AS CONST gchar PTR) AS GdaMetaStore PTR
DECLARE FUNCTION gda_meta_store_get_version(BYVAL AS GdaMetaStore PTR) AS gint
DECLARE FUNCTION gda_meta_store_get_internal_connection(BYVAL AS GdaMetaStore PTR) AS GdaConnection PTR
DECLARE FUNCTION gda_meta_store_sql_identifier_quote(BYVAL AS CONST gchar PTR, BYVAL AS GdaConnection PTR) AS gchar PTR
DECLARE FUNCTION gda_meta_store_extract(BYVAL AS GdaMetaStore PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR, ...) AS GdaDataModel PTR
DECLARE FUNCTION gda_meta_store_extract_v(BYVAL AS GdaMetaStore PTR, BYVAL AS CONST gchar PTR, BYVAL AS GHashTable PTR, BYVAL AS GError PTR PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_meta_store_modify_ ALIAS "gda_meta_store_modify"(BYVAL AS GdaMetaStore PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaDataModel PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR, ...) AS gboolean
DECLARE FUNCTION gda_meta_store_modify_v(BYVAL AS GdaMetaStore PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaDataModel PTR, BYVAL AS CONST gchar PTR, BYVAL AS gint, BYVAL AS CONST gchar PTR PTR, BYVAL AS CONST GValue PTR PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_store_modify_with_context(BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GdaDataModel PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_store_create_modify_data_model(BYVAL AS GdaMetaStore PTR, BYVAL AS CONST gchar PTR) AS GdaDataModel PTR
DECLARE SUB gda_meta_store_set_identifiers_style(BYVAL AS GdaMetaStore PTR, BYVAL AS GdaSqlIdentifierStyle)
DECLARE SUB gda_meta_store_set_reserved_keywords_func(BYVAL AS GdaMetaStore PTR, BYVAL AS GdaSqlReservedKeywordsFunc)
DECLARE FUNCTION gda_meta_store_get_attribute_value(BYVAL AS GdaMetaStore PTR, BYVAL AS CONST gchar PTR, BYVAL AS gchar PTR PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_store_set_attribute_value(BYVAL AS GdaMetaStore PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_store_schema_add_custom_object(BYVAL AS GdaMetaStore PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_store_schema_remove_custom_object(BYVAL AS GdaMetaStore PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_store_schema_get_all_tables(BYVAL AS GdaMetaStore PTR) AS GSList PTR
DECLARE FUNCTION gda_meta_store_schema_get_depend_tables(BYVAL AS GdaMetaStore PTR, BYVAL AS CONST gchar PTR) AS GSList PTR
DECLARE FUNCTION gda_meta_store_schema_get_structure(BYVAL AS GdaMetaStore PTR, BYVAL AS GError PTR PTR) AS GdaMetaStruct PTR
DECLARE FUNCTION gda_meta_store_declare_foreign_key(BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaStruct PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS guint, BYVAL AS gchar PTR PTR, BYVAL AS gchar PTR PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_store_undeclare_foreign_key(BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaStruct PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_context_get_type() AS GType
DECLARE FUNCTION gda_meta_context_new() AS GdaMetaContext PTR
DECLARE SUB gda_meta_context_set_table(BYVAL AS GdaMetaContext PTR, BYVAL AS CONST gchar PTR)
DECLARE FUNCTION gda_meta_context_get_table(BYVAL AS GdaMetaContext PTR) AS CONST gchar PTR
DECLARE SUB gda_meta_context_set_column(BYVAL AS GdaMetaContext PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR, BYVAL AS GdaConnection PTR)
DECLARE SUB gda_meta_context_set_columns(BYVAL AS GdaMetaContext PTR, BYVAL AS GHashTable PTR, BYVAL AS GdaConnection PTR)
DECLARE SUB gda_meta_context_free(BYVAL AS GdaMetaContext PTR)

#ENDIF ' __GDA_META_STORE_H_

#IFNDEF __GDA_META_STRUCT_H_
#DEFINE __GDA_META_STRUCT_H_

#DEFINE GDA_TYPE_META_STRUCT (gda_meta_struct_get_type())
#DEFINE GDA_META_STRUCT(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_meta_struct_get_type(), GdaMetaStruct)
#DEFINE GDA_META_STRUCT_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_meta_struct_get_type (), GdaMetaStructClass)
#DEFINE GDA_IS_META_STRUCT(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_meta_struct_get_type ())

EXTERN gda_meta_struct_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_META_STRUCT_ERROR gda_meta_struct_error_quark ()

ENUM GdaMetaStructError
	GDA_META_STRUCT_UNKNOWN_OBJECT_ERROR
	GDA_META_STRUCT_DUPLICATE_OBJECT_ERROR
	GDA_META_STRUCT_INCOHERENCE_ERROR
	GDA_META_STRUCT_XML_ERROR
END ENUM

TYPE _GdaMetaStruct
	AS GObject object
	AS GdaMetaStructPrivate PTR priv
END TYPE

TYPE _GdaMetaStructClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

ENUM GdaMetaDbObjectType
	GDA_META_DB_UNKNOWN
	GDA_META_DB_TABLE
	GDA_META_DB_VIEW
END ENUM

ENUM GdaMetaStructFeature
	GDA_META_STRUCT_FEATURE_NONE = 0
	GDA_META_STRUCT_FEATURE_FOREIGN_KEYS = 1  SHL 0
	GDA_META_STRUCT_FEATURE_VIEW_DEPENDENCIES = 1  SHL 1
	GDA_META_STRUCT_FEATURE_ALL = GDA_META_STRUCT_FEATURE_FOREIGN_KEYS  OR GDA_META_STRUCT_FEATURE_VIEW_DEPENDENCIES
END ENUM

ENUM GdaMetaSortType
	GDA_META_SORT_ALHAPETICAL
	GDA_META_SORT_DEPENDENCIES
END ENUM

TYPE GdaMetaTable
	AS GSList PTR columns
	AS gint PTR pk_cols_array
	AS gint pk_cols_nb
	AS GSList PTR reverse_fk_list
	AS GSList PTR fk_list
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

TYPE GdaMetaView
	AS GdaMetaTable table
	AS gchar PTR view_def
	AS gboolean is_updatable
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

UNION GdaMetaDbObject_extra
	AS GdaMetaTable meta_table
	AS GdaMetaView meta_view
END UNION

TYPE GdaMetaDbObject
	AS GdaMetaDbObject_extra extra
	AS GdaMetaDbObjectType obj_type
	AS gboolean outdated
	AS gchar PTR obj_catalog
	AS gchar PTR obj_schema
	AS gchar PTR obj_name
	AS gchar PTR obj_short_name
	AS gchar PTR obj_full_name
	AS gchar PTR obj_owner
	AS GSList PTR depend_list
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

#DEFINE GDA_META_DB_OBJECT(dbo) (CAST(GdaMetaDbObject PTR, (dbo)))
#DEFINE GDA_META_TABLE(dbobj) (@((dbobj)->extra.meta_table))
#DEFINE GDA_META_VIEW(dbobj) (@((dbobj)->extra.meta_view))

TYPE GdaMetaTableColumn
	AS gchar PTR column_name
	AS gchar PTR column_type
	AS GType gtype
	AS gboolean pkey
	AS gboolean nullok
	AS gchar PTR default_value
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

#DEFINE GDA_META_TABLE_COLUMN(col) (CAST(GdaMetaTableColumn PTR, (col)))

DECLARE FUNCTION gda_meta_table_column_get_attribute(BYVAL AS GdaMetaTableColumn PTR, BYVAL AS CONST gchar PTR) AS CONST GValue PTR
DECLARE SUB gda_meta_table_column_set_attribute(BYVAL AS GdaMetaTableColumn PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR, BYVAL AS GDestroyNotify)

#DEFINE gda_meta_table_column_set_attribute_static(column,attribute,value) gda_meta_table_column_set_attribute((column),(attribute),(value),NULL)

DECLARE SUB gda_meta_table_column_foreach_attribute(BYVAL AS GdaMetaTableColumn PTR, BYVAL AS GdaAttributesManagerFunc, BYVAL AS gpointer)

ENUM GdaMetaForeignKeyPolicy
	GDA_META_FOREIGN_KEY_UNKNOWN
	GDA_META_FOREIGN_KEY_NONE
	GDA_META_FOREIGN_KEY_NO_ACTION
	GDA_META_FOREIGN_KEY_RESTRICT
	GDA_META_FOREIGN_KEY_CASCADE
	GDA_META_FOREIGN_KEY_SET_NULL
	GDA_META_FOREIGN_KEY_SET_DEFAULT
END ENUM

TYPE GdaMetaTableForeignKey
	AS GdaMetaDbObject PTR meta_table
	AS GdaMetaDbObject PTR depend_on
	AS gint cols_nb
	AS gint PTR fk_cols_array
	AS gchar PTR PTR fk_names_array
	AS gint PTR ref_pk_cols_array
	AS gchar PTR PTR ref_pk_names_array
	AS GdaMetaForeignKeyPolicy on_update_policy
	AS GdaMetaForeignKeyPolicy on_delete_policy
	AS gboolean declared
	AS gchar PTR fk_name
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

#DEFINE GDA_META_TABLE_FOREIGN_KEY(fk) (CAST(GdaMetaTableForeignKey PTR, (fk)))
#DEFINE GDA_META_TABLE_FOREIGN_KEY_ON_UPDATE_POLICY(fk) ((CAST(GdaMetaTableForeignKey PTR, (fk)))->on_update_policy)
#DEFINE GDA_META_TABLE_FOREIGN_KEY_ON_DELETE_POLICY(fk) ((CAST(GdaMetaTableForeignKey PTR, (fk)))->on_delete_policy)
#DEFINE GDA_META_TABLE_FOREIGN_KEY_IS_DECLARED(fk) ((CAST(GdaMetaTableForeignKey PTR, (fk)))->declared)

DECLARE FUNCTION gda_meta_struct_get_type() AS GType
DECLARE FUNCTION gda_meta_struct_new(BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaStructFeature) AS GdaMetaStruct PTR
DECLARE FUNCTION gda_meta_struct_complement(BYVAL AS GdaMetaStruct PTR, BYVAL AS GdaMetaDbObjectType, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS GError PTR PTR) AS GdaMetaDbObject PTR
DECLARE FUNCTION gda_meta_struct_complement_schema(BYVAL AS GdaMetaStruct PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_struct_complement_default(BYVAL AS GdaMetaStruct PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_struct_complement_all(BYVAL AS GdaMetaStruct PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_struct_complement_depend(BYVAL AS GdaMetaStruct PTR, BYVAL AS GdaMetaDbObject PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_struct_sort_db_objects(BYVAL AS GdaMetaStruct PTR, BYVAL AS GdaMetaSortType, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_meta_struct_get_all_db_objects(BYVAL AS GdaMetaStruct PTR) AS GSList PTR
DECLARE FUNCTION gda_meta_struct_get_db_object(BYVAL AS GdaMetaStruct PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS GdaMetaDbObject PTR
DECLARE FUNCTION gda_meta_struct_get_table_column(BYVAL AS GdaMetaStruct PTR, BYVAL AS GdaMetaTable PTR, BYVAL AS CONST GValue PTR) AS GdaMetaTableColumn PTR

ENUM GdaMetaGraphInfo
	GDA_META_GRAPH_COLUMNS = 1  SHL 0
END ENUM

DECLARE FUNCTION gda_meta_struct_dump_as_graph(BYVAL AS GdaMetaStruct PTR, BYVAL AS GdaMetaGraphInfo, BYVAL AS GError PTR PTR) AS gchar PTR

#ENDIF ' __GDA_META_STRUCT_H_

EXTERN gda_sql_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_SQL_ERROR gda_sql_error_quark ()

ENUM GdaSqlError
	GDA_SQL_STRUCTURE_CONTENTS_ERROR
	GDA_SQL_MALFORMED_IDENTIFIER_ERROR
	GDA_SQL_MISSING_IDENTIFIER_ERROR
	GDA_SQL_VALIDATION_ERROR
END ENUM

TYPE GdaSqlErrorType AS GdaSqlError
TYPE GdaSqlAnyPart AS _GdaSqlAnyPart
TYPE GdaSqlStatement AS _GdaSqlStatement
TYPE GdaSqlStatementUnknown AS _GdaSqlStatementUnknown
TYPE GdaSqlStatementTransaction AS _GdaSqlStatementTransaction
TYPE GdaSqlStatementSelect AS _GdaSqlStatementSelect
TYPE GdaSqlStatementInsert AS _GdaSqlStatementInsert
TYPE GdaSqlStatementDelete AS _GdaSqlStatementDelete
TYPE GdaSqlStatementUpdate AS _GdaSqlStatementUpdate
TYPE GdaSqlStatementCompound AS _GdaSqlStatementCompound

ENUM GdaSqlStatementType
	GDA_SQL_STATEMENT_SELECT
	GDA_SQL_STATEMENT_INSERT
	GDA_SQL_STATEMENT_UPDATE
	GDA_SQL_STATEMENT_DELETE
	GDA_SQL_STATEMENT_COMPOUND
	GDA_SQL_STATEMENT_BEGIN
	GDA_SQL_STATEMENT_ROLLBACK
	GDA_SQL_STATEMENT_COMMIT
	GDA_SQL_STATEMENT_SAVEPOINT
	GDA_SQL_STATEMENT_ROLLBACK_SAVEPOINT
	GDA_SQL_STATEMENT_DELETE_SAVEPOINT
	GDA_SQL_STATEMENT_UNKNOWN
	GDA_SQL_STATEMENT_NONE
END ENUM

ENUM GdaSqlAnyPartType
	GDA_SQL_ANY_STMT_SELECT = GDA_SQL_STATEMENT_SELECT
	GDA_SQL_ANY_STMT_INSERT = GDA_SQL_STATEMENT_INSERT
	GDA_SQL_ANY_STMT_UPDATE = GDA_SQL_STATEMENT_UPDATE
	GDA_SQL_ANY_STMT_DELETE = GDA_SQL_STATEMENT_DELETE
	GDA_SQL_ANY_STMT_COMPOUND = GDA_SQL_STATEMENT_COMPOUND
	GDA_SQL_ANY_STMT_BEGIN = GDA_SQL_STATEMENT_BEGIN
	GDA_SQL_ANY_STMT_ROLLBACK = GDA_SQL_STATEMENT_ROLLBACK
	GDA_SQL_ANY_STMT_COMMIT = GDA_SQL_STATEMENT_COMMIT
	GDA_SQL_ANY_STMT_SAVEPOINT = GDA_SQL_STATEMENT_SAVEPOINT
	GDA_SQL_ANY_STMT_ROLLBACK_SAVEPOINT = GDA_SQL_STATEMENT_ROLLBACK_SAVEPOINT
	GDA_SQL_ANY_STMT_DELETE_SAVEPOINT = GDA_SQL_STATEMENT_DELETE_SAVEPOINT
	GDA_SQL_ANY_STMT_UNKNOWN = GDA_SQL_STATEMENT_UNKNOWN
	GDA_SQL_ANY_EXPR = 500
	GDA_SQL_ANY_SQL_FIELD
	GDA_SQL_ANY_SQL_TABLE
	GDA_SQL_ANY_SQL_FUNCTION
	GDA_SQL_ANY_SQL_OPERATION
	GDA_SQL_ANY_SQL_CASE
	GDA_SQL_ANY_SQL_SELECT_FIELD
	GDA_SQL_ANY_SQL_SELECT_TARGET
	GDA_SQL_ANY_SQL_SELECT_JOIN
	GDA_SQL_ANY_SQL_SELECT_FROM
	GDA_SQL_ANY_SQL_SELECT_ORDER
END ENUM

TYPE _GdaSqlAnyPart
	AS GdaSqlAnyPartType type
	AS GdaSqlAnyPart PTR parent
END TYPE

#DEFINE GDA_SQL_ANY_PART(x) (CAST(GdaSqlAnyPart PTR, (x)))
#DEFINE gda_sql_any_part_set_parent(a,p) _
 if CAST(a, GDA_SQL_ANY_PART(a))->parent = GDA_SQL_ANY_PART(p)

TYPE GdaSqlForeachFunc AS FUNCTION(BYVAL AS GdaSqlAnyPart PTR, BYVAL AS gpointer, BYVAL AS GError PTR PTR) AS gboolean

DECLARE FUNCTION gda_sql_any_part_foreach(BYVAL AS GdaSqlAnyPart PTR, BYVAL AS GdaSqlForeachFunc, BYVAL AS gpointer, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_sql_any_part_check_structure(BYVAL AS GdaSqlAnyPart PTR, BYVAL AS GError PTR PTR) AS gboolean

TYPE GdaSqlStatementContentsInfo
	AS GdaSqlStatementType type
	AS gchar PTR name
	construct AS FUNCTION() AS gpointer
	free AS SUB(BYVAL AS gpointer)
	copy AS FUNCTION(BYVAL AS gpointer) AS gpointer
	serialize AS FUNCTION(BYVAL AS gpointer) AS gchar PTR
	AS GdaSqlForeachFunc check_structure_func
	AS GdaSqlForeachFunc check_validity_func
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

TYPE GdaSqlStatementCheckValidityData
	AS GdaConnection PTR cnc
	AS GdaMetaStore PTR store
	AS GdaMetaStruct PTR mstruct
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

#ENDIF ' _GDA_STATEMENT_STRUCT_DECL_H

TYPE _GdaSqlStatement
	AS gchar PTR sql
	AS GdaSqlStatementType stmt_type
	AS gpointer contents
	AS GdaMetaStruct PTR validity_meta_struct
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

#DEFINE GDA_TYPE_SQL_STATEMENT (gda_sql_statement_get_type())

DECLARE FUNCTION gda_sql_statement_get_type() AS GType
DECLARE FUNCTION gda_sql_statement_new(BYVAL AS GdaSqlStatementType) AS GdaSqlStatement PTR
DECLARE FUNCTION gda_sql_statement_copy(BYVAL AS GdaSqlStatement PTR) AS GdaSqlStatement PTR
DECLARE SUB gda_sql_statement_free(BYVAL AS GdaSqlStatement PTR)
DECLARE FUNCTION gda_sql_statement_serialize(BYVAL AS GdaSqlStatement PTR) AS gchar PTR
DECLARE FUNCTION gda_sql_statement_type_to_string(BYVAL AS GdaSqlStatementType) AS CONST gchar PTR
DECLARE FUNCTION gda_sql_statement_string_to_type(BYVAL AS CONST gchar PTR) AS GdaSqlStatementType
DECLARE FUNCTION gda_sql_statement_check_structure(BYVAL AS GdaSqlStatement PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_sql_statement_check_validity(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaConnection PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_sql_statement_check_validity_m(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaMetaStruct PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE SUB gda_sql_statement_check_clean(BYVAL AS GdaSqlStatement PTR)
DECLARE FUNCTION gda_sql_statement_normalize(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaConnection PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_sql_statement_get_contents_infos(BYVAL AS GdaSqlStatementType) AS GdaSqlStatementContentsInfo PTR

#ENDIF ' _GDA_STATEMENT_STRUCT_H_

#DEFINE GDA_TYPE_STATEMENT (gda_statement_get_type())
#DEFINE GDA_STATEMENT(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_statement_get_type(), GdaStatement)
#DEFINE GDA_STATEMENT_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_statement_get_type (), GdaStatementClass)
#DEFINE GDA_IS_STATEMENT(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_statement_get_type ())

EXTERN gda_statement_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_STATEMENT_ERROR gda_statement_error_quark ()

ENUM GdaStatementError
	GDA_STATEMENT_PARSE_ERROR
	GDA_STATEMENT_SYNTAX_ERROR
	GDA_STATEMENT_NO_CNC_ERROR
	GDA_STATEMENT_CNC_CLOSED_ERROR
	GDA_STATEMENT_EXEC_ERROR
	GDA_STATEMENT_PARAM_TYPE_ERROR
	GDA_STATEMENT_PARAM_ERROR
END ENUM

ENUM GdaStatementModelUsage
	GDA_STATEMENT_MODEL_RANDOM_ACCESS = 1  SHL 0
	GDA_STATEMENT_MODEL_CURSOR_FORWARD = 1  SHL 1
	GDA_STATEMENT_MODEL_CURSOR_BACKWARD = 1  SHL 2
	GDA_STATEMENT_MODEL_CURSOR = GDA_STATEMENT_MODEL_CURSOR_FORWARD  OR GDA_STATEMENT_MODEL_CURSOR_BACKWARD
	GDA_STATEMENT_MODEL_ALLOW_NOPARAM = 1  SHL 3
	GDA_STATEMENT_MODEL_OFFLINE = 1  SHL 4
END ENUM

ENUM GdaStatementSqlFlag
	GDA_STATEMENT_SQL_PARAMS_AS_VALUES = 0
	GDA_STATEMENT_SQL_PRETTY = 1  SHL 0
	GDA_STATEMENT_SQL_PARAMS_LONG = 1  SHL 1
	GDA_STATEMENT_SQL_PARAMS_SHORT = 1  SHL 2
	GDA_STATEMENT_SQL_PARAMS_AS_COLON = 1  SHL 3
	GDA_STATEMENT_SQL_PARAMS_AS_DOLLAR = 1  SHL 4
	GDA_STATEMENT_SQL_PARAMS_AS_QMARK = 1  SHL 5
	GDA_STATEMENT_SQL_PARAMS_AS_UQMARK = 1  SHL 6
END ENUM

TYPE _GdaStatement
	AS GObject object
	AS GdaStatementPrivate PTR priv
END TYPE

TYPE _GdaStatementClass
	AS GObjectClass parent_class
	checked AS SUB(BYVAL AS GdaStatement PTR, BYVAL AS GdaConnection PTR, BYVAL AS gboolean)
	reset_ AS SUB(BYVAL AS GdaStatement PTR)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_statement_get_type() AS GType
DECLARE FUNCTION gda_statement_new() AS GdaStatement PTR
DECLARE FUNCTION gda_statement_copy(BYVAL AS GdaStatement PTR) AS GdaStatement PTR
DECLARE FUNCTION gda_statement_serialize(BYVAL AS GdaStatement PTR) AS gchar PTR
DECLARE FUNCTION gda_statement_get_parameters(BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR PTR, BYVAL AS GError PTR PTR) AS gboolean

#DEFINE gda_statement_to_sql(stmt,params,error) gda_statement_to_sql_extended ((stmt), NULL, (params), GDA_STATEMENT_SQL_PARAMS_SHORT, NULL, (error))

DECLARE FUNCTION gda_statement_to_sql_extended(BYVAL AS GdaStatement PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaStatementSqlFlag, BYVAL AS GSList PTR PTR, BYVAL AS GError PTR PTR) AS gchar PTR
DECLARE FUNCTION gda_statement_get_statement_type(BYVAL AS GdaStatement PTR) AS GdaSqlStatementType
DECLARE FUNCTION gda_statement_is_useless(BYVAL AS GdaStatement PTR) AS gboolean
DECLARE FUNCTION gda_statement_check_structure(BYVAL AS GdaStatement PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_statement_check_validity(BYVAL AS GdaStatement PTR, BYVAL AS GdaConnection PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_statement_normalize(BYVAL AS GdaStatement PTR, BYVAL AS GdaConnection PTR, BYVAL AS GError PTR PTR) AS gboolean

#ENDIF ' _GDA_STATEMENT_H_

#IFNDEF __GDA_SERVER_OPERATION_H__
#DEFINE __GDA_SERVER_OPERATION_H__

#DEFINE GDA_TYPE_SERVER_OPERATION (gda_server_operation_get_type())
#DEFINE GDA_SERVER_OPERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_SERVER_OPERATION, GdaServerOperation))
#DEFINE GDA_SERVER_OPERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_SERVER_OPERATION, GdaServerOperationClass))
#DEFINE GDA_IS_SERVER_OPERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_SERVER_OPERATION))
#DEFINE GDA_IS_SERVER_OPERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_SERVER_OPERATION))

ENUM GdaServerOperationType
	GDA_SERVER_OPERATION_CREATE_DB
	GDA_SERVER_OPERATION_DROP_DB
	GDA_SERVER_OPERATION_CREATE_TABLE
	GDA_SERVER_OPERATION_DROP_TABLE
	GDA_SERVER_OPERATION_RENAME_TABLE
	GDA_SERVER_OPERATION_ADD_COLUMN
	GDA_SERVER_OPERATION_DROP_COLUMN
	GDA_SERVER_OPERATION_CREATE_INDEX
	GDA_SERVER_OPERATION_DROP_INDEX
	GDA_SERVER_OPERATION_CREATE_VIEW
	GDA_SERVER_OPERATION_DROP_VIEW
	GDA_SERVER_OPERATION_COMMENT_TABLE
	GDA_SERVER_OPERATION_COMMENT_COLUMN
	GDA_SERVER_OPERATION_CREATE_USER
	GDA_SERVER_OPERATION_ALTER_USER
	GDA_SERVER_OPERATION_DROP_USER
	GDA_SERVER_OPERATION_LAST
END ENUM

EXTERN gda_server_operation_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_SERVER_OPERATION_ERROR gda_server_operation_error_quark ()

ENUM GdaServerOperationError
	GDA_SERVER_OPERATION_OBJECT_NAME_ERROR
	GDA_SERVER_OPERATION_INCORRECT_VALUE_ERROR
	GDA_SERVER_OPERATION_XML_ERROR
END ENUM

ENUM GdaServerOperationCreateTableFlag
	GDA_SERVER_OPERATION_CREATE_TABLE_NOTHING_FLAG = 1  SHL 0
	GDA_SERVER_OPERATION_CREATE_TABLE_PKEY_FLAG = 1  SHL 1
	GDA_SERVER_OPERATION_CREATE_TABLE_NOT_NULL_FLAG = 1  SHL 2
	GDA_SERVER_OPERATION_CREATE_TABLE_UNIQUE_FLAG = 1  SHL 3
	GDA_SERVER_OPERATION_CREATE_TABLE_AUTOINC_FLAG = 1  SHL 4
	GDA_SERVER_OPERATION_CREATE_TABLE_FKEY_FLAG = 1  SHL 5
	GDA_SERVER_OPERATION_CREATE_TABLE_PKEY_AUTOINC_FLAG = GDA_SERVER_OPERATION_CREATE_TABLE_PKEY_FLAG  OR GDA_SERVER_OPERATION_CREATE_TABLE_AUTOINC_FLAG
END ENUM

ENUM GdaServerOperationNodeType
	GDA_SERVER_OPERATION_NODE_PARAMLIST
	GDA_SERVER_OPERATION_NODE_DATA_MODEL
	GDA_SERVER_OPERATION_NODE_PARAM
	GDA_SERVER_OPERATION_NODE_SEQUENCE
	GDA_SERVER_OPERATION_NODE_SEQUENCE_ITEM
	GDA_SERVER_OPERATION_NODE_DATA_MODEL_COLUMN
	GDA_SERVER_OPERATION_NODE_UNKNOWN
END ENUM

ENUM GdaServerOperationNodeStatus
	GDA_SERVER_OPERATION_STATUS_OPTIONAL
	GDA_SERVER_OPERATION_STATUS_REQUIRED
	GDA_SERVER_OPERATION_STATUS_UNKNOWN
END ENUM

TYPE _GdaServerOperationNode
	AS GdaServerOperationNodeType type
	AS GdaServerOperationNodeStatus status
	AS GdaSet PTR plist
	AS GdaDataModel PTR model
	AS GdaColumn PTR column
	AS GdaHolder PTR param
	AS gpointer priv
END TYPE

TYPE GdaServerOperationNode AS _GdaServerOperationNode

TYPE _GdaServerOperation
	AS GObject object
	AS GdaServerOperationPrivate PTR priv
END TYPE

TYPE _GdaServerOperationClass
	AS GObjectClass parent_class
	seq_item_added AS SUB(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR, BYVAL AS gint)
	seq_item_remove AS SUB(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR, BYVAL AS gint)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_server_operation_get_type() AS GType
DECLARE FUNCTION gda_server_operation_new(BYVAL AS GdaServerOperationType, BYVAL AS CONST gchar PTR) AS GdaServerOperation PTR
DECLARE FUNCTION gda_server_operation_get_op_type(BYVAL AS GdaServerOperation PTR) AS GdaServerOperationType
DECLARE FUNCTION gda_server_operation_op_type_to_string(BYVAL AS GdaServerOperationType) AS CONST gchar PTR
DECLARE FUNCTION gda_server_operation_string_to_op_type(BYVAL AS CONST gchar PTR) AS GdaServerOperationType
DECLARE FUNCTION gda_server_operation_get_node_info(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR, ...) AS GdaServerOperationNode PTR
DECLARE FUNCTION gda_server_operation_get_value_at(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR, ...) AS CONST GValue PTR
DECLARE FUNCTION gda_server_operation_get_value_at_path(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR) AS CONST GValue PTR
DECLARE FUNCTION gda_server_operation_get_sql_identifier_at(BYVAL AS GdaServerOperation PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaServerProvider PTR, BYVAL AS CONST gchar PTR, ...) AS gchar PTR
DECLARE FUNCTION gda_server_operation_get_sql_identifier_at_path(BYVAL AS GdaServerOperation PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaServerProvider PTR, BYVAL AS CONST gchar PTR) AS gchar PTR
DECLARE FUNCTION gda_server_operation_set_value_at(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST gchar PTR, ...) AS gboolean
DECLARE FUNCTION gda_server_operation_set_value_at_path(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_server_operation_save_data_to_xml(BYVAL AS GdaServerOperation PTR, BYVAL AS GError PTR PTR) AS xmlNodePtr
DECLARE FUNCTION gda_server_operation_load_data_from_xml(BYVAL AS GdaServerOperation PTR, BYVAL AS xmlNodePtr, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_server_operation_get_root_nodes(BYVAL AS GdaServerOperation PTR) AS gchar PTR PTR
DECLARE FUNCTION gda_server_operation_get_node_type(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaServerOperationNodeStatus PTR) AS GdaServerOperationNodeType
DECLARE FUNCTION gda_server_operation_get_node_parent(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR) AS gchar PTR
DECLARE FUNCTION gda_server_operation_get_node_path_portion(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR) AS gchar PTR
DECLARE FUNCTION gda_server_operation_get_sequence_name(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR) AS CONST gchar PTR
DECLARE FUNCTION gda_server_operation_get_sequence_size(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR) AS guint
DECLARE FUNCTION gda_server_operation_get_sequence_max_size(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR) AS guint
DECLARE FUNCTION gda_server_operation_get_sequence_min_size(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR) AS guint
DECLARE FUNCTION gda_server_operation_get_sequence_item_names(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR) AS gchar PTR PTR
DECLARE FUNCTION gda_server_operation_add_item_to_sequence(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR) AS guint
DECLARE FUNCTION gda_server_operation_del_item_from_sequence(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR) AS gboolean
DECLARE FUNCTION gda_server_operation_is_valid(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_server_operation_prepare_create_database(BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS GdaServerOperation PTR
DECLARE FUNCTION gda_server_operation_perform_create_database(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_server_operation_prepare_drop_database(BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS GdaServerOperation PTR
DECLARE FUNCTION gda_server_operation_perform_drop_database(BYVAL AS GdaServerOperation PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_server_operation_prepare_create_table(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR, ...) AS GdaServerOperation PTR
DECLARE FUNCTION gda_server_operation_perform_create_table(BYVAL AS GdaServerOperation PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_server_operation_prepare_drop_table(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS GdaServerOperation PTR
DECLARE FUNCTION gda_server_operation_perform_drop_table(BYVAL AS GdaServerOperation PTR, BYVAL AS GError PTR PTR) AS gboolean

#ENDIF ' __GDA_SERVER_OPERATION_H__

#DEFINE GDA_TYPE_CONNECTION (gda_connection_get_type())
#DEFINE GDA_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_CONNECTION, GdaConnection))
#DEFINE GDA_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_CONNECTION, GdaConnectionClass))
#DEFINE GDA_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_CONNECTION))
#DEFINE GDA_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_CONNECTION))

EXTERN gda_connection_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_CONNECTION_ERROR gda_connection_error_quark ()

ENUM GdaConnectionError
	GDA_CONNECTION_DSN_NOT_FOUND_ERROR
	GDA_CONNECTION_PROVIDER_NOT_FOUND_ERROR
	GDA_CONNECTION_PROVIDER_ERROR
	GDA_CONNECTION_NO_CNC_SPEC_ERROR
	GDA_CONNECTION_NO_PROVIDER_SPEC_ERROR
	GDA_CONNECTION_OPEN_ERROR
	GDA_CONNECTION_STATEMENT_TYPE_ERROR
	GDA_CONNECTION_CANT_LOCK_ERROR
	GDA_CONNECTION_TASK_NOT_FOUND_ERROR
	GDA_CONNECTION_UNSUPPORTED_THREADS_ERROR
	GDA_CONNECTION_CLOSED_ERROR
	GDA_CONNECTION_META_DATA_CONTEXT_ERROR
END ENUM

#DEFINE GDA_CONNECTION_NONEXIST_DSN_ERROR GDA_CONNECTION_DSN_NOT_FOUND_ERROR

TYPE _GdaConnection
	AS GObject object
	AS GdaConnectionPrivate PTR priv
END TYPE

TYPE _GdaConnectionClass
	AS GObjectClass object_class
	error_ AS SUB(BYVAL AS GdaConnection PTR, BYVAL AS GdaConnectionEvent PTR)
	conn_opened AS SUB(BYVAL AS GdaConnection PTR)
	conn_to_close AS SUB(BYVAL AS GdaConnection PTR)
	conn_closed AS SUB(BYVAL AS GdaConnection PTR)
	dsn_changed AS SUB(BYVAL AS GdaConnection PTR)
	transaction_status_changed AS SUB(BYVAL AS GdaConnection PTR)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

ENUM GdaConnectionOptions
	GDA_CONNECTION_OPTIONS_NONE = 0
	GDA_CONNECTION_OPTIONS_READ_ONLY = 1  SHL 0
	GDA_CONNECTION_OPTIONS_SQL_IDENTIFIERS_CASE_SENSITIVE = 1  SHL 1
	GDA_CONNECTION_OPTIONS_THREAD_SAFE = 1  SHL 2
	GDA_CONNECTION_OPTIONS_THREAD_ISOLATED = 1  SHL 3
	GDA_CONNECTION_OPTIONS_AUTO_META_DATA = 1  SHL 4
END ENUM

ENUM GdaConnectionFeature
	GDA_CONNECTION_FEATURE_AGGREGATES
	GDA_CONNECTION_FEATURE_BLOBS
	GDA_CONNECTION_FEATURE_INDEXES
	GDA_CONNECTION_FEATURE_INHERITANCE
	GDA_CONNECTION_FEATURE_NAMESPACES
	GDA_CONNECTION_FEATURE_PROCEDURES
	GDA_CONNECTION_FEATURE_SEQUENCES
	GDA_CONNECTION_FEATURE_SQL
	GDA_CONNECTION_FEATURE_TRANSACTIONS
	GDA_CONNECTION_FEATURE_SAVEPOINTS
	GDA_CONNECTION_FEATURE_SAVEPOINTS_REMOVE
	GDA_CONNECTION_FEATURE_TRIGGERS
	GDA_CONNECTION_FEATURE_UPDATABLE_CURSOR
	GDA_CONNECTION_FEATURE_USERS
	GDA_CONNECTION_FEATURE_VIEWS
	GDA_CONNECTION_FEATURE_XA_TRANSACTIONS
	GDA_CONNECTION_FEATURE_MULTI_THREADING
	GDA_CONNECTION_FEATURE_LAST
END ENUM

ENUM GdaConnectionMetaType
	GDA_CONNECTION_META_NAMESPACES
	GDA_CONNECTION_META_TYPES
	GDA_CONNECTION_META_TABLES
	GDA_CONNECTION_META_VIEWS
	GDA_CONNECTION_META_FIELDS
	GDA_CONNECTION_META_INDEXES
END ENUM

DECLARE FUNCTION gda_connection_get_type() AS GType
DECLARE FUNCTION gda_connection_open_from_dsn(BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaConnectionOptions, BYVAL AS GError PTR PTR) AS GdaConnection PTR
DECLARE FUNCTION gda_connection_open_from_string(BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaConnectionOptions, BYVAL AS GError PTR PTR) AS GdaConnection PTR
DECLARE FUNCTION gda_connection_new_from_dsn(BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaConnectionOptions, BYVAL AS GError PTR PTR) AS GdaConnection PTR
DECLARE FUNCTION gda_connection_new_from_string(BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaConnectionOptions, BYVAL AS GError PTR PTR) AS GdaConnection PTR
DECLARE FUNCTION gda_connection_open(BYVAL AS GdaConnection PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE SUB gda_connection_close(BYVAL AS GdaConnection PTR)
DECLARE SUB gda_connection_close_no_warning(BYVAL AS GdaConnection PTR)
DECLARE FUNCTION gda_connection_is_opened(BYVAL AS GdaConnection PTR) AS gboolean
DECLARE FUNCTION gda_connection_get_options(BYVAL AS GdaConnection PTR) AS GdaConnectionOptions
DECLARE FUNCTION gda_connection_get_provider(BYVAL AS GdaConnection PTR) AS GdaServerProvider PTR
DECLARE FUNCTION gda_connection_get_provider_name(BYVAL AS GdaConnection PTR) AS CONST gchar PTR
DECLARE FUNCTION gda_connection_create_operation(BYVAL AS GdaConnection PTR, BYVAL AS GdaServerOperationType, BYVAL AS GdaSet PTR, BYVAL AS GError PTR PTR) AS GdaServerOperation PTR
DECLARE FUNCTION gda_connection_perform_operation(BYVAL AS GdaConnection PTR, BYVAL AS GdaServerOperation PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_get_dsn(BYVAL AS GdaConnection PTR) AS CONST gchar PTR
DECLARE FUNCTION gda_connection_get_cnc_string(BYVAL AS GdaConnection PTR) AS CONST gchar PTR
DECLARE FUNCTION gda_connection_get_authentication(BYVAL AS GdaConnection PTR) AS CONST gchar PTR
DECLARE FUNCTION gda_connection_parse_sql_string(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaSet PTR PTR, BYVAL AS GError PTR PTR) AS GdaStatement PTR
DECLARE FUNCTION gda_connection_execute_select_command(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_connection_execute_non_select_command(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gint
DECLARE FUNCTION gda_connection_insert_row_into_table(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR, ...) AS gboolean
DECLARE FUNCTION gda_connection_insert_row_into_table_v(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GSList PTR, BYVAL AS GSList PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_update_row_in_table(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GValue PTR, BYVAL AS GError PTR PTR, ...) AS gboolean
DECLARE FUNCTION gda_connection_update_row_in_table_v(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GValue PTR, BYVAL AS GSList PTR, BYVAL AS GSList PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_delete_row_from_table(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GValue PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_get_events(BYVAL AS GdaConnection PTR) AS CONST GList PTR
DECLARE FUNCTION gda_connection_create_parser(BYVAL AS GdaConnection PTR) AS GdaSqlParser PTR
DECLARE FUNCTION gda_connection_batch_execute(BYVAL AS GdaConnection PTR, BYVAL AS GdaBatch PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaStatementModelUsage, BYVAL AS GError PTR PTR) AS GSList PTR
DECLARE FUNCTION gda_connection_quote_sql_identifier(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR) AS gchar PTR
DECLARE FUNCTION gda_connection_statement_to_sql(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaStatementSqlFlag, BYVAL AS GSList PTR PTR, BYVAL AS GError PTR PTR) AS gchar PTR
DECLARE FUNCTION gda_connection_statement_prepare(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_statement_execute(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaStatementModelUsage, BYVAL AS GdaSet PTR PTR, BYVAL AS GError PTR PTR) AS GObject PTR
DECLARE FUNCTION gda_connection_statement_execute_select(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GError PTR PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_connection_statement_execute_select_fullv(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaStatementModelUsage, BYVAL AS GError PTR PTR, ...) AS GdaDataModel PTR
DECLARE FUNCTION gda_connection_statement_execute_select_full(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaStatementModelUsage, BYVAL AS GType PTR, BYVAL AS GError PTR PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_connection_statement_execute_non_select(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaSet PTR PTR, BYVAL AS GError PTR PTR) AS gint
DECLARE FUNCTION gda_connection_async_statement_execute(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaStatementModelUsage, BYVAL AS GType PTR, BYVAL AS gboolean, BYVAL AS GError PTR PTR) AS guint
DECLARE FUNCTION gda_connection_async_fetch_result(BYVAL AS GdaConnection PTR, BYVAL AS guint, BYVAL AS GdaSet PTR PTR, BYVAL AS GError PTR PTR) AS GObject PTR
DECLARE FUNCTION gda_connection_async_cancel(BYVAL AS GdaConnection PTR, BYVAL AS guint, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_repetitive_statement_execute(BYVAL AS GdaConnection PTR, BYVAL AS GdaRepetitiveStatement PTR, BYVAL AS GdaStatementModelUsage, BYVAL AS GType PTR, BYVAL AS gboolean, BYVAL AS GError PTR PTR) AS GSList PTR
DECLARE FUNCTION gda_connection_begin_transaction(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaTransactionIsolation, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_commit_transaction(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_rollback_transaction(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_add_savepoint(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_rollback_savepoint(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_delete_savepoint(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_get_transaction_status(BYVAL AS GdaConnection PTR) AS GdaTransactionStatus PTR
DECLARE FUNCTION gda_connection_value_to_sql_string(BYVAL AS GdaConnection PTR, BYVAL AS GValue PTR) AS gchar PTR
DECLARE FUNCTION gda_connection_supports_feature(BYVAL AS GdaConnection PTR, BYVAL AS GdaConnectionFeature) AS gboolean
DECLARE FUNCTION gda_connection_get_meta_store(BYVAL AS GdaConnection PTR) AS GdaMetaStore PTR
DECLARE FUNCTION gda_connection_update_meta_store(BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_connection_get_meta_store_data(BYVAL AS GdaConnection PTR, BYVAL AS GdaConnectionMetaType, BYVAL AS GError PTR PTR, BYVAL AS gint, ...) AS GdaDataModel PTR
DECLARE FUNCTION gda_connection_get_meta_store_data_v(BYVAL AS GdaConnection PTR, BYVAL AS GdaConnectionMetaType, BYVAL AS GList PTR, BYVAL AS GError PTR PTR) AS GdaDataModel PTR

#ENDIF ' __GDA_CONNECTION_H__

#IFNDEF __GDA_CONNECTION_PRIVATE_H_
#DEFINE __GDA_CONNECTION_PRIVATE_H_

#IFNDEF __GDA_PSTMT_H__
#DEFINE __GDA_PSTMT_H__

#DEFINE GDA_TYPE_PSTMT (gda_pstmt_get_type())
#DEFINE GDA_PSTMT(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_PSTMT, GdaPStmt))
#DEFINE GDA_PSTMT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_PSTMT, GdaPStmtClass))
#DEFINE GDA_IS_PSTMT(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_PSTMT))
#DEFINE GDA_IS_PSTMT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_PSTMT))

TYPE GdaPStmt AS _GdaPStmt
TYPE GdaPStmtPrivate AS _GdaPStmtPrivate
TYPE GdaPStmtClass AS _GdaPStmtClass

TYPE _GdaPStmt
	AS GObject object
	AS GdaPStmtPrivate PTR priv
	AS gchar PTR sql
	AS GSList PTR param_ids
	AS gint ncols
	AS GType PTR types
	AS GSList PTR tmpl_columns
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

TYPE _GdaPStmtClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_pstmt_get_type() AS GType
DECLARE SUB gda_pstmt_set_gda_statement(BYVAL AS GdaPStmt PTR, BYVAL AS GdaStatement PTR)
DECLARE SUB gda_pstmt_copy_contents(BYVAL AS GdaPStmt PTR, BYVAL AS GdaPStmt PTR)
DECLARE FUNCTION gda_pstmt_get_gda_statement(BYVAL AS GdaPStmt PTR) AS GdaStatement PTR

#ENDIF ' __GDA_PSTMT_H__

DECLARE SUB gda_connection_internal_set_provider_data(BYVAL AS GdaConnection PTR, BYVAL AS gpointer, BYVAL AS GDestroyNotify)
DECLARE FUNCTION gda_connection_internal_get_provider_data(BYVAL AS GdaConnection PTR) AS gpointer
DECLARE FUNCTION gda_connection_internal_get_provider_data_error(BYVAL AS GdaConnection PTR, BYVAL AS GError PTR PTR) AS gpointer
DECLARE FUNCTION gda_connection_point_available_event(BYVAL AS GdaConnection PTR, BYVAL AS GdaConnectionEventType) AS GdaConnectionEvent PTR
DECLARE SUB gda_connection_add_event(BYVAL AS GdaConnection PTR, BYVAL AS GdaConnectionEvent PTR)
DECLARE FUNCTION gda_connection_add_event_string(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, ...) AS GdaConnectionEvent PTR
DECLARE SUB gda_connection_clear_events_list(BYVAL AS GdaConnection PTR)
DECLARE SUB gda_connection_internal_transaction_started(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaTransactionIsolation)
DECLARE SUB gda_connection_internal_transaction_rolledback(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR)
DECLARE SUB gda_connection_internal_transaction_committed(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR)
DECLARE SUB gda_connection_internal_statement_executed(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaConnectionEvent PTR)
DECLARE SUB gda_connection_internal_savepoint_added(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR)
DECLARE SUB gda_connection_internal_savepoint_rolledback(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR)
DECLARE SUB gda_connection_internal_savepoint_removed(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR)
DECLARE SUB gda_connection_internal_change_transaction_state(BYVAL AS GdaConnection PTR, BYVAL AS GdaTransactionStatusState)
DECLARE SUB gda_connection_internal_reset_transaction_status(BYVAL AS GdaConnection PTR)
DECLARE SUB gda_connection_add_prepared_statement(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaPStmt PTR)
DECLARE SUB gda_connection_del_prepared_statement(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR)
DECLARE FUNCTION gda_connection_get_prepared_statement(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR) AS GdaPStmt PTR
DECLARE FUNCTION gda_connection_open_sqlite(BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS gboolean) AS GdaConnection PTR

#ENDIF ' __GDA_CONNECTION_PRIVATE_H_

#IFNDEF __GDA_DATA_COMPARATOR_H_
#DEFINE __GDA_DATA_COMPARATOR_H_

#DEFINE GDA_TYPE_DATA_COMPARATOR (gda_data_comparator_get_type())
#DEFINE GDA_DATA_COMPARATOR(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_data_comparator_get_type(), GdaDataComparator)
#DEFINE GDA_DATA_COMPARATOR_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_data_comparator_get_type (), GdaDataComparatorClass)
#DEFINE GDA_IS_DATA_COMPARATOR(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_data_comparator_get_type ())

TYPE GdaDataComparator AS _GdaDataComparator
TYPE GdaDataComparatorClass AS _GdaDataComparatorClass
TYPE GdaDataComparatorPrivate AS _GdaDataComparatorPrivate

EXTERN gda_data_comparator_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_DATA_COMPARATOR_ERROR gda_data_comparator_error_quark ()

ENUM GdaDataComparatorError
	GDA_DATA_COMPARATOR_MISSING_DATA_MODEL_ERROR
	GDA_DATA_COMPARATOR_COLUMN_TYPES_MISMATCH_ERROR
	GDA_DATA_COMPARATOR_MODEL_ACCESS_ERROR
	GDA_DATA_COMPARATOR_USER_CANCELLED_ERROR
END ENUM

ENUM GdaDiffType
	GDA_DIFF_ADD_ROW
	GDA_DIFF_REMOVE_ROW
	GDA_DIFF_MODIFY_ROW
END ENUM

TYPE GdaDiff
	AS GdaDiffType type
	AS gint old_row
	AS gint new_row
	AS GHashTable PTR values
END TYPE

TYPE _GdaDataComparator
	AS GObject object
	AS GdaDataComparatorPrivate PTR priv
END TYPE

TYPE _GdaDataComparatorClass
	AS GObjectClass parent_class
	diff_computed AS FUNCTION(BYVAL AS GdaDataComparator PTR, BYVAL AS GdaDiff PTR) AS gboolean
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_data_comparator_get_type() AS GType
DECLARE FUNCTION gda_data_comparator_new(BYVAL AS GdaDataModel PTR, BYVAL AS GdaDataModel PTR) AS GObject PTR
DECLARE SUB gda_data_comparator_set_key_columns(BYVAL AS GdaDataComparator PTR, BYVAL AS CONST gint PTR, BYVAL AS gint)
DECLARE FUNCTION gda_data_comparator_compute_diff(BYVAL AS GdaDataComparator PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_comparator_get_n_diffs(BYVAL AS GdaDataComparator PTR) AS gint
DECLARE FUNCTION gda_data_comparator_get_diff(BYVAL AS GdaDataComparator PTR, BYVAL AS gint) AS CONST GdaDiff PTR

#ENDIF ' __GDA_DATA_COMPARATOR_H_

#IFNDEF __GDA_DATA_MODEL_ARRAY_H__
#DEFINE __GDA_DATA_MODEL_ARRAY_H__

#IFNDEF __GDA_ROW_H__
#DEFINE __GDA_ROW_H__

#DEFINE GDA_TYPE_ROW (gda_row_get_type())
#DEFINE GDA_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_ROW, GdaRow))
#DEFINE GDA_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_ROW, GdaRowClass))
#DEFINE GDA_IS_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE (obj, GDA_TYPE_ROW))
#DEFINE GDA_IS_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GDA_TYPE_ROW))

TYPE GdaRow AS _GdaRow
TYPE GdaRowClass AS _GdaRowClass
TYPE GdaRowPrivate AS _GdaRowPrivate

TYPE _GdaRow
	AS GObject object
	AS GdaRowPrivate PTR priv
END TYPE

TYPE _GdaRowClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_row_get_type() AS GType
DECLARE FUNCTION gda_row_new(BYVAL AS gint) AS GdaRow PTR
DECLARE FUNCTION gda_row_get_length(BYVAL AS GdaRow PTR) AS gint
DECLARE FUNCTION gda_row_get_value(BYVAL AS GdaRow PTR, BYVAL AS gint) AS GValue PTR
DECLARE SUB gda_row_invalidate_value(BYVAL AS GdaRow PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_row_invalidate_value_e(BYVAL AS GdaRow PTR, BYVAL AS GValue PTR, BYVAL AS GError PTR)
DECLARE FUNCTION gda_row_value_is_valid(BYVAL AS GdaRow PTR, BYVAL AS GValue PTR) AS gboolean
DECLARE FUNCTION gda_row_value_is_valid_e(BYVAL AS GdaRow PTR, BYVAL AS GValue PTR, BYVAL AS GError PTR PTR) AS gboolean

#ENDIF ' __GDA_ROW_H__

#DEFINE GDA_TYPE_DATA_MODEL_ARRAY (gda_data_model_array_get_type())
#DEFINE GDA_DATA_MODEL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_DATA_MODEL_ARRAY, GdaDataModelArray))
#DEFINE GDA_DATA_MODEL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_DATA_MODEL_ARRAY, GdaDataModelArrayClass))
#DEFINE GDA_IS_DATA_MODEL_ARRAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE (obj, GDA_TYPE_DATA_MODEL_ARRAY))
#DEFINE GDA_IS_DATA_MODEL_ARRAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GDA_TYPE_DATA_MODEL_ARRAY))

TYPE GdaDataModelArray AS _GdaDataModelArray
TYPE GdaDataModelArrayClass AS _GdaDataModelArrayClass
TYPE GdaDataModelArrayPrivate AS _GdaDataModelArrayPrivate

TYPE _GdaDataModelArray
	AS GObject object
	AS GdaDataModelArrayPrivate PTR priv
END TYPE

TYPE _GdaDataModelArrayClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_data_model_array_get_type() AS GType
DECLARE FUNCTION gda_data_model_array_new_with_g_types(BYVAL AS gint, ...) AS GdaDataModel PTR
DECLARE FUNCTION gda_data_model_array_new_with_g_types_v(BYVAL AS gint, BYVAL AS GType PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_data_model_array_new(BYVAL AS gint) AS GdaDataModel PTR
DECLARE FUNCTION gda_data_model_array_copy_model(BYVAL AS GdaDataModel PTR, BYVAL AS GError PTR PTR) AS GdaDataModelArray PTR
DECLARE FUNCTION gda_data_model_array_copy_model_ext(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS gint PTR, BYVAL AS GError PTR PTR) AS GdaDataModelArray PTR
DECLARE FUNCTION gda_data_model_array_get_row(BYVAL AS GdaDataModelArray PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS GdaRow PTR
DECLARE SUB gda_data_model_array_set_n_columns(BYVAL AS GdaDataModelArray PTR, BYVAL AS gint)
DECLARE SUB gda_data_model_array_clear(BYVAL AS GdaDataModelArray PTR)

#ENDIF ' __GDA_DATA_MODEL_ARRAY_H__

#IFNDEF __GDA_DATA_MODEL_ITER_H_
#DEFINE __GDA_DATA_MODEL_ITER_H_

#IFNDEF __GDA_SET_H_
#DEFINE __GDA_SET_H_

#DEFINE GDA_TYPE_SET (gda_set_get_type())
#DEFINE GDA_SET(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_set_get_type(), GdaSet)
#DEFINE GDA_SET_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_set_get_type (), GdaSetClass)
#DEFINE GDA_IS_SET(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_set_get_type ())

EXTERN gda_set_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_SET_ERROR gda_set_error_quark ()

ENUM GdaSetError
	GDA_SET_XML_SPEC_ERROR
	GDA_SET_HOLDER_NOT_FOUND_ERROR
	GDA_SET_INVALID_ERROR
	GDA_SET_READ_ONLY_ERROR
	GDA_SET_IMPLEMENTATION_ERROR
END ENUM

TYPE _GdaSetNode
	AS GdaHolder PTR holder
	AS GdaDataModel PTR source_model
	AS gint source_column
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

TYPE _GdaSetGroup
	AS GSList PTR nodes
	AS GdaSetSource PTR nodes_source
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

TYPE _GdaSetSource
	AS GdaDataModel PTR data_model
	AS GSList PTR nodes
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

#DEFINE GDA_SET_NODE(x) (CAST(GdaSetNode PTR, (x)))
#DEFINE GDA_SET_SOURCE(x) (CAST(GdaSetSource PTR, (x)))
#DEFINE GDA_SET_GROUP(x) (CAST(GdaSetGroup PTR, (x)))

TYPE _GdaSet
	AS GObject object
	AS GdaSetPrivate PTR priv
	AS GSList PTR holders
	AS GSList PTR nodes_list
	AS GSList PTR sources_list
	AS GSList PTR groups_list
END TYPE

TYPE _GdaSetClass
	AS GObjectClass parent_class
	validate_holder_change AS FUNCTION(BYVAL AS GdaSet PTR, BYVAL AS GdaHolder PTR, BYVAL AS CONST GValue PTR) AS GError PTR
	validate_set AS FUNCTION(BYVAL AS GdaSet PTR) AS GError PTR
	holder_changed AS SUB(BYVAL AS GdaSet PTR, BYVAL AS GdaHolder PTR)
	holder_attr_changed AS SUB(BYVAL AS GdaSet PTR, BYVAL AS GdaHolder PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR)
	public_data_changed AS SUB(BYVAL AS GdaSet PTR)
	holder_type_set AS SUB(BYVAL AS GdaSet PTR, BYVAL AS GdaHolder PTR)
	source_model_changed AS SUB(BYVAL AS GdaSet PTR, BYVAL AS GdaSetSource PTR)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_set_get_type() AS GType
DECLARE FUNCTION gda_set_new(BYVAL AS GSList PTR) AS GdaSet PTR
DECLARE FUNCTION gda_set_copy(BYVAL AS GdaSet PTR) AS GdaSet PTR
DECLARE FUNCTION gda_set_new_inline(BYVAL AS gint, ...) AS GdaSet PTR
DECLARE FUNCTION gda_set_new_from_spec_string(BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS GdaSet PTR
DECLARE FUNCTION gda_set_new_from_spec_node(BYVAL AS xmlNodePtr, BYVAL AS GError PTR PTR) AS GdaSet PTR
DECLARE FUNCTION gda_set_set_holder_value(BYVAL AS GdaSet PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST gchar PTR, ...) AS gboolean
DECLARE FUNCTION gda_set_get_holder_value(BYVAL AS GdaSet PTR, BYVAL AS CONST gchar PTR) AS CONST GValue PTR
DECLARE FUNCTION gda_set_get_holder(BYVAL AS GdaSet PTR, BYVAL AS CONST gchar PTR) AS GdaHolder PTR
DECLARE FUNCTION gda_set_get_nth_holder(BYVAL AS GdaSet PTR, BYVAL AS gint) AS GdaHolder PTR
DECLARE FUNCTION gda_set_add_holder(BYVAL AS GdaSet PTR, BYVAL AS GdaHolder PTR) AS gboolean
DECLARE SUB gda_set_remove_holder(BYVAL AS GdaSet PTR, BYVAL AS GdaHolder PTR)
DECLARE SUB gda_set_merge_with_set(BYVAL AS GdaSet PTR, BYVAL AS GdaSet PTR)
DECLARE FUNCTION gda_set_is_valid(BYVAL AS GdaSet PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE SUB gda_set_replace_source_model(BYVAL AS GdaSet PTR, BYVAL AS GdaSetSource PTR, BYVAL AS GdaDataModel PTR)
DECLARE FUNCTION gda_set_get_node(BYVAL AS GdaSet PTR, BYVAL AS GdaHolder PTR) AS GdaSetNode PTR
DECLARE FUNCTION gda_set_get_source_for_model(BYVAL AS GdaSet PTR, BYVAL AS GdaDataModel PTR) AS GdaSetSource PTR
DECLARE FUNCTION gda_set_get_source(BYVAL AS GdaSet PTR, BYVAL AS GdaHolder PTR) AS GdaSetSource PTR
DECLARE FUNCTION gda_set_get_group(BYVAL AS GdaSet PTR, BYVAL AS GdaHolder PTR) AS GdaSetGroup PTR
DECLARE FUNCTION _gda_set_validate(BYVAL AS GdaSet PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_set_new_read_only(BYVAL AS GSList PTR) AS GdaSet PTR

#ENDIF ' __GDA_SET_H_

#DEFINE GDA_TYPE_DATA_MODEL_ITER (gda_data_model_iter_get_type())
#DEFINE GDA_DATA_MODEL_ITER(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_data_model_iter_get_type(), GdaDataModelIter)
#DEFINE GDA_DATA_MODEL_ITER_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_data_model_iter_get_type (), GdaDataModelIterClass)
#DEFINE GDA_IS_DATA_MODEL_ITER(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_data_model_iter_get_type ())

EXTERN gda_data_model_iter_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_DATA_MODEL_ITER_ERROR gda_data_model_iter_error_quark ()

ENUM GdaDataModelIterError
	GDA_DATA_MODEL_ITER_COLUMN_OUT_OF_RANGE_ERROR
END ENUM

TYPE _GdaDataModelIter
	AS GdaSet object
	AS GdaDataModelIterPrivate PTR priv
END TYPE

TYPE _GdaDataModelIterClass
	AS GdaSetClass parent_class
	row_changed AS SUB(BYVAL AS GdaDataModelIter PTR, BYVAL AS gint)
	end_of_data AS SUB(BYVAL AS GdaDataModelIter PTR)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_data_model_iter_get_type() AS GType
DECLARE FUNCTION gda_data_model_iter_get_value_at(BYVAL AS GdaDataModelIter PTR, BYVAL AS gint) AS CONST GValue PTR
DECLARE FUNCTION gda_data_model_iter_get_value_at_e(BYVAL AS GdaDataModelIter PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS CONST GValue PTR
DECLARE FUNCTION gda_data_model_iter_get_value_for_field(BYVAL AS GdaDataModelIter PTR, BYVAL AS CONST gchar PTR) AS CONST GValue PTR
DECLARE FUNCTION gda_data_model_iter_set_value_at(BYVAL AS GdaDataModelIter PTR, BYVAL AS gint, BYVAL AS CONST GValue PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_model_iter_move_to_row(BYVAL AS GdaDataModelIter PTR, BYVAL AS gint) AS gboolean
DECLARE FUNCTION gda_data_model_iter_move_next(BYVAL AS GdaDataModelIter PTR) AS gboolean
DECLARE FUNCTION gda_data_model_iter_move_prev(BYVAL AS GdaDataModelIter PTR) AS gboolean
DECLARE FUNCTION gda_data_model_iter_get_row(BYVAL AS GdaDataModelIter PTR) AS gint
DECLARE SUB gda_data_model_iter_invalidate_contents(BYVAL AS GdaDataModelIter PTR)
DECLARE FUNCTION gda_data_model_iter_is_valid(BYVAL AS GdaDataModelIter PTR) AS gboolean
DECLARE FUNCTION gda_data_model_iter_get_holder_for_field(BYVAL AS GdaDataModelIter PTR, BYVAL AS gint) AS GdaHolder PTR

#DEFINE gda_data_model_iter_move_at_row gda_data_model_iter_move_to_row
#ENDIF ' __GDA_DATA_MODEL_ITER_H_

#IFNDEF __GDA_DATA_MODEL_IMPORT_H__
#DEFINE __GDA_DATA_MODEL_IMPORT_H__

#DEFINE GDA_TYPE_DATA_MODEL_IMPORT (gda_data_model_import_get_type())
#DEFINE GDA_DATA_MODEL_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_DATA_MODEL_IMPORT, GdaDataModelImport))
#DEFINE GDA_DATA_MODEL_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_DATA_MODEL_IMPORT, GdaDataModelImportClass))
#DEFINE GDA_IS_DATA_MODEL_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_DATA_MODEL_IMPORT))
#DEFINE GDA_IS_DATA_MODEL_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_DATA_MODEL_IMPORT))

TYPE GdaDataModelImport AS _GdaDataModelImport
TYPE GdaDataModelImportClass AS _GdaDataModelImportClass
TYPE GdaDataModelImportPrivate AS _GdaDataModelImportPrivate

TYPE _GdaDataModelImport
	AS GObject object
	AS GdaDataModelImportPrivate PTR priv
END TYPE

TYPE _GdaDataModelImportClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_data_model_import_get_type() AS GType
DECLARE FUNCTION gda_data_model_import_new_file(BYVAL AS CONST gchar PTR, BYVAL AS gboolean, BYVAL AS GdaSet PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_data_model_import_new_mem(BYVAL AS CONST gchar PTR, BYVAL AS gboolean, BYVAL AS GdaSet PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_data_model_import_new_xml_node(BYVAL AS xmlNodePtr) AS GdaDataModel PTR
DECLARE FUNCTION gda_data_model_import_get_errors(BYVAL AS GdaDataModelImport PTR) AS GSList PTR
DECLARE SUB gda_data_model_import_clean_errors(BYVAL AS GdaDataModelImport PTR)

#ENDIF ' __GDA_DATA_MODEL_IMPORT_H__

#IFNDEF __GDA_DATA_MODEL_DIR_H__
#DEFINE __GDA_DATA_MODEL_DIR_H__

#DEFINE GDA_TYPE_DATA_MODEL_DIR (gda_data_model_dir_get_type())
#DEFINE GDA_DATA_MODEL_DIR(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_DATA_MODEL_DIR, GdaDataModelDir))
#DEFINE GDA_DATA_MODEL_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_DATA_MODEL_DIR, GdaDataModelDirClass))
#DEFINE GDA_IS_DATA_MODEL_DIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_DATA_MODEL_DIR))
#DEFINE GDA_IS_DATA_MODEL_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_DATA_MODEL_DIR))

TYPE GdaDataModelDir AS _GdaDataModelDir
TYPE GdaDataModelDirClass AS _GdaDataModelDirClass
TYPE GdaDataModelDirPrivate AS _GdaDataModelDirPrivate

TYPE _GdaDataModelDir
	AS GObject object
	AS GdaDataModelDirPrivate PTR priv
END TYPE

TYPE _GdaDataModelDirClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_data_model_dir_get_type() AS GType
DECLARE FUNCTION gda_data_model_dir_new(BYVAL AS CONST gchar PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_data_model_dir_get_errors(BYVAL AS GdaDataModelDir PTR) AS CONST GSList PTR
DECLARE SUB gda_data_model_dir_clean_errors(BYVAL AS GdaDataModelDir PTR)

#ENDIF ' __GDA_DATA_MODEL_DIR_H__

#IFNDEF __GDA_DATA_ACCESS_WRAPPER_H__
#DEFINE __GDA_DATA_ACCESS_WRAPPER_H__

#DEFINE GDA_TYPE_DATA_ACCESS_WRAPPER (gda_data_access_wrapper_get_type())
#DEFINE GDA_DATA_ACCESS_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_DATA_ACCESS_WRAPPER, GdaDataAccessWrapper))
#DEFINE GDA_DATA_ACCESS_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_DATA_ACCESS_WRAPPER, GdaDataAccessWrapperClass))
#DEFINE GDA_IS_DATA_ACCESS_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_DATA_ACCESS_WRAPPER))
#DEFINE GDA_IS_DATA_ACCESS_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_DATA_ACCESS_WRAPPER))

TYPE GdaDataAccessWrapper AS _GdaDataAccessWrapper
TYPE GdaDataAccessWrapperClass AS _GdaDataAccessWrapperClass
TYPE GdaDataAccessWrapperPrivate AS _GdaDataAccessWrapperPrivate

TYPE _GdaDataAccessWrapper
	AS GObject object
	AS GdaDataAccessWrapperPrivate PTR priv
END TYPE

TYPE _GdaDataAccessWrapperClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_data_access_wrapper_get_type() AS GType
DECLARE FUNCTION gda_data_access_wrapper_new(BYVAL AS GdaDataModel PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_data_access_wrapper_set_mapping(BYVAL AS GdaDataAccessWrapper PTR, BYVAL AS gint PTR, BYVAL AS gint) AS gboolean

#ENDIF ' __GDA_DATA_ACCESS_WRAPPER_H__

#IFNDEF __GDA_DATA_PROXY_H_
#DEFINE __GDA_DATA_PROXY_H_

#DEFINE GDA_TYPE_DATA_PROXY (gda_data_proxy_get_type())
#DEFINE GDA_DATA_PROXY(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_data_proxy_get_type(), GdaDataProxy)
#DEFINE GDA_DATA_PROXY_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_data_proxy_get_type (), GdaDataProxyClass)
#DEFINE GDA_IS_DATA_PROXY(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_data_proxy_get_type ())

EXTERN gda_data_proxy_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_DATA_PROXY_ERROR gda_data_proxy_error_quark ()

ENUM GdaDataProxyError
	GDA_DATA_PROXY_COMMIT_ERROR
	GDA_DATA_PROXY_COMMIT_CANCELLED
	GDA_DATA_PROXY_READ_ONLY_VALUE
	GDA_DATA_PROXY_READ_ONLY_ROW
	GDA_DATA_PROXY_FILTER_ERROR
END ENUM

TYPE _GdaDataProxy
	AS GObject object
	AS GdaDataProxyPrivate PTR priv
END TYPE

TYPE _GdaDataProxyClass
	AS GObjectClass parent_class
	row_delete_changed AS SUB(BYVAL AS GdaDataProxy PTR, BYVAL AS gint, BYVAL AS gboolean)
	sample_size_changed AS SUB(BYVAL AS GdaDataProxy PTR, BYVAL AS gint)
	sample_changed AS SUB(BYVAL AS GdaDataProxy PTR, BYVAL AS gint, BYVAL AS gint)
	validate_row_changes AS FUNCTION(BYVAL AS GdaDataProxy PTR, BYVAL AS gint, BYVAL AS gint) AS GError PTR
	row_changes_applied AS SUB(BYVAL AS GdaDataProxy PTR, BYVAL AS gint, BYVAL AS gint)
	filter_changed AS SUB(BYVAL AS GdaDataProxy PTR)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_data_proxy_get_type() AS GType
DECLARE FUNCTION gda_data_proxy_new(BYVAL AS GdaDataModel PTR) AS GObject PTR
DECLARE FUNCTION gda_data_proxy_new_with_data_model(BYVAL AS GdaDataModel PTR) AS GdaDataProxy PTR
DECLARE FUNCTION gda_data_proxy_get_proxied_model(BYVAL AS GdaDataProxy PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_data_proxy_get_proxied_model_n_cols(BYVAL AS GdaDataProxy PTR) AS gint
DECLARE FUNCTION gda_data_proxy_get_proxied_model_n_rows(BYVAL AS GdaDataProxy PTR) AS gint
DECLARE FUNCTION gda_data_proxy_is_read_only(BYVAL AS GdaDataProxy PTR) AS gboolean
DECLARE FUNCTION gda_data_proxy_get_values(BYVAL AS GdaDataProxy PTR, BYVAL AS gint, BYVAL AS gint PTR, BYVAL AS gint) AS GSList PTR
DECLARE FUNCTION gda_data_proxy_get_value_attributes(BYVAL AS GdaDataProxy PTR, BYVAL AS gint, BYVAL AS gint) AS GdaValueAttribute
DECLARE SUB gda_data_proxy_alter_value_attributes(BYVAL AS GdaDataProxy PTR, BYVAL AS gint, BYVAL AS gint, BYVAL AS GdaValueAttribute)
DECLARE FUNCTION gda_data_proxy_get_proxied_model_row(BYVAL AS GdaDataProxy PTR, BYVAL AS gint) AS gint
DECLARE SUB gda_data_proxy_delete(BYVAL AS GdaDataProxy PTR, BYVAL AS gint)
DECLARE SUB gda_data_proxy_undelete(BYVAL AS GdaDataProxy PTR, BYVAL AS gint)
DECLARE FUNCTION gda_data_proxy_row_is_deleted(BYVAL AS GdaDataProxy PTR, BYVAL AS gint) AS gboolean
DECLARE FUNCTION gda_data_proxy_row_is_inserted(BYVAL AS GdaDataProxy PTR, BYVAL AS gint) AS gboolean
DECLARE FUNCTION gda_data_proxy_row_has_changed(BYVAL AS GdaDataProxy PTR, BYVAL AS gint) AS gboolean
DECLARE FUNCTION gda_data_proxy_has_changed(BYVAL AS GdaDataProxy PTR) AS gboolean
DECLARE FUNCTION gda_data_proxy_get_n_new_rows(BYVAL AS GdaDataProxy PTR) AS gint
DECLARE FUNCTION gda_data_proxy_get_n_modified_rows(BYVAL AS GdaDataProxy PTR) AS gint
DECLARE FUNCTION gda_data_proxy_apply_row_changes(BYVAL AS GdaDataProxy PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
DECLARE SUB gda_data_proxy_cancel_row_changes(BYVAL AS GdaDataProxy PTR, BYVAL AS gint, BYVAL AS gint)
DECLARE FUNCTION gda_data_proxy_apply_all_changes(BYVAL AS GdaDataProxy PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_proxy_cancel_all_changes(BYVAL AS GdaDataProxy PTR) AS gboolean
DECLARE SUB gda_data_proxy_set_sample_size(BYVAL AS GdaDataProxy PTR, BYVAL AS gint)
DECLARE FUNCTION gda_data_proxy_get_sample_size(BYVAL AS GdaDataProxy PTR) AS gint
DECLARE SUB gda_data_proxy_set_sample_start(BYVAL AS GdaDataProxy PTR, BYVAL AS gint)
DECLARE FUNCTION gda_data_proxy_get_sample_start(BYVAL AS GdaDataProxy PTR) AS gint
DECLARE FUNCTION gda_data_proxy_get_sample_end(BYVAL AS GdaDataProxy PTR) AS gint
DECLARE FUNCTION gda_data_proxy_set_filter_expr(BYVAL AS GdaDataProxy PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_proxy_get_filter_expr(BYVAL AS GdaDataProxy PTR) AS CONST gchar PTR
DECLARE FUNCTION gda_data_proxy_set_ordering_column(BYVAL AS GdaDataProxy PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_proxy_get_filtered_n_rows(BYVAL AS GdaDataProxy PTR) AS gint

#ENDIF ' __GDA_DATA_PROXY_H_

#IFNDEF __GDA_DATA_SELECT_H__
#DEFINE __GDA_DATA_SELECT_H__

#IFNDEF __GDA_SQL_STATEMENT_H__
#DEFINE __GDA_SQL_STATEMENT_H__

#IFNDEF _GDA_STATEMENT_STRUCT_SELECT_H_
#DEFINE _GDA_STATEMENT_STRUCT_SELECT_H_

#IFNDEF _GDA_STATEMENT_STRUCT_PARTS_H
#DEFINE _GDA_STATEMENT_STRUCT_PARTS_H

#IFNDEF _GDA_STATEMENT_STRUCT_PSPEC_H
#DEFINE _GDA_STATEMENT_STRUCT_PSPEC_H

TYPE GdaSqlParamSpec AS _GdaSqlParamSpec

TYPE _GdaSqlParamSpec
	AS gchar PTR name
	AS gchar PTR descr
	AS gboolean is_param
	AS gboolean nullok
	AS GType g_type
	AS gpointer validity_meta_dict
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_param_spec_new(BYVAL AS GValue PTR) AS GdaSqlParamSpec PTR
DECLARE FUNCTION gda_sql_param_spec_copy(BYVAL AS GdaSqlParamSpec PTR) AS GdaSqlParamSpec PTR
DECLARE SUB gda_sql_param_spec_take_name(BYVAL AS GdaSqlParamSpec PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_param_spec_take_type(BYVAL AS GdaSqlParamSpec PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_param_spec_take_descr(BYVAL AS GdaSqlParamSpec PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_param_spec_take_nullok(BYVAL AS GdaSqlParamSpec PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_param_spec_free(BYVAL AS GdaSqlParamSpec PTR)
DECLARE FUNCTION gda_sql_param_spec_serialize(BYVAL AS GdaSqlParamSpec PTR) AS gchar PTR

#ENDIF ' _GDA_STATEMENT_STRUCT_PSPEC_H

TYPE GdaSqlExpr AS _GdaSqlExpr
TYPE GdaSqlField AS _GdaSqlField
TYPE GdaSqlTable AS _GdaSqlTable
TYPE GdaSqlFunction AS _GdaSqlFunction
TYPE GdaSqlOperation AS _GdaSqlOperation
TYPE GdaSqlCase AS _GdaSqlCase
TYPE GdaSqlSelectField AS _GdaSqlSelectField
TYPE GdaSqlSelectTarget AS _GdaSqlSelectTarget
TYPE GdaSqlSelectJoin AS _GdaSqlSelectJoin
TYPE GdaSqlSelectFrom AS _GdaSqlSelectFrom
TYPE GdaSqlSelectOrder AS _GdaSqlSelectOrder

TYPE _GdaSqlExpr
	AS GdaSqlAnyPart any
	AS GValue PTR value
	AS GdaSqlParamSpec PTR param_spec
	AS GdaSqlFunction PTR func
	AS GdaSqlOperation PTR cond
	AS GdaSqlAnyPart PTR select
	AS GdaSqlCase PTR case_s
	AS gchar PTR cast_as
	AS gboolean value_is_ident
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

#DEFINE GDA_TYPE_SQL_EXPR (gda_sql_expr_get_type())

DECLARE FUNCTION gda_sql_expr_get_type() AS GType
DECLARE FUNCTION gda_sql_expr_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlExpr PTR
DECLARE SUB gda_sql_expr_free(BYVAL AS GdaSqlExpr PTR)
DECLARE FUNCTION gda_sql_expr_copy(BYVAL AS GdaSqlExpr PTR) AS GdaSqlExpr PTR
DECLARE FUNCTION gda_sql_expr_serialize(BYVAL AS GdaSqlExpr PTR) AS gchar PTR
DECLARE SUB _gda_sql_expr_check_clean(BYVAL AS GdaSqlExpr PTR)
DECLARE SUB gda_sql_expr_take_select(BYVAL AS GdaSqlExpr PTR, BYVAL AS GdaSqlStatement PTR)

TYPE _GdaSqlField
	AS GdaSqlAnyPart any
	AS gchar PTR field_name
	AS GdaMetaTableColumn PTR validity_meta_table_column
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_field_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlField PTR
DECLARE SUB gda_sql_field_free(BYVAL AS GdaSqlField PTR)
DECLARE FUNCTION gda_sql_field_copy(BYVAL AS GdaSqlField PTR) AS GdaSqlField PTR
DECLARE FUNCTION gda_sql_field_serialize(BYVAL AS GdaSqlField PTR) AS gchar PTR
DECLARE SUB _gda_sql_field_check_clean(BYVAL AS GdaSqlField PTR)
DECLARE SUB gda_sql_field_take_name(BYVAL AS GdaSqlField PTR, BYVAL AS GValue PTR)

TYPE _GdaSqlTable
	AS GdaSqlAnyPart any
	AS gchar PTR table_name
	AS GdaMetaDbObject PTR validity_meta_object
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_table_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlTable PTR
DECLARE SUB gda_sql_table_free(BYVAL AS GdaSqlTable PTR)
DECLARE FUNCTION gda_sql_table_copy(BYVAL AS GdaSqlTable PTR) AS GdaSqlTable PTR
DECLARE FUNCTION gda_sql_table_serialize(BYVAL AS GdaSqlTable PTR) AS gchar PTR
DECLARE SUB _gda_sql_table_check_clean(BYVAL AS GdaSqlTable PTR)
DECLARE SUB gda_sql_table_take_name(BYVAL AS GdaSqlTable PTR, BYVAL AS GValue PTR)

TYPE _GdaSqlFunction
	AS GdaSqlAnyPart any
	AS gchar PTR function_name
	AS GSList PTR args_list
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_function_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlFunction PTR
DECLARE SUB gda_sql_function_free(BYVAL AS GdaSqlFunction PTR)
DECLARE FUNCTION gda_sql_function_copy(BYVAL AS GdaSqlFunction PTR) AS GdaSqlFunction PTR
DECLARE FUNCTION gda_sql_function_serialize(BYVAL AS GdaSqlFunction PTR) AS gchar PTR
DECLARE SUB gda_sql_function_check_clean(BYVAL AS GdaSqlFunction PTR)
DECLARE SUB gda_sql_function_take_name(BYVAL AS GdaSqlFunction PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_function_take_args_list(BYVAL AS GdaSqlFunction PTR, BYVAL AS GSList PTR)

ENUM GdaSqlOperatorType
	GDA_SQL_OPERATOR_TYPE_AND
	GDA_SQL_OPERATOR_TYPE_OR
	GDA_SQL_OPERATOR_TYPE_EQ
	GDA_SQL_OPERATOR_TYPE_IS
	GDA_SQL_OPERATOR_TYPE_LIKE
	GDA_SQL_OPERATOR_TYPE_BETWEEN
	GDA_SQL_OPERATOR_TYPE_GT
	GDA_SQL_OPERATOR_TYPE_LT
	GDA_SQL_OPERATOR_TYPE_GEQ
	GDA_SQL_OPERATOR_TYPE_LEQ
	GDA_SQL_OPERATOR_TYPE_DIFF
	GDA_SQL_OPERATOR_TYPE_REGEXP
	GDA_SQL_OPERATOR_TYPE_REGEXP_CI
	GDA_SQL_OPERATOR_TYPE_NOT_REGEXP
	GDA_SQL_OPERATOR_TYPE_NOT_REGEXP_CI
	GDA_SQL_OPERATOR_TYPE_SIMILAR
	GDA_SQL_OPERATOR_TYPE_ISNULL
	GDA_SQL_OPERATOR_TYPE_ISNOTNULL
	GDA_SQL_OPERATOR_TYPE_NOT
	GDA_SQL_OPERATOR_TYPE_IN
	GDA_SQL_OPERATOR_TYPE_NOTIN
	GDA_SQL_OPERATOR_TYPE_CONCAT
	GDA_SQL_OPERATOR_TYPE_PLUS
	GDA_SQL_OPERATOR_TYPE_MINUS
	GDA_SQL_OPERATOR_TYPE_STAR
	GDA_SQL_OPERATOR_TYPE_DIV
	GDA_SQL_OPERATOR_TYPE_REM
	GDA_SQL_OPERATOR_TYPE_BITAND
	GDA_SQL_OPERATOR_TYPE_BITOR
	GDA_SQL_OPERATOR_TYPE_BITNOT
	GDA_SQL_OPERATOR_TYPE_ILIKE
	GDA_SQL_OPERATOR_TYPE_NOTLIKE
	GDA_SQL_OPERATOR_TYPE_NOTILIKE
END ENUM

TYPE _GdaSqlOperation
	AS GdaSqlAnyPart any
	AS GdaSqlOperatorType operator_type
	AS GSList PTR operands
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_operation_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlOperation PTR
DECLARE SUB gda_sql_operation_free(BYVAL AS GdaSqlOperation PTR)
DECLARE FUNCTION gda_sql_operation_copy(BYVAL AS GdaSqlOperation PTR) AS GdaSqlOperation PTR
DECLARE FUNCTION gda_sql_operation_serialize(BYVAL AS GdaSqlOperation PTR) AS gchar PTR
DECLARE FUNCTION gda_sql_operation_operator_to_string(BYVAL AS GdaSqlOperatorType) AS CONST gchar PTR
DECLARE FUNCTION gda_sql_operation_operator_from_string(BYVAL AS CONST gchar PTR) AS GdaSqlOperatorType

TYPE _GdaSqlCase
	AS GdaSqlAnyPart any
	AS GdaSqlExpr PTR base_expr
	AS GSList PTR when_expr_list
	AS GSList PTR then_expr_list
	AS GdaSqlExpr PTR else_expr
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_case_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlCase PTR
DECLARE SUB gda_sql_case_free(BYVAL AS GdaSqlCase PTR)
DECLARE FUNCTION gda_sql_case_copy(BYVAL AS GdaSqlCase PTR) AS GdaSqlCase PTR
DECLARE FUNCTION gda_sql_case_serialize(BYVAL AS GdaSqlCase PTR) AS gchar PTR

TYPE _GdaSqlSelectField
	AS GdaSqlAnyPart any
	AS GdaSqlExpr PTR expr
	AS gchar PTR field_name
	AS gchar PTR table_name
	AS gchar PTR as
	AS GdaMetaDbObject PTR validity_meta_object
	AS GdaMetaTableColumn PTR validity_meta_table_column
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_select_field_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlSelectField PTR
DECLARE SUB gda_sql_select_field_free(BYVAL AS GdaSqlSelectField PTR)
DECLARE FUNCTION gda_sql_select_field_copy(BYVAL AS GdaSqlSelectField PTR) AS GdaSqlSelectField PTR
DECLARE FUNCTION gda_sql_select_field_serialize(BYVAL AS GdaSqlSelectField PTR) AS gchar PTR
DECLARE SUB _gda_sql_select_field_check_clean(BYVAL AS GdaSqlSelectField PTR)
DECLARE SUB gda_sql_select_field_take_star_value(BYVAL AS GdaSqlSelectField PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_select_field_take_expr(BYVAL AS GdaSqlSelectField PTR, BYVAL AS GdaSqlExpr PTR)
DECLARE SUB gda_sql_select_field_take_alias(BYVAL AS GdaSqlSelectField PTR, BYVAL AS GValue PTR)

TYPE _GdaSqlSelectTarget
	AS GdaSqlAnyPart any
	AS GdaSqlExpr PTR expr
	AS gchar PTR table_name
	AS gchar PTR as
	AS GdaMetaDbObject PTR validity_meta_object
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_select_target_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlSelectTarget PTR
DECLARE SUB gda_sql_select_target_free(BYVAL AS GdaSqlSelectTarget PTR)
DECLARE FUNCTION gda_sql_select_target_copy(BYVAL AS GdaSqlSelectTarget PTR) AS GdaSqlSelectTarget PTR
DECLARE FUNCTION gda_sql_select_target_serialize(BYVAL AS GdaSqlSelectTarget PTR) AS gchar PTR
DECLARE SUB _gda_sql_select_target_check_clean(BYVAL AS GdaSqlSelectTarget PTR)
DECLARE SUB gda_sql_select_target_take_table_name(BYVAL AS GdaSqlSelectTarget PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_select_target_take_select(BYVAL AS GdaSqlSelectTarget PTR, BYVAL AS GdaSqlStatement PTR)
DECLARE SUB gda_sql_select_target_take_alias(BYVAL AS GdaSqlSelectTarget PTR, BYVAL AS GValue PTR)

ENUM GdaSqlSelectJoinType
	GDA_SQL_SELECT_JOIN_CROSS
	GDA_SQL_SELECT_JOIN_NATURAL
	GDA_SQL_SELECT_JOIN_INNER
	GDA_SQL_SELECT_JOIN_LEFT
	GDA_SQL_SELECT_JOIN_RIGHT
	GDA_SQL_SELECT_JOIN_FULL
END ENUM

TYPE _GdaSqlSelectJoin
	AS GdaSqlAnyPart any
	AS GdaSqlSelectJoinType type
	AS gint position
	AS GdaSqlExpr PTR expr
	AS GSList PTR use
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_select_join_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlSelectJoin PTR
DECLARE SUB gda_sql_select_join_free(BYVAL AS GdaSqlSelectJoin PTR)
DECLARE FUNCTION gda_sql_select_join_copy(BYVAL AS GdaSqlSelectJoin PTR) AS GdaSqlSelectJoin PTR
DECLARE FUNCTION gda_sql_select_join_serialize(BYVAL AS GdaSqlSelectJoin PTR) AS gchar PTR
DECLARE FUNCTION gda_sql_select_join_type_to_string(BYVAL AS GdaSqlSelectJoinType) AS CONST gchar PTR

TYPE _GdaSqlSelectFrom
	AS GdaSqlAnyPart any
	AS GSList PTR targets
	AS GSList PTR joins
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_select_from_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlSelectFrom PTR
DECLARE SUB gda_sql_select_from_free(BYVAL AS GdaSqlSelectFrom PTR)
DECLARE FUNCTION gda_sql_select_from_copy(BYVAL AS GdaSqlSelectFrom PTR) AS GdaSqlSelectFrom PTR
DECLARE FUNCTION gda_sql_select_from_serialize(BYVAL AS GdaSqlSelectFrom PTR) AS gchar PTR
DECLARE SUB gda_sql_select_from_take_new_target(BYVAL AS GdaSqlSelectFrom PTR, BYVAL AS GdaSqlSelectTarget PTR)
DECLARE SUB gda_sql_select_from_take_new_join(BYVAL AS GdaSqlSelectFrom PTR, BYVAL AS GdaSqlSelectJoin PTR)

TYPE _GdaSqlSelectOrder
	AS GdaSqlAnyPart any
	AS GdaSqlExpr PTR expr
	AS gboolean asc
	AS gchar PTR collation_name
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION gda_sql_select_order_new(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlSelectOrder PTR
DECLARE SUB gda_sql_select_order_free(BYVAL AS GdaSqlSelectOrder PTR)
DECLARE FUNCTION gda_sql_select_order_copy(BYVAL AS GdaSqlSelectOrder PTR) AS GdaSqlSelectOrder PTR
DECLARE FUNCTION gda_sql_select_order_serialize(BYVAL AS GdaSqlSelectOrder PTR) AS gchar PTR

#ENDIF ' _GDA_STATEMENT_STRUCT_PARTS_H

TYPE _GdaSqlStatementSelect
	AS GdaSqlAnyPart any
	AS gboolean distinct
	AS GdaSqlExpr PTR distinct_expr
	AS GSList PTR expr_list
	AS GdaSqlSelectFrom PTR from
	AS GdaSqlExpr PTR where_cond
	AS GSList PTR group_by
	AS GdaSqlExpr PTR having_cond
	AS GSList PTR order_by
	AS GdaSqlExpr PTR limit_count
	AS GdaSqlExpr PTR limit_offset
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION _gda_sql_statement_select_copy(BYVAL AS gpointer) AS gpointer
DECLARE SUB _gda_sql_statement_select_free(BYVAL AS gpointer)
DECLARE FUNCTION _gda_sql_statement_select_serialize(BYVAL AS gpointer) AS gchar PTR
DECLARE FUNCTION _gda_sql_statement_select_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE SUB gda_sql_statement_select_take_distinct(BYVAL AS GdaSqlStatement PTR, BYVAL AS gboolean, BYVAL AS GdaSqlExpr PTR)
DECLARE SUB gda_sql_statement_select_take_expr_list(BYVAL AS GdaSqlStatement PTR, BYVAL AS GSList PTR)
DECLARE SUB gda_sql_statement_select_take_from(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSqlSelectFrom PTR)
DECLARE SUB gda_sql_statement_select_take_where_cond(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSqlExpr PTR)
DECLARE SUB gda_sql_statement_select_take_group_by(BYVAL AS GdaSqlStatement PTR, BYVAL AS GSList PTR)
DECLARE SUB gda_sql_statement_select_take_having_cond(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSqlExpr PTR)
DECLARE SUB gda_sql_statement_select_take_order_by(BYVAL AS GdaSqlStatement PTR, BYVAL AS GSList PTR)
DECLARE SUB gda_sql_statement_select_take_limits(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSqlExpr PTR, BYVAL AS GdaSqlExpr PTR)

#ENDIF ' _GDA_STATEMENT_STRUCT_SELECT_H_

#IFNDEF _GDA_STATEMENT_STRUCT_INSERT_H_
#DEFINE _GDA_STATEMENT_STRUCT_INSERT_H_

TYPE _GdaSqlStatementInsert
	AS GdaSqlAnyPart any
	AS gchar PTR on_conflict
	AS GdaSqlTable PTR table
	AS GSList PTR fields_list
	AS GSList PTR values_list
	AS GdaSqlAnyPart PTR select
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION _gda_sql_statement_insert_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE SUB gda_sql_statement_insert_take_table_name(BYVAL AS GdaSqlStatement PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_statement_insert_take_on_conflict(BYVAL AS GdaSqlStatement PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_statement_insert_take_fields_list(BYVAL AS GdaSqlStatement PTR, BYVAL AS GSList PTR)
DECLARE SUB gda_sql_statement_insert_take_1_values_list(BYVAL AS GdaSqlStatement PTR, BYVAL AS GSList PTR)
DECLARE SUB gda_sql_statement_insert_take_extra_values_list(BYVAL AS GdaSqlStatement PTR, BYVAL AS GSList PTR)
DECLARE SUB gda_sql_statement_insert_take_select(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSqlStatement PTR)

#ENDIF ' _GDA_STATEMENT_STRUCT_INSERT_H_

#IFNDEF _GDA_STATEMENT_STRUCT_UPDATE_H_
#DEFINE _GDA_STATEMENT_STRUCT_UPDATE_H_

TYPE _GdaSqlStatementUpdate
	AS GdaSqlAnyPart any
	AS gchar PTR on_conflict
	AS GdaSqlTable PTR table
	AS GSList PTR fields_list
	AS GSList PTR expr_list
	AS GdaSqlExpr PTR cond
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION _gda_sql_statement_update_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE SUB gda_sql_statement_update_take_table_name(BYVAL AS GdaSqlStatement PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_statement_update_take_on_conflict(BYVAL AS GdaSqlStatement PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_statement_update_take_condition(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSqlExpr PTR)
DECLARE SUB gda_sql_statement_update_take_set_value(BYVAL AS GdaSqlStatement PTR, BYVAL AS GValue PTR, BYVAL AS GdaSqlExpr PTR)

#ENDIF ' _GDA_STATEMENT_STRUCT_UPDATE_H_

#IFNDEF _GDA_STATEMENT_STRUCT_DELETE_H_
#DEFINE _GDA_STATEMENT_STRUCT_DELETE_H_

TYPE _GdaSqlStatementDelete
	AS GdaSqlAnyPart any
	AS GdaSqlTable PTR table
	AS GdaSqlExpr PTR cond
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION _gda_sql_statement_delete_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE SUB gda_sql_statement_delete_take_table_name(BYVAL AS GdaSqlStatement PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_statement_delete_take_condition(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSqlExpr PTR)

#ENDIF ' _GDA_STATEMENT_STRUCT_DELETE_H_

#IFNDEF _GDA_STATEMENT_STRUCT_COMPOUND_H_
#DEFINE _GDA_STATEMENT_STRUCT_COMPOUND_H_

ENUM GdaSqlStatementCompoundType
	GDA_SQL_STATEMENT_COMPOUND_UNION
	GDA_SQL_STATEMENT_COMPOUND_UNION_ALL
	GDA_SQL_STATEMENT_COMPOUND_INTERSECT
	GDA_SQL_STATEMENT_COMPOUND_INTERSECT_ALL
	GDA_SQL_STATEMENT_COMPOUND_EXCEPT
	GDA_SQL_STATEMENT_COMPOUND_EXCEPT_ALL
END ENUM

TYPE _GdaSqlStatementCompound
	AS GdaSqlAnyPart any
	AS GdaSqlStatementCompoundType compound_type
	AS GSList PTR stmt_list
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION _gda_sql_statement_compound_copy(BYVAL AS gpointer) AS gpointer
DECLARE SUB _gda_sql_statement_compound_free(BYVAL AS gpointer)
DECLARE FUNCTION _gda_sql_statement_compound_serialize(BYVAL AS gpointer) AS gchar PTR
DECLARE FUNCTION _gda_sql_statement_compound_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE FUNCTION _gda_sql_statement_compound_get_n_cols(BYVAL AS GdaSqlStatementCompound PTR, BYVAL AS GError PTR PTR) AS gint
DECLARE FUNCTION _gda_sql_statement_compound_reduce(BYVAL AS GdaSqlAnyPart PTR) AS GdaSqlAnyPart PTR
DECLARE SUB gda_sql_statement_compound_set_type(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSqlStatementCompoundType)
DECLARE SUB gda_sql_statement_compound_take_stmt(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSqlStatement PTR)

#ENDIF ' _GDA_STATEMENT_STRUCT_COMPOUND_H_

#IFNDEF _GDA_STATEMENT_STRUCT_TRANS_H_
#DEFINE _GDA_STATEMENT_STRUCT_TRANS_H_

TYPE _GdaSqlStatementTransaction
	AS GdaSqlAnyPart any
	AS GdaTransactionIsolation isolation_level
	AS gchar PTR trans_mode
	AS gchar PTR trans_name
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION _gda_sql_statement_begin_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE FUNCTION _gda_sql_statement_commit_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE FUNCTION _gda_sql_statement_rollback_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE FUNCTION _gda_sql_statement_savepoint_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE FUNCTION _gda_sql_statement_rollback_savepoint_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE FUNCTION _gda_sql_statement_delete_savepoint_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE SUB gda_sql_statement_trans_take_mode(BYVAL AS GdaSqlStatement PTR, BYVAL AS GValue PTR)
DECLARE SUB gda_sql_statement_trans_set_isol_level(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaTransactionIsolation)
DECLARE SUB gda_sql_statement_trans_take_name(BYVAL AS GdaSqlStatement PTR, BYVAL AS GValue PTR)

#ENDIF ' _GDA_STATEMENT_STRUCT_TRANS_H_

#IFNDEF _GDA_STATEMENT_STRUCT_UNKNOWN_H_
#DEFINE _GDA_STATEMENT_STRUCT_UNKNOWN_H_

TYPE _GdaSqlStatementUnknown
	AS GdaSqlAnyPart any
	AS GSList PTR expressions
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
END TYPE

DECLARE FUNCTION _gda_sql_statement_unknown_get_infos() AS GdaSqlStatementContentsInfo PTR
DECLARE SUB gda_sql_statement_unknown_take_expressions(BYVAL AS GdaSqlStatement PTR, BYVAL AS GSList PTR)

#ENDIF ' _GDA_STATEMENT_STRUCT_UNKNOWN_H_

#ENDIF ' __GDA_SQL_STATEMENT_H__

#DEFINE GDA_TYPE_DATA_SELECT (gda_data_select_get_type())
#DEFINE GDA_DATA_SELECT(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_DATA_SELECT, GdaDataSelect))
#DEFINE GDA_DATA_SELECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_DATA_SELECT, GdaDataSelectClass))
#DEFINE GDA_IS_DATA_SELECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_DATA_SELECT))
#DEFINE GDA_IS_DATA_SELECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_DATA_SELECT))

TYPE GdaDataSelect AS _GdaDataSelect
TYPE GdaDataSelectClass AS _GdaDataSelectClass
TYPE GdaDataSelectPrivate AS _GdaDataSelectPrivate

EXTERN gda_data_select_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_DATA_SELECT_ERROR gda_data_select_error_quark ()

ENUM GdaDataSelectError
	GDA_DATA_SELECT_MODIFICATION_STATEMENT_ERROR
	GDA_DATA_SELECT_MISSING_MODIFICATION_STATEMENT_ERROR
	GDA_DATA_SELECT_CONNECTION_ERROR
	GDA_DATA_SELECT_ACCESS_ERROR
	GDA_DATA_SELECT_SQL_ERROR
	GDA_DATA_SELECT_SAFETY_LOCKED_ERROR
END ENUM

ENUM GdaDataSelectConditionType
	GDA_DATA_SELECT_COND_PK
	GDA_DATA_SELECT_COND_ALL_COLUMNS
END ENUM

TYPE _GdaDataSelect
	AS GObject object
	AS GdaDataSelectPrivate PTR priv
	AS GdaPStmt PTR prep_stmt
	AS gint nb_stored_rows
	AS gint advertized_nrows
	AS gpointer _gda_reserved1
	AS gpointer _gda_reserved2
	AS gpointer _gda_reserved3
	AS gpointer _gda_reserved4
END TYPE

TYPE _GdaDataSelectClass
	AS GObjectClass parent_class
	fetch_nb_rows AS FUNCTION(BYVAL AS GdaDataSelect PTR) AS gint
	fetch_random AS FUNCTION(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaRow PTR PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
	store_all AS FUNCTION(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean
	fetch_next AS FUNCTION(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaRow PTR PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
	fetch_prev AS FUNCTION(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaRow PTR PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
	fetch_at AS FUNCTION(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaRow PTR PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_data_select_get_type() AS GType
DECLARE FUNCTION gda_data_select_set_row_selection_condition(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaSqlExpr PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_set_row_selection_condition_sql(BYVAL AS GdaDataSelect PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_compute_row_selection_condition(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_set_modification_statement(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaStatement PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_set_modification_statement_sql(BYVAL AS GdaDataSelect PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_compute_modification_statements(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_compute_modification_statements_ext(BYVAL AS GdaDataSelect PTR, BYVAL AS GdaDataSelectConditionType, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_compute_columns_attributes(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_get_connection(BYVAL AS GdaDataSelect PTR) AS GdaConnection PTR
DECLARE FUNCTION gda_data_select_rerun(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_select_prepare_for_offline(BYVAL AS GdaDataSelect PTR, BYVAL AS GError PTR PTR) AS gboolean

#ENDIF ' __GDA_DATA_SELECT_H__

#IFNDEF __GDA_DATA_PIVOT_H__
#DEFINE __GDA_DATA_PIVOT_H__

#DEFINE GDA_TYPE_DATA_PIVOT (gda_data_pivot_get_type())
#DEFINE GDA_DATA_PIVOT(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_DATA_PIVOT, GdaDataPivot))
#DEFINE GDA_DATA_PIVOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_DATA_PIVOT, GdaDataPivotClass))
#DEFINE GDA_IS_DATA_PIVOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_DATA_PIVOT))
#DEFINE GDA_IS_DATA_PIVOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_DATA_PIVOT))

TYPE GdaDataPivot AS _GdaDataPivot
TYPE GdaDataPivotClass AS _GdaDataPivotClass
TYPE GdaDataPivotPrivate AS _GdaDataPivotPrivate

TYPE _GdaDataPivot
	AS GObject object
	AS GdaDataPivotPrivate PTR priv
END TYPE

TYPE _GdaDataPivotClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

EXTERN gda_data_pivot_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_DATA_PIVOT_ERROR gda_data_pivot_error_quark ()

ENUM GdaDataPivotError
	GDA_DATA_PIVOT_INTERNAL_ERROR
	GDA_DATA_PIVOT_SOURCE_MODEL_ERROR
	GDA_DATA_PIVOT_FIELD_FORMAT_ERROR
	GDA_DATA_PIVOT_USAGE_ERROR
	GDA_DATA_PIVOT_OVERFLOW_ERROR
END ENUM

ENUM GdaDataPivotAggregate
	GDA_DATA_PIVOT_AVG
	GDA_DATA_PIVOT_COUNT
	GDA_DATA_PIVOT_MAX
	GDA_DATA_PIVOT_MIN
	GDA_DATA_PIVOT_SUM
END ENUM

ENUM GdaDataPivotFieldType
	GDA_DATA_PIVOT_FIELD_ROW
	GDA_DATA_PIVOT_FIELD_COLUMN
END ENUM

DECLARE FUNCTION gda_data_pivot_get_type() AS GType
DECLARE FUNCTION gda_data_pivot_new(BYVAL AS GdaDataModel PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_data_pivot_add_field(BYVAL AS GdaDataPivot PTR, BYVAL AS GdaDataPivotFieldType, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_pivot_add_data(BYVAL AS GdaDataPivot PTR, BYVAL AS GdaDataPivotAggregate, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_data_pivot_populate(BYVAL AS GdaDataPivot PTR, BYVAL AS GError PTR PTR) AS gboolean

#ENDIF ' __GDA_DATA_PIVOT_H__

#IFNDEF __GDA_LOCKABLE_H__
#DEFINE __GDA_LOCKABLE_H__

#DEFINE GDA_TYPE_LOCKABLE (gda_lockable_get_type())
#DEFINE GDA_LOCKABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_LOCKABLE, GdaLockable))
#DEFINE GDA_IS_LOCKABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE (obj, GDA_TYPE_LOCKABLE))
#DEFINE GDA_LOCKABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GDA_TYPE_LOCKABLE, GdaLockableIface))

TYPE GdaLockableIface AS _GdaLockableIface
TYPE GdaLockable AS _GdaLockable

TYPE _GdaLockableIface
	AS GTypeInterface g_iface
	i_lock AS SUB(BYVAL AS GdaLockable PTR)
	i_trylock AS FUNCTION(BYVAL AS GdaLockable PTR) AS gboolean
	i_unlock AS SUB(BYVAL AS GdaLockable PTR)
END TYPE

DECLARE FUNCTION gda_lockable_get_type() AS GType
DECLARE SUB gda_lockable_lock(BYVAL AS GdaLockable PTR)
DECLARE FUNCTION gda_lockable_trylock(BYVAL AS GdaLockable PTR) AS gboolean
DECLARE SUB gda_lockable_unlock(BYVAL AS GdaLockable PTR)

#ENDIF ' __GDA_LOCKABLE_H__

#IFNDEF __GDA_LOG_H__
#DEFINE __GDA_LOG_H__

DECLARE SUB gda_log_enable()
DECLARE SUB gda_log_disable()
DECLARE FUNCTION gda_log_is_enabled() AS gboolean
DECLARE SUB gda_log_message(BYVAL AS CONST gchar PTR, ...)
DECLARE SUB gda_log_error(BYVAL AS CONST gchar PTR, ...)

#ENDIF ' __GDA_LOG_H__

#IFNDEF __GDA_QUARK_LIST_H__
#DEFINE __GDA_QUARK_LIST_H__

TYPE GdaQuarkList AS _GdaQuarkList

#DEFINE GDA_TYPE_QUARK_LIST (gda_quark_list_get_type())

DECLARE FUNCTION gda_quark_list_get_type() AS GType
DECLARE FUNCTION gda_quark_list_new() AS GdaQuarkList PTR
DECLARE FUNCTION gda_quark_list_new_from_string(BYVAL AS CONST gchar PTR) AS GdaQuarkList PTR
DECLARE FUNCTION gda_quark_list_copy(BYVAL AS GdaQuarkList PTR) AS GdaQuarkList PTR
DECLARE SUB gda_quark_list_free(BYVAL AS GdaQuarkList PTR)
DECLARE SUB gda_quark_list_add_from_string(BYVAL AS GdaQuarkList PTR, BYVAL AS CONST gchar PTR, BYVAL AS gboolean)
DECLARE FUNCTION gda_quark_list_find(BYVAL AS GdaQuarkList PTR, BYVAL AS CONST gchar PTR) AS CONST gchar PTR
DECLARE SUB gda_quark_list_protect_values(BYVAL AS GdaQuarkList PTR)
DECLARE SUB gda_quark_list_remove(BYVAL AS GdaQuarkList PTR, BYVAL AS CONST gchar PTR)
DECLARE SUB gda_quark_list_clear(BYVAL AS GdaQuarkList PTR)
DECLARE SUB gda_quark_list_foreach(BYVAL AS GdaQuarkList PTR, BYVAL AS GHFunc, BYVAL AS gpointer)

#ENDIF ' __GDA_QUARK_LIST_H__

#IFNDEF __GDA_SERVER_PROVIDER_H__
#DEFINE __GDA_SERVER_PROVIDER_H__

#IFNDEF __GDA_XA_TRANSACTION_H__
#DEFINE __GDA_XA_TRANSACTION_H__

#DEFINE GDA_TYPE_XA_TRANSACTION (gda_xa_transaction_get_type())
#DEFINE GDA_XA_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_XA_TRANSACTION, GdaXaTransaction))
#DEFINE GDA_XA_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_XA_TRANSACTION, GdaXaTransactionClass))
#DEFINE GDA_IS_XA_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_XA_TRANSACTION))
#DEFINE GDA_IS_XA_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_XA_TRANSACTION))

TYPE GdaXaTransaction AS _GdaXaTransaction
TYPE GdaXaTransactionClass AS _GdaXaTransactionClass
TYPE GdaXaTransactionPrivate AS _GdaXaTransactionPrivate
TYPE GdaXaTransactionId AS _GdaXaTransactionId

EXTERN gda_xa_transaction_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_XA_TRANSACTION_ERROR gda_xa_transaction_error_quark ()

ENUM GdaXaTransactionError
	GDA_XA_TRANSACTION_ALREADY_REGISTERED_ERROR
	GDA_XA_TRANSACTION_DTP_NOT_SUPPORTED_ERROR
	GDA_XA_TRANSACTION_CONNECTION_BRANCH_LENGTH_ERROR
END ENUM

TYPE _GdaXaTransaction
	AS GObject object
	AS GdaXaTransactionPrivate PTR priv
END TYPE

TYPE _GdaXaTransactionClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

TYPE _GdaXaTransactionId
	AS guint32 format
	AS gushort gtrid_length
	AS gushort bqual_length
	AS ZSTRING*128 data
END TYPE

DECLARE FUNCTION gda_xa_transaction_get_type() AS GType
DECLARE FUNCTION gda_xa_transaction_new(BYVAL AS guint32, BYVAL AS CONST gchar PTR) AS GdaXaTransaction PTR
DECLARE FUNCTION gda_xa_transaction_register_connection(BYVAL AS GdaXaTransaction PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE SUB gda_xa_transaction_unregister_connection(BYVAL AS GdaXaTransaction PTR, BYVAL AS GdaConnection PTR)
DECLARE FUNCTION gda_xa_transaction_begin(BYVAL AS GdaXaTransaction PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_xa_transaction_commit(BYVAL AS GdaXaTransaction PTR, BYVAL AS GSList PTR PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_xa_transaction_rollback(BYVAL AS GdaXaTransaction PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_xa_transaction_commit_recovered(BYVAL AS GdaXaTransaction PTR, BYVAL AS GSList PTR PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_xa_transaction_id_to_string(BYVAL AS CONST GdaXaTransactionId PTR) AS gchar PTR
DECLARE FUNCTION gda_xa_transaction_string_to_id(BYVAL AS CONST gchar PTR) AS GdaXaTransactionId PTR

#ENDIF ' __GDA_XA_TRANSACTION_H__

#DEFINE GDA_TYPE_SERVER_PROVIDER (gda_server_provider_get_type())
#DEFINE GDA_SERVER_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_SERVER_PROVIDER, GdaServerProvider))
#DEFINE GDA_SERVER_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_SERVER_PROVIDER, GdaServerProviderClass))
#DEFINE GDA_IS_SERVER_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_SERVER_PROVIDER))
#DEFINE GDA_IS_SERVER_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_SERVER_PROVIDER))

EXTERN gda_server_provider_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_SERVER_PROVIDER_ERROR gda_server_provider_error_quark ()

ENUM GdaServerProviderError
	GDA_SERVER_PROVIDER_METHOD_NON_IMPLEMENTED_ERROR
	GDA_SERVER_PROVIDER_PREPARE_STMT_ERROR
	GDA_SERVER_PROVIDER_EMPTY_STMT_ERROR
	GDA_SERVER_PROVIDER_MISSING_PARAM_ERROR
	GDA_SERVER_PROVIDER_STATEMENT_EXEC_ERROR
	GDA_SERVER_PROVIDER_OPERATION_ERROR
	GDA_SERVER_PROVIDER_INTERNAL_ERROR
	GDA_SERVER_PROVIDER_BUSY_ERROR
	GDA_SERVER_PROVIDER_NON_SUPPORTED_ERROR
	GDA_SERVER_PROVIDER_SERVER_VERSION_ERROR
	GDA_SERVER_PROVIDER_DATA_ERROR
	GDA_SERVER_PROVIDER_DEFAULT_VALUE_HANDLING_ERROR
	GDA_SERVER_PROVIDER_MISUSE_ERROR
	GDA_SERVER_PROVIDER_FILE_NOT_FOUND_ERROR
END ENUM

TYPE _GdaServerProvider
	AS GObject object
	AS GdaServerProviderPrivate PTR priv
END TYPE

TYPE GdaServerProviderMeta
	_info AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	_btypes AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	_udt AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	udt AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_udt_cols AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	udt_cols AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_enums AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	enums AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_domains AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	domains AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_constraints_dom AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	constraints_dom AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_el_types AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	el_types AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_collations AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	collations AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_character_sets AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	character_sets AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_schemata AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	schemata AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_tables_views AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	tables_views AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_columns AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	columns AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_view_cols AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	view_cols AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_constraints_tab AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	constraints_tab AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_constraints_ref AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	constraints_ref AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_key_columns AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	key_columns AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_check_columns AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	check_columns AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_triggers AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	triggers AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_routines AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	routines AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_routine_col AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	routine_col AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_routine_par AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	routine_par AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_indexes_tab AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	indexes_tab AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_index_cols AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR) AS gboolean
	index_cols AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaMetaStore PTR, BYVAL AS GdaMetaContext PTR, BYVAL AS GError PTR PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR, BYVAL AS CONST GValue PTR) AS gboolean
	_gda_reserved5 AS SUB()
	_gda_reserved6 AS SUB()
	_gda_reserved7 AS SUB()
	_gda_reserved8 AS SUB()
	_gda_reserved9 AS SUB()
	_gda_reserved10 AS SUB()
	_gda_reserved11 AS SUB()
	_gda_reserved12 AS SUB()
	_gda_reserved13 AS SUB()
	_gda_reserved14 AS SUB()
	_gda_reserved15 AS SUB()
	_gda_reserved16 AS SUB()
END TYPE

TYPE GdaServerProviderXa
	xa_start AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST GdaXaTransactionId PTR, BYVAL AS GError PTR PTR) AS gboolean
	xa_end AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST GdaXaTransactionId PTR, BYVAL AS GError PTR PTR) AS gboolean
	xa_prepare AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST GdaXaTransactionId PTR, BYVAL AS GError PTR PTR) AS gboolean
	xa_commit AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST GdaXaTransactionId PTR, BYVAL AS GError PTR PTR) AS gboolean
	xa_rollback AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST GdaXaTransactionId PTR, BYVAL AS GError PTR PTR) AS gboolean
	xa_recover AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GError PTR PTR) AS GList PTR
END TYPE

TYPE GdaServerProviderAsyncCallback AS SUB(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS guint, BYVAL AS gboolean, BYVAL AS CONST GError PTR, BYVAL AS gpointer)
TYPE GdaServerProviderExecCallback AS SUB(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS guint, BYVAL AS GObject PTR, BYVAL AS CONST GError PTR, BYVAL AS gpointer)

#DEFINE GDA_SERVER_PROVIDER_UNDEFINED_LIMITING_THREAD (CAST(gpointer, &h1))

TYPE _GdaServerProviderClass
	AS GObjectClass parent_class
	AS GThread PTR limiting_thread
	get_name AS FUNCTION(BYVAL AS GdaServerProvider PTR) AS CONST gchar PTR
	get_version AS FUNCTION(BYVAL AS GdaServerProvider PTR) AS CONST gchar PTR
	get_server_version AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR) AS CONST gchar PTR
	supports_feature AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaConnectionFeature) AS gboolean
	get_data_handler AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GType, BYVAL AS CONST gchar PTR) AS GdaDataHandler PTR
	get_def_dbms_type AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GType) AS CONST gchar PTR
	escape_string AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR) AS gchar PTR
	unescape_string AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR) AS gchar PTR
	open_connection AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaQuarkList PTR, BYVAL AS GdaQuarkList PTR, BYVAL AS guint PTR, BYVAL AS GdaServerProviderAsyncCallback, BYVAL AS gpointer) AS gboolean
	close_connection AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR) AS gboolean
	get_database AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR) AS CONST gchar PTR
	supports_operation AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaServerOperationType, BYVAL AS GdaSet PTR) AS gboolean
	create_operation AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaServerOperationType, BYVAL AS GdaSet PTR, BYVAL AS GError PTR PTR) AS GdaServerOperation PTR
	render_operation AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaServerOperation PTR, BYVAL AS GError PTR PTR) AS gchar PTR
	perform_operation AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaServerOperation PTR, BYVAL AS guint PTR, BYVAL AS GdaServerProviderAsyncCallback, BYVAL AS gpointer, BYVAL AS GError PTR PTR) AS gboolean
	begin_transaction AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaTransactionIsolation, BYVAL AS GError PTR PTR) AS gboolean
	commit_transaction AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
	rollback_transaction AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
	add_savepoint AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
	rollback_savepoint AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
	delete_savepoint AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
	create_parser AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR) AS GdaSqlParser PTR
	statement_to_sql AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaStatementSqlFlag, BYVAL AS GSList PTR PTR, BYVAL AS GError PTR PTR) AS gchar PTR
	statement_prepare AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GError PTR PTR) AS gboolean
	statement_execute AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaStatementModelUsage, BYVAL AS GType PTR, BYVAL AS GdaSet PTR PTR, BYVAL AS guint PTR, BYVAL AS GdaServerProviderExecCallback, BYVAL AS gpointer, BYVAL AS GError PTR PTR) AS GObject PTR
	is_busy AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GError PTR PTR) AS gboolean
	cancel AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS guint, BYVAL AS GError PTR PTR) AS gboolean
	create_connection AS FUNCTION(BYVAL AS GdaServerProvider PTR) AS GdaConnection PTR
	AS GdaServerProviderMeta meta_funcs
	AS GdaServerProviderXa PTR xa_funcs
	identifier_quote AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS gboolean, BYVAL AS gboolean) AS gchar PTR
	handle_async AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GError PTR PTR) AS gboolean
	statement_rewrite AS FUNCTION(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GError PTR PTR) AS GdaSqlStatement PTR
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
	_gda_reserved5 AS SUB()
	_gda_reserved6 AS SUB()
END TYPE

DECLARE FUNCTION gda_server_provider_get_type() AS GType
DECLARE FUNCTION gda_server_provider_get_name(BYVAL AS GdaServerProvider PTR) AS CONST gchar PTR
DECLARE FUNCTION gda_server_provider_get_version(BYVAL AS GdaServerProvider PTR) AS CONST gchar PTR
DECLARE FUNCTION gda_server_provider_get_server_version(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR) AS CONST gchar PTR
DECLARE FUNCTION gda_server_provider_supports_feature(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaConnectionFeature) AS gboolean
DECLARE FUNCTION gda_server_provider_get_data_handler_g_type(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GType) AS GdaDataHandler PTR
DECLARE FUNCTION gda_server_provider_get_data_handler_dbms(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR) AS GdaDataHandler PTR
DECLARE FUNCTION gda_server_provider_string_to_value(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS GType, BYVAL AS gchar PTR PTR) AS GValue PTR
DECLARE FUNCTION gda_server_provider_value_to_sql_string(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GValue PTR) AS gchar PTR
DECLARE FUNCTION gda_server_provider_get_default_dbms_type(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GType) AS CONST gchar PTR
DECLARE FUNCTION gda_server_provider_escape_string(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR) AS gchar PTR
DECLARE FUNCTION gda_server_provider_unescape_string(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR) AS gchar PTR
DECLARE FUNCTION gda_server_provider_supports_operation(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaServerOperationType, BYVAL AS GdaSet PTR) AS gboolean
DECLARE FUNCTION gda_server_provider_create_operation(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaServerOperationType, BYVAL AS GdaSet PTR, BYVAL AS GError PTR PTR) AS GdaServerOperation PTR
DECLARE FUNCTION gda_server_provider_render_operation(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaServerOperation PTR, BYVAL AS GError PTR PTR) AS gchar PTR
DECLARE FUNCTION gda_server_provider_perform_operation(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaServerOperation PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_server_provider_create_parser(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR) AS GdaSqlParser PTR

#ENDIF ' __GDA_SERVER_PROVIDER_H__

#IFNDEF __GDA_TRANSACTION_STATUS_PRIVATE_H__
#DEFINE __GDA_TRANSACTION_STATUS_PRIVATE_H__

DECLARE FUNCTION gda_transaction_status_add_event_svp(BYVAL AS GdaTransactionStatus PTR, BYVAL AS CONST gchar PTR) AS GdaTransactionStatusEvent PTR
DECLARE FUNCTION gda_transaction_status_add_event_sql(BYVAL AS GdaTransactionStatus PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaConnectionEvent PTR) AS GdaTransactionStatusEvent PTR
DECLARE FUNCTION gda_transaction_status_add_event_sub(BYVAL AS GdaTransactionStatus PTR, BYVAL AS GdaTransactionStatus PTR) AS GdaTransactionStatusEvent PTR
DECLARE SUB gda_transaction_status_free_events(BYVAL AS GdaTransactionStatus PTR, BYVAL AS GdaTransactionStatusEvent PTR, BYVAL AS gboolean)
DECLARE FUNCTION gda_transaction_status_find(BYVAL AS GdaTransactionStatus PTR, BYVAL AS CONST gchar PTR, BYVAL AS GdaTransactionStatusEvent PTR PTR) AS GdaTransactionStatus PTR
DECLARE FUNCTION gda_transaction_status_find_current(BYVAL AS GdaTransactionStatus PTR, BYVAL AS GdaTransactionStatusEvent PTR PTR, BYVAL AS gboolean) AS GdaTransactionStatus PTR

#IFDEF GDA_DEBUG

DECLARE SUB gda_transaction_status_dump(BYVAL AS GdaTransactionStatus PTR, BYVAL AS guint)

#ENDIF ' GDA_DEBUG
#ENDIF ' __GDA_TRANSACTION_STATUS_PRIVATE_H__

#IFNDEF __GDA_UTIL_H__
#DEFINE __GDA_UTIL_H__

#IFNDEF __GDA_HOLDER_H_
#DEFINE __GDA_HOLDER_H_

#DEFINE GDA_TYPE_HOLDER (gda_holder_get_type())
#DEFINE GDA_HOLDER(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_holder_get_type(), GdaHolder)
#DEFINE GDA_HOLDER_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_holder_get_type (), GdaHolderClass)
#DEFINE GDA_IS_HOLDER(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_holder_get_type ())

EXTERN gda_holder_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_HOLDER_ERROR gda_holder_error_quark ()

ENUM GdaHolderError
	GDA_HOLDER_STRING_CONVERSION_ERROR
	GDA_HOLDER_VALUE_TYPE_ERROR
	GDA_HOLDER_VALUE_NULL_ERROR
END ENUM

TYPE _GdaHolder
	AS GObject object
	AS GdaHolderPrivate PTR priv
END TYPE

TYPE _GdaHolderClass
	AS GObjectClass parent_class
	changed AS SUB(BYVAL AS GdaHolder PTR)
	source_changed AS SUB(BYVAL AS GdaHolder PTR)
	validate_change AS FUNCTION(BYVAL AS GdaHolder PTR, BYVAL AS CONST GValue PTR) AS GError PTR
	att_changed AS SUB(BYVAL AS GdaHolder PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_holder_get_type() AS GType
DECLARE FUNCTION gda_holder_new(BYVAL AS GType) AS GdaHolder PTR
DECLARE FUNCTION gda_holder_new_inline(BYVAL AS GType, BYVAL AS CONST gchar PTR, ...) AS GdaHolder PTR
DECLARE FUNCTION gda_holder_copy(BYVAL AS GdaHolder PTR) AS GdaHolder PTR
DECLARE FUNCTION gda_holder_get_g_type(BYVAL AS GdaHolder PTR) AS GType
DECLARE FUNCTION gda_holder_get_id(BYVAL AS GdaHolder PTR) AS CONST gchar PTR

#DEFINE gda_holder_new_string(id,str) gda_holder_new_inline (G_TYPE_STRING, (id), (str))
#DEFINE gda_holder_new_boolean(id,abool) gda_holder_new_inline (G_TYPE_BOOLEAN, (id), (abool))
#DEFINE gda_holder_new_int(id,anint) gda_holder_new_inline (G_TYPE_INT, (id), (anint))

DECLARE FUNCTION gda_holder_get_value(BYVAL AS GdaHolder PTR) AS CONST GValue PTR
DECLARE FUNCTION gda_holder_get_value_str(BYVAL AS GdaHolder PTR, BYVAL AS GdaDataHandler PTR) AS gchar PTR
DECLARE FUNCTION gda_holder_set_value(BYVAL AS GdaHolder PTR, BYVAL AS CONST GValue PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_holder_take_value(BYVAL AS GdaHolder PTR, BYVAL AS GValue PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_holder_take_static_value(BYVAL AS GdaHolder PTR, BYVAL AS CONST GValue PTR, BYVAL AS gboolean PTR, BYVAL AS GError PTR PTR) AS GValue PTR
DECLARE FUNCTION gda_holder_set_value_str(BYVAL AS GdaHolder PTR, BYVAL AS GdaDataHandler PTR, BYVAL AS CONST gchar PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_holder_get_default_value(BYVAL AS GdaHolder PTR) AS CONST GValue PTR
DECLARE SUB gda_holder_set_default_value(BYVAL AS GdaHolder PTR, BYVAL AS CONST GValue PTR)
DECLARE FUNCTION gda_holder_set_value_to_default(BYVAL AS GdaHolder PTR) AS gboolean
DECLARE FUNCTION gda_holder_value_is_default(BYVAL AS GdaHolder PTR) AS gboolean
DECLARE SUB gda_holder_force_invalid(BYVAL AS GdaHolder PTR)
DECLARE SUB gda_holder_force_invalid_e(BYVAL AS GdaHolder PTR, BYVAL AS GError PTR)
DECLARE FUNCTION gda_holder_is_valid(BYVAL AS GdaHolder PTR) AS gboolean
DECLARE FUNCTION gda_holder_is_valid_e(BYVAL AS GdaHolder PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE SUB gda_holder_set_not_null(BYVAL AS GdaHolder PTR, BYVAL AS gboolean)
DECLARE FUNCTION gda_holder_get_not_null(BYVAL AS GdaHolder PTR) AS gboolean
DECLARE FUNCTION gda_holder_set_source_model(BYVAL AS GdaHolder PTR, BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_holder_get_source_model(BYVAL AS GdaHolder PTR, BYVAL AS gint PTR) AS GdaDataModel PTR
DECLARE FUNCTION gda_holder_set_bind(BYVAL AS GdaHolder PTR, BYVAL AS GdaHolder PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_holder_get_bind(BYVAL AS GdaHolder PTR) AS GdaHolder PTR
DECLARE FUNCTION gda_holder_get_attribute(BYVAL AS GdaHolder PTR, BYVAL AS CONST gchar PTR) AS CONST GValue PTR
DECLARE SUB gda_holder_set_attribute(BYVAL AS GdaHolder PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR, BYVAL AS GDestroyNotify)

#DEFINE gda_holder_set_attribute_static(holder,attribute,value) gda_holder_set_attribute((holder),(attribute),(value),NULL)
#ENDIF ' __GDA_HOLDER_H_

DECLARE FUNCTION gda_g_type_to_string(BYVAL AS GType) AS CONST gchar PTR
DECLARE FUNCTION gda_g_type_from_string(BYVAL AS CONST gchar PTR) AS GType
DECLARE FUNCTION gda_default_escape_string(BYVAL AS CONST gchar PTR) AS gchar PTR
DECLARE FUNCTION gda_default_unescape_string(BYVAL AS CONST gchar PTR) AS gchar PTR
DECLARE FUNCTION gda_identifier_hash(BYVAL AS CONST gchar PTR) AS guint
DECLARE FUNCTION gda_identifier_equal(BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR) AS gboolean
DECLARE FUNCTION gda_completion_list_get(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS gint, BYVAL AS gint) AS gchar PTR PTR
DECLARE FUNCTION gda_sql_identifier_split(BYVAL AS CONST gchar PTR) AS gchar PTR PTR
DECLARE FUNCTION gda_sql_identifier_quote(BYVAL AS CONST gchar PTR, BYVAL AS GdaConnection PTR, BYVAL AS GdaServerProvider PTR, BYVAL AS gboolean, BYVAL AS gboolean) AS gchar PTR
DECLARE FUNCTION gda_utility_check_data_model(BYVAL AS GdaDataModel PTR, BYVAL AS gint, ...) AS gboolean
DECLARE FUNCTION gda_utility_check_data_model_v(BYVAL AS GdaDataModel PTR, BYVAL AS gint, BYVAL AS GType PTR) AS gboolean
DECLARE FUNCTION gda_utility_data_model_dump_data_to_xml(BYVAL AS GdaDataModel PTR, BYVAL AS xmlNodePtr, BYVAL AS CONST gint PTR, BYVAL AS gint, BYVAL AS CONST gint PTR, BYVAL AS gint, BYVAL AS gboolean) AS gboolean
DECLARE FUNCTION gda_utility_data_model_find_column_description(BYVAL AS GdaDataSelect PTR, BYVAL AS CONST gchar PTR) AS CONST gchar PTR
DECLARE FUNCTION gda_utility_holder_load_attributes(BYVAL AS GdaHolder PTR, BYVAL AS xmlNodePtr, BYVAL AS GSList PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_statement_rewrite_for_default_values(BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS gboolean, BYVAL AS GError PTR PTR) AS GdaSqlStatement PTR
DECLARE FUNCTION gda_text_to_alphanum(BYVAL AS CONST gchar PTR) AS gchar PTR
DECLARE FUNCTION gda_alphanum_to_text(BYVAL AS gchar PTR) AS gchar PTR
DECLARE FUNCTION gda_compute_unique_table_row_condition(BYVAL AS GdaSqlStatementSelect PTR, BYVAL AS GdaMetaTable PTR, BYVAL AS gboolean, BYVAL AS GError PTR PTR) AS GdaSqlExpr PTR
DECLARE FUNCTION gda_compute_unique_table_row_condition_with_cnc(BYVAL AS GdaConnection PTR, BYVAL AS GdaSqlStatementSelect PTR, BYVAL AS GdaMetaTable PTR, BYVAL AS gboolean, BYVAL AS GError PTR PTR) AS GdaSqlExpr PTR
DECLARE FUNCTION gda_compute_dml_statements(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS gboolean, BYVAL AS GdaStatement PTR PTR, BYVAL AS GdaStatement PTR PTR, BYVAL AS GdaStatement PTR PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_compute_select_statement_from_update(BYVAL AS GdaStatement PTR, BYVAL AS GError PTR PTR) AS GdaSqlStatement PTR
DECLARE FUNCTION gda_rewrite_sql_statement_for_null_parameters(BYVAL AS GdaSqlStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS gboolean PTR, BYVAL AS GError PTR PTR) AS GdaSqlStatement PTR
DECLARE FUNCTION gda_rewrite_statement_for_null_parameters(BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR, BYVAL AS GdaStatement PTR PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE SUB _gda_modify_statement_param_types(BYVAL AS GdaStatement PTR, BYVAL AS GdaDataModel PTR)
DECLARE FUNCTION gda_rfc1738_encode(BYVAL AS CONST gchar PTR) AS gchar PTR
DECLARE FUNCTION gda_rfc1738_decode(BYVAL AS gchar PTR) AS gboolean
DECLARE SUB gda_dsn_split(BYVAL AS CONST gchar PTR, BYVAL AS gchar PTR PTR, BYVAL AS gchar PTR PTR, BYVAL AS gchar PTR PTR)
DECLARE SUB gda_connection_string_split(BYVAL AS CONST gchar PTR, BYVAL AS gchar PTR PTR, BYVAL AS gchar PTR PTR, BYVAL AS gchar PTR PTR, BYVAL AS gchar PTR PTR)
DECLARE FUNCTION gda_parse_iso8601_date(BYVAL AS GDate PTR, BYVAL AS CONST gchar PTR) AS gboolean
DECLARE FUNCTION gda_parse_iso8601_time(BYVAL AS GdaTime PTR, BYVAL AS CONST gchar PTR) AS gboolean
DECLARE FUNCTION gda_parse_iso8601_timestamp(BYVAL AS GdaTimestamp PTR, BYVAL AS CONST gchar PTR) AS gboolean

#ENDIF ' __GDA_UTIL_H__

#IFNDEF __GDA_DATA_HANDLER_H_
#DEFINE __GDA_DATA_HANDLER_H_

#DEFINE GDA_TYPE_DATA_HANDLER (gda_data_handler_get_type())
#DEFINE GDA_DATA_HANDLER(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_DATA_HANDLER, GdaDataHandler)
#DEFINE GDA_IS_DATA_HANDLER(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, GDA_TYPE_DATA_HANDLER)
#DEFINE GDA_DATA_HANDLER_GET_IFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GDA_TYPE_DATA_HANDLER, GdaDataHandlerIface))

TYPE _GdaDataHandlerIface
	AS GTypeInterface g_iface
	get_sql_from_value AS FUNCTION(BYVAL AS GdaDataHandler PTR, BYVAL AS CONST GValue PTR) AS gchar PTR
	get_str_from_value AS FUNCTION(BYVAL AS GdaDataHandler PTR, BYVAL AS CONST GValue PTR) AS gchar PTR
	get_value_from_sql AS FUNCTION(BYVAL AS GdaDataHandler PTR, BYVAL AS CONST gchar PTR, BYVAL AS GType) AS GValue PTR
	get_value_from_str AS FUNCTION(BYVAL AS GdaDataHandler PTR, BYVAL AS CONST gchar PTR, BYVAL AS GType) AS GValue PTR
	get_sane_init_value AS FUNCTION(BYVAL AS GdaDataHandler PTR, BYVAL AS GType) AS GValue PTR
	accepts_g_type AS FUNCTION(BYVAL AS GdaDataHandler PTR, BYVAL AS GType) AS gboolean
	get_descr AS FUNCTION(BYVAL AS GdaDataHandler PTR) AS CONST gchar PTR
END TYPE

DECLARE FUNCTION gda_data_handler_get_type() AS GType
DECLARE FUNCTION gda_data_handler_get_sql_from_value(BYVAL AS GdaDataHandler PTR, BYVAL AS CONST GValue PTR) AS gchar PTR
DECLARE FUNCTION gda_data_handler_get_str_from_value(BYVAL AS GdaDataHandler PTR, BYVAL AS CONST GValue PTR) AS gchar PTR
DECLARE FUNCTION gda_data_handler_get_value_from_sql(BYVAL AS GdaDataHandler PTR, BYVAL AS CONST gchar PTR, BYVAL AS GType) AS GValue PTR
DECLARE FUNCTION gda_data_handler_get_value_from_str(BYVAL AS GdaDataHandler PTR, BYVAL AS CONST gchar PTR, BYVAL AS GType) AS GValue PTR
DECLARE FUNCTION gda_data_handler_get_sane_init_value(BYVAL AS GdaDataHandler PTR, BYVAL AS GType) AS GValue PTR
DECLARE FUNCTION gda_data_handler_accepts_g_type(BYVAL AS GdaDataHandler PTR, BYVAL AS GType) AS gboolean
DECLARE FUNCTION gda_data_handler_get_descr(BYVAL AS GdaDataHandler PTR) AS CONST gchar PTR
DECLARE FUNCTION gda_data_handler_get_default(BYVAL AS GType) AS GdaDataHandler PTR

#ENDIF ' __GDA_DATA_HANDLER_H_

#IFNDEF __GDA_HANDLER_BIN__
#DEFINE __GDA_HANDLER_BIN__

#DEFINE GDA_TYPE_HANDLER_BIN (gda_handler_bin_get_type())
#DEFINE GDA_HANDLER_BIN(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_handler_bin_get_type(), GdaHandlerBin)
#DEFINE GDA_HANDLER_BIN_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_handler_bin_get_type (), GdaHandlerBinClass)
#DEFINE GDA_IS_HANDLER_BIN(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_handler_bin_get_type ())

TYPE GdaHandlerBin AS _GdaHandlerBin
TYPE GdaHandlerBinClass AS _GdaHandlerBinClass
TYPE GdaHandlerBinPriv AS _GdaHandlerBinPriv

TYPE _GdaHandlerBin
	AS GObject object
	AS GdaHandlerBinPriv PTR priv
END TYPE

TYPE _GdaHandlerBinClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
END TYPE

DECLARE FUNCTION gda_handler_bin_get_type() AS GType
DECLARE FUNCTION gda_handler_bin_new() AS GdaDataHandler PTR

#ENDIF ' __GDA_HANDLER_BIN__

#IFNDEF __GDA_HANDLER_BOOLEAN__
#DEFINE __GDA_HANDLER_BOOLEAN__

#DEFINE GDA_TYPE_HANDLER_BOOLEAN (gda_handler_boolean_get_type())
#DEFINE GDA_HANDLER_BOOLEAN(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_handler_boolean_get_type(), GdaHandlerBoolean)
#DEFINE GDA_HANDLER_BOOLEAN_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_handler_boolean_get_type (), GdaHandlerBooleanClass)
#DEFINE GDA_IS_HANDLER_BOOLEAN(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_handler_boolean_get_type ())

TYPE GdaHandlerBoolean AS _GdaHandlerBoolean
TYPE GdaHandlerBooleanClass AS _GdaHandlerBooleanClass
TYPE GdaHandlerBooleanPriv AS _GdaHandlerBooleanPriv

TYPE _GdaHandlerBoolean
	AS GObject object
	AS GdaHandlerBooleanPriv PTR priv
END TYPE

TYPE _GdaHandlerBooleanClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
END TYPE

DECLARE FUNCTION gda_handler_boolean_get_type() AS GType
DECLARE FUNCTION gda_handler_boolean_new() AS GdaDataHandler PTR

#ENDIF ' __GDA_HANDLER_BOOLEAN__

#IFNDEF __GDA_HANDLER_NUMERICAL__
#DEFINE __GDA_HANDLER_NUMERICAL__

#DEFINE GDA_TYPE_HANDLER_NUMERICAL (gda_handler_numerical_get_type())
#DEFINE GDA_HANDLER_NUMERICAL(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_handler_numerical_get_type(), GdaHandlerNumerical)
#DEFINE GDA_HANDLER_NUMERICAL_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_handler_numerical_get_type (), GdaHandlerNumericalClass)
#DEFINE GDA_IS_HANDLER_NUMERICAL(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_handler_numerical_get_type ())

TYPE GdaHandlerNumerical AS _GdaHandlerNumerical
TYPE GdaHandlerNumericalClass AS _GdaHandlerNumericalClass
TYPE GdaHandlerNumericalPriv AS _GdaHandlerNumericalPriv

TYPE _GdaHandlerNumerical
	AS GObject object
	AS GdaHandlerNumericalPriv PTR priv
END TYPE

TYPE _GdaHandlerNumericalClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
END TYPE

DECLARE FUNCTION gda_handler_numerical_get_type() AS GType
DECLARE FUNCTION gda_handler_numerical_new() AS GdaDataHandler PTR

#ENDIF ' __GDA_HANDLER_NUMERICAL__

#IFNDEF __GDA_HANDLER_STRING__
#DEFINE __GDA_HANDLER_STRING__

#DEFINE GDA_TYPE_HANDLER_STRING (gda_handler_string_get_type())
#DEFINE GDA_HANDLER_STRING(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_handler_string_get_type(), GdaHandlerString)
#DEFINE GDA_HANDLER_STRING_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_handler_string_get_type (), GdaHandlerStringClass)
#DEFINE GDA_IS_HANDLER_STRING(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_handler_string_get_type ())

TYPE GdaHandlerString AS _GdaHandlerString
TYPE GdaHandlerStringClass AS _GdaHandlerStringClass
TYPE GdaHandlerStringPriv AS _GdaHandlerStringPriv

TYPE _GdaHandlerString
	AS GObject object
	AS GdaHandlerStringPriv PTR priv
END TYPE

TYPE _GdaHandlerStringClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
END TYPE

DECLARE FUNCTION gda_handler_string_get_type() AS GType
DECLARE FUNCTION gda_handler_string_new() AS GdaDataHandler PTR
DECLARE FUNCTION gda_handler_string_new_with_provider(BYVAL AS GdaServerProvider PTR, BYVAL AS GdaConnection PTR) AS GdaDataHandler PTR

#ENDIF ' __GDA_HANDLER_STRING__

#IFNDEF __GDA_HANDLER_TIME__
#DEFINE __GDA_HANDLER_TIME__

#DEFINE GDA_TYPE_HANDLER_TIME (gda_handler_time_get_type())
#DEFINE GDA_HANDLER_TIME(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_handler_time_get_type(), GdaHandlerTime)
#DEFINE GDA_HANDLER_TIME_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_handler_time_get_type (), GdaHandlerTimeClass)
#DEFINE GDA_IS_HANDLER_TIME(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_handler_time_get_type ())

TYPE GdaHandlerTime AS _GdaHandlerTime
TYPE GdaHandlerTimeClass AS _GdaHandlerTimeClass
TYPE GdaHandlerTimePriv AS _GdaHandlerTimePriv

TYPE _GdaHandlerTime
	AS GObject object
	AS GdaHandlerTimePriv PTR priv
END TYPE

TYPE _GdaHandlerTimeClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
END TYPE

DECLARE FUNCTION gda_handler_time_get_type() AS GType
DECLARE FUNCTION gda_handler_time_new() AS GdaDataHandler PTR
DECLARE FUNCTION gda_handler_time_new_no_locale() AS GdaDataHandler PTR
DECLARE SUB gda_handler_time_set_sql_spec(BYVAL AS GdaHandlerTime PTR, BYVAL AS GDateDMY_, BYVAL AS GDateDMY_, BYVAL AS GDateDMY_, BYVAL AS UBYTE, BYVAL AS gboolean)
DECLARE SUB gda_handler_time_set_str_spec(BYVAL AS GdaHandlerTime PTR, BYVAL AS GDateDMY_, BYVAL AS GDateDMY_, BYVAL AS GDateDMY_, BYVAL AS UBYTE, BYVAL AS gboolean)
DECLARE FUNCTION gda_handler_time_get_no_locale_str_from_value(BYVAL AS GdaHandlerTime PTR, BYVAL AS CONST GValue PTR) AS gchar PTR
DECLARE FUNCTION gda_handler_time_get_format(BYVAL AS GdaHandlerTime PTR, BYVAL AS GType) AS gchar PTR

#ENDIF ' __GDA_HANDLER_TIME__

#IFNDEF __GDA_HANDLER_TYPE__
#DEFINE __GDA_HANDLER_TYPE__

#DEFINE GDA_TYPE_HANDLER_TYPE (gda_handler_type_get_type())
#DEFINE GDA_HANDLER_TYPE(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_handler_type_get_type(), GdaHandlerType)
#DEFINE GDA_HANDLER_TYPE_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_handler_type_get_type (), GdaHandlerTypeClass)
#DEFINE GDA_IS_HANDLER_TYPE(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_handler_type_get_type ())

TYPE GdaHandlerType AS _GdaHandlerType
TYPE GdaHandlerTypeClass AS _GdaHandlerTypeClass
TYPE GdaHandlerTypePriv AS _GdaHandlerTypePriv

TYPE _GdaHandlerType
	AS GObject object
	AS GdaHandlerTypePriv PTR priv
END TYPE

TYPE _GdaHandlerTypeClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
END TYPE

DECLARE FUNCTION gda_handler_type_get_type() AS GType
DECLARE FUNCTION gda_handler_type_new() AS GdaDataHandler PTR

#ENDIF ' __GDA_HANDLER_TYPE__

#IFNDEF __GDA_BATCH_H_
#DEFINE __GDA_BATCH_H_

#DEFINE GDA_TYPE_BATCH (gda_batch_get_type())
#DEFINE GDA_BATCH(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_batch_get_type(), GdaBatch)
#DEFINE GDA_BATCH_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_batch_get_type (), GdaBatchClass)
#DEFINE GDA_IS_BATCH(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_batch_get_type ())

EXTERN gda_batch_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_BATCH_ERROR gda_batch_error_quark ()

ENUM GdaBatchError
	GDA_BATCH_CONFLICTING_PARAMETER_ERROR
END ENUM

TYPE _GdaBatch
	AS GObject object
	AS GdaBatchPrivate PTR priv
END TYPE

TYPE _GdaBatchClass
	AS GObjectClass parent_class
	changed AS SUB(BYVAL AS GdaBatch PTR, BYVAL AS GdaStatement PTR)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_batch_get_type() AS GType
DECLARE FUNCTION gda_batch_new() AS GdaBatch PTR
DECLARE FUNCTION gda_batch_copy(BYVAL AS GdaBatch PTR) AS GdaBatch PTR
DECLARE SUB gda_batch_add_statement(BYVAL AS GdaBatch PTR, BYVAL AS GdaStatement PTR)
DECLARE SUB gda_batch_remove_statement(BYVAL AS GdaBatch PTR, BYVAL AS GdaStatement PTR)
DECLARE FUNCTION gda_batch_serialize(BYVAL AS GdaBatch PTR) AS gchar PTR
DECLARE FUNCTION gda_batch_get_statements(BYVAL AS GdaBatch PTR) AS CONST GSList PTR
DECLARE FUNCTION gda_batch_get_parameters(BYVAL AS GdaBatch PTR, BYVAL AS GdaSet PTR PTR, BYVAL AS GError PTR PTR) AS gboolean

#ENDIF ' __GDA_BATCH_H_

#IFNDEF __GDA_TREE_H__
#DEFINE __GDA_TREE_H__

#INCLUDE ONCE "crt/stdio.bi"

#DEFINE GDA_TYPE_TREE (gda_tree_get_type())
#DEFINE GDA_TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_TREE, GdaTree))
#DEFINE GDA_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_TREE, GdaTreeClass))
#DEFINE GDA_IS_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_TREE))
#DEFINE GDA_IS_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_TREE))
#DEFINE GDA_TREE_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GDA_TYPE_TREE, GdaTreeClass))

EXTERN gda_tree_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_TREE_ERROR gda_tree_error_quark ()

ENUM GdaTreeError
	GDA_TREE_UNKNOWN_ERROR
END ENUM

TYPE _GdaTree
	AS GObject object
	AS GdaTreePrivate PTR priv
END TYPE

TYPE _GdaTreeClass
	AS GObjectClass object_class
	node_changed AS SUB(BYVAL AS GdaTree PTR, BYVAL AS GdaTreeNode PTR)
	node_inserted AS SUB(BYVAL AS GdaTree PTR, BYVAL AS GdaTreeNode PTR)
	node_has_child_toggled AS SUB(BYVAL AS GdaTree PTR, BYVAL AS GdaTreeNode PTR)
	node_deleted AS SUB(BYVAL AS GdaTree PTR, BYVAL AS CONST gchar PTR)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_tree_get_type() AS GType
DECLARE FUNCTION gda_tree_new() AS GdaTree PTR
DECLARE SUB gda_tree_add_manager(BYVAL AS GdaTree PTR, BYVAL AS GdaTreeManager PTR)
DECLARE SUB gda_tree_clean(BYVAL AS GdaTree PTR)
DECLARE FUNCTION gda_tree_update_all(BYVAL AS GdaTree PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_tree_update_part(BYVAL AS GdaTree PTR, BYVAL AS GdaTreeNode PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_tree_update_children(BYVAL AS GdaTree PTR, BYVAL AS GdaTreeNode PTR, BYVAL AS GError PTR PTR) AS gboolean
DECLARE FUNCTION gda_tree_get_nodes_in_path(BYVAL AS GdaTree PTR, BYVAL AS CONST gchar PTR, BYVAL AS gboolean) AS GSList PTR
DECLARE FUNCTION gda_tree_get_node(BYVAL AS GdaTree PTR, BYVAL AS CONST gchar PTR, BYVAL AS gboolean) AS GdaTreeNode PTR
DECLARE FUNCTION gda_tree_get_node_path(BYVAL AS GdaTree PTR, BYVAL AS GdaTreeNode PTR) AS gchar PTR
DECLARE FUNCTION gda_tree_get_node_manager(BYVAL AS GdaTree PTR, BYVAL AS GdaTreeNode PTR) AS GdaTreeManager PTR
DECLARE SUB gda_tree_set_attribute(BYVAL AS GdaTree PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR, BYVAL AS GDestroyNotify)
DECLARE SUB gda_tree_dump(BYVAL AS GdaTree PTR, BYVAL AS GdaTreeNode PTR, BYVAL AS FILE PTR)

#ENDIF ' __GDA_TREE_H__

#IFNDEF __GDA_TREE_MANAGER_H__
#DEFINE __GDA_TREE_MANAGER_H__

#DEFINE GDA_TYPE_TREE_MANAGER (gda_tree_manager_get_type())
#DEFINE GDA_TREE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_TREE_MANAGER, GdaTreeManager))
#DEFINE GDA_TREE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_TREE_MANAGER, GdaTreeManagerClass))
#DEFINE GDA_IS_TREE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_TREE_MANAGER))
#DEFINE GDA_IS_TREE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_TREE_MANAGER))
#DEFINE GDA_TREE_MANAGER_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GDA_TYPE_TREE_MANAGER, GdaTreeManagerClass))

TYPE GdaTreeManagerNodesFunc AS FUNCTION(BYVAL AS GdaTreeManager PTR, BYVAL AS GdaTreeNode PTR, BYVAL AS CONST GSList PTR, BYVAL AS gboolean PTR, BYVAL AS GError PTR PTR) AS GSList PTR
TYPE GdaTreeManagerNodeFunc AS FUNCTION(BYVAL AS GdaTreeManager PTR, BYVAL AS GdaTreeNode PTR, BYVAL AS CONST gchar PTR) AS GdaTreeNode PTR

EXTERN gda_tree_manager_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_TREE_MANAGER_ERROR gda_tree_manager_error_quark ()

ENUM GdaTreeManagerError
	GDA_TREE_MANAGER_UNKNOWN_ERROR
END ENUM

TYPE _GdaTreeManager
	AS GObject object
	AS GdaTreeManagerPrivate PTR priv
END TYPE

TYPE _GdaTreeManagerClass
	AS GObjectClass object_class
	update_children AS FUNCTION(BYVAL AS GdaTreeManager PTR, BYVAL AS GdaTreeNode PTR, BYVAL AS CONST GSList PTR, BYVAL AS gboolean PTR, BYVAL AS GError PTR PTR) AS GSList PTR
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_tree_manager_get_type() AS GType
DECLARE FUNCTION gda_tree_manager_new_with_func(BYVAL AS GdaTreeManagerNodesFunc) AS GdaTreeManager PTR
DECLARE SUB gda_tree_manager_add_manager(BYVAL AS GdaTreeManager PTR, BYVAL AS GdaTreeManager PTR)
DECLARE FUNCTION gda_tree_manager_get_managers(BYVAL AS GdaTreeManager PTR) AS CONST GSList PTR
DECLARE SUB gda_tree_manager_set_node_create_func(BYVAL AS GdaTreeManager PTR, BYVAL AS GdaTreeManagerNodeFunc)
DECLARE FUNCTION gda_tree_manager_get_node_create_func(BYVAL AS GdaTreeManager PTR) AS GdaTreeManagerNodeFunc
DECLARE SUB gda_tree_manager_add_new_node_attribute(BYVAL AS GdaTreeManager PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR)
DECLARE FUNCTION gda_tree_manager_create_node(BYVAL AS GdaTreeManager PTR, BYVAL AS GdaTreeNode PTR, BYVAL AS CONST gchar PTR) AS GdaTreeNode PTR
DECLARE SUB _gda_tree_manager_update_children(BYVAL AS GdaTreeManager PTR, BYVAL AS GdaTreeNode PTR, BYVAL AS CONST GSList PTR, BYVAL AS gboolean PTR, BYVAL AS GError PTR PTR)

#ENDIF ' __GDA_TREE_MANAGER_H__

#IFNDEF __GDA_TREE_MGR_COLUMNS_H__
#DEFINE __GDA_TREE_MGR_COLUMNS_H__

#DEFINE GDA_TYPE_TREE_MGR_COLUMNS (gda_tree_mgr_columns_get_type())
#DEFINE GDA_TREE_MGR_COLUMNS(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_TREE_MGR_COLUMNS, GdaTreeMgrColumns))
#DEFINE GDA_TREE_MGR_COLUMNS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_TREE_MGR_COLUMNS, GdaTreeMgrColumnsClass))
#DEFINE GDA_IS_TREE_MGR_COLUMNS(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_TREE_MGR_COLUMNS))
#DEFINE GDA_IS_TREE_MGR_COLUMNS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_TREE_MGR_COLUMNS))
#DEFINE GDA_TREE_MGR_COLUMNS_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GDA_TYPE_TREE_MGR_COLUMNS, GdaTreeMgrColumnsClass))

TYPE GdaTreeMgrColumns AS _GdaTreeMgrColumns
TYPE GdaTreeMgrColumnsPriv AS _GdaTreeMgrColumnsPriv
TYPE GdaTreeMgrColumnsClass AS _GdaTreeMgrColumnsClass

TYPE _GdaTreeMgrColumns
	AS GdaTreeManager object
	AS GdaTreeMgrColumnsPriv PTR priv
END TYPE

TYPE _GdaTreeMgrColumnsClass
	AS GdaTreeManagerClass object_class
END TYPE

DECLARE FUNCTION gda_tree_mgr_columns_get_type() AS GType
DECLARE FUNCTION gda_tree_mgr_columns_new(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR) AS GdaTreeManager PTR

#ENDIF ' __GDA_TREE_MGR_COLUMNS_H__

#IFNDEF __GDA_TREE_MGR_LABEL_H__
#DEFINE __GDA_TREE_MGR_LABEL_H__

#DEFINE GDA_TYPE_TREE_MGR_LABEL (gda_tree_mgr_label_get_type())
#DEFINE GDA_TREE_MGR_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_TREE_MGR_LABEL, GdaTreeMgrLabel))
#DEFINE GDA_TREE_MGR_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_TREE_MGR_LABEL, GdaTreeMgrLabelClass))
#DEFINE GDA_IS_TREE_MGR_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_TREE_MGR_LABEL))
#DEFINE GDA_IS_TREE_MGR_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_TREE_MGR_LABEL))
#DEFINE GDA_TREE_MGR_LABEL_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GDA_TYPE_TREE_MGR_LABEL, GdaTreeMgrLabelClass))

TYPE GdaTreeMgrLabel AS _GdaTreeMgrLabel
TYPE GdaTreeMgrLabelPriv AS _GdaTreeMgrLabelPriv
TYPE GdaTreeMgrLabelClass AS _GdaTreeMgrLabelClass

TYPE _GdaTreeMgrLabel
	AS GdaTreeManager object
	AS GdaTreeMgrLabelPriv PTR priv
END TYPE

TYPE _GdaTreeMgrLabelClass
	AS GdaTreeManagerClass object_class
END TYPE

DECLARE FUNCTION gda_tree_mgr_label_get_type() AS GType
DECLARE FUNCTION gda_tree_mgr_label_new(BYVAL AS CONST gchar PTR) AS GdaTreeManager PTR

#ENDIF ' __GDA_TREE_MGR_LABEL_H__

#IFNDEF __GDA_TREE_MGR_SCHEMAS_H__
#DEFINE __GDA_TREE_MGR_SCHEMAS_H__

#DEFINE GDA_TYPE_TREE_MGR_SCHEMAS (gda_tree_mgr_schemas_get_type())
#DEFINE GDA_TREE_MGR_SCHEMAS(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_TREE_MGR_SCHEMAS, GdaTreeMgrSchemas))
#DEFINE GDA_TREE_MGR_SCHEMAS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_TREE_MGR_SCHEMAS, GdaTreeMgrSchemasClass))
#DEFINE GDA_IS_TREE_MGR_SCHEMAS(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_TREE_MGR_SCHEMAS))
#DEFINE GDA_IS_TREE_MGR_SCHEMAS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_TREE_MGR_SCHEMAS))
#DEFINE GDA_TREE_MGR_SCHEMAS_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GDA_TYPE_TREE_MGR_SCHEMAS, GdaTreeMgrSchemasClass))

TYPE GdaTreeMgrSchemas AS _GdaTreeMgrSchemas
TYPE GdaTreeMgrSchemasPriv AS _GdaTreeMgrSchemasPriv
TYPE GdaTreeMgrSchemasClass AS _GdaTreeMgrSchemasClass

TYPE _GdaTreeMgrSchemas
	AS GdaTreeManager object
	AS GdaTreeMgrSchemasPriv PTR priv
END TYPE

TYPE _GdaTreeMgrSchemasClass
	AS GdaTreeManagerClass object_class
END TYPE

DECLARE FUNCTION gda_tree_mgr_schemas_get_type() AS GType
DECLARE FUNCTION gda_tree_mgr_schemas_new(BYVAL AS GdaConnection PTR) AS GdaTreeManager PTR

#ENDIF ' __GDA_TREE_MGR_SCHEMAS_H__

#IFNDEF __GDA_TREE_MGR_SELECT_H__
#DEFINE __GDA_TREE_MGR_SELECT_H__

#DEFINE GDA_TYPE_TREE_MGR_SELECT (gda_tree_mgr_select_get_type())
#DEFINE GDA_TREE_MGR_SELECT(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_TREE_MGR_SELECT, GdaTreeMgrSelect))
#DEFINE GDA_TREE_MGR_SELECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_TREE_MGR_SELECT, GdaTreeMgrSelectClass))
#DEFINE GDA_IS_TREE_MGR_SELECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_TREE_MGR_SELECT))
#DEFINE GDA_IS_TREE_MGR_SELECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_TREE_MGR_SELECT))
#DEFINE GDA_TREE_MGR_SELECT_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GDA_TYPE_TREE_MGR_SELECT, GdaTreeMgrSelectClass))

TYPE GdaTreeMgrSelect AS _GdaTreeMgrSelect
TYPE GdaTreeMgrSelectPriv AS _GdaTreeMgrSelectPriv
TYPE GdaTreeMgrSelectClass AS _GdaTreeMgrSelectClass

TYPE _GdaTreeMgrSelect
	AS GdaTreeManager object
	AS GdaTreeMgrSelectPriv PTR priv
END TYPE

TYPE _GdaTreeMgrSelectClass
	AS GdaTreeManagerClass object_class
END TYPE

DECLARE FUNCTION gda_tree_mgr_select_get_type() AS GType
DECLARE FUNCTION gda_tree_mgr_select_new(BYVAL AS GdaConnection PTR, BYVAL AS GdaStatement PTR, BYVAL AS GdaSet PTR) AS GdaTreeManager PTR

#ENDIF ' __GDA_TREE_MGR_SELECT_H__

#IFNDEF __GDA_TREE_MGR_TABLES_H__
#DEFINE __GDA_TREE_MGR_TABLES_H__

#DEFINE GDA_TYPE_TREE_MGR_TABLES (gda_tree_mgr_tables_get_type())
#DEFINE GDA_TREE_MGR_TABLES(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_TREE_MGR_TABLES, GdaTreeMgrTables))
#DEFINE GDA_TREE_MGR_TABLES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_TREE_MGR_TABLES, GdaTreeMgrTablesClass))
#DEFINE GDA_IS_TREE_MGR_TABLES(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_TREE_MGR_TABLES))
#DEFINE GDA_IS_TREE_MGR_TABLES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_TREE_MGR_TABLES))
#DEFINE GDA_TREE_MGR_TABLES_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GDA_TYPE_TREE_MGR_TABLES, GdaTreeMgrTablesClass))

TYPE GdaTreeMgrTables AS _GdaTreeMgrTables
TYPE GdaTreeMgrTablesPriv AS _GdaTreeMgrTablesPriv
TYPE GdaTreeMgrTablesClass AS _GdaTreeMgrTablesClass

TYPE _GdaTreeMgrTables
	AS GdaTreeManager object
	AS GdaTreeMgrTablesPriv PTR priv
END TYPE

TYPE _GdaTreeMgrTablesClass
	AS GdaTreeManagerClass object_class
END TYPE

DECLARE FUNCTION gda_tree_mgr_tables_get_type() AS GType
DECLARE FUNCTION gda_tree_mgr_tables_new(BYVAL AS GdaConnection PTR, BYVAL AS CONST gchar PTR) AS GdaTreeManager PTR

#ENDIF ' __GDA_TREE_MGR_TABLES_H__

#IFNDEF __GDA_TREE_NODE_H__
#DEFINE __GDA_TREE_NODE_H__

#DEFINE GDA_TYPE_TREE_NODE (gda_tree_node_get_type())
#DEFINE GDA_TREE_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST (obj, GDA_TYPE_TREE_NODE, GdaTreeNode))
#DEFINE GDA_TREE_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST (klass, GDA_TYPE_TREE_NODE, GdaTreeNodeClass))
#DEFINE GDA_IS_TREE_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE(obj, GDA_TYPE_TREE_NODE))
#DEFINE GDA_IS_TREE_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), GDA_TYPE_TREE_NODE))
#DEFINE GDA_TREE_NODE_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GDA_TYPE_TREE_NODE, GdaTreeNodeClass))

EXTERN gda_tree_node_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_TREE_NODE_ERROR gda_tree_node_error_quark ()

ENUM GdaTreeNodeError
	GDA_TREE_NODE_UNKNOWN_ERROR
END ENUM

TYPE _GdaTreeNode
	AS GObject object
	AS GdaTreeNodePrivate PTR priv
END TYPE

TYPE _GdaTreeNodeClass
	AS GObjectClass object_class
	node_changed AS SUB(BYVAL AS GdaTreeNode PTR, BYVAL AS GdaTreeNode PTR)
	node_inserted AS SUB(BYVAL AS GdaTreeNode PTR, BYVAL AS GdaTreeNode PTR)
	node_has_child_toggled AS SUB(BYVAL AS GdaTreeNode PTR, BYVAL AS GdaTreeNode PTR)
	node_deleted AS SUB(BYVAL AS GdaTreeNode PTR, BYVAL AS CONST gchar PTR)
	dump_header AS FUNCTION(BYVAL AS GdaTreeNode PTR) AS gchar PTR
	dump_children AS SUB(BYVAL AS GdaTreeNode PTR, BYVAL AS CONST gchar PTR, BYVAL AS GString PTR)
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

DECLARE FUNCTION gda_tree_node_get_type() AS GType
DECLARE FUNCTION gda_tree_node_new(BYVAL AS CONST gchar PTR) AS GdaTreeNode PTR
DECLARE FUNCTION gda_tree_node_get_parent(BYVAL AS GdaTreeNode PTR) AS GdaTreeNode PTR
DECLARE FUNCTION gda_tree_node_get_children(BYVAL AS GdaTreeNode PTR) AS GSList PTR
DECLARE FUNCTION gda_tree_node_get_child_index(BYVAL AS GdaTreeNode PTR, BYVAL AS gint) AS GdaTreeNode PTR
DECLARE FUNCTION gda_tree_node_get_child_name(BYVAL AS GdaTreeNode PTR, BYVAL AS CONST gchar PTR) AS GdaTreeNode PTR
DECLARE SUB gda_tree_node_set_node_attribute(BYVAL AS GdaTreeNode PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR, BYVAL AS GDestroyNotify)
DECLARE FUNCTION gda_tree_node_get_node_attribute(BYVAL AS GdaTreeNode PTR, BYVAL AS CONST gchar PTR) AS CONST GValue PTR
DECLARE FUNCTION gda_tree_node_fetch_attribute(BYVAL AS GdaTreeNode PTR, BYVAL AS CONST gchar PTR) AS CONST GValue PTR
DECLARE SUB _gda_tree_node_add_children(BYVAL AS GdaTreeNode PTR, BYVAL AS GdaTreeManager PTR, BYVAL AS CONST GSList PTR)
DECLARE FUNCTION _gda_tree_node_get_children_for_manager(BYVAL AS GdaTreeNode PTR, BYVAL AS GdaTreeManager PTR) AS CONST GSList PTR
DECLARE FUNCTION _gda_tree_node_get_managers_for_children(BYVAL AS GdaTreeNode PTR) AS GSList PTR
DECLARE FUNCTION _gda_tree_node_get_manager_for_child(BYVAL AS GdaTreeNode PTR, BYVAL AS GdaTreeNode PTR) AS GdaTreeManager PTR

#ENDIF ' __GDA_TREE_NODE_H__

#IFNDEF __GDA_SQL_BUILDER_H_
#DEFINE __GDA_SQL_BUILDER_H_

#DEFINE GDA_TYPE_SQL_BUILDER (gda_sql_builder_get_type())
#DEFINE GDA_SQL_BUILDER(obj) G_TYPE_CHECK_INSTANCE_CAST (obj, gda_sql_builder_get_type(), GdaSqlBuilder)
#DEFINE GDA_SQL_BUILDER_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, gda_sql_builder_get_type (), GdaSqlBuilderClass)
#DEFINE GDA_IS_SQL_BUILDER(obj) G_TYPE_CHECK_INSTANCE_TYPE (obj, gda_sql_builder_get_type ())
#DEFINE GDA_SQL_BUILDER_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GDA_TYPE_SQL_BUILDER, GdaSqlBuilderClass))

TYPE GdaSqlBuilder AS _GdaSqlBuilder
TYPE GdaSqlBuilderClass AS _GdaSqlBuilderClass
TYPE GdaSqlBuilderPrivate AS _GdaSqlBuilderPrivate

EXTERN gda_sql_builder_error_quark AS FUNCTION() AS GQuark

#DEFINE GDA_SQL_BUILDER_ERROR gda_sql_builder_error_quark ()

ENUM GdaSqlBuilderError
	GDA_SQL_BUILDER_WRONG_TYPE_ERROR
	GDA_SQL_BUILDER_MISUSE_ERROR
END ENUM

TYPE _GdaSqlBuilder
	AS GObject object
	AS GdaSqlBuilderPrivate PTR priv
END TYPE

TYPE _GdaSqlBuilderClass
	AS GObjectClass parent_class
	_gda_reserved1 AS SUB()
	_gda_reserved2 AS SUB()
	_gda_reserved3 AS SUB()
	_gda_reserved4 AS SUB()
END TYPE

TYPE GdaSqlBuilderId AS guint

DECLARE FUNCTION gda_sql_builder_get_type() AS GType
DECLARE FUNCTION gda_sql_builder_new(BYVAL AS GdaSqlStatementType) AS GdaSqlBuilder PTR
DECLARE FUNCTION gda_sql_builder_get_statement(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GError PTR PTR) AS GdaStatement PTR
DECLARE FUNCTION gda_sql_builder_get_sql_statement(BYVAL AS GdaSqlBuilder PTR) AS GdaSqlStatement PTR
DECLARE FUNCTION gda_sql_builder_add_id(BYVAL AS GdaSqlBuilder PTR, BYVAL AS CONST gchar PTR) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_add_field_id(BYVAL AS GdaSqlBuilder PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_add_expr(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaDataHandler PTR, BYVAL AS GType, ...) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_add_expr_value(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaDataHandler PTR, BYVAL AS CONST GValue PTR) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_add_param(BYVAL AS GdaSqlBuilder PTR, BYVAL AS CONST gchar PTR, BYVAL AS GType, BYVAL AS gboolean) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_add_cond(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlOperatorType, BYVAL AS GdaSqlBuilderId, BYVAL AS GdaSqlBuilderId, BYVAL AS GdaSqlBuilderId) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_add_cond_v(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlOperatorType, BYVAL AS CONST GdaSqlBuilderId PTR, BYVAL AS gint) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_add_function(BYVAL AS GdaSqlBuilder PTR, BYVAL AS CONST gchar PTR, ...) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_add_function_v(BYVAL AS GdaSqlBuilder PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GdaSqlBuilderId PTR, BYVAL AS gint) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_add_sub_select(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlStatement PTR) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_add_case(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId, BYVAL AS GdaSqlBuilderId, ...) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_add_case_v(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId, BYVAL AS GdaSqlBuilderId, BYVAL AS CONST GdaSqlBuilderId PTR, BYVAL AS CONST GdaSqlBuilderId PTR, BYVAL AS gint) AS GdaSqlBuilderId
DECLARE SUB gda_sql_builder_add_field_value(BYVAL AS GdaSqlBuilder PTR, BYVAL AS CONST gchar PTR, BYVAL AS GType, ...)
DECLARE SUB gda_sql_builder_add_field_value_as_gvalue(BYVAL AS GdaSqlBuilder PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST GValue PTR)
DECLARE SUB gda_sql_builder_add_field_value_id(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId, BYVAL AS GdaSqlBuilderId)
DECLARE SUB gda_sql_builder_set_table(BYVAL AS GdaSqlBuilder PTR, BYVAL AS CONST gchar PTR)
DECLARE SUB gda_sql_builder_set_where(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId)
DECLARE FUNCTION gda_sql_builder_select_add_field(BYVAL AS GdaSqlBuilder PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_select_add_target(BYVAL AS GdaSqlBuilder PTR, BYVAL AS CONST gchar PTR, BYVAL AS CONST gchar PTR) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_select_add_target_id(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId, BYVAL AS CONST gchar PTR) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_select_join_targets(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId, BYVAL AS GdaSqlBuilderId, BYVAL AS GdaSqlSelectJoinType, BYVAL AS GdaSqlBuilderId) AS GdaSqlBuilderId
DECLARE SUB gda_sql_builder_join_add_field(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId, BYVAL AS CONST gchar PTR)
DECLARE SUB gda_sql_builder_select_order_by(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId, BYVAL AS gboolean, BYVAL AS CONST gchar PTR)
DECLARE SUB gda_sql_builder_select_set_distinct(BYVAL AS GdaSqlBuilder PTR, BYVAL AS gboolean, BYVAL AS GdaSqlBuilderId)
DECLARE SUB gda_sql_builder_select_set_limit(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId, BYVAL AS GdaSqlBuilderId)
DECLARE SUB gda_sql_builder_select_set_having(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId)
DECLARE SUB gda_sql_builder_select_group_by(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId)
DECLARE SUB gda_sql_builder_compound_set_type(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlStatementCompoundType)
DECLARE SUB gda_sql_builder_compound_add_sub_select(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlStatement PTR)
DECLARE SUB gda_sql_builder_compound_add_sub_select_from_builder(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilder PTR)
DECLARE FUNCTION gda_sql_builder_export_expression(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId) AS GdaSqlExpr PTR
DECLARE FUNCTION gda_sql_builder_import_expression(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlExpr PTR) AS GdaSqlBuilderId
DECLARE FUNCTION gda_sql_builder_import_expression_from_builder(BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilder PTR, BYVAL AS GdaSqlBuilderId) AS GdaSqlBuilderId

#ENDIF ' __GDA_SQL_BUILDER_H_

#IFNDEF __GDA_MUTEX_H__
#DEFINE __GDA_MUTEX_H__

#IF GLIB_CHECK_VERSION(2,31,7)

TYPE GdaMutex AS GRecMutex

#ELSE ' GLIB_CHECK_VERS...

TYPE GdaMutex AS _GdaMutex

#ENDIF ' GLIB_CHECK_VERS...

DECLARE FUNCTION gda_mutex_new() AS GdaMutex PTR
DECLARE SUB gda_mutex_lock(BYVAL AS GdaMutex PTR)
DECLARE FUNCTION gda_mutex_trylock(BYVAL AS GdaMutex PTR) AS gboolean
DECLARE SUB gda_mutex_unlock(BYVAL AS GdaMutex PTR)
DECLARE SUB gda_mutex_free(BYVAL AS GdaMutex PTR)

#IFDEF GDA_DEBUG_MUTEX

DECLARE SUB gda_mutex_debug(BYVAL AS GdaMutex PTR, BYVAL AS gboolean)
DECLARE SUB gda_mutex_dump_usage(BYVAL AS GdaMutex PTR, BYVAL AS FILE PTR)

#ENDIF ' GDA_DEBUG_MUTEX
#ENDIF ' __GDA_MUTEX_H__

DECLARE SUB gda_init()
DECLARE SUB gda_locale_changed()
DECLARE FUNCTION gda_get_application_exec_path(BYVAL AS CONST gchar PTR) AS gchar PTR

#ENDIF ' __LIBGDA_H__

END EXTERN ' (h_2_bi -P_oCD option)

#IFDEF __FB_WIN32__
#PRAGMA pop(msbitfields)
#ENDIF

' Translated at 13-01-31 19:54:20, by h_2_bi (version 0.2.2.1,
' released under GPLv3 by Thomas[ dot ]Freiherr{ at }gmx[ dot ]net)

'   Protocol: libgda-5.0.bi
' Parameters: 
'                                  Process time [s]: 0.7964249263750389
'                                  Bytes translated: 218034
'                                      Maximum deep: 6
'                                SUB/FUNCTION names: 863
'                                mangled TYPE names: 0
'                                        files done: 67
' ../../C_C++/libgda-5.1.1/libgda/libgda.h
' ../../C_C++/libgda-5.1.1/libgda/gda-attributes-manager.h
' ../../C_C++/libgda-5.1.1/libgda/gda-column.h
' ../../C_C++/libgda-5.1.1/libgda/gda-value.h
' ../../C_C++/libgda-5.1.1/libgda/gda-decl.h
' ../../C_C++/libgda-5.1.1/libgda/gda-debug-macros.h
' ../../C_C++/libgda-5.1.1/libgda/gda-config.h
' ../../C_C++/libgda-5.1.1/libgda/gda-data-model.h
' ../../C_C++/libgda-5.1.1/libgda/gda-enums.h
' ../../C_C++/libgda-5.1.1/libgda/gda-connection-event.h
' ../../C_C++/libgda-5.1.1/libgda/gda-connection.h
' ../../C_C++/libgda-5.1.1/libgda/gda-transaction-status.h
' ../../C_C++/libgda-5.1.1/libgda/gda-statement.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-statement-struct.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-statement-struct-decl.h
' ../../C_C++/libgda-5.1.1/libgda/gda-meta-store.h
' ../../C_C++/libgda-5.1.1/libgda/gda-meta-struct.h
' ../../C_C++/libgda-5.1.1/libgda/gda-server-operation.h
' ../../C_C++/libgda-5.1.1/libgda/gda-connection-private.h
' ../../C_C++/libgda-5.1.1/libgda/providers-support/gda-pstmt.h
' ../../C_C++/libgda-5.1.1/libgda/gda-data-comparator.h
' ../../C_C++/libgda-5.1.1/libgda/gda-data-model-array.h
' ../../C_C++/libgda-5.1.1/libgda/gda-row.h
' ../../C_C++/libgda-5.1.1/libgda/gda-data-model-iter.h
' ../../C_C++/libgda-5.1.1/libgda/gda-set.h
' ../../C_C++/libgda-5.1.1/libgda/gda-data-model-import.h
' ../../C_C++/libgda-5.1.1/libgda/gda-data-model-dir.h
' ../../C_C++/libgda-5.1.1/libgda/gda-data-access-wrapper.h
' ../../C_C++/libgda-5.1.1/libgda/gda-data-proxy.h
' ../../C_C++/libgda-5.1.1/libgda/gda-data-select.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-sql-statement.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-statement-struct-select.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-statement-struct-parts.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-statement-struct-pspec.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-statement-struct-insert.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-statement-struct-update.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-statement-struct-delete.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-statement-struct-compound.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-statement-struct-trans.h
' ../../C_C++/libgda-5.1.1/libgda/sql-parser/gda-statement-struct-unknown.h
' ../../C_C++/libgda-5.1.1/libgda/gda-data-pivot.h
' ../../C_C++/libgda-5.1.1/libgda/gda-lockable.h
' ../../C_C++/libgda-5.1.1/libgda/gda-log.h
' ../../C_C++/libgda-5.1.1/libgda/gda-quark-list.h
' ../../C_C++/libgda-5.1.1/libgda/gda-server-provider.h
' ../../C_C++/libgda-5.1.1/libgda/gda-xa-transaction.h
' ../../C_C++/libgda-5.1.1/libgda/gda-transaction-status-private.h
' ../../C_C++/libgda-5.1.1/libgda/gda-util.h
' ../../C_C++/libgda-5.1.1/libgda/gda-holder.h
' ../../C_C++/libgda-5.1.1/libgda/gda-data-handler.h
' ../../C_C++/libgda-5.1.1/libgda/handlers/gda-handler-bin.h
' ../../C_C++/libgda-5.1.1/libgda/handlers/gda-handler-boolean.h
' ../../C_C++/libgda-5.1.1/libgda/handlers/gda-handler-numerical.h
' ../../C_C++/libgda-5.1.1/libgda/handlers/gda-handler-string.h
' ../../C_C++/libgda-5.1.1/libgda/handlers/gda-handler-time.h
' ../../C_C++/libgda-5.1.1/libgda/handlers/gda-handler-type.h
' ../../C_C++/libgda-5.1.1/libgda/gda-batch.h
' ../../C_C++/libgda-5.1.1/libgda/gda-tree.h
' ../../C_C++/libgda-5.1.1/libgda/gda-tree-manager.h
' ../../C_C++/libgda-5.1.1/libgda/gda-tree-mgr-columns.h
' ../../C_C++/libgda-5.1.1/libgda/gda-tree-mgr-label.h
' ../../C_C++/libgda-5.1.1/libgda/gda-tree-mgr-schemas.h
' ../../C_C++/libgda-5.1.1/libgda/gda-tree-mgr-select.h
' ../../C_C++/libgda-5.1.1/libgda/gda-tree-mgr-tables.h
' ../../C_C++/libgda-5.1.1/libgda/gda-tree-node.h
' ../../C_C++/libgda-5.1.1/libgda/gda-sql-builder.h
' ../../C_C++/libgda-5.1.1/libgda/gda-mutex.h
'                                      files missed: 2
' libxml/tree.h
' libxml/parser.h
'                                       __FOLDERS__: 2
' ../../C_C++/libgda-5.1.1/libgda/
' ../../C_C++/libgda-5.1.1/
'                                        __MACROS__: 3
' 64: #define G_BEGIN_DECLS
' 64: #define G_END_DECLS
' 3: #define GSEAL(ident) ident
'                                       __HEADERS__: 0
'                                         __TYPES__: 0
'                                     __POST_REPS__: 0
